unit e_SortElements;
interface

uses elements;

type


TSortOwnerEntity = class(TOwnerEntity)
private
   FSortByName: boolean;
   FIndex: longInt;
protected
   function  FindIndex(const aName: string; var NearestRight: longInt): longInt;
public
   procedure AddSortElement(aElement: TElement); virtual;
end;


implementation
uses e_class,
     SysUtils;

procedure TSortOwnerEntity.AddSortElement(aElement: TElement);
var
   E: TElement;
   i: longInt;
   S: string;
begin
   E := TElement.Create;
   E := aElement;
   S := aElement.Name;
   E.Name := S;
   E.ID := FIndex;
   inc(FIndex);
   FindIndex(S, i);
   if i > -1 then
      InsertElement(i, E)
   else
      AddElement(E);
end;



function TSortOwnerEntity.FindIndex(const aName: string; var NearestRight: longInt): longInt;
var
   L,R,C: longInt;
   LResult, RResult, CResult: integer;
begin
   result := -1;
   NearestRight := -1;
   if NoElements then exit;
   L := 0;
   R := Count - 1;
   RResult := AnsiCompareText(aName, Elements[R].Name);
   if (RResult > 0) then exit;
   if RResult = 0 then
   begin
      result := R;
      exit;
   end;
   if R > L then
   begin
      LResult := AnsiCompareText(aName, Elements[L].Name);
      if (LResult < 0) then
      begin
         NearestRight := L;
         exit;
      end;
      if LResult = 0 then
      begin
         result := L;
         NearestRight := L + 1;
         exit;
      end;
   end
   else
   begin
      NearestRight := L;
      exit;
   end;
   repeat
      NearestRight := R;
      if R - L <= 1 then exit;
      C := ((R - L) div 2) + L;
      CResult := AnsiCompareText(aName, Elements[C].Name);
      if CResult < 0 then R := C else
      if CResult > 0 then L := C else
      begin
         result := C;
         NearestRight := C + 1;
         exit;
      end;
   until L >= R;
end;


INITIALIZATION
   RegisterOrbisClass(TSortOwnerEntity);
END.
