unit i_GeometryEx;

interface
uses
   Graphics,
   Elements,
   e_Device,
   i_Basic;
type

TGis_NoteInterpret = class(TRectInterpret)
private
   fBM: TPicture;
   fnf: boolean;
protected
   procedure Process(Element: TElement); override;
   function  IsItsClass(AObject: TObject): boolean; override;
   function  QGoInside(Element: TElement): boolean; override;
   function  QProcessBefore(Element: TElement): boolean; override;
public
   function   CanUniGoInside(Element: TElement): boolean; override;
   destructor Destroy; override;
   procedure  Reset(aDevice: TDevice); override;
end;

implementation
uses
   SysUtils,
   u_String,
   e_GeometryEx,
   e_Class;


{ TGis_NoteInterpret }

function TGis_NoteInterpret.CanUniGoInside(Element: TElement): boolean;
begin
   result := false;
end;

destructor TGis_NoteInterpret.Destroy;
begin
   if fBM <> nil then
      fBM.Free;
   inherited;
end;

function TGis_NoteInterpret.IsItsClass(AObject: TObject): boolean;
begin
   result := AObject is Tgis_Note;
end;

procedure TGis_NoteInterpret.Process(Element: TElement);
var
   aNote: Tgis_Note;
   lX,lY: integer;
begin
   aNote := Tgis_Note(Element);
   lX := Device.Projection.GetPageX(aNote.X);
   lY := Device.Projection.GetPageY(aNote.Y);
   Device.DrawDevice(lx - fbm.Graphic.Width div 2,ly - fbm.Graphic.Height,fbm.Graphic);
end;

function TGis_NoteInterpret.QGoInside(Element: TElement): boolean;
begin
  Result:= false;
end;

function TGis_NoteInterpret.QProcessBefore(Element: TElement): boolean;
begin
  result:= false;
  if not (Element is Tgis_Note) then exit;
  try
    if not Tgis_Note(Element).IsInsideRegion
            (Rect.MinX,Rect.MinY,Rect.MaxX,Rect.MaxY) then exit;
    Result:= true
  except
  end;
end;

procedure TGis_NoteInterpret.Reset(aDevice: TDevice);
var
   aBakule: string;
begin
   inherited Reset(aDevice);
   if fBM = nil  then
   begin
      if fnf then exit;
      aBakule := GetAbsolutePath('Bakule.png');
      if not FileExists(aBakule) then
      begin
         fnf := true;
         exit;
      end;
      fBM := TPicture.Create;
      fBM.LoadFromFile(aBakule);
   end;
end;

INITIALIZATION
   RegisterOrbisClass(TGIs_NoteInterpret);
END.
