unit t_ExchangeElementClass;

interface
uses
   Elements,
   Tools ;
type

TExchangeElementClass = Class(TResultTool)
  private
    FSrcClassName: string;
    FDstClassName: string;
    FSrcClass: TElementClass;
    FDstClass: TElementClass;
    procedure SetDstClass(const Value: TElementClass);
    procedure SetDstClassName(const Value: string);
    procedure SetSrcClass(const Value: TElementClass);
    procedure SetSrcClassName(const Value: string);
public
   function  NumberToPropertyName(aNumber: longInt): string; override;
   procedure DoIt; override;
   property  SrcClass: TElementClass read FSrcClass write SetSrcClass;
   property  DstClass: TElementClass read FDstClass write SetDstClass;
published
   property SrcClassName: string read FSrcClassName write SetSrcClassName;
   property DstClassName: string read FDstClassName write SetDstClassName;
end;

implementation
uses
   e_Class;

{ TExchangeElementClass }

procedure TExchangeElementClass.DoIt;
var
   E,NE: TElement;
   En,NEn,Ow: TEntity;
   i,ix: integer;
begin
   result := 'I';
   if Input = nil then exit;
   E := Input;
   result := 'S';
   if SrcClass = nil then exit;
   if not (E is SrcClass) then exit;
   result := 'D';
   IF DstClass = nil then exit;
   // Create dest element
   NE := DstClass.Create;
   // solve owners
   if E.OwnersCount > 0 then
   for i := 0 to E.OwnersCount - 1 do
   begin
      Ow := E.Owners[i];
      ix := Ow.IndexOf(E);
      Ow.InsertElement(ix,NE);
      Ow.RemoveElement(E);
   end;
   // solve elements
   if (E is TEntity) and (NE is TEntity) then
   begin
      En := TEntity(E);
      NEN := TEntity(NE);
      NEN.AddAllFrom := En;
   end;
   NE.Name := E.Name;
   E.Free;
end;

function TExchangeElementClass.NumberToPropertyName(aNumber: Integer): string;
begin
   case aNumber of
      0: result := 'SrcClassName';
      1: result := 'DstClassName';
   end;
end;

procedure TExchangeElementClass.SetDstClass(const Value: TElementClass);
begin
  FDstClass := Value;
end;

procedure TExchangeElementClass.SetDstClassName(const Value: string);
begin
  FDstClassName := Value;
  DstClass := OrbisClasses.FindClass(Value);
end;

procedure TExchangeElementClass.SetSrcClass(const Value: TElementClass);
begin
  FSrcClass := Value;
end;

procedure TExchangeElementClass.SetSrcClassName(const Value: string);
begin
  FSrcClassName := Value;
  SrcClass := OrbisClasses.FindClass(Value);
end;

INITIALIZATION
   RegisterOrbisClass(TExchangeElementClass);
END.
