unit t_PrepareSymbols;

interface
uses
   Classes,
   ComCtrls,
   e_PlZn,
   Tools;

type

TPrepareARESymbols = class(TTool)
private
   PlosneZnacky: TPlosneZnacky;
protected
   procedure CreatePlosneZnacky;
   procedure FreePlosneZnacky;
public
   procedure FillARESymbolsList(const aList: TStrings);
   procedure FillComboBoxEx(aCombo: TComboBoxEx; aList: TStrings;ImageWidth,ImageHeight: integer);
end;

implementation
uses
   Forms,
   Graphics,
   ImgList,
   SysUtils,
   e_Device,
   e_Geometry,
   e_LHCElements,
   i_LHCElements,
   u_Symbol;

{ TPrepareARESymbols }

procedure TPrepareARESymbols.CreatePlosneZnacky;
begin
   PlosneZnacky := TPlosneZnacky.CreateAll(PathOfLibraries+'\Srafy.txt');
end;

procedure TPrepareARESymbols.FillARESymbolsList(const aList: TStrings);
begin
   CreatePlosneZnacky;
   PlosneZnacky.VratListKodu(aList);
   FreePlosneZnacky;
end;

procedure TPrepareARESymbols.FillComboBoxEx(aCombo: TComboBoxEx;
  aList: TStrings; ImageWidth, ImageHeight: integer);
var
   Images: TCustomImageList;
   Bitmap: TBitmap;
   Item: TComboExItem;
   IP: Tgis_UserAreaElementInterpret;
   Are: TAreaElement;
   UA: Tgis_UserAreaElement;
   D: TBitmapDevice;
   i: integer;
   SZnacka: string;
   Znacka: integer;
begin
   aCombo.ItemsEx.Clear;
   if aCombo.Images = nil then exit;
   Images := aCombo.Images;
   Images.Clear;
   if aList = nil then exit;
   if aList.Count = 0 then exit;
   Images.Width := ImageWidth;
   Images.Height := ImageHeight;

   Bitmap := TBitmap.Create;
   Bitmap.Width := ImageWidth;
   Bitmap.Height := ImageHeight;
   Bitmap.Canvas.Brush.Style := bsSolid;

   Bitmap.Canvas.Brush.Color := 0;
   Bitmap.Canvas.Rectangle(0,0,ImageWidth,ImageHeight);
   Images.Add(Bitmap,nil);
   aCombo.ItemsEx.AddItem('1',0,0,-1,0,nil);

   D := TBitmapDevice.Create;
   D.Bitmap := Bitmap;
   D.Projection.Scale := 15000;
   D.Projection.VirtualScale := 5000;
   Are := TAreaElement.Create;
   Are.AddXY(D.Projection.CLipModelView.MinX,D.Projection.CLipModelView.MinY);
   Are.AddXY(D.Projection.CLipModelView.MaxX,D.Projection.CLipModelView.MinY);
   Are.AddXY(D.Projection.CLipModelView.MaxX,D.Projection.CLipModelView.MaxY);
   Are.AddXY(D.Projection.CLipModelView.MinX,D.Projection.CLipModelView.MaxY);
   Are.Update;
   Are.AbsRefX := Are.CenterX;
   Are.AbsRefY := Are.CenterY;
   UA := Tgis_UserAreaElement.Create;
   UA.Geometry := Are;
   IP := Tgis_UserAreaElementInterpret.Create;
   IP.Input := UA;
   D.Page.Color := $F0F0F0;
   IP.Reset(D);
   IP.ReadAllSymbols;
   StartProgress('Prepare Symbols',0,aList.Count - 1);
   aCombo.ItemsEx.BeginUpdate;
   for i := 0 to aList.Count - 1 do
   begin
      Progress := i;
      ProgressText := SZnacka;
      Application.ProcessMessages;
      SZnacka := aList.Strings[i];
      Znacka := StrToIntDef(SZnacka,1);
      UA.Znacka := Znacka;
      D.Clear;
      IP.DoIt;
      Images.Add(Bitmap,nil);
      aCombo.ItemsEx.AddItem(SZnacka,i+1,i+1,-1,0,nil);
   end;
   aCombo.ItemsEx.EndUpdate;
   aCombo.ItemIndex := 0;
   IP.Close;
   IP.Free;
   UA.Free;
   Bitmap.Free;
end;

procedure TPrepareARESymbols.FreePlosneZnacky;
begin
   if PlosneZnacky <> nil then
      PlosneZnacky.Free;
   PlosneZnacky := nil;
end;

INITIALIZATION

END.

