unit e_VersionInfo;

interface
uses
   Elements;

type

TVersionInfoElement = class(TOwnerElement)
  private
    FMajorVersion: integer;
    FMinorVersion: integer;
    procedure SetMajorVersion(const Value: integer);
    procedure SetMinorVersion(const Value: integer);
    function GetVersionString: string;
published
   property MajorVersion: integer read FMajorVersion write SetMajorVersion;
   property MinorVersion: integer read FMinorVersion write SetMinorVersion;
   property VersionString: string read GetVersionString stored false;
end;

implementation
uses
   SysUtils,
   e_Class;

{ TVersionInfoElement }

function TVersionInfoElement.GetVersionString: string;
begin
   result := IntToStr(MajorVersion)+'.'+IntToStr(MinorVersion);
end;

procedure TVersionInfoElement.SetMajorVersion(const Value: integer);
begin
  FMajorVersion := Value;
end;

procedure TVersionInfoElement.SetMinorVersion(const Value: integer);
begin
  FMinorVersion := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TVersionInfoElement);
END.
