unit F_topimp;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Buttons, Grids, Outline, FileCtrl;

type
  TBlockSelectDLG = class(TForm)
    DirectoryDlg: TDirectoryListBox;
    Drive: TDriveComboBox;
    Outline: TOutline;
    bt_Pridat: TBitBtn;
    bt_Ubrat: TBitBtn;
    Panel1: TPanel;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Panel3: TPanel;
    ed_Knihovny: TEdit;
    BitBtn3: TBitBtn;
    ROutline: TOutline;
    Panel4: TPanel;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    RasFiles: TFileListBox;
    Panel5: TPanel;
    BitBtn6: TBitBtn;
    procedure bt_PridatClick(Sender: TObject);
    procedure bt_UbratClick(Sender: TObject);
    procedure DirectoryDlgDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure OutlineDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure DirectoryDlgDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure OutlineDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure BitBtn3Click(Sender: TObject);
    procedure ed_KnihovnyDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure ROutlineDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure RasFilesDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure ROutlineDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure BitBtn6DragDrop(Sender, Source: TObject; X, Y: Integer);
  private
    procedure SetLibrary;
    function  GetActualDir: string;
    procedure AddBlock;
    procedure RemoveBlock;
    procedure AddRaster;
    procedure RemoveRaster;
    function  BlockValid(s: string): boolean;
    function  GetDirectory: string;
    procedure SetDirectory(aVal: string);
  published
    property Directory: string read GetDirectory write SetDirectory;
  end;


implementation

{$R *.DFM}


procedure TBlockSelectDLG.SetLibrary;
var
   s: string;
begin
   s:= GetActualDir;
   ed_Knihovny.Text := s;
end;


procedure TBlockSelectDLG.AddBlock;
var
   s: string;
begin
   s:= GetActualDir;
   if BlockValid(s) then Outline.Add(0, s)
   else MessageDlg(s + ' nen plnohodnotn blok TopoLu', mtInformation, [mbOK], 0);
end;



procedure TBlockSelectDLG.RemoveBlock;
begin
   Outline.Lines.Delete(OutLine.SelectedItem -1);
end;


procedure TBlockSelectDLG.AddRaster;
var
   s: string;
begin
   s:= RasFiles.FileName;
   ROutline.Add(0, s)
end;



procedure TBlockSelectDLG.RemoveRaster;
begin
   ROutline.Lines.Delete(ROutLine.SelectedItem -1);
end;



function  TBlockSelectDLG.BlockValid(s: string): boolean;
begin
   result := false;
   if UpperCase(ExtractFileExt(s)) <> '.BLK' then exit;
   result := true;
end;






function  TBlockSelectDLG.GetActualDir: string;
var
   i: longInt;
begin
   result := '';
   i := DirectoryDLG.ItemIndex;
   if i < 0 then exit;
   result := (DirectoryDlg.GetItemPath(i));
end;


procedure TBlockSelectDLG.bt_PridatClick(Sender: TObject);
begin
   AddBlock;
end;

procedure TBlockSelectDLG.bt_UbratClick(Sender: TObject);
begin
   RemoveBlock;
end;

procedure TBlockSelectDLG.DirectoryDlgDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
   if (Source = Outline) and (Sender = DirectoryDlg)then
   begin
      RemoveBlock;
   end;
end;

procedure TBlockSelectDLG.OutlineDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
   if (Source = DirectoryDlg) and (Sender = Outline)then
   begin
      AddBlock;
   end
   else
   if Source = Sender then
   begin
      Outline.SelectedItem := Outline.GetItem(x, y);
   end;
end;

procedure TBlockSelectDLG.DirectoryDlgDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
   Accept := true;
end;

procedure TBlockSelectDLG.OutlineDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
   Accept := (Source = DirectoryDlg) or (Source = Outline);
end;

procedure TBlockSelectDLG.BitBtn3Click(Sender: TObject);
begin
   SetLibrary;
end;

procedure TBlockSelectDLG.ed_KnihovnyDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
   if (Source = DirectoryDlg) and (Sender = ed_Knihovny) then
   begin
       SetLibrary;
   end;
end;

procedure TBlockSelectDLG.ROutlineDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
   Accept := (Source = RasFiles) or (Source = ROutline);
end;

procedure TBlockSelectDLG.RasFilesDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
   Accept := true;
end;

procedure TBlockSelectDLG.ROutlineDragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
   if (Source = RasFiles) and (Sender = ROutline)then
   begin
      AddRaster;
   end
   else
   if Source = Sender then
   begin
      ROutline.SelectedItem := ROutline.GetItem(x, y);
   end;
end;

procedure TBlockSelectDLG.BitBtn4Click(Sender: TObject);
begin
  AddRaster;
end;

procedure TBlockSelectDLG.BitBtn5Click(Sender: TObject);
begin
   RemoveRaster;
end;

procedure TBlockSelectDLG.BitBtn6DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
   Accept := (Source = Outline) or (Source = ROutline);
end;

procedure TBlockSelectDLG.BitBtn6DragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
   if Source = Outline  then RemoveBlock else
   if Source = ROutline then RemoveRaster;
end;



function  TBlockSelectDLG.GetDirectory: string;
begin
  result:= '';
  try
    result:= DirectoryDLG.Directory;
  except
  end;
end;


procedure TBlockSelectDLG.SetDirectory(aVal: string);
begin
  if not DirectoryExists(aVal) then exit;
  DirectoryDLG.Directory:= aVal;
end;



end.
