unit F_wview;

{
[Unit_Description]
Description=Formul prohlee svta
Commen=bude pekopno do 32 bitov verze
Admin=Petr
TechTopic=Form
Topic=Zobrazen svta
Version=1.0

[Edit]
 8.8.1997 20:03=Registrace
}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,
  Elements, Grids, Menus,

  C_wView,
  Tools, StdCtrls, Buttons, ExtCtrls,
  f_ViewDt,
  f_Watch,
  F_EEDt;


type
  Tf_WorldView = class(TForm)
    Outline: TWorldOutline;
    PopUpMenu: TPopupMenu;
    Vlastnosti1: TMenuItem;
    Prohlejelement1: TMenuItem;
    Zruobjekt1: TMenuItem;
    NovEntita1: TMenuItem;
    Zobraz: TMenuItem;
    DragPopupMenu: TPopupMenu;
    Presun: TMenuItem;
    Koprovat1: TMenuItem;
    Vytvoitzstupce1: TMenuItem;
    Vytvoitzdezstupce1: TMenuItem;
    Pejmenovat1: TMenuItem;
    NovaUroven: TMenuItem;
    N1: TMenuItem;
    Stono1: TMenuItem;
    Panel1: TPanel;
    b_Corb: TBitBtn;
    b_View: TBitBtn;
    Eval1: TMenuItem;
    Novdatabzovobjekt1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    Vyber: TMenuItem;
    Save1: TMenuItem;
    N4: TMenuItem;
    Load1: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    Panel: TPanel;
    Info: TLabel;
    BitBtn1: TBitBtn;
    Prohlejvlastnky1: TMenuItem;
    procedure Prohlejelement1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Zruobjekt1Click(Sender: TObject);
    procedure NovEntita1Click(Sender: TObject);
    procedure ZobrazClick(Sender: TObject);
    procedure OutlineMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OutlineDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure PresunClick(Sender: TObject);
    procedure NovaUrovenClick(Sender: TObject);
    procedure Vlastnosti1Click(Sender: TObject);
    procedure Pejmenovat1Click(Sender: TObject);
    procedure ZastupceClick(Sender: TObject);
    procedure OutlineMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure b_CorbDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure b_CorbDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure b_ViewDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure b_CorbClick(Sender: TObject);
    procedure Eval1Click(Sender: TObject);
    procedure Novdatabzovobjekt1Click(Sender: TObject);
    procedure VyberClick(Sender: TObject);
    procedure b_ViewClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Save1Click(Sender: TObject);
    procedure Load1Click(Sender: TObject);
    procedure InfoClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Prohlejvlastnky1Click(Sender: TObject);
  private
     FShowOwners: boolean;
  protected
     FDragButton: TMouseButton;
     FDestIndex: longInt;
     FDragObject: TObject;
  public
     P: WinTypes.TPoint;
     Tool: TTool;
     W: TWatchForm;
     procedure ExpandElement(aIndex: longInt; aElement: TElement);
     procedure CollapseElement(aIndex: longInt; aElement: TElement);
     procedure SetFirstElement(aElement: TElement);
     procedure NewViewer(aShowElements: boolean);
     procedure NewEntity;
     procedure DeleteElement;

     property  DragButton: TMouseButton read FDragButton write FDragButton;
     property  DragObject: TObject read FDragObject write FDragObject;
     property  DestIndex: longInt read FDestIndex write FDestIndex;
  published
     property ShowOwners: boolean read FShowOwners write FShowOwners;
  end;


implementation
{$R *.DFM}

uses
   F_CMDLn,
   F_STD,
   f_WCoord,
   e_TopMDL,
   m_Orbis,
   e_BGIF,
   e_Class,
   e_Desktp,
   g_Elems,
   i_Desktp,
   i_TopoL,
   i_Top_t,
   f_Names,
   f_NewEl,
   t_EdiPro,
   t_CoView,
   t_InterA,
   t_Loader,
   t_Mttt,
   t_WView,
   {!t_Main,}
   t_Recurs,
   t_Saver,
   i_Files, e_Files,
   Worlds,
   E_DClass,
   F_NewDB,
   u_Help;

{$IFDEF TiskDLL}
{$i \orbis\db\TiskDll.inc}
{$ENDIF}

procedure TF_WorldView.ExpandElement(aIndex: longInt; aElement: TElement);
var
   E: TEntity;
   EE: TElement;
   i: longInt;
   ii: longInt;
begin
   if not Assigned(aElement) then exit;
   if not(aElement is TEntity) then exit;
   E := TEntity(aElement);
   Outline.Cursor := crHourGlass;
   ii := 0;
   Outline.BeginUpdate;
   if E.Count > 0 then
   for i := 0 to E.Count - 1 do
   begin
      EE := E.Elements[i];
      OutLine.AddChildObject(aIndex, EE.Name, EE);
      inc(ii);
      if ii > 100 then
      begin
         ii := 0;
         Application.ProcessMessages;
      end;
   end;
   Outline.EndUpdate;
   Outline.Cursor := crDefault;
end;

procedure TF_WorldView.CollapseElement(aIndex: longInt; aElement: TElement);
var
   i,ii: longInt;
   delIndex: longInt;
begin
   (*
   if not Assigned(aElement) then exit;
   if not(aElement is TEntity) then exit;
   Outline.Cursor := crHourGlass;
   Outline.BeginUpdate;
   ii := 0;
   for i := Outline.Items[aIndex].GetFirstChild to Outline.Items[aIndex].GetLastChild do
   begin
       Outline.Items[i].Free;
   end;
   {
   repeat
      delIndex := Outline.Items[aIndex].GetFirstChild;
      if delIndex <> -1 then Outline.Items[delIndex].Free;
      inc(ii);
      if ii > 100 then
      begin
         ii := 0;
         Application.ProcessMessages;
      end;
   until delIndex = -1;
   }
   Outline.EndUpdate;
   Outline.Cursor := crDefault;
   *)
end;


procedure TF_WorldView.SetFirstElement(aElement: TElement);
begin
  if aElement = nil then exit;
  OutLine.ShowOwners:= ShowOwners;
  OutLine.AddObject(0, aElement.Name, aElement)
end;


procedure TF_WorldView.NewViewer(aShowElements: boolean);
var
   aTool: TTool;
begin
   aTool:= TTechnology(World.MainTool).AddTool(TWorldView.Create);
   if assigned(aTool) then
   begin
     TWorldView(aTool).ShowOwners:= not aShowElements;
     aTool.Input:= TElement(Outline.Items[Outline.SelectedItem].Data);
     aTool.DoIt;
   end;
end;


procedure TF_WorldView.NewEntity;
var
   E: TElement;
   Ent: TEntity;
   Dlg: TNewElementDlg;
   C: TElementClass;
   T: TModelTreeToListTool;
begin
   Ent := TEntity(Outline.Items[Outline.SelectedItem].Data);
   if not (Ent is TEntity) then
   begin
      ShowMessage('Vybran objekt nen entita !');
      exit;
   end;
   Application.CreateForm(TNewElementDlg, Dlg);
   T := TModelTreeToListTool.Create;
   T.Input := World.ObjectClasses;
   T.Sorted := true;
   T.DoIt;
   Dlg.ed_Class.Items := T.List;
   T.Free;
   Dlg.ed_Name.Text := 'No name';
   if Dlg.ShowModal = mrOK then
   begin
      try
         C := GetOrbisClass(Dlg.ed_Class.Text);
         E := C.Create;
         E.Name := Dlg.ed_Name.Text;
      except
         ShowMessage('Chybn nzev objektov tdy !');
         Dlg.Free;
         exit;
      end;
   end
   else
   begin
      Dlg.Free;
      exit;
   end;
   Ent.AddElement(E);
   Outline.Items[Outline.SelectedItem].Collapse;
   Outline.Items[Outline.SelectedItem].Expand;
   Dlg.Free;
end;


procedure TF_WorldView.DeleteElement;
var
   aTool: TTool;
   Element: TElement;
   index: longInt;
   Owner: TEntity;
begin
   if MessageDLG('Opravdu zruit vybran objekt ?', mtConfirmation, [mbYes, mbNo],0) = mrYes then
   begin
      index := Outline.SelectedItem;
      Owner := TEntity(Outline.Items[Outline.SelectedItem].Parent.Data);
      Element := TElement(Outline.Items[index].Data);
      Owner.FreeElement(Element);
      Outline.Items[index].Free;
   end;
end;



procedure Tf_WorldView.Prohlejelement1Click(Sender: TObject);
begin
   NewViewer(true);
end;

procedure Tf_WorldView.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   Tool.PostMsg(tm_QuitTask, Tool, nil, DontKill);
   CanClose := true;
   if W <> nil then
   try
      W.Free;
   except
   end;
end;

procedure Tf_WorldView.Zruobjekt1Click(Sender: TObject);
begin
   DeleteElement;
end;

procedure Tf_WorldView.NovEntita1Click(Sender: TObject);
begin
   NewEntity;
end;


procedure Tf_WorldView.ZobrazClick(Sender: TObject);
var
   Element: TElement;
   Tool: TFormToolManager;

   ViewData : TF_ViewData;
   EEData : TF_EEData;

   PocetPoli,i,Index : LongInt;
   aAdress : string;

   MyElement : TVirtualElement;
begin
   {Rodl absolutnch index v Outline}
   Index := Outline.SelectedItem - (Outline.Items[Outline.SelectedItem].Parent.GetFirstChild);
   Element:= TElement(Outline.Items[Outline.SelectedItem].Data);


   if (Element is TDatabaseClass) then
     begin
       ViewData := TF_ViewData.Create(Self);
       ViewData.DBGrid1.DataSource := (Element as TDatabaseClass).DSData;
       ViewData.Show;
       exit;
     end;

{    if (Element is TVirtualElement) then
      begin
        EEData := TF_EEData.Create(Application);
        PocetPoli := (Element as TVirtualElement).PropertyCount;
        EEData.SG.ColCount := PocetPoli;
        aAdress := (Element as TVirtualElement).ElementAdress;
        for i := 0 to PocetPoli - 1 do
          begin
            EEData.SG.Cells[i,0] := (Element as TVirtualElement).PropertyName[i];
            EEData.SG.Cells[i,1] := (Element as TVirtualElement).GetPropertyStringByIndex(i);
          end;
        EEData.ShowModal;
        exit;
      end;}

    if (Element is TVirtualElement) then
      begin
        if MyElement = nil then MyElement := TVirtualElement.Create;
        MyElement := (Element as TVirtualElement).ElementClass.Get(Index) as TVirtualElement;

        EEData := TF_EEData.Create(Application);
        PocetPoli := MyElement.PropertyCount;
        EEData.SG.ColCount := PocetPoli;
        aAdress := MyElement.ElementAdress;
        for i := 0 to PocetPoli - 1 do
          begin
            EEData.SG.Cells[i,0] := MyElement.PropertyName[i];
            EEData.SG.Cells[i,1] := MyElement.GetPropertyStringByIndex(i);
          end;
        EEData.ShowModal;
        exit;
      end;

   Tool := TFormToolManager.Create;
   Tool.Input := Element;
   Tool.Device.Page.Color := clWhite;
   World.MainTool.AddTool(Tool);
   Tool.DoIt;
end;

procedure Tf_WorldView.OutlineMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   P: Wintypes.TPoint;
   Item: longInt;
begin
   DragObject := Outline;
   DragButton := Button;
   Item := Outline.GetItem(x,y);
   {
   if Outline.Items[Item].IsInClassTree(TObjectModel)then
   }
   begin
      Outline.SelectedItem := Item;
      Outline.BeginDrag(false);
   end
   {
   else
   begin
      P := ClientToScreen(Point(x,y));
      if Button = mbRight then PopUpMenu.PopUp(P.x,P.y);
   end;
   }
end;

procedure Tf_WorldView.OutlineDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
var
   NodeIndex: longInt;
   Node: TOutlineNode;
begin
   Accept := false;
   try
      if not (Source is TWorldOutline) then exit;
      if (Tf_WorldView(TWorldOutline(Source).Owner).DragObject <> Outline) and
         (Sender <> Source) then
         Tf_WorldView(TWorldOutline(Source).Owner).DragObject := Outline;
      if Sender <> Source then Outline.SelectedItem := Outline.GetItem(x,y);
      Accept := true;
   except
   end;
end;


procedure Tf_WorldView.PresunClick(Sender: TObject);
var
   Element: TElement;
   SourceNode: TOutlineNode;
   DestNode: TOutlineNode;
   SourceIndex: longInt;
   Owner: TEntity;
begin
   SourceIndex := Outline.SelectedItem;
   SourceNode  := Outline.Items[SourceIndex];
   DestNode    := Outline.Items[DestIndex];
   Element := TElement(SourceNode.Data);
   Owner := TEntity(SourceNode.Parent.Data);
   Owner.RemoveElement(Element);
   try
      if NovaUroven.Checked then SourceNode.MoveTo(DestIndex, oaAddChild)
                            else SourceNode.MoveTo(DestIndex, oaInsert);
   finally
      Owner := TEntity(SourceNode.Parent.Data);
      DestIndex := Owner.IndexOf(TElement(DestNode.Data));
      if NovaUroven.Checked or (DestIndex = -1) then Owner.AddElement(Element)
                                                else Owner.InsertElement(DestIndex, Element);
   end;
   Outline.SelectedItem := SourceNode.Index;
end;

procedure Tf_WorldView.NovaUrovenClick(Sender: TObject);
begin
   NovaUroven.Checked := not NovaUroven.Checked;
   DragPopUpMenu.PopUp(P.x,P.y) ;
end;

procedure Tf_WorldView.Vlastnosti1Click(Sender: TObject);
var
   Element: TElement;
   Editor:  TObjectPropertyEditor;

   Index : LongInt;
begin
   {Rodl absolutnch index v Outline}
   Index := Outline.SelectedItem - (Outline.Items[Outline.SelectedItem].Parent.GetFirstChild);
   Element:= TElement(Outline.Items[Outline.SelectedItem].Data);

   if Element is TVirtualElement then
     Element := (Element as TVirtualElement).ElementClass.Get(Index) as TVirtualElement;

   if Element is TPersistent then
   begin
     Editor:= TObjectPropertyEditor.Create;
     Editor.Input:= Element;
     Editor.DoIt;
   end;
end;


procedure Tf_WorldView.Pejmenovat1Click(Sender: TObject);
var
   Element: TElement;
begin
   Element:= TElement(Outline.Items[Outline.SelectedItem].Data);
   f_Name.ed_Name.Text := Element.Name;
   if f_Name.ShowModal = mrOK then
   begin
      Element.Name := f_Name.ed_Name.Text;
      Outline.Items[Outline.SelectedItem].Text := f_Name.ed_Name.Text;
   end;
end;


procedure Tf_WorldView.ZastupceClick(Sender: TObject);
var
   Element: TElement;
   SourceNode: TOutlineNode;
   DestNode: TOutlineNode;
   SourceIndex: longInt;
   Owner: TEntity;
   OOwner: TEntity;
begin
   SourceIndex := Outline.SelectedItem;
   SourceNode  := Outline.Items[SourceIndex];
   DestNode    := Outline.Items[DestIndex];
   Element := TElement(SourceNode.Data);
   Owner := TEntity(DestNode.Data);
   OOwner := TEntity(DestNode.Parent.Data);
   try
      if not (OOwner is TEntity) then exit;
      DestIndex := OOwner.IndexOf(Owner);
      if NovaUroven.Checked or (DestIndex = -1) then
      begin
         if not (Owner is TEntity) then exit;
         Owner.AddElement(Element)
      end
      else
      begin
         OOwner.InsertElement(DestIndex, Element);
      end;
   except
   end;

   Outline.SelectedItem := SourceNode.Index;
   Outline.Refresh;
end;




procedure Tf_WorldView.OutlineMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   Node: TOutlineNode;
   Other: boolean;
   Outl: TWorldOutline;
   P1: WinTypes.TPoint;
   Tool: TTool;
begin
   Outline.EndDrag(true);
   try
      P := Outline.ClientToScreen(Point(x,y));
      Other := DragObject <> Outline;
      if Other then
      begin
         Outl := TWorldoutline(DragObject);
         P1   := Outl.ScreenToClient(P);
         DestIndex := Outl.GetItem(P1.x,P1.y);
         Node   := Outl.Items[DestIndex];
         Outl.SelectedItem := DestIndex;
         if TElement(Outl.Items[Outl.SelectedItem].Data) is TTool then
         begin
            Tool := TTool(Outl.Items[Outl.SelectedItem].Data);
            Tool.Input := TElement(Outline.Items[Outline.SelectedItem].Data);
            Tool.DoIt;
            World.ObjectModel.AddElement(Tool.Output);
         end;
      end
      else
      begin
         DestIndex := Outline.GetItem(x,y);
         Node   := Outline.Items[DestIndex];
         if not (Outline.SelectedItem = DestIndex) then
         begin
            if Button = mbRight then DragPopUpMenu.PopUp(P.x,P.y)
            else
            begin
               NovaUroven.Checked := false;
               PresunClick(nil);
            end;
         end
         else
            if Button = mbRight then PopUpMenu.PopUp(P.x,P.y);
       end;
    except
    end;
end;

procedure Tf_WorldView.b_CorbDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
   Accept := Source = Outline;
end;

procedure Tf_WorldView.b_CorbDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
   aTool: TTool;
   Element: TElement;
   index: longInt;
   Owner: TEntity;
begin
   if not (Source = Outline )then exit;
   index := Outline.SelectedItem;
   Owner := TEntity(Outline.Items[Outline.SelectedItem].Parent.Data);
   Element := TElement(Outline.Items[index].Data);
   Owner.RemoveElement(Element);
   TWorldView(Tool).Corb.AddElement(Element);
   Outline.Items[index].Free;
end;

procedure Tf_WorldView.b_ViewDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
   aTool: TTool;
   Element: TElement;
   index: longInt;
   Owner: TEntity;
begin
   if not (Source = Outline )then exit;
   ZobrazClick(nil);
end;

procedure Tf_WorldView.b_CorbClick(Sender: TObject);
var
   aTool: TTool;
begin
   aTool:= TTechnology(World.MainTool).AddTool(TWorldView.Create);
   if assigned(aTool) then
   begin
      aTool.Input:= TWorldView(Tool).Corb;
      aTool.DoIt;
   end;
end;


procedure Tf_WorldView.Eval1Click(Sender: TObject);
var
   CMD: TCommandLineDlg;
begin
   Application.CreateForm(TCommandLineDlg, CMD);
   CMD.E := TElement(Outline.Items[Outline.SelectedItem].Data);
   {
   CMD.ShowModal;
   CMD.Free;
   }
end;

procedure Tf_WorldView.Novdatabzovobjekt1Click(Sender: TObject);
var
   Entity: TDatabaseClass;
   F_DB : TF_DB;
   i : LongInt;
   E : TVirtualElement;
begin
   F_DB := TF_DB.Create(Self);
   if F_DB.ShowModal = mrOK then
   begin
      Entity:= TDatabaseClass.Create;
      Entity.Name := F_DB.ed_Name.Text;
      Entity.DataSourcePath := F_DB.CB_Path.Text;
      Entity.DataSourceType := F_NewDB.FDSType;

      if F_NewDB.FDSType = dstTable then
        begin
          Entity.DataSource := F_DB.CB_FileDS.Text;
          Entity.NameField := F_DB.CB_NameField.Text;

          F_DB.Table.IndexDefs.Update;
          {Udlat z toho funkci a dt ji do F_NewDB}
          for i := 0 to F_DB.Table.IndexDefs.Count - 1 do
            if F_DB.Table.IndexDefs.Items[i].Name = F_DB.Table.IndexName then
               Entity.AdressField := F_DB.Table.IndexDefs.Items[i].Fields;
        end;

      if F_NewDB.FDSType = dstText then
        begin
          Entity.DataSource := F_DB.CB_FileDS.Text;
          Entity.NameField := F_DB.CB_NameField.Text;
          Entity.AdressField := F_DB.CB_AdressField.Text;
        end;

      if F_NewDB.FDSType = dstSQL then
        begin
          Entity.DataSource := F_DB.CB_FileDS.Text;
          Entity.NameField := F_DB.CB_NameField.Text;
          Entity.AdressField := F_DB.CB_AdressField.Text;
          Entity.DSSQL.LoadFromFile(F_DB.CB_FileDS.Text);
        end;

{$IFDEF TiskDLL}
      if F_NewDB.FDSType = dstSQLdef then
        begin
          Entity.DataSource := F_DB.CB_FileDS.Text;
          Entity.NameField := F_DB.CB_NameField.Text;
          Entity.AdressField := F_DB.CB_AdressField.Text;
          Entity.DSSQL.LoadFromFile(NactiDotaz('',F_DB.CB_FileDS.Text));
        end;
{$ENDIF}

      if F_NewDB.FDSType = dstQBE then
        begin
          Entity.DataSource := F_DB.CB_FileDS.Text;
          Entity.NameField := F_DB.CB_NameField.Text;
          Entity.AdressField := F_DB.CB_AdressField.Text;
          Entity.DSSQL.LoadFromFile(F_DB.CB_FileDS.Text);
        end;

   end else exit;
   TEntity(Outline.Items[Outline.SelectedItem].Data).AddElement(Entity);
   Outline.Items[Outline.SelectedItem].Collapse;
   Outline.Items[Outline.SelectedItem].Expand;
end;

procedure Tf_WorldView.VyberClick(Sender: TObject);
var  aTool: TCondView;
begin
    aTool:= TCondView(World.Maintool.AddTool(TCondView.Create));
    if assigned(aTool) then
    begin
      aTool.Input:=TElement(Outline.Items[Outline.SelectedItem].Data);
      aTool.DoIt
    end;
end;

procedure Tf_WorldView.b_ViewClick(Sender: TObject);
begin
   ZobrazClick(nil);
end;

procedure Tf_WorldView.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if Key = VK_F1 then
   begin
      if ActiveControl.Name = 'Outline' then
      begin
         OrbisP1HelpJump(TElement(Outline.Items[Outline.SelectedItem].Data));
      end;
   end;
end;

procedure Tf_WorldView.Save1Click(Sender: TObject);
var
   S: TStreamSaver;
begin
   if not SaveDialog.Execute then exit;
   SaveDialog.InitialDir := ExtractFilePath(SaveDialog.FileName);
   OpenDialog.InitialDir := SaveDialog.InitialDir;
   OpenDialog.FileName := SaveDialog.FileName;
   S := TStreamSaver.Create;
   S.Input := TElement(Outline.Items[Outline.SelectedItem].Data);
   S.FileName := ChangeFileExt(SaveDialog.FileName, '.ORB');
   S.DoIt;
   S.Free;
end;

procedure Tf_WorldView.Load1Click(Sender: TObject);
var
   S: TStreamLoader;
   E: TEntity;
begin
   E := TEntity(Outline.Items[Outline.SelectedItem].Data);
   if not (E is TEntity) then
   begin
      ShowMessage('Vybran objekt nen entita !');
      exit;
   end;
   if not OpenDialog.Execute then exit;
   OpenDialog.InitialDir := ExtractFilePath(OpenDialog.FileName);
   SaveDialog.InitialDir := OpenDialog.InitialDir;
   SaveDialog.FileName := OpenDialog.FileName;
   S := TStreamLoader.Create;
   S.FileName := OpenDialog.FileName;
   S.DoIt;
   E.AddElement(S.Output);
   S.Free;
   Outline.Items[Outline.SelectedItem].Collapse;
   Outline.Items[Outline.SelectedItem].Expand;
end;

procedure Tf_WorldView.InfoClick(Sender: TObject);
var
   E: TElement;
begin
   E := TElement(Outline.Items[Outline.SelectedItem].Data);
   if E = nil then Info.Caption := ' '
              else Info.Caption := E.Name + ' ('+ E.ClassName+')';
   if W <> nil then
   begin
      W.C.ActiveElement := E;
      W.Run;
   end;
end;

procedure Tf_WorldView.BitBtn1Click(Sender: TObject);
begin
   if W = nil then
   begin
      Application.CreateForm(TWatchForm,W);
      W.C.ActiveElement := TElement(Outline.Items[Outline.SelectedItem].Data);
   end
   else
   begin
      try
         W.Free;
         W := nil;
      except
      end;
   end;
end;

procedure Tf_WorldView.Prohlejvlastnky1Click(Sender: TObject);
begin
   NewViewer(false);
end;

end.
