unit D_txt;
{
[Unit_Description]
Description=Textov zazen
Admin=Petr
TechTopic=Devices
Topic=Zobrazen dat
Version=1.0

[Edit]
 8.6.1997 12:41=Registrace
}

interface

uses
  WinTypes,
  // KERNEL
  Elements,
  // DEVICE
  E_Device,
  f_StdTxt;

type

TTextFileDevice = class(TDevice)
private
  FTextFile: TextFile;
  function GetFileName: string;
  procedure SetFileName(aText: string);
  function IsOpen: boolean;
    procedure SetDoReset(const Value: boolean);
    procedure SetLnTx(const Value: string);
    procedure SetTx(const Value: string);
protected
    function GetHandle: HDC; override;
    procedure SetVisible(aVisible: boolean); override;
public
  constructor Create; override;
  destructor  Destroy; override;
  procedure Clear; override;
  procedure Reset; override;
  procedure Close; override;
  procedure Adjust; override;
  procedure SetupPage(Sender: TObject); override;

  procedure WriteText(aText: string); override;
  procedure WriteLnText(aText: string); override;
published
  property FileName: string read GetFileName write SetFileName;
  property DoReset: boolean write SetDoReset;
  property Tx: string write SetTx;
  property LnTx: string write SetLnTx;
end;

TMemoFormDevice = class(TDevice)
private
   FForm: TStdTxtForm;
   function GetLeft: integer;
   function GetTop: integer;
   function GetWidth: integer;
   function GetHeight: integer;
   function GetCaption: string;
   procedure SetLeft(aValue: integer);
   procedure SetTop(aValue: integer);
   procedure SetWidth(aValue: integer);
   procedure SetHeight(aValue: integer);
protected
   procedure SetVisible(aVisible: boolean); override;
   function GetTextColor: integer; override;
   procedure SetTextColor(const Value: integer); override;
   procedure SetCaption(aCaption: string); override;
public
   constructor Create; override;
   destructor  Destroy; override;
   procedure Clear; override;
   procedure Reset; override;
   procedure Close; override;
   procedure Adjust; override;
   procedure SetupPage(Sender: TObject); override;

   procedure WriteText(aText: string); override;
   procedure WriteLnText(aText: string); override;
   property  Form: TStdTxtForm read FForm;
published
   property Left: integer read GetLeft write SetLeft;
   property Top: integer read GetTop write SetTop;
   property Width: integer read GetWidth write SetWidth;
   property Height: integer read GetHeight write SetHeight;
   property Caption: string read GetCaption write SetCaption;
end;




implementation
{ SysUtils
fmClosed = $D7B0;
fmInput  = $D7B1;
fmOutput = $D7B2;
fmInOut  = $D7B3;
}

uses
  Classes,
  Dialogs,
  Forms,
  SysUtils,
  // KERNEL
  e_Class,
  m_Orbis;

  { TMemoFormDevice }

function TMemoFormDevice.GetLeft: integer;
begin
   result := -1;
   if Form <> nil then
   try
      result := Form.Left;
   except
   end;
end;

function TMemoFormDevice.GetTop: integer;
begin
   result := -1;
   if Form <> nil then
   try
      result := Form.Top;
   except
   end;
end;

function TMemoFormDevice.GetWidth: integer;
begin
   result := -1;
   if Form <> nil then
   try
      result := Form.Width;
   except
   end;
end;

function TMemoFormDevice.GetHeight: integer;
begin
   result := -1;
   if Form <> nil then
   try
      result := Form.Height;
   except
   end;
end;

function TMemoFormDevice.GetCaption: string;
begin
   if Form <> nil then
   try
      result := Form.Caption;
   except
   end;
end;

procedure TMemoFormDevice.SetLeft(aValue: integer);
begin
   if Form <> nil then
   try
      Form.Left := aValue;
   except
   end;
end;

procedure TMemoFormDevice.SetTop(aValue: integer);
begin
   if Form <> nil then
   try
      Form.Top := aValue;
   except
   end;
end;

procedure TMemoFormDevice.SetWidth(aValue: integer);
begin
   if Form <> nil then
   try
      Form.Width := aValue;
   except
   end;
end;

procedure TMemoFormDevice.SetHeight(aValue: integer);
begin
   if Form <> nil then
   try
      Form.Height := aValue;
   except
   end;
end;

procedure TMemoFormDevice.SetCaption(aCaption: string);
begin
   if Form <> nil then
   try
      Form.Caption := aCaption;
   except
   end;
end;



procedure TMemoFormDevice.SetVisible(aVisible: boolean);
begin
   if Form <> nil then
   try
      Form.Visible := aVisible;
   except
   end;
end;

constructor TMemoFormDevice.Create;
begin
   inherited Create;
   FForm:= TStdTxtForm.Create(Application);
   Form.FormStyle := fsStayOnTop;
   Form.Device := Self;
end;

destructor  TMemoFormDevice.Destroy;
begin
   try
      if not Form.Closed then Form.Device := nil;
   except
   end;
   PostMsg(tm_Done,nil,nil,DontKill);
   Application.ProcessMessages;
   inherited Destroy;
end;

procedure TMemoFormDevice.Clear;
begin
   if Form <> nil then
   try
      Form.RichEdit.Lines.Clear;
      Form.S := '';
   except
   end;
end;

procedure TMemoFormDevice.Reset;
begin
   if Form <> nil then
   try
      Form.StartWriting;
   except
   end;
end;

procedure TMemoFormDevice.Close;
begin
   if Form <> nil then
   try
      Form.EndOfWriting;
   except
   end;
end;

procedure TMemoFormDevice.Adjust;
begin
end;

procedure TMemoFormDevice.SetupPage(Sender: TObject);
begin
end;

procedure TMemoFormDevice.WriteText(aText: string);
begin
   if Form <> nil then Form.WriteText(aText);
end;


procedure TMemoFormDevice.WriteLnText(aText: string);
begin
   if Form <> nil then Form.WriteLnText(aText);
end;



function TMemoFormDevice.GetTextColor: integer;
begin
   result := 0;
   if Form <> nil then
      result := Form.TextColor;
end;

procedure TMemoFormDevice.SetTextColor(const Value: integer);
begin
   if Form <> nil then
   begin
      //Form.RichEdit.SelStart := Length(Form.RichEdit.Text)+1;
      //Form.RichEdit.SelAttributes.Color := Value;
      //WriteLnText('TextColor '+IntToStr(Value));
      if Value <> Form.TextColor then
         Form.TextColor := Value;
      //ShowMessage('Text Color '+IntToStr(Value));
      //Application.ProcessMessages;
   end;
end;

{ TTextFileDevice }

function TTextFileDevice.GetHandle: HDC;
begin
  result:= 0;
end;

procedure TTextFileDevice.SetVisible(aVisible: boolean);
begin
end;


constructor TTextFileDevice.Create;
begin
end;


destructor TTextFileDevice.Destroy;
begin
  //if IsOpen then
     CloseFile(FTextFile)
end;

procedure TTextFileDevice.Clear;
begin
end;

procedure TTextFileDevice.Reset;
begin
  system.Reset(FTextFile)
end;

procedure TTextFileDevice.Close;
begin
  CloseFile(FTextFile)
end;


procedure TTextFileDevice.Adjust;
begin
end;

procedure TTextFileDevice.SetupPage(Sender: TObject);
begin
end;




function TTextFileDevice.IsOpen: boolean;
begin
  result:= TTextRec(FTextFile).Mode = fmOutput;
end;



function TTextFileDevice.GetFileName: string;
begin
  if not IsOpen then exit;
  result:= TTextRec(FTextFile).Name;
end;

procedure TTextFileDevice.SetFileName(aText: string);
begin
  if IsOpen then
     closeFile(FTextFile);

  assignFile(FTextFile, aText);
  rewrite(FTextFile)
end;


procedure TTextFileDevice.WriteText(aText: string);
begin
  //if not IsOpen then exit;
  Write(FTextFile, aText)
end;


procedure TTextFileDevice.WriteLnText(aText: string);
begin
  //if not IsOpen then exit;
  WriteLn(FTextFile, aText)
end;



procedure TTextFileDevice.SetDoReset(const Value: boolean);
begin
   if Value then Reset;
end;

procedure TTextFileDevice.SetLnTx(const Value: string);
begin
   WriteLnText(Value);
end;

procedure TTextFileDevice.SetTx(const Value: string);
begin
   WriteText(Value);
end;

initialization
  RegisterOrbisClass(TTextFileDevice);
  RegisterOrbisClass(TMemoFormDevice);
end.

