unit E_inode;

interface

uses
// KERNEL
   e_Type,
   Elements,
// INTERPRET
   e_IModel;


type

TInterpretNode= class(TOwnerEntity)
private
   FDynamicModel: boolean;
   FDontInterpretModels: boolean;
   function  GetDataModel: TstringListElement;
   function  GetInterpretModel: TInterpretModelEntity;
   procedure SetDataModel(aValue: TstringListElement);
   procedure SetInterpretModel(aValue: TInterpretModelEntity);
published
   property DynamicModel: boolean read FDynamicModel write FDynamicModel stored true;
   property DataModel: TStringListElement read GetDataModel write SetDataModel stored false;
   property InterpretModel: TInterpretModelEntity read GetInterpretModel write SetInterpretModel stored false;
   property DontInterpretModels: boolean read FDontInterpretModels write FDontInterpretModels stored true;
end;

TInterpretNodeEntity = class(TOwnerEntity)
private
   FDynamicModel: boolean;
   FDontInterpretModels: boolean;
    FVersion: integer;
   function GetInterpretNode(aIndex: longInt): TInterpretNode;
   procedure SetDynamicModel(aValue: boolean);
    procedure SetVersion(const Value: integer);
public
   property InterpretNode[aIndex: longInt]: TInterpretNode read GetInterpretNode;
published
   property DynamicModel: boolean read FDynamicModel write SetDynamicModel stored true;
   property DontInterpretModels: boolean read FDontInterpretModels write FDontInterpretModels stored true;
   property Version: integer read FVersion write SetVersion;
end;



implementation

uses
   {!PubUnits,}
// KERNEL
   e_Class;

{ TInterpretNode }


function  TInterpretNode.GetDataModel: TstringListElement;
begin
   result := TStringListElement(FindElementClass(TStringListElement));
end;

function  TInterpretNode.GetInterpretModel: TInterpretModelEntity;
begin
   result := TInterpretModelEntity(FindElementClass(TInterpretModelEntity));
end;

procedure TInterpretNode.SetDataModel(aValue: TstringListElement);
var
   DM: TStringListElement;
begin
   DM := GetDataModel;
   if aValue = DM then exit;
   if DM <> nil then FreeElement(DM);
   AddElement(aValue);
end;

procedure TInterpretNode.SetInterpretModel(aValue: TInterpretModelEntity);
var
   IM: TInterpretModelEntity;
begin
   IM := GetInterpretModel;
   if aValue = IM then exit;
   if IM <> nil then FreeElement(IM);
   AddElement(aValue);
end;

{ TIntrepretNodeEntity }

procedure TInterpretNodeEntity.SetDynamicModel(aValue: boolean);
var
   i: longInt;
begin
   FDynamicModel := aValue;
   if not aValue then exit;
   if NoElements then exit;
   for i := 0 to LastIndex do InterpretNode[i].DynamicModel := aValue;
end;



function TInterpretNodeEntity.GetInterpretNode(aIndex: longInt): TInterpretNode;
begin
   result := TInterpretNode(Elements[aIndex]);
end;



procedure TInterpretNodeEntity.SetVersion(const Value: integer);
begin
   FVersion := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TInterpretNodeEntity);
   RegisterOrbisClass(TInterpretNode);
END.
