unit T_ExpTez;

interface
uses
// KERNEL
   Elements,
   Tools,
// SPACE
   e_Space;

type

TExportTez = class(TTool)
private
  FBlockName: string;
  FControlDIR: string;
  function DejDATAEntitu(aJm: string): TEntity;
  function ExtractTezbaAreas: TAreaString;
public
  procedure DoIt; override;
published
  property BlockName: string read FBlockName write FBlockName;
  property ControlDIR: string read FControlDIR write FControlDIR;
end;


implementation
uses
   Dialogs,
// KERNEL
   e_Class,
   worlds,
// GLIB
   G_Elems,
// TOPOL
   T_areare,
   T_ExArTL,
   T_CopBlk,
   E_TplPrp,
// 
   e_LHCProps;


function  TExportTez.DejDATAEntitu(aJm: string): TEntity;
var
  aDATA: TElement;
begin
  result:= nil;
  aDATA:= World.ObjectModel.findElementName('DATA');
  if not (aDATA is TEntity) then exit;
  aData:= TEntity(aDATA).FindElementName(aJm);
  if not (aDATA is TEntity) then exit;
  result:= TEntity(aData)
end;



function TExportTez.ExtractTezbaAreas: TAreaString;
var
  aTezba: TRectEntity;
  aTez: TRectEntity;
  I, J: integer;
  aPlochyTezby: TAreaString;
  aPlocha: TAreaElement;
begin
  Result:= nil;
  aTezba:= TRectEntity(DejDataEntitu('T̎BA'));
  if not (TObject(aTezba) is TRectEntity) then
     Exit;
  aPlochyTezby:= TAreaString.Create;

  for I:= aTezba.Count-1 downto 0 do
  begin
    aTez:= TRectEntity(aTezba.Elements[I]);
    if not (TObject(aTez) is TRectEntity) then
       continue;
    if aTez.Name <> 'T̎BA' then
       continue;
    for J:= 0 to aTez.Count-1 do
    begin
      aPlocha:= TAreaElement(aTez.Elements[J]);
      if not (TObject(aPlocha) is TAreaElement) then
         continue;
      aPlochyTezby.AddAndUpdateRect(aPlocha);
    end;
  end;
  Result:= aPlochyTezby
end;



procedure TExportTez.DoIt;
var
  aTez: TEntity;
//  MNAA: TMakeNodesAndAreas;
  MNAA: TMakeNodes;
  aPlochy: TAreaString;
  aPlocha: TAreaElement;
  aPlochaProp: TTopolAreaProps;
  aLines: TPolyLineString;
  aLine: TPolyLineElement;
  //CAAL: TCarryArToArThroughLines;
  ArExp: TExportAreasToTopol;
  I: integer;
  aLinProp: TTopolLineProps;
begin
  aTez:= DejDataEntitu('T̎BA');

  if aTez = nil then
     Exit;

  MNAA:= TMakeNodes.Create;
  MNAA.Input:= aTez;
  MNAA.DoIt;
  aLines:= TPolyLineString(MNAA.Output);
  AddElement(aLines);
  AddElement(MNAA.NodesQTree);
  MNAA.Free;

// Oeten novch lini
  for I:= 0 to aLines.Count-1 do
  begin
    aLine:= TPolyLineElement(aLines.Elements[I]);
    if not (TObject(aLine) is TPolyLineElement) then
       continue;
    if aLine.Properties = nil then
    begin
      aLinProp:= TTopolLineProps.Create;
      aLine.Properties:= aLinProp;
      aLinProp.Barva:= 13;
      aLinProp.Znacka:= 0;
      aLinProp.Druh:= 135
    end
  end;
{
  MNAA:= TMakeNodesAndAreas.Create;
  MNAA.Input:= aTez;
  MNAA.DoIt;
  aPlochy:= TAreaString(MNAA.Output);
  MNAA.Free;

  if aPlochy = nil then
     Exit;

  CAAL:= TCarryArToArThroughLines.Create;
  CAAL.Input:= aPlochy;
  CAAL.ProtocolFile:= '';
  CAAL.SelectForProblem:=true;
  CAAL.DoIt;
  CAAL.Free;
}
{
  for I:= 0 to aPlochy.Count-1 do
  begin
    NastavDruh(Plochy.Elements[I]);
    Application.ProcessMessages
  end;
}

  aPlochy:= ExtractTezbaAreas;
  if aPlochy = nil then
     Exit;
  aTez.AddElement(aPlochy);

  for I:= 0 to aPlochy.Count-1 do
  begin
    aPlocha:= TAreaElement(aPlochy.Elements[I]);
    if not (TObject(aPlocha) is TAreaElement) then
       continue;
    if aPlocha.Properties = nil then
    begin
      aPlochaProp:= TTopolAreaProps.Create;
      aPlocha.Properties:= aPlochaProp;
      aPlochaProp.Barva:= 13;
      aPlochaProp.Znacka:= 1;
      aPlochaProp.Druh:= 135
    end
    else
    if aPlocha.Properties is TTezPProps then
    begin
      TTezPProps(aPlocha.Properties).Druh:= 135
    end
  end;

  ArExp:= TExportAreasToTopol.Create;
  try
    ArExp.Input:= aPlochy;
    ArExp.Name:= 'Export ploch tby';
    ArExp.BlockName:= BlockName;
    ArExp.ControlDir:= ControlDIR; //LCRGisDir;
//    ArExp.DruhLinii:= 1100;
    ArExp.ExportDBF:= true;
    ArExp.DoIt;
  finally
    ArExp.Free;
  end;

  ShowMessage('Konec tvorby LHC');
end;


begin
  RegisterOrbisClass(TExportTez);
end.
