unit T_HelSlu;

interface
uses
// KERNEL
  Elements,
// GLIB
  g_elems,
// SPACE
  e_Space,
  T_HelSel;

type

THeleNactiSlu = class(THeleNacti)
private
  FSluTemp: TEntity;
  function GetPSK(aLin: TPolyLineElement;  var JeToPSK: boolean): TRectEntity;
  procedure AddSluToPSK(JeToPSK: Boolean; aPSK: TRectEntity; aLin: TPolyLineElement);
public
  procedure DoIt; override;
  procedure NactiSlu;
end;

implementation
uses
  Dialogs, SysUtils,
// KERNEL
  e_Class,
// OIL
  T_SelectByName,
  T_Helhie;

procedure THeleNactiSlu.AddSLUToPSK(JeToPSK: Boolean; aPSK: TRectEntity; aLin: TPolyLineElement);
var
  aSlucky: TRectEntity;
begin
  if JeToPSK then
     aSlucky:= TRectEntity(aPSK.FindElementName('SLUCLIN'))
  else
     aSlucky:= TRectEntity(aPSK.FindElementName('SLUCLIN NEZAAZEN'));

  if aSlucky = nil then
  begin
    aSlucky:= TRectEntity.Create;
    if JeToPSK then
       aSlucky.Name:= 'SLUCLIN'
    else
       aSlucky.Name:= 'SLUCLIN NEZAAZEN';

    aPSK.AddElement(aSlucky);
  end;
  aSlucky.AddAndUpdateRect(aLin);
  aPSK.UpdateRect(aLin);
end;



function THeleNactiSlu.GetPSK(aLin: TPolyLineElement;  var JeToPSK: boolean): TRectEntity;
var
  HelSku: THeleSkupina;
  aLHC, aOdd, aDil, aPor, aPSK: string;

  procedure AddToProtocol(aStr: string);
  begin
     Protocol:= 'Zaazovn Slukov linie .' + IntToStr(aLin.SpaceId) +
                aStr
  end;

begin
  Result:= nil;
  JeToPSK:= false;

  HelSku:= THeleSkupina.Create;
  HelSku.Input:= Hierarchy;
  HelSku.X:= aLin.X;
  HelSku.Y:= aLin.Y;
  HelSku.DoIt;
  if not HelSku.Found then
  begin
    HelSku.Free;
    Exit;
  end;

  aLHC := HelSku.LHC;
  aOdd := HelSku.Odd;
  aDIL := HelSku.Dil;
  aPOR := HelSku.Por;
  aPSK := HelSku.PSK;

  result:= HelSku.PSKObject;
  JeToPSK:= Result <> nil;
  HelSku.Free;
end;



procedure THeleNactiSlu.NactiSlu;
var
  I: integer;
  aHier: TEntity;
  aLin: TPolyLineElement;
  aPSK: TRectEntity;
  JeToPSK: Boolean;
  SBN: TSelectByName;
  aSlu: TRectEntity;
begin
  FSLUTemp:= FindLayer('SLU', 'LIN');

  if not(FSLUTEMP is TPolyLineString) then exit;
  if FSLUTemp.Count = 0 then exit;

  aHier:= Hierarchy;
  if aHier =nil then Exit;

  for I:= 0 to FSLUTemp.Count-1 do
  begin
    aLin:= TPolyLineElement(FSluTemp.elements[I]);
    if not (TObject(aLin) is TPolyLineElement) then
       continue;
    aPSK:= GetPSK(aLin, JeToPSK);
    if aPSK = nil then
    begin
      ShowMessage('Pro linii c.' + IntToStr(aLin.SpaceId) + ' nen nalezen objekt pro pidn');
      continue
    end
    else
      AddSluToPSK(JeToPSK, aPSK, aLin)
  end;


  aSlu:= CreateDataRectEntitu('SLUCLIN');

  SBN:= TSelectByName.Create;
  SBN.CaseSensitive:= False;
  SBN.SelectedName:='SLUCLIN';
  SBN.Input := aHier;
  SBN.Partialy:= false;
  SBN.Output:= aSlu;
  SBN.DoIt;
  SBN.Free;
end;


procedure THeleNactiSlu.DoIt;
begin
   NactiSlu;
end;



begin
  RegisterOrbisClass(THeleNactiSLU);
end.

