unit e_KatastrModel;

interface
{$I ..\_conditions.inc}
uses
   Classes,
   Elements,
   e_Props,
   e_GeometryElement,
   e_LHCModelSupport,
   g_Elems;

type

Tgis_Person=class(TOwnerEntity)
  private
    FCHAROS_KOD: integer;
    FCP_CE: integer;
    FDOPLNEK_ICO: integer;
    FICO: integer;
    FCISLO_DOMOVNI: string;
    FCISLO_ORIENTACNI: string;
    FJMENO: string;
    FNAZEV_ULICE: string;
    FJMENO_U: string;
    FOPSUB_TYPE: string;
    FNAZEV: string;
    FPSC: string;
    FPRIJMENI: string;
    FPRIJMENI_U: string;
    FMESTSKA_CAST: string;
    FOKRES: string;
    FTITUL_ZA_JMENEM: string;
    FTITUL_PRED_JMENEM: string;
    FSTAT: string;
    FOBEC: string;
    FCAST_OBCE: string;
    FRODNE_CISLO: string;
    FAutoName: boolean;
    FID_JE_1_PARTNER_BSM: string;
    FID_JE_2_PARTNER_BSM: string;
    FaID: string;
    FNAZEV_U: string;
    procedure SetCAST_OBCE(const Value: string);
    procedure SetCISLO_DOMOVNI(const Value: string);
    procedure SetCISLO_ORIENTACNI(const Value: string);
    procedure SetCP_CE(const Value: integer);
    procedure SetDOPLNEK_ICO(const Value: integer);
    procedure SetCHAROS_KOD(const Value: integer);
    procedure SetICO(const Value: integer);
    procedure SetJMENO(const Value: string);
    procedure SetJMENO_U(const Value: string);
    procedure SetMESTSKA_CAST(const Value: string);
    procedure SetNAZEV(const Value: string);
    procedure SetNAZEV_ULICE(const Value: string);
    procedure SetOBEC(const Value: string);
    procedure SetOKRES(const Value: string);
    procedure SetOPSUB_TYPE(const Value: string);
    procedure SetPRIJMENI(const Value: string);
    procedure SetPRIJMENI_U(const Value: string);
    procedure SetPSC(const Value: string);
    procedure SetSTAT(const Value: string);
    procedure SetTITUL_PRED_JMENEM(const Value: string);
    procedure SetTITUL_ZA_JMENEM(const Value: string);
    procedure SetRODNE_CISLO(const Value: string);
    procedure SetAutoName(const Value: boolean);
    function GetAdresa_Full: string;
    function GetJmeno_Full: string;
    function GetPartner1: Tgis_Person;
    function GetPartner2: Tgis_Person;
    procedure SetID_JE_1_PARTNER_BSM(const Value: string);
    procedure SetID_JE_2_PARTNER_BSM(const Value: string);
    procedure SetaID(const Value: string);
    procedure SetNAZEV_U(const Value: string);
protected
   function  GetName: string; override;
   procedure SetName(aName: string); override;
   function FindOwnerByID(Value: string): Tgis_Person;
published
   property aID: string read FaID write SetaID;
   property ID_JE_1_PARTNER_BSM: string read FID_JE_1_PARTNER_BSM write SetID_JE_1_PARTNER_BSM;
   property ID_JE_2_PARTNER_BSM: string read FID_JE_2_PARTNER_BSM write SetID_JE_2_PARTNER_BSM;
   property Partner1: Tgis_Person read GetPartner1 stored false;
   property Partner2: Tgis_Person read GetPartner2 stored false;
   property OPSUB_TYPE: string read FOPSUB_TYPE write SetOPSUB_TYPE;
   property CHAROS_KOD: integer read FCHAROS_KOD write SetCHAROS_KOD;
   property ICO: integer read FICO write SetICO;
   property DOPLNEK_ICO: integer read FDOPLNEK_ICO write SetDOPLNEK_ICO;
   property NAZEV: string read FNAZEV write SetNAZEV;
   property NAZEV_U: string read FNAZEV_U write SetNAZEV_U;
   property RODNE_CISLO: string read FRODNE_CISLO write SetRODNE_CISLO;
   property TITUL_PRED_JMENEM: string read FTITUL_PRED_JMENEM write SetTITUL_PRED_JMENEM;
   property JMENO: string read FJMENO write SetJMENO;
   property JMENO_U: string read FJMENO_U write SetJMENO_U;
   property PRIJMENI: string read FPRIJMENI write SetPRIJMENI;
   property PRIJMENI_U: string read FPRIJMENI_U write SetPRIJMENI_U;
   property TITUL_ZA_JMENEM: string read FTITUL_ZA_JMENEM write SetTITUL_ZA_JMENEM;
   property CISLO_DOMOVNI: string read FCISLO_DOMOVNI write SetCISLO_DOMOVNI;
   property CISLO_ORIENTACNI: string read FCISLO_ORIENTACNI write SetCISLO_ORIENTACNI;
   property NAZEV_ULICE: string read FNAZEV_ULICE write SetNAZEV_ULICE;
   property CAST_OBCE: string read FCAST_OBCE write SetCAST_OBCE;
   property OBEC: string read FOBEC write SetOBEC;
   property OKRES: string read FOKRES write SetOKRES;
   property STAT: string read FSTAT write SetSTAT;
   property PSC: string read FPSC write SetPSC;
   property MESTSKA_CAST: string read FMESTSKA_CAST write SetMESTSKA_CAST;
   property CP_CE: integer read FCP_CE write SetCP_CE;
   property Jmeno_Full: string read GetJmeno_Full stored false;
   property Adresa_Full: string read GetAdresa_Full stored false;
   property AutoName: boolean read FAutoName write SetAutoName;
end;

Tgis_People = class(TOwnerEntity)
end;

Tgis_Vlastnictvi = class(TOwnerEntity)
  private
    FTYPRAV_KOD: integer;
    FPODIL_CITATEL: integer;
    FPODIL_JMENOVATEL: integer;
    FOPSUB_ID: string;
    FTEL_ID: string;
    FAutoName: boolean;
    procedure SetPODIL_CITATEL(const Value: integer);
    procedure SetPODIL_JMENOVATEL(const Value: integer);
    procedure SetTYPRAV_KOD(const Value: integer);
    procedure SetOPSUB_ID(const Value: string);
    procedure SetTEL_ID(const Value: string);
    procedure SetAutoName(const Value: boolean);
protected
   function  GetName: string; override;
   procedure SetName(aName: string); override;
published
   property PODIL_CITATEL: integer read FPODIL_CITATEL write SetPODIL_CITATEL;
   property PODIL_JMENOVATEL: integer read FPODIL_JMENOVATEL write SetPODIL_JMENOVATEL;
   property TYPRAV_KOD: integer read FTYPRAV_KOD write SetTYPRAV_KOD;
   property TEL_ID: string read FTEL_ID write SetTEL_ID;
   property OPSUB_ID: string read FOPSUB_ID write SetOPSUB_ID;
   property AutoName: boolean read FAutoName write SetAutoName;
end;

tgis_Tel = class(TOwnerEntity)
  private
    FCISLO_TEL: integer;
    FKATUZE_KOD: integer;
    FAutoName: boolean;
    procedure SetCISLO_TEL(const Value: integer);
    procedure SetKATUZE_KOD(const Value: integer);
    procedure SetAutoName(const Value: boolean);
protected
   function  GetName: string; override;
   procedure SetName(aName: string); override;
published
   property KATUZE_KOD: integer read FKATUZE_KOD write SetKATUZE_KOD;
   property CISLO_TEL: integer read FCISLO_TEL write SetCISLO_TEL;
   property AutoName: boolean read FAutoName write SetAutoName;
end;

Tgis_Majitel = class(TOwnerEntity)
  private
    FMAJ_DRUH: integer;
    FCislo: string;
    FMAJ_KOD: string;
    FComment: string;
    FAdresa: string;
    FJmeno: string;
    FPrijmeni: string;
    FFullNameToName: boolean;
    FSwapJmeno: boolean;
    FAdresaToName: boolean;
    FFixMaj: boolean;
    procedure SetCislo(const Value: string);
    procedure SetComment(const Value: string);
    procedure SetMAJ_DRUH(const Value: integer);
    procedure SetMAJ_KOD(const Value: string);
    procedure SetAdresa(const Value: string);
    procedure SetJmeno(const Value: string);
    procedure SetPrijmeni(const Value: string);
    function GetFullName: string;
    procedure SetFullNameToName(const Value: boolean);
    procedure SetSwapJmeno(const Value: boolean);
    procedure SetAdresaToName(const Value: boolean);
    function GetMAJ_DRUH: integer;
    function GetMAJ_KOD: string;
    procedure SetFixMaj(const Value: boolean);
    function GetMultimajitel: boolean;
    function GetTel: Tgis_Tel;
    procedure WriteSetBy(const Value: TElement);
protected
   function  GetName: string; override;
   procedure SetName(aName: string); override;
published
   property FullName: string read GetFullName stored false;
   property Cislo: string read FCislo write SetCislo;
   property MAJ_DRUH: integer read GetMAJ_DRUH write SetMAJ_DRUH;
   property MAJ_KOD: string read GetMAJ_KOD write SetMAJ_KOD;
   property Jmeno: string read FJmeno write SetJmeno;
   property Prijmeni: string read FPrijmeni write SetPrijmeni;
   property Adresa: string read FAdresa write SetAdresa;
   property Comment: string read FComment write SetComment;
   property SwapJmeno: boolean read FSwapJmeno write SetSwapJmeno;
   property FullNameToName: boolean read FFullNameToName write SetFullNameToName;
   property AdresaToName: boolean read FAdresaToName write SetAdresaToName;
   property FixMaj: boolean read FFixMaj write SetFixMaj;
   property Tel: Tgis_Tel read GetTel stored false;
   property Multimajitel: boolean read GetMultimajitel stored false;
   property SetBy: TElement write WriteSetBy stored false;
end;

Tgis_Majitele = class(TOwnerEntity)
private
    FActualMajitel: Tgis_Majitel;
    procedure SetActualMajitel(const Value: Tgis_Majitel);
    procedure SetFindMajitelCislo(const Value: string);
    procedure SetSortByCislo(const Value: boolean);
public
   function GetMajitelCislo(Value: string): Tgis_Majitel;
   function CreateMajitelCislo(Value: string): Tgis_Majitel;
   function CreateMajitelByMajitel(Value: Tgis_Majitel): Tgis_Majitel;
published
   property FindMajitelCislo: string write SetFindMajitelCislo stored false;
   property ActualMajitel: Tgis_Majitel read FActualMajitel write SetActualMajitel stored false;
   property SortByCislo: boolean write SetSortByCislo stored false;
end;

TGis_OLH = class(TOwnerEntity)
  private
    FComment: string;
    FPrijmeni: string;
    FOLH_ID: string;
    FJmeno: string;
    FAdresa: string;
    FOLH_PR_TIT: string;
    function GetFullName: string;
    procedure SetAdresa(const Value: string);
    procedure SetComment(const Value: string);
    procedure SetJmeno(const Value: string);
    procedure SetOLH_ID(const Value: string);
    procedure SetOLH_PR_TIT(const Value: string);
    procedure SetPrijmeni(const Value: string);
protected
   function  GetName: string; override;
   procedure SetName(aName: string); override;
published
   property OLH_ID: string read FOLH_ID write SetOLH_ID;
   property OLH_PR_TIT: string read FOLH_PR_TIT write SetOLH_PR_TIT;
   property FullName: string read GetFullName stored false;
   property Jmeno: string read FJmeno write SetJmeno;
   property Prijmeni: string read FPrijmeni write SetPrijmeni;
   property Adresa: string read FAdresa write SetAdresa;
   property Comment: string read FComment write SetComment;
end;

TGis_OLHs = class(TOwnerEntity)
  private
    FActualOLH: TGis_OLH;
    procedure SetActualOLH(const Value: TGis_OLH);
    procedure SetFindOLH_ID(const Value: string);
public
   function GetOLH_ID(Value: string): TGis_OLH;
   function CreateOLH_ID(Value: string): TGis_OLH;
   function CreateOLHByOLH(Value: TGis_OLH): TGis_OLH;
published
   property FindOLH_ID: string write SetFindOLH_ID stored false;
   property ActualOLH: TGis_OLH read FActualOLH write SetActualOLH;
end;

Tgis_KatastralElement = class(TPropertyGeometryElement)
private
    FZnacka: integer;
    FBarva: integer;
    FaID: string;
    procedure SetBarva(const Value: integer);
    procedure SetZnacka(const Value: integer);
    function GetVlastnik: string;
    procedure SetVlastnik(const Value: string);
    function GetMAJ_Adresa: string;
    function GetMAJ_DRUH: integer;
    function GETMAJ_KOD: string;
    function GetMAJ_Name: string;
    procedure SetaID(const Value: string);
    function GetOLH_Adresa: string;
    function GetOLH_ID: string;
    function GetOLH_Name: string;
    function GetOLH_PR_TIT: string;
protected
   FCislo: integer;
   procedure SetCislo(const Value: integer);
   function  GetName: string; override;
   procedure SetName(aName: string); override;
    function GetMultiElement: boolean; override;
    function GetMultiElementClass: TElementClass; override;
    function GetMajitel: Tgis_Majitel; virtual;
    procedure SetMajitel(const Value: Tgis_Majitel); virtual;
    function GetSameMajitel: boolean; virtual;
    function GetOLH: TGis_OLH; virtual;
    procedure SetOLH (const Value: TGis_OLH); virtual;
    function GetSameOLH: boolean; virtual;
published
   property aID: string read FaID write SetaID;
   property Cislo: integer read FCislo write SetCislo;
   property Barva: integer read FBarva write SetBarva;
   property Znacka: integer read FZnacka write SetZnacka;
   property Vlastnik: string read GetVlastnik write SetVlastnik stored false;
   property SameMajitel: boolean read GetSameMajitel stored false;
   property MAJ_DRUH: integer read GetMAJ_DRUH stored false;
   property MAJ_KOD: string read GETMAJ_KOD stored false;
   property MAJ_Name: string read GetMAJ_Name stored false;
   property MAJ_Adresa: string read GetMAJ_Adresa stored false;
   property Majitel: Tgis_Majitel read GetMajitel write SetMajitel stored false;
   property OLH: TGis_OLH read GetOLH write SetOLH stored false;
   property OLH_ID: string read GetOLH_ID stored false;
   property OLH_PR_TIT: string read GetOLH_PR_TIT stored false;
   property OLH_Name: string read GetOLH_Name stored false;
   property OLH_Adresa: string read GetOLH_Adresa stored false;
   property SameOLH: boolean read GetSameOLH stored false;
end;


Tgis_SkupinyParcel = class(TAreaCollection)
protected
   function  GetName: string; override;
   procedure SetName(aName: string); override;
end;

Tgis_Parcely = class(TAreaCollection)
protected
   function  GetName: string; override;
   procedure SetName(aName: string); override;
end;

Tgis_ParCasti = class(TAreaCollection)
protected
   function  GetName: string; override;
   procedure SetName(aName: string); override;
end;


Tgis_KParcely = class(TAreaCollection)
protected
   function  GetName: string; override;
   procedure SetName(aName: string); override;
end;


Tgis_SkupinaParcel=class;
Tgis_Parcela=class;
Tgis_ParcelaCast=class;
Tgis_ParcelModel=class;

Tgis_Katastr = class(Tgis_KatastralElement)
private
   FNazev: string;
    FSkupinyParcel: Tgis_SkupinyParcel;
    FParcely: Tgis_KParcely;
    FCislo_: integer;
    FORP: integer;
    FORP_Nazev: string;
    FKraj_Nazev: string;
    FKraj: string;
    FPoznamka: string;
   procedure SetNazev(const Value: string);
    procedure SetNextSkupinaParcel(const Value: Tgis_SkupinaParcel);
    procedure SetSkupinyParcel(const Value: Tgis_SkupinyParcel);
    function GetSkupinyParcel: Tgis_SkupinyParcel;
    function GetNoSkupinaparcel: boolean;
    function GetParcely: Tgis_KParcely;
    procedure SetNextParcela(const Value: Tgis_Parcela);
    procedure SetParcely(const Value: Tgis_KParcely);
    function GetNoParcela: boolean;
    procedure SetCislo_(const Value: integer);
    procedure SetSwapCislo(const Value: boolean);
    procedure SetORP(const Value: integer);
    procedure SetORP_Nazev(const Value: string);
    procedure SetKraj(const Value: string);
    procedure SetKraj_Nazev(const Value: string);
    procedure SetPoznamka(const Value: string);
public
    function  GetParcelaCislo(aParcis,aParpod, aKATUZE_KOD_PUV: integer): Tgis_Parcela;
    function  CreateParcelaCislo(aParcis,aParpod, aKATUZE_KOD_PUV: integer; aSKP: Tgis_SkupinaParcel): Tgis_Parcela;
    function  GetSkupinaParcelCislo(aCislo: integer): Tgis_SkupinaParcel;
    function  GetSkupinaParcelComment(aComment: string): Tgis_SkupinaParcel;
    function  CreateSkupinaParcelCislo(aCislo: integer): Tgis_SkupinaParcel;
    function  CreateSkupinaParcelComment(aComment: string): Tgis_SkupinaParcel;
    property  NoSkupinaParcel: boolean read GetNoSkupinaparcel;
    property  NoParcela: boolean read GetNoParcela;
published
   property KU_KOD: integer read FCislo write SetCislo stored false;
   property KU_KOD_: integer read FCislo_ write SetCislo_ stored false;
   property Cislo_: integer read FCislo_ write SetCislo_ stored true;
   property SwapCislo: boolean write SetSwapCislo stored false;
   property Nazev: string read FNazev write SetNazev stored true;
   property ORP: integer read FORP write SetORP stored true;
   property ORP_Nazev: string read FORP_Nazev write SetORP_Nazev stored true;
   property Kraj: string read FKraj write SetKraj stored true;
   property Kraj_Nazev: string read FKraj_Nazev write SetKraj_Nazev stored true;
   property SkupinyParcel: Tgis_SkupinyParcel read GetSkupinyParcel write SetSkupinyParcel stored false;
   property NextSkupinaParcel: Tgis_SkupinaParcel write SetNextSkupinaParcel stored false;
   property Parcely: Tgis_KParcely read GetParcely write SetParcely stored false;
   property NextParcela: Tgis_Parcela write SetNextParcela stored false;
   property Poznamka: string read FPoznamka write SetPoznamka;
end;

Tgis_ParcelaElement = class(Tgis_KatastralElement)
private
   FKVAL_P: byte;
   FVymera: double;
   FKATPAR_KOD: integer;
    FTEL_ID: string;
   function GetKU_KOD: integer;
   procedure SetKATPAR_KOD(const Value: integer);
   procedure SetKVAL_P(const Value: byte);
   procedure SetVymera(const Value: double);
    procedure SetAddVymera(const Value: double);
    function GetKU_KOD_: integer;
    function GetKU_Nazev: string;
    function GetIsKUMajitel: boolean;
    function GetKUMajitel: Tgis_Majitel;
    function GetORP: integer;
    function GetORP_Nazev: string;
    function GetKraj: string;
    function GetKraj_Nazev: string;
    function GetKU_Poznamka: string;
    procedure SetTEL_ID(const Value: string);
    function GetIsKUOLH: boolean;
    function GetKUOLH: Tgis_OLH;
protected
   function GetPlocha: double; virtual;
   function GetPlocha_ha: double;
   function GetKatastr: Tgis_Katastr; virtual; abstract;
   function GetSKUPAR_CIS: integer; virtual; abstract;
    procedure SetKatastr(const Value: Tgis_Katastr); virtual;
    function GetSKUPAR_Comment: string; virtual;
    procedure SetSKUPAR_Comment(const Value: string); virtual;
   procedure SetSKUPAR_CIS(const Value: integer); virtual; abstract;
   function  GetVymera: double; virtual;
    function GetMultiparcela: boolean; virtual;
    function GetMultiVymera: double; virtual;
published
   property Plocha: double read GetPlocha stored false;
   property Plocha_ha: double read GetPlocha_ha stored false;
   property Vymera: double read GetVymera write SetVymera;
   property AddVymera: double write SetAddVymera stored false;
   property KU_KOD: integer read GetKU_KOD stored false;
   property KU_KOD_: integer read GetKU_KOD_ stored false;
   property KU_Nazev: string read GetKU_Nazev stored false;
   property ORP: integer read GetORP stored false;
   property ORP_Nazev: string read GetORP_Nazev stored false;
   property Kraj: string read GetKraj stored false;
   property Kraj_Nazev: string read GetKraj_Nazev stored false;
   property KATPAR_KOD: integer read FKATPAR_KOD write SetKATPAR_KOD;
   property SKUPAR_CIS: integer read GetSKUPAR_CIS write SetSKUPAR_CIS stored false;
   property SKUPAR_Comment: string read GetSKUPAR_Comment write SetSKUPAR_Comment stored false;
   property KVAL_P: byte read FKVAL_P write SetKVAL_P;
   property Katastr: Tgis_Katastr read GetKatastr write SetKatastr stored false;
   property Multiparcela: boolean read GetMultiparcela stored false;
   property MultiVymera: double read GetMultiVymera stored false;
   property KUOLH: Tgis_OLH read GetKUOLH stored false;
   property IsKUOLH: boolean read GetIsKUOLH stored false;
   property KUMajitel: Tgis_Majitel read GetKUMajitel stored false;
   property IsKUMajitel: boolean read GetIsKUMajitel stored false;
   property KU_Poznamka: string read GetKU_Poznamka stored false;
   property TEL_ID: string read FTEL_ID write SetTEL_ID;
end;


Tgis_SkupinaParcel = class(Tgis_ParcelaElement)
  private
    FParcely: Tgis_Parcely;
    FParCasti: Tgis_ParCasti;
    FPorosty: TForest_ParcelConnectionEntity;
    FSkupiny: TForest_ParcelDetailConnectionEntity;
    FComment: string;
    procedure SetNextParcela(const Value: Tgis_Parcela);
    procedure SetParcely(const Value: Tgis_Parcely);
    function GetParcely: Tgis_Parcely;
    function GetPorosty: TForest_ParcelConnectionEntity;
    function GetSkupiny: TForest_ParcelDetailConnectionEntity;
    procedure SetNextPorost(const Value: TElement);
    procedure SetPorosty(const Value: TForest_ParcelConnectionEntity);
    procedure SetSkupiny(const Value: TForest_ParcelDetailConnectionEntity);
    function GetNoParcela: boolean;
    procedure SetNextSkupina(const Value: TElement);
    procedure SetDisconnect(const Value: boolean);
    function GetNoParCast: boolean;
    function GetParCasti: Tgis_ParCasti;
    procedure SetNextParCast(const Value: Tgis_ParcelaCast);
    procedure SetParCasti(const Value: Tgis_ParCasti);
    function GetNoPorosty: boolean;
    function GetNoSkupiny: boolean;
    function GetForestConnected: boolean;
    procedure SetComment(const Value: string);
    function GetLV: integer;
    function GetLVc: integer;
protected
   //function  GetVymera: double; override;
   function GetKatastr: Tgis_Katastr; override;
   function GetSKUPAR_CIS: integer; override;
   procedure SetSKUPAR_CIS(const Value: integer); override;
    function GetSKUPAR_Comment: string; override;
    procedure SetSKUPAR_Comment(const Value: string); override;
    function GetMajitel: Tgis_Majitel; override;
    procedure SetMajitel(const Value: Tgis_Majitel); override;
    function GetSameMajitel: boolean; override;
    function GetOLH: Tgis_OLH; override;
    procedure SetOLH(const Value: Tgis_OLH); override;
    function GetSameOLH: boolean; override;
public
   function GetFirstParCast: Tgis_ParcelaCast;
   function  GetParcelaCislo(aParcis,aParpod, aKATUZE_KOD_PUV: integer): Tgis_Parcela;
   function  CreateParcelaCislo(aParcis,aParpod, aKATUZE_KOD_PUV: integer): Tgis_Parcela;
   procedure RemovePorost(aValue: TElement);
   procedure RemoveSkupina(aValue: TElement);
   procedure RemoveParcela(aValue: TElement);
   procedure RemoveParCast(aValue: TElement);
published
   property Parcely: Tgis_Parcely read GetParcely write SetParcely stored false;
   property NextParcela: Tgis_Parcela write SetNextParcela stored false;
   property ParCasti: Tgis_ParCasti read GetParCasti write SetParCasti stored false;
   property NextParCast: Tgis_ParcelaCast write SetNextParCast stored false;
   property Porosty: TForest_ParcelConnectionEntity read GetPorosty write SetPorosty stored false;
   property Skupiny: TForest_ParcelDetailConnectionEntity read GetSkupiny write SetSkupiny stored false;
   property NextPorost: TElement write SetNextporost stored false;
   property NextSkupina: TElement write SetNextSkupina stored false;
   property Disconnect: boolean write SetDisconnect stored false;
   property ForestConnected: boolean read GetForestConnected stored false;
   property Comment: string read FComment write SetComment;
   property  NoParcela: boolean read GetNoParcela stored false;
   property  NoParcast: boolean read GetNoParCast stored false;
   property  NoPorosty: boolean read GetNoPorosty stored false;
   property  NoSkupiny: boolean read GetNoSkupiny stored false;
   property  LV: integer read GetLV stored false;
   property  LVc: integer read GetLVc stored false;
end;

Tgis_Parcela = class(Tgis_ParcelaElement)
private
   //FPAR_SKU_KN: byte;
   FPARPOD: integer;
    FLV: integer;
    FKultura: integer;
    FParZar: boolean;
    FPUPFL: boolean;
    FPK: boolean;
    FKATUZE_KOD_PUV: integer;
   function GetSkupinaParcel: Tgis_SkupinaParcel;
   procedure SetPAR_SKU_KN(const Value: byte);
   procedure SetPARPOD(const Value: integer);
    procedure SetLV(const Value: integer);
    function GetPAR_SKU_KN: byte;
    function GetPARCISAbs: integer;
    procedure SetKultura(const Value: integer);
    procedure SetParZar(const Value: boolean);
    procedure SetPUPFL(const Value: boolean);
    function GetParZar_Text: string;
    function GetPUPFL_Text: string;
    procedure SetParZar_Text(const Value: string);
    procedure SetPUPFL_Text(const Value: string);
    procedure SetSkupinaParcel(const Value: Tgis_SkupinaParcel);
    procedure SetPK(const Value: boolean);
    procedure SetKATUZE_KOD_PUV(const Value: integer);
protected
   function  GetName: string; override;
   procedure SetName(aName: string); override;
   function GetPlocha: double; override;
   function GetKatastr: Tgis_Katastr; override;
   function GetSKUPAR_CIS: integer; override;
   procedure SetKatastr(const Value: Tgis_Katastr); override;
   procedure SetSKUPAR_CIS(const Value: integer); override;
   function GetMultiparcela: boolean; override;
   function GetMultiVymera: double; override;
    function GetSKUPAR_Comment: string; override;
    procedure SetSKUPAR_Comment(const Value: string); override;
    function GetMajitel: Tgis_Majitel; override;
    procedure SetMajitel(const Value: Tgis_Majitel); override;
    function GetSameMajitel: boolean; override;
    function GetOLH: Tgis_OLH; override;
    procedure SetOLH(const Value: Tgis_OLH); override;
    function GetSameOLH: boolean; override;
public
   function CreateParCast: Tgis_ParcelaCast;
   function CreateParcastPKCislo(aPKCis,aPKPod: integer): Tgis_ParcelaCast;
   function CreateParcastPKCisloDil(aPKCis,aPKPod,aPKDil: integer): Tgis_ParcelaCast;
   function CreateParcastDil(aPKDil: integer): Tgis_ParcelaCast;
   function GetParcastPKCislo(aPKCis,aPKPod: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
   function GetParcastPKCisloDil(aPKCis,aPKPod,aPKDil: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
   function GetParcastDil(aPKDil: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
   function GetNextParcastPKCislo(aParcast: Tgis_ParcelaCast; aPKCis,aPKPod: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
   function GetNextParcastPKCisloDil(aParcast: Tgis_ParcelaCast; aPKCis,aPKPod,aPKDil: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
   function GetNextParcastDil(aParcast: Tgis_ParcelaCast; aPKDil: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
   function GetParCastByXY(aX,aY: double): Tgis_ParcelaCast;
published
   property KATUZE_KOD_PUV: integer read FKATUZE_KOD_PUV write SetKATUZE_KOD_PUV;
   property PARCIS: integer read FCislo write SetCislo stored false;
   property PARCISAbs: integer read GetPARCISAbs stored false;
   property PARPOD: integer read FPARPOD write SetPARPOD;
   property PAR_SKU_KN: byte read GetPAR_SKU_KN write SetPAR_SKU_KN stored false;
   property LV: integer read FLV write SetLV;
   property SkupinaParcel: Tgis_SkupinaParcel read GetSkupinaParcel write SetSkupinaParcel stored false;
   property Kultura: integer read FKultura write SetKultura;
   property ParZar: boolean read FParZar write SetParZar;
   property PUPFL: boolean read FPUPFL write SetPUPFL;
   property ParZar_Text: string read GetParZar_Text write SetParZar_Text stored false;
   property PUPFL_Text: string read GetPUPFL_Text write SetPUPFL_Text stored false;
   property PK: boolean read FPK write SetPK;
end;

Tgis_ParcelaCast = class(Tgis_ParcelaElement)
private
   //FPAR_SKU_KN: byte;
    FLVC: integer;
    FParZar: boolean;
    FPKPOD: integer;
    FPKCIS: integer;
    FSuperID: integer;
    FPUPFLc: boolean;
    FPK_Dil: integer;
    FGP: boolean;
    FZmena: string;
    FPoznamka: string;
    FKulturaC: integer;
    FNEP: boolean;
    FATR_PUV: integer;
   function GetSkupinaParcel: Tgis_SkupinaParcel;
   procedure SetPAR_SKU_KN(const Value: byte);
   procedure SetPARPOD(const Value: integer);
    procedure SetLV(const Value: integer);
    function GetPAR_SKU_KN: byte;
    function GetPARCISAbs: integer;
    procedure SetKultura(const Value: integer);
    procedure SetParZar(const Value: boolean);
    procedure SetPUPFL(const Value: boolean);
    function GetParZar_Text: string;
    function GetPUPFL_Text: string;
    procedure SetParZar_Text(const Value: string);
    procedure SetPUPFL_Text(const Value: string);
    function GetKultura: integer;
    function GETLV: integer;
    function GETLVC: integer;
    function GetPARCAST: integer;
    function GetParcela: Tgis_Parcela;
    function GetPARCIS: integer;
    function GetPARPOD: integer;
    function GetPK_Text: string;
    function GetPUPFL: boolean;
    procedure SetLVC(const Value: integer);
    procedure SetParcela(const Value: Tgis_Parcela);
    procedure SetPARCIS(const Value: integer);
    procedure SetPKCIS(const Value: integer);
    procedure SetPKPOD(const Value: integer);
    procedure SetSkupinaParcel(const Value: Tgis_SkupinaParcel);
    function GetPCSkupinaParcel: Tgis_SkupinaParcel;
    procedure SetPCSkupinaParcel(const Value: Tgis_SkupinaParcel);
    procedure SetSuperID(const Value: integer);
    function GetPKName: string;
    procedure SetPKName(const Value: string);
    procedure SetParName(const Value: string);
    function GetParName: string;
    function GetParNameAbs: string;
    procedure SetParNameAbs(const Value: string);
    function GetPAR_Vymera: double;
    procedure SetPAR_Vymera(const Value: double);
    function GetPUPFLc_Text: string;
    procedure SetPUPFLc(const Value: boolean);
    procedure SetPUPFLc_Text(const Value: string);
    function GetPK: boolean;
    procedure SetPK(const Value: boolean);
    procedure SetPK_Dil(const Value: integer);
    procedure SetGP(const Value: boolean);
    function GetGP_Text: string;
    procedure SetGP_Text(const Value: string);
    procedure SetZmena(const Value: string);
    procedure SetPoznamka(const Value: string);
    procedure SetKulturaC(const Value: integer);
    procedure SetNEP(const Value: boolean);
    function GetNEP_TEXT: string;
    procedure SetNEP_Text(const Value: string);
    function GetParNameAbsDTTO: string;
    function GetPKNameDTTO: string;
    function GetKATUZE_KOD_PUV: integer;
    procedure SetATR_PUV(const Value: integer);
protected
   function  GetName: string; override;
   procedure SetName(aName: string); override;
   function GetKatastr: Tgis_Katastr; override;
   function GetSKUPAR_CIS: integer; override;
   procedure SetKatastr(const Value: Tgis_Katastr); override;
   procedure SetSKUPAR_CIS(const Value: integer); override;
   function GetMultiparcela: boolean; override;
   function GetMultiVymera: double; override;
    function GetSKUPAR_Comment: string; override;
    procedure SetSKUPAR_Comment(const Value: string); override;
    function GetMajitel: Tgis_Majitel; override;
    procedure SetMajitel(const Value: Tgis_Majitel); override;
    function GetOLH: Tgis_OLH; override;
    procedure SetOLH(const Value: Tgis_OLH); override;
public
   property PCSkupinaParcel: Tgis_SkupinaParcel read GetPCSkupinaParcel write SetPCSkupinaParcel;
published
   property KATUZE_KOD_PUV: integer read GetKATUZE_KOD_PUV stored false;
   property PARCIS: integer read GetPARCIS write SetPARCIS stored false;
   property PARCISAbs: integer read GetPARCISAbs stored false;
   property PARPOD: integer read GetPARPOD write SetPARPOD stored false;
   property PAR_SKU_KN: byte read GetPAR_SKU_KN write SetPAR_SKU_KN stored false;
   property LV: integer read GETLV write SetLV;
   property LVC: integer read GETLVC write SetLVC;
   property SkupinaParcel: Tgis_SkupinaParcel read GetSkupinaParcel write SetSkupinaParcel stored false;
   property Parcela: Tgis_Parcela read GetParcela write SetParcela stored false;
   property PAR_Vymera: double read GetPAR_Vymera write SetPAR_Vymera stored false;
   property Kultura: integer read GetKultura write SetKultura stored false;
   property KulturaC: integer read FKulturaC write SetKulturaC;
   property ParZar: boolean read FParZar write SetParZar;
   property PUPFL: boolean read GetPUPFL write SetPUPFL stored false;
   property PUPFLc: boolean read FPUPFLc write SetPUPFLc;
   property ParZar_Text: string read GetParZar_Text write SetParZar_Text stored false;
   property PUPFL_Text: string read GetPUPFL_Text write SetPUPFL_Text stored false;
   property PUPFLc_Text: string read GetPUPFLc_Text write SetPUPFLc_Text stored false;
   property PKCIS: integer read FPKCIS write SetPKCIS;
   property PKPOD: integer read FPKPOD write SetPKPOD;
   property PK_Dil: integer read FPK_Dil write SetPK_Dil;
   property ParName: string read GetParName write SetParName stored false;
   property ParNameAbs: string read GetParNameAbs write SetParNameAbs stored false;
   property ParNameAbsDTTO: string read GetParNameAbsDTTO stored false;
   property PKName: string read GetPKName write SetPKName stored false;
   property PKNameDtto: string read GetPKNameDTTO stored false;
   property PK_Text: string read GetPK_Text stored false;
   property GP_Text: string read GetGP_Text write SetGP_Text stored false;
   property NEP_TEXT: string read GetNEP_TEXT write SetNEP_Text stored false;
   property PARCAST: integer read GetPARCAST stored false;
   property SuperID: integer read FSuperID write SetSuperID;
   property PK: boolean read GetPK write SetPK stored false;
   property GP: boolean read FGP write SetGP;
   property NEP: boolean read FNEP write SetNEP;
   property Zmena: string read FZmena write SetZmena;
   property Poznamka: string read FPoznamka write SetPoznamka;
   property ATR_PUV: integer read FATR_PUV write SetATR_PUV;
end;

Tgis_ParcelaCast_Props = class(TProperties)
private
    FPUPFL: boolean;
    FLV: integer;
    FKraj: string;
    FPK_Dil: integer;
    FVymera: double;
    FSuperID: integer;
    FPKPOD: integer;
    FKU_KOD: integer;
    FATR_PUV: integer;
    FPARPOD: integer;
    FGP: boolean;
    FSKUPAR_CIS: integer;
    FKATPAR_KOD: integer;
    FPUPFLc: boolean;
    FLVC: integer;
    FPoznamka: string;
    FNEP: boolean;
    FParZar: boolean;
    FSKUPAR_Comment: string;
    FKATUZE_KOD_PUV: integer;
    FORP_Nazev: string;
    FZmena: string;
    FPAR_Vymera: double;
    FTEL_ID: string;
    FORP: integer;
    FKVAL_P: byte;
    FKU_Nazev: string;
    FKU_KOD_: integer;
    FKraj_Nazev: string;
    FaID: string;
    FPKCIS: integer;
    FPARCIS: integer;
    FKultura: integer;
    FMAJ_Adresa: string;
    FMAJ_Name: string;
    FVlastnik: string;
    FMAJ_DRUH: integer;
    FMAJ_KOD: string;
    function GetGP_Text: string;
    function GetNEP_TEXT: string;
    function GetPAR_SKU_KN: byte;
    function GetPARCAST: integer;
    function GetPARCISAbs: integer;
    function GetParName: string;
    function GetParNameAbs: string;
    function GetParNameAbsDTTO: string;
    function GetParZar_Text: string;
    function GetPK: boolean;
    function GetPK_Text: string;
    function GetPKName: string;
    function GetPKNameDTTO: string;
    function GetPUPFL_Text: string;
    function GetPUPFLc_Text: string;
    procedure SetaID(const Value: string);
    procedure SetATR_PUV(const Value: integer);
    procedure SetGP(const Value: boolean);
    procedure SetGP_Text(const Value: string);
    procedure SetKATPAR_KOD(const Value: integer);
    procedure SetKATUZE_KOD_PUV(const Value: integer);
    procedure SetKraj(const Value: string);
    procedure SetKraj_Nazev(const Value: string);
    procedure SetKU_KOD(const Value: integer);
    procedure SetKU_KOD_(const Value: integer);
    procedure SetKU_Nazev(const Value: string);
    procedure SetKultura(const Value: integer);
    procedure SetKVAL_P(const Value: byte);
    procedure SetLV(const Value: integer);
    procedure SetLVC(const Value: integer);
    procedure SetNEP(const Value: boolean);
    procedure SetNEP_Text(const Value: string);
    procedure SetORP(const Value: integer);
    procedure SetORP_Nazev(const Value: string);
    procedure SetPAR_SKU_KN(const Value: byte);
    procedure SetPAR_Vymera(const Value: double);
    procedure SetPARCIS(const Value: integer);
    procedure SetParName(const Value: string);
    procedure SetParNameAbs(const Value: string);
    procedure SetPARPOD(const Value: integer);
    procedure SetParZar(const Value: boolean);
    procedure SetParZar_Text(const Value: string);
    procedure SetPK(const Value: boolean);
    procedure SetPK_Dil(const Value: integer);
    procedure SetPKCIS(const Value: integer);
    procedure SetPKName(const Value: string);
    procedure SetPKPOD(const Value: integer);
    procedure SetPoznamka(const Value: string);
    procedure SetPUPFL(const Value: boolean);
    procedure SetPUPFL_Text(const Value: string);
    procedure SetPUPFLc(const Value: boolean);
    procedure SetPUPFLc_Text(const Value: string);
    procedure SetSKUPAR_CIS(const Value: integer);
    procedure SetSKUPAR_Comment(const Value: string);
    procedure SetSuperID(const Value: integer);
    procedure SetTEL_ID(const Value: string);
    procedure SetVymera(const Value: double);
    procedure SetZmena(const Value: string);
    procedure SetAssignBy(const Value: TElement);
    procedure SetMAJ_Adresa(const Value: string);
    procedure SetMAJ_DRUH(const Value: integer);
    procedure SetMAJ_KOD(const Value: string);
    procedure SetMAJ_Name(const Value: string);
    procedure SetVlastnik(const Value: string);
public
    procedure Assign(Source: TPersistent); override;
published
   property aID: string read FaID write SetaID;
   property Vymera: double read FVymera write SetVymera;
   property KU_KOD: integer read FKU_KOD write SetKU_KOD;
   property KU_KOD_: integer read FKU_KOD_ write SetKU_KOD_;
   property KU_Nazev: string read FKU_Nazev write SetKU_Nazev;
   property ORP: integer read FORP write SetORP;
   property ORP_Nazev: string read FORP_Nazev write SetORP_Nazev;
   property Kraj: string read FKraj write SetKraj;
   property Kraj_Nazev: string read FKraj_Nazev write SetKraj_Nazev;
   property KATPAR_KOD: integer read FKATPAR_KOD write SetKATPAR_KOD;
   property SKUPAR_CIS: integer read FSKUPAR_CIS write SetSKUPAR_CIS;
   property SKUPAR_Comment: string read FSKUPAR_Comment write SetSKUPAR_Comment;
   property KVAL_P: byte read FKVAL_P write SetKVAL_P;
   property TEL_ID: string read FTEL_ID write SetTEL_ID;
   property KATUZE_KOD_PUV: integer read FKATUZE_KOD_PUV write SetKATUZE_KOD_PUV;
   property PARCIS: integer read FPARCIS write SetPARCIS;
   property PARCISAbs: integer read GetPARCISAbs stored false;
   property PARPOD: integer read FPARPOD write SetPARPOD;
   property PAR_SKU_KN: byte read GetPAR_SKU_KN write SetPAR_SKU_KN stored false;
   property LV: integer read FLV write SetLV;
   property LVC: integer read FLVC write SetLVC;
   property PAR_Vymera: double read FPAR_Vymera write SetPAR_Vymera;
   property Kultura: integer read FKultura write SetKultura;
   property ParZar: boolean read FParZar write SetParZar;
   property PUPFL: boolean read FPUPFL write SetPUPFL;
   property PUPFLc: boolean read FPUPFLc write SetPUPFLc;
   property ParZar_Text: string read GetParZar_Text write SetParZar_Text stored false;
   property PUPFL_Text: string read GetPUPFL_Text write SetPUPFL_Text stored false;
   property PUPFLc_Text: string read GetPUPFLc_Text write SetPUPFLc_Text stored false;
   property PKCIS: integer read FPKCIS write SetPKCIS;
   property PKPOD: integer read FPKPOD write SetPKPOD;
   property PK_Dil: integer read FPK_Dil write SetPK_Dil;
   property ParName: string read GetParName write SetParName stored false;
   property ParNameAbs: string read GetParNameAbs write SetParNameAbs stored false;
   property ParNameAbsDTTO: string read GetParNameAbsDTTO stored false;
   property PKName: string read GetPKName write SetPKName stored false;
   property PKNameDtto: string read GetPKNameDTTO stored false;
   property PK_Text: string read GetPK_Text stored false;
   property GP_Text: string read GetGP_Text write SetGP_Text stored false;
   property NEP_TEXT: string read GetNEP_TEXT write SetNEP_Text stored false;
   property PARCAST: integer read GetPARCAST stored false;
   property SuperID: integer read FSuperID write SetSuperID;
   property PK: boolean read GetPK write SetPK stored false;
   property GP: boolean read FGP write SetGP;
   property NEP: boolean read FNEP write SetNEP;
   property Zmena: string read FZmena write SetZmena;
   property Poznamka: string read FPoznamka write SetPoznamka;
   property ATR_PUV: integer read FATR_PUV write SetATR_PUV;
   property Vlastnik: string read FVlastnik write SetVlastnik;
   property MAJ_DRUH: integer read FMAJ_DRUH write SetMAJ_DRUH;
   property MAJ_KOD: string read FMAJ_KOD write SetMAJ_KOD;
   property MAJ_Name: string read FMAJ_Name write SetMAJ_Name;
   property MAJ_Adresa: string read FMAJ_Adresa write SetMAJ_Adresa;
   property AssignBy: TElement write SetAssignBy stored false;
end;


Tgis_ParcelModel = class(TRectEntity)
private
    FActualKatastr: Tgis_Katastr;
    FActualParcela: Tgis_Parcela;
    FActualSkupinaParcel: Tgis_SkupinaParcel;
    FFullTest: boolean;
    FActualParCast: Tgis_ParcelaCast;
    FVersion: integer;
    FAutoCreate: boolean;
    procedure SetActualKatastr(const Value: Tgis_Katastr);
    procedure SetActualParcela(const Value: Tgis_Parcela);
    procedure SetActualSkupinaParcel(const Value: Tgis_SkupinaParcel);
    function GetKatastr_Cislo: integer;
    function GetParcela_CisloPodlomeni: string;
    function GetSkupinaParcel_Cislo: integer;
    procedure SeKatastr_Cislo(const Value: integer);
    procedure SetParcela_CisloPodlomeni(const Value: string);
    procedure SetSkupinaParcel_Cislo(const Value: integer);
    procedure SetUpdateAll(const Value: boolean);
    procedure SetSort(const Value: boolean);
    procedure SetFullTest(const Value: boolean);
    procedure SetDisconnect(const Value: boolean);
    procedure SetActualParCast(const Value: Tgis_ParcelaCast);
    function GetVersion: integer;
    procedure SetVersion(const Value: integer);
    function GetSkupinaParcel_Comment: string;
    procedure SetSkupinaParcel_Comment(const Value: string);
    function GetParCastPK_CisloPodlomeni: string;
    procedure SetParCastPK_CisloPodlomeni(const Value: string);
    procedure SetAutoCreate(const Value: boolean);
public
   procedure FreeAll; override;
   function GetKatastrCislo(aCislo: integer): Tgis_Katastr;
   function GetSkupinaParcelCislo(aCislo: integer): Tgis_SkupinaParcel;
   function GetSkupinaParcelComment(aComment: string): Tgis_SkupinaParcel;
   function GetParcelaCislo(aParcis,aParpod,aKATUZE_KOD_PUV: integer): Tgis_Parcela;
   function GetParCastPKCislo(aPKCis,aPKPod: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
   function GetParCastPKCisloDil(aPKCis,aPKPod,aPKDil: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
   function GetParCastDil(aPKDil: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
   function CreateKatastrCislo(aCislo: integer): Tgis_Katastr;
   function CreateSkupinaParcelCislo(aCislo: integer): Tgis_SkupinaParcel;
   function CreateSkupinaParcelComment(aComment: string): Tgis_SkupinaParcel;
   function CreateParcelaCislo(aParcis,aParpod, aKATUZE_KOD_PUV: integer): Tgis_Parcela;
   function CreateParCastPKCislo(aPKCis,aPKPod: integer): Tgis_ParcelaCast;
   function CreateParCastPKCisloDil(aPKCis,aPKPod,aPKDil: integer): Tgis_ParcelaCast;
   function CreateParCastDil(aPKDil: integer): Tgis_ParcelaCast;
   function CreateParCast: Tgis_ParcelaCast;
published
   property ActualKatastr: Tgis_Katastr read FActualKatastr write SetActualKatastr stored false;
   property ActualSkupinaParcel: Tgis_SkupinaParcel read FActualSkupinaParcel write SetActualSkupinaParcel stored false;
   property ActualParcela: Tgis_Parcela read FActualParcela write SetActualParcela stored false;
   property ActualParCast: Tgis_ParcelaCast read FActualParCast write SetActualParCast stored false;
   property Katastr_Cislo: integer read GetKatastr_Cislo write SeKatastr_Cislo stored false;
   property SkupinaParcel_Cislo: integer read GetSkupinaParcel_Cislo write SetSkupinaParcel_Cislo stored false;
   property SkupinaParcel_Comment: string read GetSkupinaParcel_Comment write SetSkupinaParcel_Comment stored false;
   property Parcela_CisloPodlomeni: string read GetParcela_CisloPodlomeni write SetParcela_CisloPodlomeni stored false;
   property ParCastPK_CisloPodlomeni: string read GetParCastPK_CisloPodlomeni write SetParCastPK_CisloPodlomeni stored false;
   property UpdateAll: boolean write SetUpdateAll stored false;
   property Sort: boolean write SetSort stored false;
   property FullTest: boolean read FFullTest write SetFullTest stored false;
   property Disconnect: boolean write SetDisconnect stored false;
   property Version: integer read GetVersion write SetVersion stored true;
   property AutoCreate: boolean read FAutoCreate write SetAutoCreate;
end;

IMPLEMENTATION
uses
   SysUtils,
   e_Class,
   e_Geometry,
   t_Sort,
   u_String;

{ Tgis_KatastralElement }

function Tgis_KatastralElement.GetMajitel: Tgis_Majitel;
begin
   result := Tgis_Majitel(FindOwnerClass(Tgis_Majitel));
end;

function Tgis_KatastralElement.GetMAJ_Adresa: string;
var
   M: Tgis_Majitel;
begin
   result := '';
   M := Majitel;
   if M = nil then exit;
   result := M.Adresa;
end;

function Tgis_KatastralElement.GetMAJ_DRUH: integer;
var
   M: Tgis_Majitel;
begin
   result := 0;
   M := Majitel;
   if M = nil then exit;
   result := M.MAJ_DRUH;
end;

function Tgis_KatastralElement.GETMAJ_KOD: string;
var
   M: Tgis_Majitel;
begin
   result := '0';
   M := Majitel;
   if M = nil then exit;
   result := M.MAJ_KOD;
end;

function Tgis_KatastralElement.GetMAJ_Name: string;
var
   M: Tgis_Majitel;
begin
   result := '';
   M := Majitel;
   if M = nil then exit;
   result := M.FullName;
end;

function Tgis_KatastralElement.GetMultiElement: boolean;
begin
   result := true;
end;

function Tgis_KatastralElement.GetMultiElementClass: TElementClass;
begin
   result := TMulTiAreaElement;
end;

function Tgis_KatastralElement.GetName: string;
begin
   result := IntToStr(FCislo);
end;

function Tgis_KatastralElement.GetOLH: TGis_OLH;
begin
   result := Tgis_OLH(FindOwnerClass(Tgis_OLH));
end;

function Tgis_KatastralElement.GetOLH_Adresa: string;
var
   anOLH: TGis_OLH;
begin
   result := '';
   anOLH := OLH;
   if anOLH <> nil then
      result := OLH.Adresa;
end;

function Tgis_KatastralElement.GetOLH_ID: string;
var
   anOLH: TGis_OLH;
begin
   result := '';
   anOLH := OLH;
   if anOLH <> nil then
      result := OLH.OLH_ID;
end;

function Tgis_KatastralElement.GetOLH_Name: string;
var
   anOLH: TGis_OLH;
begin
   result := '';
   anOLH := OLH;
   if anOLH <> nil then
      result := OLH.FullName;
end;

function Tgis_KatastralElement.GetOLH_PR_TIT: string;
var
   anOLH: TGis_OLH;
begin
   result := '';
   anOLH := OLH;
   if anOLH <> nil then
      result := OLH.OLH_PR_TIT;
end;

function Tgis_KatastralElement.GetSameMajitel: boolean;
begin
   result := true;
end;

function Tgis_KatastralElement.GetSameOLH: boolean;
begin
   result := true;
end;

function Tgis_KatastralElement.GetVlastnik: string;
var
   M: Tgis_Majitel;
begin
   result := '0';
   M := Majitel;
   if M = nil then exit;
   result := M.Cislo;
end;


procedure Tgis_KatastralElement.SetaID(const Value: string);
begin
  FaID := Value;
end;

procedure Tgis_KatastralElement.SetBarva(const Value: integer);
begin
  FBarva := Value;
end;

procedure Tgis_KatastralElement.SetCislo(const Value: integer);
begin
   FCislo := Value;
end;

procedure Tgis_KatastralElement.SetMajitel(const Value: Tgis_Majitel);
var
   M: Tgis_Majitel;
begin
   M := Majitel;
   if Value = M then exit;   //ftejnej
   if M <> nil then
      M.RemoveElement(Self);
   if Value <> nil then
      Value.AddElement(Self);
end;

procedure Tgis_KatastralElement.SetName(aName: string);
begin
end;

procedure Tgis_KatastralElement.SetOLH(const Value: TGis_OLH);
var
   O: Tgis_OLH;
begin
   O := OLH;
   if Value = O then exit;   //ftejnej
   if O <> nil then
      O.RemoveElement(Self);
   if Value <> nil then
      Value.AddElement(Self);
end;


procedure Tgis_KatastralElement.SetVlastnik(const Value: string);
begin

end;

procedure Tgis_KatastralElement.SetZnacka(const Value: integer);
begin
  FZnacka := Value;
end;

{ Tgis_Katastr }

function Tgis_Katastr.CreateParcelaCislo(aParcis, aParpod, aKATUZE_KOD_PUV: integer; aSKP: Tgis_SkupinaParcel): Tgis_Parcela;
var
   Par: Tgis_Parcela;
begin
   Par := GetParcelaCislo(aParcis,aParpod, aKATUZE_KOD_PUV);
   if Par = nil then
   begin
      Par := Tgis_Parcela.Create;
      Par.Parcis := aParcis;
      Par.Parpod := aParpod;
      if aKATUZE_KOD_PUV < 0 then
         Par.KATUZE_KOD_PUV := 0
      else
         Par.KATUZE_KOD_PUV := aKATUZE_KOD_PUV;
      NextParcela := Par;
      if (aSKP <> nil) and (aSKP.Katastr = Self) then
      begin
         Par.SkupinaParcel := aSKP;
      end;
   end;
   result := Par;
end;

function Tgis_Katastr.CreateSkupinaParcelCislo(aCislo: integer): Tgis_SkupinaParcel;
var
   SP: Tgis_SkupinaParcel;
begin
   SP := GetSkupinaParcelCislo(aCislo);
   if SP = nil then
   begin
      SP := Tgis_SkupinaParcel.Create;
      SP.Cislo := aCislo;
      NextSkupinaParcel := SP;
   end;
   result := SP;
end;

function Tgis_Katastr.CreateSkupinaParcelComment(aComment: string): Tgis_SkupinaParcel;
var
   SP: Tgis_SkupinaParcel;
begin
   if (aComment = '0') or (aComment='') then
   begin
      result := CreateSkupinaParcelCislo(0);
      exit;
   end;
   SP := GetSkupinaParcelComment(aComment);
   if SP = nil then
   begin
      SP := Tgis_SkupinaParcel.Create;
      NextSkupinaParcel := SP;
      SP.Cislo := SkupinyParcel.IndexOf(SP)+1;
      SP.Comment := aComment;
   end;
   result := SP;
end;

function Tgis_Katastr.GetNoParcela: boolean;
begin
   result := (Parcely = nil) or Parcely.NoElements;
end;

function Tgis_Katastr.GetNoSkupinaparcel: boolean;
begin
   result := (SkupinyParcel = nil) or SkupinyParcel.NoElements;
end;

function Tgis_Katastr.GetParcelaCislo(aParcis, aParpod, aKATUZE_KOD_PUV: integer): Tgis_Parcela;
var
   i: integer;
   Par: Tgis_Parcela;
   DontUseKKP: boolean;
begin
   result := nil;
   if Parcely = nil then exit;
   DontUseKKP := aKATUZE_KOD_PUV < 0;
   for i := 0 to Parcely.LastIndex do
   begin
      Par := Tgis_Parcela(Parcely.Elements[i]);
      if (Par.PARCIS = aParcis) and (Par.PARPOD = aParpod) and (DontUseKKP or (Par.KATUZE_KOD_PUV = aKATUZE_KOD_PUV)) then
      begin
         result := Par;
         exit;
      end;
   end;
end;

function Tgis_Katastr.GetParcely: Tgis_KParcely;
begin
   if FParcely = nil then
      FParcely := Tgis_KParcely(FindElementClass(Tgis_KParcely));
   result := FParcely;
end;

function Tgis_Katastr.GetSkupinaParcelCislo(aCislo: integer): Tgis_SkupinaParcel;
var
   i: integer;
   SP: Tgis_SkupinaParcel;
begin
   result := nil;
   if SkupinyParcel = nil then exit;
   for i := 0 to SkupinyParcel.LastIndex do
   begin
      SP := Tgis_SkupinaParcel(SkupinyParcel.Elements[i]);
      if SP.Cislo = aCislo then
      begin
         result := SP;
         exit;
      end;
   end;
end;

function Tgis_Katastr.GetSkupinaParcelComment(aComment: string): Tgis_SkupinaParcel;
var
   SP: Tgis_SkupinaParcel;
   i: integer;
begin
   result := nil;
   if (aComment = '0') or (aComment = '') then
   begin
      result := GetSkupinaParcelCislo(0);
      exit;
   end;
   if SkupinyParcel = nil then exit;
   for i := 0 to SkupinyParcel.LastIndex do
   begin
      SP := Tgis_SkupinaParcel(SkupinyParcel.Elements[i]);
      if SameText(aComment,SP.Comment) then
      begin
         result := SP;
         exit;
      end;
   end;
end;

function Tgis_Katastr.GetSkupinyParcel: Tgis_SkupinyParcel;
begin
   if FSkupinyParcel = nil then
      FSkupinyParcel := Tgis_SkupinyParcel(FindElementClass(Tgis_SkupinyParcel));
   result := FskupinyParcel;
end;

procedure Tgis_Katastr.SetCislo_(const Value: integer);
begin
  FCislo_ := Value;
end;

procedure Tgis_Katastr.SetKraj(const Value: string);
begin
  FKraj := Value;
end;

procedure Tgis_Katastr.SetKraj_Nazev(const Value: string);
begin
  FKraj_Nazev := Value;
end;

procedure Tgis_Katastr.SetNazev(const Value: string);
begin
   FNazev := Value;
end;

procedure Tgis_Katastr.SetNextParcela(const Value: Tgis_Parcela);
begin
   if Parcely = nil then
      Parcely := Tgis_KParcely.Create;
   Parcely.AddAndUpdateRect(Value);
end;

procedure Tgis_Katastr.SetNextSkupinaParcel(const Value: Tgis_SkupinaParcel);
begin
   if SkupinyParcel = nil then
      SkupinyParcel := Tgis_SkupinyParcel.Create;
   SkupinyParcel.AddAndUpdateRect(Value);
end;

procedure Tgis_Katastr.SetORP(const Value: integer);
begin
  FORP := Value;
end;

procedure Tgis_Katastr.SetORP_Nazev(const Value: string);
begin
  FORP_Nazev := Value;
end;

procedure Tgis_Katastr.SetParcely(const Value: Tgis_KParcely);
begin
   ExchangeFieldElement(TElement(FParcely), Value);
end;

procedure Tgis_Katastr.SetPoznamka(const Value: string);
begin
  FPoznamka := Value;
end;

procedure Tgis_Katastr.SetSkupinyParcel(const Value: Tgis_SkupinyParcel);
begin
   ExchangeFieldElement(TElement(FSkupinyParcel), Value);
end;

procedure Tgis_Katastr.SetSwapCislo(const Value: boolean);
var
   i: integer;
begin
   i := Cislo;
   Cislo := Cislo_;
   Cislo_ := i;
end;

{ Tgis_ParcelaElement }


function Tgis_ParcelaElement.GetIsKUMajitel: boolean;
var
   K: Tgis_Katastr;
begin
   result := false;
   K := Katastr;
   if K = nil then exit;
   result := K.Majitel <> nil;
end;

function Tgis_ParcelaElement.GetIsKUOLH: boolean;
var
   K: Tgis_Katastr;
begin
   result := false;
   K := Katastr;
   if K = nil then exit;
   result := K.OLH <> nil;
end;

function Tgis_ParcelaElement.GetKraj: string;
var
   K: Tgis_Katastr;
begin
   result := '';
   K := Katastr;
   if K = nil then exit;
   result := K.Kraj;
end;

function Tgis_ParcelaElement.GetKraj_Nazev: string;
var
   K: Tgis_Katastr;
begin
   result := '';
   K := Katastr;
   if K = nil then exit;
   result := K.Kraj_Nazev;
end;

function Tgis_ParcelaElement.GetKUMajitel: Tgis_Majitel;
var
   K: Tgis_Katastr;
begin
   result := nil;
   K := Katastr;
   if K = nil then exit;
   result := K.Majitel;
end;

function Tgis_ParcelaElement.GetKUOLH: Tgis_OLH;
var
   K: Tgis_Katastr;
begin
   result := nil;
   K := Katastr;
   if K = nil then exit;
   result := K.OLH;
end;

function Tgis_ParcelaElement.GetKU_KOD: integer;
var
   K: Tgis_Katastr;
begin
   result := -1;
   K := Katastr;
   if K <> nil then
      result := K.Cislo;
end;

function Tgis_ParcelaElement.GetKU_KOD_: integer;
var
   K: Tgis_Katastr;
begin
   result := -1;
   K := Katastr;
   if K <> nil then
      result := K.Cislo_;
end;

function Tgis_ParcelaElement.GetKU_Nazev: string;
var
   K: Tgis_Katastr;
begin
   result := '';
   K := Katastr;
   if K <> nil then
      result := K.Nazev;
end;



function Tgis_ParcelaElement.GetKU_Poznamka: string;
var
   K: Tgis_Katastr;
begin
   result := '';
   K := Katastr;
   if K <> nil then
      result := K.Poznamka;
end;

function Tgis_ParcelaElement.GetMultiparcela: boolean;
begin
   result := false;
end;

function Tgis_ParcelaElement.GetMultiVymera: double;
begin
   result := 0;
end;

function Tgis_ParcelaElement.GetORP: integer;
var
   K: Tgis_Katastr;
begin
   result := 0;
   K := Katastr;
   if K <> nil then
      result := K.ORP;
end;

function Tgis_ParcelaElement.GetORP_Nazev: string;
var
   K: Tgis_Katastr;
begin
   result := '';
   K := Katastr;
   if K <> nil then
      result := K.ORP_Nazev;
end;

function Tgis_ParcelaElement.GetPlocha: double;
begin
   result := 0;
   if NoGeometry then exit;
   if not (Geometry is TAreaElement) then exit;
   result := TAreaElement(Geometry).Area;
end;

function Tgis_ParcelaElement.GetPlocha_ha: double;
begin
   result := Plocha / 10000;
end;



function Tgis_ParcelaElement.GetSKUPAR_Comment: string;
begin
   result := '';
end;


function Tgis_ParcelaElement.GetVymera: double;
begin
   result := FVymera;
end;

procedure Tgis_ParcelaElement.SetAddVymera(const Value: double);
begin
   Vymera := Vymera + Value;
end;

procedure Tgis_ParcelaElement.SetKatastr(const Value: Tgis_Katastr);
begin

end;

procedure Tgis_ParcelaElement.SetKATPAR_KOD(const Value: integer);
begin
   FKATPAR_KOD := Value;
end;


procedure Tgis_ParcelaElement.SetKVAL_P(const Value: byte);
begin
   FKVAL_P := Value;
end;



procedure Tgis_ParcelaElement.SetSKUPAR_Comment(const Value: string);
begin

end;


procedure Tgis_ParcelaElement.SetTEL_ID(const Value: string);
begin
  FTEL_ID := Value;
end;

procedure Tgis_ParcelaElement.SetVymera(const Value: double);
begin
   FVymera := Value;
end;

{ Tgis_SkupinyParcel }

function Tgis_SkupinyParcel.GetName: string;
begin
   result := 'Skupiny parcel';
end;

procedure Tgis_SkupinyParcel.SetName(aName: string);
begin
end;

{ Tgis_Parcely }

function Tgis_Parcely.GetName: string;
begin
   result := 'Parcely';
end;

procedure Tgis_Parcely.SetName(aName: string);
begin
end;

{ Tgis_SkupinaParcel }

function Tgis_SkupinaParcel.CreateParcelaCislo(aParcis,aParpod, aKATUZE_KOD_PUV: integer): Tgis_Parcela;
var
   Par: Tgis_Parcela;
begin
   Par := GetParcelaCislo(aParcis,aParpod, aKATUZE_KOD_PUV);
   if Par = nil then
   begin
      Par := Tgis_Parcela.Create;
      Par.Parcis := aParcis;
      Par.Parpod := aParpod;
      Par.KATUZE_KOD_PUV := aKATUZE_KOD_PUV;
      NextParcela := Par;
   end;
   result := Par;
end;

procedure Tgis_SkupinaParcel.RemovePorost(aValue: TElement);
begin
   if Porosty = nil then exit;
   Porosty.RemoveElement(aValue);
end;

procedure Tgis_SkupinaParcel.RemoveSkupina(aValue: TElement);
begin
   if Skupiny = nil then exit;
   Skupiny.RemoveElement(aValue);
end;

function Tgis_SkupinaParcel.GetKatastr: Tgis_Katastr;
var
   SK: Tgis_SkupinyParcel;
begin
   result := nil;
   SK := Tgis_SkupinyParcel(FindOwnerClass(Tgis_SkupinyParcel));
   if SK = nil then exit;
   result := Tgis_Katastr(SK.FindOwnerClass(Tgis_Katastr));
end;

function Tgis_SkupinaParcel.GetParcelaCislo(aParcis,
  aParpod, aKATUZE_KOD_PUV: integer): Tgis_Parcela;
var
   i: integer;
   Par: Tgis_Parcela;
begin
   result := nil;
   if Parcely = nil then exit;
   for i := 0 to Parcely.LastIndex do
   begin
      Par := Tgis_Parcela(Parcely.Elements[i]);
      if (Par.PARCIS = aParcis) and (Par.PARPOD = aParpod) and (Par.KATUZE_KOD_PUV = aKATUZE_KOD_PUV)then
      begin
         result := Par;
         exit;
      end;
   end;
end;

function Tgis_SkupinaParcel.GetParcely: Tgis_Parcely;
begin
   if FParcely = nil then
      FParcely := Tgis_Parcely(FindElementClass(Tgis_Parcely));
   result := FParcely;
end;

function Tgis_SkupinaParcel.GetPorosty: TForest_ParcelConnectionEntity;
begin
   if FPorosty = nil then
      FPorosty := TForest_ParcelConnectionEntity(FindElementClass(TForest_ParcelConnectionEntity));
   result := FPorosty;
end;

function Tgis_SkupinaParcel.GetSkupiny: TForest_ParcelDetailConnectionEntity;
begin
   if FSkupiny = nil then
      FSkupiny := TForest_ParcelDetailConnectionEntity(FindElementClass(TForest_ParcelDetailConnectionEntity));
   result := FSkupiny;
end;

function Tgis_SkupinaParcel.GetSKUPAR_CIS: integer;
begin
   result := cislo;
end;

procedure Tgis_SkupinaParcel.SetNextParcela(const Value: Tgis_Parcela);
begin
   if Parcely = nil then
      Parcely := Tgis_Parcely.Create;
   Parcely.AddAndUpdateRect(Value);
end;

procedure Tgis_SkupinaParcel.SetNextporost(const Value: TElement);
begin
   if Porosty = nil then
      Porosty := TForest_ParcelConnectionEntity.Create;
   if Porosty.IndexOf(Value) > -1 then exit;
   Porosty.AddElement(Value);
end;

procedure Tgis_SkupinaParcel.SetNextSkupina(const Value: TElement);
begin
   if Skupiny = nil then
      Skupiny := TForest_ParcelDetailConnectionEntity.Create;
   if Skupiny.IndexOf(Value) > -1 then exit;
   Skupiny.AddElement(Value);
end;

procedure Tgis_SkupinaParcel.SetOLH(const Value: Tgis_OLH);
var
   i: integer;
begin
  if not NoParcela then
  for i := 0 to Parcely.LastIndex do
     Tgis_Parcela(Parcely.Elements[i]).OLH := Value;
  if not NoParCast then
  for i := 0 to ParCasti.LastIndex do
     Tgis_ParcelaCast(Parcasti.Elements[i]).OLH := Value;

end;

procedure Tgis_SkupinaParcel.SetParcely(const Value: Tgis_Parcely);
begin
   ExchangeFieldElement(TElement(FParcely), Value);
end;

procedure Tgis_SkupinaParcel.SetPorosty(const Value: TForest_ParcelConnectionEntity);
begin
   ExchangeFieldElement(TElement(FPorosty), Value);
end;

procedure Tgis_SkupinaParcel.SetSkupiny(const Value: TForest_ParcelDetailConnectionEntity);
begin
   ExchangeFieldElement(TElement(FSkupiny), Value);
end;

procedure Tgis_SkupinaParcel.SetSKUPAR_CIS(const Value: integer);
begin
   Cislo := Value;
end;

function Tgis_SkupinaParcel.GetNoParcela: boolean;
begin
   result := (Parcely = nil) or Parcely.NoElements;
end;

{
function Tgis_SkupinaParcel.GetVymera: double;
var
   i: integer;
   P: Tgis_Parcela;
begin
   result := 0;
   if NoParcela then
   begin
      result := FVymera;
   end
   else
   begin
      for i := 0 to Parcely.LastIndex do
      begin
         P := Tgis_Parcela(Parcely.Elements[i]);
         result := result + P.Vymera;
      end;
   end;
end;
}


function Tgis_SkupinaParcel.GetNoParCast: boolean;
begin
   result := (ParCasti = nil) or ParCasti.NoElements;
end;

function Tgis_SkupinaParcel.GetParCasti: Tgis_ParCasti;
begin
   if FParCasti = nil then
      FParCasti := Tgis_ParCasti(FindElementClass(Tgis_ParCasti));
   result := FParCasti;
end;

procedure Tgis_SkupinaParcel.SetNextParCast(const Value: Tgis_ParcelaCast);
begin
   if ParCasti = nil then
      ParCasti := Tgis_ParCasti.Create;
   ParCasti.AddAndUpdateRect(Value);
end;

procedure Tgis_SkupinaParcel.SetParCasti(const Value: Tgis_ParCasti);
begin
   ExchangeFieldElement(TElement(FParCasti), Value);
end;

procedure Tgis_SkupinaParcel.RemoveParCast(aValue: TElement);
begin
   if Parcasti = nil then exit;
   Parcasti.RemoveElement(aValue);
end;

procedure Tgis_SkupinaParcel.RemoveParcela(aValue: TElement);
begin
   if Parcely = nil then exit;
   Parcely.RemoveElement(aValue);
end;

function Tgis_SkupinaParcel.GetNoPorosty: boolean;
begin
   result := (Porosty = nil) or Porosty.NoElements;
end;

function Tgis_SkupinaParcel.GetNoSkupiny: boolean;
begin
   result := (Skupiny = nil) or Skupiny.NoElements;
end;

function Tgis_SkupinaParcel.GetOLH: Tgis_OLH;
var
   PC: Tgis_ParcelaCast;
begin
   //result := nil;
   // tady ten zatek bych si moh odpustit, spolen majitel katastru by vylezl i z parcely
   result := KUOLH;
   if result = nil then // Katastr majitele nema, hledame v parcelach
   begin
      PC := GetFirstParCast;
      if PC <> nil then
         result := PC.OLH;
   end;
end;

function Tgis_SkupinaParcel.GetForestConnected: boolean;
begin
   result := not NoPorosty or not NoSkupiny;
end;

procedure Tgis_SkupinaParcel.SetComment(const Value: string);
begin
  FComment := Value;
end;

function Tgis_SkupinaParcel.GetSKUPAR_Comment: string;
begin
   result := Comment;
end;

procedure Tgis_SkupinaParcel.SetSKUPAR_Comment(const Value: string);
begin
   Comment := Value;
end;


function Tgis_SkupinaParcel.GetSameMajitel: boolean;
var
   i: integer;
   e: TElement;
   P: Tgis_Parcela;
   PC: Tgis_ParcelaCast;
begin
   result := true;
   if not NoParcela then
   for i := 0 to Parcely.LastIndex do
   begin
      e := Parcely.Elements[i];
      if not (e is Tgis_Parcela) then continue;
      P := Tgis_Parcela(e);
      if not P.SameMajitel or (P.Majitel <> Majitel) then
      begin
         result := false;
         exit;
      end;
   end;
   if not NoParcast  then
   for i := 0 to Parcasti.LastIndex do
   begin
      e := Parcasti.Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      PC  := Tgis_ParcelaCast(e);
      if PC.Majitel <> Majitel then
      begin
         result := false;
         exit;
      end;
   end;
end;

function Tgis_SkupinaParcel.GetSameOLH: boolean;
var
   i: integer;
   e: TElement;
   P: Tgis_Parcela;
   PC: Tgis_ParcelaCast;
begin
   result := true;
   if not NoParcela then
   for i := 0 to Parcely.LastIndex do
   begin
      e := Parcely.Elements[i];
      if not (e is Tgis_Parcela) then continue;
      P := Tgis_Parcela(e);
      if not P.SameOLH or (P.OLH <> OLH) then
      begin
         result := false;
         exit;
      end;
   end;
   if not NoParcast  then
   for i := 0 to Parcasti.LastIndex do
   begin
      e := Parcasti.Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      PC  := Tgis_ParcelaCast(e);
      if PC.OLH <> OLH then
      begin
         result := false;
         exit;
      end;
   end;
end;

function Tgis_SkupinaParcel.GetMajitel: Tgis_Majitel;
var
   PC: Tgis_ParcelaCast;
begin
   //result := nil;
   // tady ten zatek bych si moh odpustit, spolen majitel katastru by vylezl i z parcely
   result := KUMajitel;
   if result = nil then // Katastr majitele nema, hledame v parcelach
   begin
      PC := GetFirstParCast;
      if PC <> nil then
         result := PC.Majitel;
   end;
end;

procedure Tgis_SkupinaParcel.SetMajitel(const Value: Tgis_Majitel);
var
   i: integer;
begin
  if not NoParcela then
  for i := 0 to Parcely.LastIndex do
     Tgis_Parcela(Parcely.Elements[i]).Majitel := Value;
  if not NoParCast then
  for i := 0 to ParCasti.LastIndex do
     Tgis_ParcelaCast(Parcasti.Elements[i]).Majitel := Value;

end;

function Tgis_SkupinaParcel.GetFirstParCast: Tgis_ParcelaCast;
var
   P: Tgis_Parcela;
begin
   result := nil;
   if not NoParcast then
      result :=  Tgis_ParcelaCast(ParCasti.Elements[0])
   else
   if not NoParcela then
   begin
      P := Tgis_Parcela(Parcely.Elements[0]);
      if P = nil then exit;
      result := Tgis_ParcelaCast(P.FindElementClass(Tgis_ParcelaCast));
   end;
end;

function Tgis_SkupinaParcel.GetLV: integer;
var
   PC: Tgis_ParcelaCast;
begin
   result := 0;
   PC := GetFirstParCast;
   if PC <> nil then
      result := PC.LV;
end;

function Tgis_SkupinaParcel.GetLVc: integer;
var
   PC: Tgis_ParcelaCast;
begin
   result := 0;
   PC := GetFirstParCast;
   if PC <> nil then
      result := PC.LVc;
end;

{ Tgis_Parcela }

function Tgis_Parcela.GetKatastr: Tgis_Katastr;
var
   KP: Tgis_KParcely;
begin
   result := nil;
   KP := Tgis_KParcely(FindOwnerClass(Tgis_KParcely));
   if KP = nil then exit;
   result := Tgis_Katastr(KP.FindOwnerClass(Tgis_Katastr));
end;

function Tgis_Parcela.GetSKUPAR_CIS: integer;
var
   SK: Tgis_SkupinaParcel;
begin
   result := -1;
   SK := SkupinaParcel;
   if SK = nil then exit;
   result := SK.Cislo;
end;

function Tgis_Parcela.GetSkupinaParcel: Tgis_SkupinaParcel;
var
   P: Tgis_Parcely;
begin
   result := nil;
   P := Tgis_Parcely(FindOwnerClass(Tgis_Parcely));
   if P = nil then exit;
   result := Tgis_SkupinaParcel(P.FindOwnerClass(Tgis_SkupinaParcel));
end;

procedure Tgis_Parcela.SetPAR_SKU_KN(const Value: byte);
var
   i: integer;
begin
   i := ABS(PARCIS);
   PK := false;
   if (Value = 1) or (Value = 4) or (Value = 6)then
      PARCIS := -i
   else
      PARCIS := i;
   PK := Value > 2;
end;

procedure Tgis_Parcela.SetPARPOD(const Value: integer);
begin
   FPARPOD := Value;
end;

procedure Tgis_Parcela.SetSKUPAR_CIS(const Value: integer);
begin
   ///!!!!!!!!!!!!!!!
end;

function Tgis_Parcela.GetName: string;
begin
   result := IntToStr(PARCIS);
   if PARPOD > 0 then
      result := result+'/'+ IntToStr(PARPOD);
end;

procedure Tgis_Parcela.SetName(aName: string);
var
   S1,S2: string;
begin
   if StringAsTwoParams(aName,'/',S1,S2) then
      PARPOD := StrToIntDef(S2,0)
   else
      PARPOD := 0;
   PARCIS := StrToIntDef(S1,0);
end;

procedure Tgis_Parcela.SetLV(const Value: integer);
begin
   FLV := Value;
end;

function Tgis_Parcela.GetPAR_SKU_KN: byte;
begin
   if PARCIS < 0 then
      result := 1
   else
      result := 2;
   if PK then
      result := result + 3;
end;

function Tgis_Parcela.GetPARCISAbs: integer;
begin
   result := Abs(PARCIS);
end;

procedure Tgis_Parcela.SetKultura(const Value: integer);
begin
  FKultura := Value;
end;

procedure Tgis_Parcela.SetParZar(const Value: boolean);
begin
  FParZar := Value;
end;

procedure Tgis_Parcela.SetPUPFL(const Value: boolean);
begin
  FPUPFL := Value;
end;

procedure Tgis_SkupinaParcel.SetDisconnect(const Value: boolean);
var
   e: TElement;
begin
   if not Value then exit;
   e := Porosty;
   if e <> nil then
      Porosty := nil;
   e := Skupiny;
   if e <> nil then
      Skupiny := nil;
end;

function Tgis_Parcela.GetParZar_Text: string;
begin
   if PARZAR then
      result := 'ANO'
   else
      result := 'NE';
end;

function Tgis_Parcela.GetPUPFL_Text: string;
begin
   if PUPFL then
      result := 'ANO'
   else
      result := 'NE';
end;

procedure Tgis_Parcela.SetParZar_Text(const Value: string);
begin
   if Value = '' then exit;
   if UpperCase(Value)[1] = 'A' then
      ParZar := true
   else
      ParZar := false;
end;

procedure Tgis_Parcela.SetPUPFL_Text(const Value: string);
begin
   if Value = '' then exit;
   if UpperCase(Value)[1] = 'A' then
      PUPFL := true
   else
      PUPFL := false;
end;

procedure Tgis_Parcela.SetSkupinaParcel(const Value: Tgis_SkupinaParcel);
var
   SKP: Tgis_SkupinaParcel;
begin
   SKP := GetSkupinaParcel;
   if SKP = Value then exit;
   if SKP <> nil then
      SKP.RemoveParcela(Self);
   if Value <> nil then
      Value.NextParcela := Self;
end;

procedure Tgis_Parcela.SetKatastr(const Value: Tgis_Katastr);
var
   K: Tgis_Katastr;
begin
   K := GetKatastr;
   if K = Value then exit;
   if K <> nil then
      K.Parcely.RemoveElement(Self);
   Value.NextParcela := Self;
end;

function Tgis_Parcela.CreateParCast: Tgis_ParcelaCast;
begin
   result := Tgis_ParcelaCast.Create;
   AddElement(result);
end;

function Tgis_Parcela.GetPlocha: double;
var
   i: integer;
   pc: Tgis_ParcelaCast;
   e: TElement;
begin
   result := 0;
   for i := 0 to LastIndex do
   begin
      e := Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      pc := Tgis_ParcelaCast(e);
      result := result + pc.Plocha;
   end;
end;

function Tgis_Parcela.GetMultiparcela: boolean;
var
   i: integer;
   e: TElement;
   casti: integer;
begin
   result := false;
   casti := 0;
   for i := 0 to LastIndex do
   begin
      e := Elements[i];
      if (e is Tgis_ParcelaCast) then Inc(Casti);
      result := casti > 1;
      if result then exit;
   end;
end;

function Tgis_Parcela.GetMultiVymera: double;
var
   i: integer;
   e: TElement;
begin
   result := 0;
   for i := 0 to LastIndex do
   begin
      e := Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      result := result + Tgis_ParcelaCast(e).Vymera;
   end;
end;

function Tgis_Parcela.GetParCastByXY(aX, aY: double): Tgis_ParcelaCast;
var
   i: integer;
   e: TElement;
   PC: Tgis_ParcelaCast;
begin
   result := nil;
   for i := 0 to LastIndex do
   begin
      e := Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      PC := Tgis_ParcelaCast(e);
      if PC.IsHitByXY(aX,aY,0) then
      begin
         result := PC;
         exit;
      end;
   end;
end;

procedure Tgis_Parcela.SetPK(const Value: boolean);
begin
  FPK := Value;
end;

function Tgis_Parcela.GetSKUPAR_Comment: string;
var
   SK: Tgis_SkupinaParcel;
begin
   result := '';
   SK := SkupinaParcel;
   if SK = nil then exit;
   result := SK.Comment;
end;

procedure Tgis_Parcela.SetSKUPAR_Comment(const Value: string);
begin
   ///-----------------
end;

function Tgis_Parcela.GetMajitel: Tgis_Majitel;
var
   PC: Tgis_ParcelaCast;
begin
   result := nil;
   PC := Tgis_ParcelaCast(FindElementClass(Tgis_ParcelaCast));
   if PC <> nil then
   begin
      result := PC.Majitel;
   end;
end;

procedure Tgis_Parcela.SetMajitel(const Value: Tgis_Majitel);
var
   i: integer;
   e: TElement;
   PC: Tgis_ParcelaCast;
begin
   for i := 0 to LastIndex do
   begin
      e := Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      PC := Tgis_ParcelaCast(e);
      PC.Majitel := Value;
   end;
end;

procedure Tgis_Parcela.SetOLH(const Value: Tgis_OLH);
var
   i: integer;
   e: TElement;
   PC: Tgis_ParcelaCast;
begin
   for i := 0 to LastIndex do
   begin
      e := Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      PC := Tgis_ParcelaCast(e);
      PC.OLH := Value;
   end;
end;

function Tgis_Parcela.GetSameMajitel: boolean;
var
   i: integer;
   e: TElement;
   PC: Tgis_ParcelaCast;
   M: Tgis_Majitel;
begin
   M := nil;
   result := true;
   for i := 0 to LastIndex do
   begin
      e := Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      PC := Tgis_ParcelaCast(e);
      if M = nil then
         M := PC.Majitel
      else
      if M <> PC.Majitel then
      begin
         result := false;
         exit;
      end;
   end;
end;

function Tgis_Parcela.GetSameOLH: boolean;
var
   i: integer;
   e: TElement;
   PC: Tgis_ParcelaCast;
   O: Tgis_OLH;
begin
   O := nil;
   result := true;
   for i := 0 to LastIndex do
   begin
      e := Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      PC := Tgis_ParcelaCast(e);
      if O = nil then
         O := PC.OLH
      else
      if O <> PC.OLH then
      begin
         result := false;
         exit;
      end;
   end;
end;

function Tgis_Parcela.CreateParcastPKCislo(aPKCis,aPKPod: integer): Tgis_ParcelaCast;
begin
   result := GetParcastPKCislo(aPKCis,aPKPod,false,false);
   if result = nil then
   begin
      result := CreateParCast;
      result.PKCIS := aPKCis;
      result.PKPOD := aPKPod;
   end;
end;

function Tgis_Parcela.GetParcastPKCislo(aPKCis,aPKPod: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
var
   i: integer;
   e: TElement;
   PC: Tgis_ParcelaCast;
begin
   result := nil;
   for i := 0 to LastIndex do
   begin
      e := Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      PC := Tgis_ParcelaCast(e);
      if not((PC.PKCIS = aPKCis) and (PC.PKPOD = aPKPod)) then continue;
      if UseGP and not (PC.GP = aGP) then continue;
      result := PC;
      exit;
   end;
end;

function Tgis_Parcela.GetNextParcastPKCislo(aParcast: Tgis_ParcelaCast; aPKCis, aPKPod: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
var
   i,Fi: integer;
   e: TElement;
   PC: Tgis_ParcelaCast;
begin
   result := nil;
   if aParcast = nil then
      Fi := 0
   else
   begin
      Fi := IndexOf(aParcast);
      Inc(Fi);
      if Fi > LastIndex then exit;
   end;
   for i := Fi to LastIndex do
   begin
      e := Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      PC := Tgis_ParcelaCast(e);
      if not((PC.PKCIS = aPKCis) and (PC.PKPOD = aPKPod)) then continue;
      if UseGP and not (PC.GP = aGP) then continue;
      result := PC;
      exit;
   end;
end;

function Tgis_Parcela.CreateParcastPKCisloDil(aPKCis, aPKPod,
  aPKDil: integer): Tgis_ParcelaCast;
begin
   result := GetParcastPKCisloDil(aPKCis,aPKPod,aPKDil,false,false);
   if result = nil then
   begin
      result := CreateParCast;
      result.PKCIS := aPKCis;
      result.PKPOD := aPKPod;
      result.PK_Dil := aPKDil;
   end;
end;

function Tgis_Parcela.GetNextParcastPKCisloDil(aParcast: Tgis_ParcelaCast;
  aPKCis, aPKPod, aPKDil: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
var
   i,Fi: integer;
   e: TElement;
   PC: Tgis_ParcelaCast;
begin
   result := nil;
   if aParcast = nil then
      Fi := 0
   else
   begin
      Fi := IndexOf(aParcast);
      Inc(Fi);
      if Fi > LastIndex then exit;
   end;
   for i := Fi to LastIndex do
   begin
      e := Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      PC := Tgis_ParcelaCast(e);
      if not((PC.PKCIS = aPKCis) and (PC.PKPOD = aPKPod) and (PC.PK_Dil = aPKDil)) then continue;
      if UseGP and not (PC.GP = aGP) then continue;
      result := PC;
      exit;
   end;
end;

function Tgis_Parcela.GetOLH: Tgis_OLH;
var
   PC: Tgis_ParcelaCast;
begin
   result := nil;
   PC := Tgis_ParcelaCast(FindElementClass(Tgis_ParcelaCast));
   if PC <> nil then
   begin
      result := PC.OLH;
   end;
end;

function Tgis_Parcela.GetParcastPKCisloDil(aPKCis, aPKPod,
  aPKDil: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
var
   i: integer;
   e: TElement;
   PC: Tgis_ParcelaCast;
begin
   result := nil;
   for i := 0 to LastIndex do
   begin
      e := Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      PC := Tgis_ParcelaCast(e);
      if not((PC.PKCIS = aPKCis) and (PC.PKPOD = aPKPod) and (PC.PK_Dil = aPKDil)) then continue;
      if UseGP and not (PC.GP = aGP) then continue;
      result := PC;
      exit;
   end;
end;

function Tgis_Parcela.CreateParcastDil(aPKDil: integer): Tgis_ParcelaCast;
begin
   result := GetParcastDil(aPKDil,false,false);
   if result = nil then
   begin
      result := CreateParCast;
      result.PK_Dil := aPKDil;
   end;
end;

function Tgis_Parcela.GetParcastDil(aPKDil: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
var
   i: integer;
   e: TElement;
   PC: Tgis_ParcelaCast;
begin
   result := nil;
   for i := 0 to LastIndex do
   begin
      e := Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      PC := Tgis_ParcelaCast(e);
      if PC.PK_Dil <> aPKDil then continue;
      if UseGP and not (PC.GP = aGP) then continue;
      result := PC;
      exit;
   end;
end;

function Tgis_Parcela.GetNextParcastDil(aParcast: Tgis_ParcelaCast; aPKDil: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
var
   i,Fi: integer;
   e: TElement;
   PC: Tgis_ParcelaCast;
begin
   result := nil;
   if aParcast = nil then
      Fi := 0
   else
   begin
      Fi := IndexOf(aParcast);
      Inc(Fi);
      if Fi > LastIndex then exit;
   end;
   for i := Fi to LastIndex do
   begin
      e := Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      PC := Tgis_ParcelaCast(e);
      if PC.PK_Dil <> aPKDil then continue;
      if UseGP and not (PC.GP = aGP) then continue;
      result := PC;
      exit;
   end;
end;

procedure Tgis_Parcela.SetKATUZE_KOD_PUV(const Value: integer);
begin
  FKATUZE_KOD_PUV := Value;
end;

{ Tgis_ParcelModel }

function Tgis_ParcelModel.CreateKatastrCislo(aCislo: integer): Tgis_Katastr;
var
   K: Tgis_Katastr;
begin
   K := GetKatastrCislo(aCislo);
   if K = nil then
   begin
      K := Tgis_Katastr.Create;
      K.Cislo := aCislo;
      AddElement(K);
      ActualKatastr := K;
   end;
   result := K;
end;

function Tgis_ParcelModel.GetKatastrCislo(aCislo: integer): Tgis_Katastr;
var
   K: Tgis_Katastr;
   i: integer;
begin
   result := nil;
   if (ActualKatastr <> nil) and (ActualKatastr.Cislo = aCislo) then
   begin
      result := ActualKatastr;
      exit;
   end;
   for i := 0 to LastIndex do
   begin
      K := Tgis_Katastr(Elements[i]);
      if K.Cislo = aCislo then
      begin
         result := K;
         break;
      end;
   end;
   ActualKatastr := result;
end;

function Tgis_ParcelModel.GetKatastr_Cislo: integer;
begin
   result := -1;
   if ActualKatastr = nil then exit;
   result := ActualKatastr.Cislo;
end;

function Tgis_ParcelModel.GetParcela_CisloPodlomeni: string;
begin
   result := '';
   if ActualParcela = nil then exit;
   result := ActualParcela.GetPropertyStringByName('PARCIS')+'/'+ActualParcela.GetPropertyStringByName('PARPOD');
end;

function Tgis_ParcelModel.GetParcelaCislo(aParcis,aParpod,aKATUZE_KOD_PUV: integer): Tgis_Parcela;
var
   DontUseKKP: boolean;
begin
   result := nil;
   DontUseKKP := aKATUZE_KOD_PUV < 0;
   if (ActualParcela <> nil) and (ActualParcela.PARCIS = aParcis) and (ActualParcela.PARPOD = aParpod) and (DontUseKKP or (ActualParcela.KATUZE_KOD_PUV = aKATUZE_KOD_PUV))then
   begin
      result := ActualParcela;
      exit;
   end;
   if ActualKatastr = nil then exit;
   result := ActualKatastr.GetParcelaCislo(aParcis,aParPod, aKATUZE_KOD_PUV);
   if result <> nil then
      ActualSkupinaParcel := result.SkupinaParcel
   else
      ActualSkupinaParcel := nil;
   ActualParcela := result;
end;

function Tgis_ParcelModel.GetSkupinaParcel_Cislo: integer;
begin
   result := -1;
   if ActualSkupinaParcel = nil then exit;
   result := ActualSkupinaParcel.Cislo;
end;

function Tgis_ParcelModel.GetSkupinaParcelCislo(aCislo: integer): Tgis_SkupinaParcel;
begin
   result := nil;
   if (ActualSkupinaParcel <> nil) and (ActualSkupinaParcel.Cislo = aCislo) then
   begin
      result := ActualSkupinaParcel;
      exit;
   end;
   if ActualKatastr = nil then exit;
   result := ActualKatastr.GetSkupinaParcelCislo(aCislo);
   ActualSkupinaParcel := result;
end;

procedure Tgis_ParcelModel.SeKatastr_Cislo(const Value: integer);
begin
   if AutoCreate then
      CreateKatastrCislo(Value)
   else
      GetKatastrCislo(Value);
end;

procedure Tgis_ParcelModel.SetActualKatastr(const Value: Tgis_Katastr);
begin
   FActualKatastr := Value;
   ActualSkupinaParcel := nil;
end;

procedure Tgis_ParcelModel.SetActualParcela(const Value: Tgis_Parcela);
begin
   FActualParcela := Value;
   ActualParCast := nil;
end;

procedure Tgis_ParcelModel.SetActualSkupinaParcel(
  const Value: Tgis_SkupinaParcel);
begin
   FActualSkupinaParcel := Value;
   ActualParcela := nil;
end;

procedure Tgis_ParcelModel.SetParcela_CisloPodlomeni(const Value: string);
var
   S1,S2,S3: string;
   aParcis,aParpod, aKATUZE_KOD_PUV: integer;
begin
   aParcis := 0;
   aParPod := 0;
   aKATUZE_KOD_PUV := -1;
   StringAsTwoParams(Value,'/',S1,S2);
   try
      if S1 <> '' then
         aParcis := StrToInt(S1);
   except
   end;
   try
      if S2 <> '' then
      begin
         StringAsTwoParams(S2,'\',S2,S3);
         aParpod := StrToInt(S2);
         if S3 <> '' then
            aKATUZE_KOD_PUV := StrToInt(S3);
      end;
   except
   end;
   if AutoCreate then
      CreateParcelaCislo(aParcis,aParpod,aKATUZE_KOD_PUV)
   else
      GetParcelaCislo(aParcis,aParpod,aKATUZE_KOD_PUV);
end;

procedure Tgis_ParcelModel.SetSkupinaParcel_Cislo(const Value: integer);
begin
   if AutoCreate then
      CreateSkupinaParcelCislo(Value)
   else
      GetSkupinaParcelCislo(Value);
end;

function Tgis_ParcelModel.CreateParcelaCislo(aParcis, aParpod, aKATUZE_KOD_PUV: integer): Tgis_Parcela;
begin
   result := nil;
   if ActualKatastr = nil then exit;
   result := ActualKatastr.CreateParcelaCislo(aParcis,aParpod, aKATUZE_KOD_PUV,ActualSkupinaParcel);
   ActualParcela := result;
end;

function Tgis_ParcelModel.CreateSkupinaParcelCislo(aCislo: integer): Tgis_SkupinaParcel;
begin
   result := nil;
   if ActualKatastr = nil then exit;
   result := ActualKatastr.CreateSkupinaParcelCislo(aCislo);
   ActualSkupinaParcel := result;
end;

procedure Tgis_ParcelModel.SetUpdateAll(const Value: boolean);
var
   K: Tgis_Katastr;
   SK: Tgis_SkupinaParcel;
   P: Tgis_Parcela;
   i,j,l: integer;
begin
   for i := 0 to LastIndex do
   begin
      K := Tgis_Katastr(Elements[i]);
      if not K.NoSkupinaParcel then
      begin
         for j := 0 to K.SkupinyParcel.LastIndex do
         begin
            SK := Tgis_SkupinaParcel(K.SkupinyParcel.Elements[j]);
            if not SK.NoParcela then
            begin
               for l := 0 to SK.Parcely.LastIndex do
               begin
                  P := Tgis_Parcela(SK.Parcely.Elements[l]);
                  P.Update;
               end;
               SK.Parcely.Update;
            end;
            if not SK.NoParcast then
               SK.ParCasti.Update;
            SK.Update;
         end;
         K.SkupinyParcel.Update;
      end;
      if not K.NoParcela then
      begin
         for j := 0 to K.Parcely.LastIndex do
         begin
            P := Tgis_Parcela(K.Parcely.Elements[j]);
            P.Update;
         end;
         K.Parcely.Update;
      end;
      K.Update;
   end;
end;

procedure Tgis_ParcelModel.SetSort(const Value: boolean);
var
   K: Tgis_Katastr;
   SK: Tgis_SkupinaParcel;
   i,j: integer;
   T: TSortElementsByInteger;
   TT: TSortElementsBy2Integers;
begin
   T := TSortElementsByInteger.Create;
   T.PropertyName := 'Name';
   T.Input := Self;
   T.DoIt;
   TT := TSortElementsBy2Integers.Create;
   TT.PropertyName := 'Parcis';
   TT.PropertyName1 := 'Parpod';
   for i := 0 to LastIndex do
   begin
      K := Tgis_Katastr(Elements[i]);
      if not K.NoParcela then
      begin
         TT.Input := K.Parcely;
         TT.DoIt;
      end;
      if K.NoSkupinaParcel then continue;
      T.Input := K.SkupinyParcel;
      T.DoIt;
      for j := 0 to K.SkupinyParcel.LastIndex do
      begin
         SK := Tgis_SkupinaParcel(K.SkupinyParcel.Elements[j]);
         if not SK.NoParcela then
         begin
            TT.Input := SK.Parcely;
            TT.DoIt;
         end;
         if not SK.NoParcast then
         begin
            TT.Input := SK.Parcasti;
            TT.DoIt;
         end;
      end;
   end;
   T.Free;
   TT.Free;
end;

procedure Tgis_ParcelModel.SetFullTest(const Value: boolean);
begin
  FFullTest := Value;
end;

procedure Tgis_ParcelModel.SetDisconnect(const Value: boolean);
var
   K: Tgis_Katastr;
   SK: Tgis_SkupinaParcel;
   i,j: integer;
begin
   if not Value then exit;
   for i := 0 to LastIndex do
   begin
      K := Tgis_Katastr(Elements[i]);
      if K.NoSkupinaParcel then continue;
      for j := 0 to K.SkupinyParcel.LastIndex do
      begin
         SK := Tgis_SkupinaParcel(K.SkupinyParcel.Elements[j]);
         SK.Disconnect := true;
      end;
   end;
end;

procedure Tgis_ParcelModel.SetActualParCast(const Value: Tgis_ParcelaCast);
begin
  FActualParCast := Value;
end;

function Tgis_ParcelModel.CreateParCast: Tgis_ParcelaCast;
begin
   result := nil;
   if ActualParcela <> nil then
      result := ActualParcela.CreateParCast;
   ActualParCast := result;
end;

function Tgis_ParcelModel.GetVersion: integer;
begin
   result := FVersion;
end;

procedure Tgis_ParcelModel.SetVersion(const Value: integer);
begin
   FVersion := Value;
end;

procedure Tgis_ParcelModel.FreeAll;
begin
   ActualKatastr := nil;
   inherited;
end;

function Tgis_ParcelModel.GetSkupinaParcel_Comment: string;
begin
   result := '';
   if ActualSkupinaParcel = nil then exit;
   result := ActualSkupinaParcel.Comment;
end;

procedure Tgis_ParcelModel.SetSkupinaParcel_Comment(const Value: string);
begin
   GetSkupinaParcelComment(Value);
end;

function Tgis_ParcelModel.GetSkupinaParcelComment(aComment: string): Tgis_SkupinaParcel;
begin
   result := nil;
   if ActualKatastr = nil then exit;
   result := ActualKatastr.GetSkupinaParcelComment(aComment);
   ActualSkupinaParcel := result;
end;

function Tgis_ParcelModel.CreateSkupinaParcelComment(aComment: string): Tgis_SkupinaParcel;
begin
   result := nil;
   if ActualKatastr = nil then exit;
   result := ActualKatastr.CreateSkupinaParcelComment(aComment);
   ActualSkupinaParcel := result;
end;

function Tgis_ParcelModel.GetParCastPKCislo(aPKCis, aPKPod: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
begin
   result := nil;
   if ActualParcela <> nil then
      result := ActualParcela.GetParcastPKCislo(aPKCis,aPKPod, aGP,UseGP);
   ActualParCast := result;
end;

function Tgis_ParcelModel.CreateParCastPKCislo(aPKCis,aPKPod: integer): Tgis_ParcelaCast;
begin
   result := nil;
   if ActualParcela <> nil then
      result := ActualParcela.CreateParcastPKCislo(aPKCis,aPKPod);
   ActualParCast := result;
end;


function Tgis_ParcelModel.GetParCastPK_CisloPodlomeni: string;
begin
   result := '';
   if ActualParCast = nil then exit;
   result := ActualParCast.GetPropertyStringByName('PKCIS')+'/'+ActualParCast.GetPropertyStringByName('PKPOD');
end;

procedure Tgis_ParcelModel.SetParCastPK_CisloPodlomeni(const Value: string);
var
   S1,S2: string;
   aPKcis,aPKpod: integer;
begin
   aPKcis := 0;
   aPKPod := 0;
   StringAsTwoParams(Value,'/',S1,S2);
   try
      if S1 <> '' then
         aPKcis := StrToIntDef(S1,0);
   except
   end;
   try
      if S2 <> '' then
         aPKpod := StrToIntDef(S2,0);
   except
   end;
   GetParCastPKCislo(aPKcis,aPKpod, false, false);
end;

function Tgis_ParcelModel.CreateParCastPKCisloDil(aPKCis, aPKPod,
  aPKDil: integer): Tgis_ParcelaCast;
begin
   result := nil;
   if ActualParcela <> nil then
      result := ActualParcela.CreateParcastPKCisloDil(aPKCis,aPKPod,aPKDil);
   ActualParCast := result;
end;

function Tgis_ParcelModel.GetParCastPKCisloDil(aPKCis, aPKPod,
  aPKDil: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
begin
   result := nil;
   if ActualParcela <> nil then
      result := ActualParcela.GetParcastPKCisloDil(aPKCis,aPKPod,aPKDil,aGP,UseGP);
   ActualParCast := result;
end;

function Tgis_ParcelModel.GetParCastDil(aPKDil: integer; aGP,UseGP: boolean): Tgis_ParcelaCast;
begin
   result := nil;
   if ActualParcela <> nil then
      result := ActualParcela.GetParcastDil(aPKDil,aGP,UseGP);
   ActualParCast := result;
end;

function Tgis_ParcelModel.CreateParCastDil(aPKDil: integer): Tgis_ParcelaCast;
begin
   result := nil;
   if ActualParcela <> nil then
      result := ActualParcela.CreateParcastDil(aPKDil);
   ActualParCast := result;
end;

procedure Tgis_ParcelModel.SetAutoCreate(const Value: boolean);
begin
  FAutoCreate := Value;
end;

{ Tgis_ParCasti }

function Tgis_ParCasti.GetName: string;
begin
   result := 'Parcely_Cast';
end;

procedure Tgis_ParCasti.SetName(aName: string);
begin
end;

{ Tgis_ParcelaCast }

function Tgis_ParcelaCast.GetKatastr: Tgis_Katastr;
var
   P: Tgis_Parcela;
begin
   result := nil;
   P := Parcela;
   if P = nil then exit;
   result := P.Katastr;
end;

function Tgis_ParcelaCast.GetKultura: integer;
var
   P: Tgis_Parcela;
begin
   result := 0;
   P := Parcela;
   if P = nil then exit;
   result := P.Kultura;
end;

function Tgis_ParcelaCast.GETLV: integer;
var
   P: Tgis_Parcela;
begin
   result := 0;
   P := Parcela;
   if P = nil then exit;
   result := P.LV;
end;

function Tgis_ParcelaCast.GETLVC: integer;
begin
   result := FLVC;
end;

function Tgis_ParcelaCast.GetName: string;
var
   P: Tgis_Parcela;
begin
   result := '?';
   P := Parcela;
   if P = nil then exit;
   result := P.Name;
   if P.Count > 1 then
      result := result+'.'+IntToStr(PARCAST);
end;

function Tgis_ParcelaCast.GetPAR_SKU_KN: byte;
var
   P: Tgis_Parcela;
begin
   result := 0;
   {
   P := Parcela;
   if P = nil then exit;
   result := P.PAR_SKU_KN;
   }
   if PARCIS < 0 then
      result := 1
   else
      result := 2;
   {$IFDEF UHUL}
   if KATUZE_KOD_PUV > 0 then
   begin
      result := 9;
      exit;
   end;
   {$ENDIF}
   if NEP then
   begin
      result := 3;
      exit;
   end;
   if GP then
      result := result + 5
   else
   if PK then
      result := result + 3;
end;

function Tgis_ParcelaCast.GetPARCAST: integer;
var
   P: Tgis_Parcela;
   i: integer;
   e: TElement;
begin
   result := 0;
   P := Parcela;
   if P = nil then exit;
   for i := 0 to Parcela.LastIndex do
   begin
      e := Parcela.Elements[i];
      if (e is Tgis_ParcelaCast) then result := result + 1;
      if e = Self then exit;
   end;
end;


function Tgis_ParcelaCast.GetParcela: Tgis_Parcela;
begin
   result := Tgis_Parcela(FindOwnerClass(Tgis_Parcela));
end;

function Tgis_ParcelaCast.GetPARCIS: integer;
var
   P: Tgis_Parcela;
begin
   result := 0;
   P := Parcela;
   if P = nil then exit;
   result := Parcela.PARCIS;
end;

function Tgis_ParcelaCast.GetPARCISAbs: integer;
begin
   result := Abs(PARCIS);
end;

function Tgis_ParcelaCast.GetPARPOD: integer;
var
   P: Tgis_Parcela;
begin
   result := 0;
   P := Parcela;
   if P = nil then exit;
   result := Parcela.PARPOD;
end;

function Tgis_ParcelaCast.GetParZar_Text: string;
begin
   if PARZAR then
      result := 'ANO'
   else
      result := 'NE';
end;

function Tgis_ParcelaCast.GetPK_Text: string;
begin
   if PK then
      result := 'ANO'
   else
      result := 'NE';
end;

function Tgis_ParcelaCast.GetPUPFL: boolean;
var
   P: Tgis_Parcela;
begin
   result := false;
   P := Parcela;
   if P = nil then exit;
   result := Parcela.PUPFL;
end;

function Tgis_ParcelaCast.GetPUPFL_Text: string;
var
   P: Tgis_Parcela;
begin
   result := 'NE';
   P := Parcela;
   if P = nil then exit;
   result := Parcela.PUPFL_Text;
end;

function Tgis_ParcelaCast.GetSKUPAR_CIS: integer;
var
   SKP: Tgis_SkupinaParcel;
begin
   result := -1;
   SKP := SkupinaParcel;
   if SKP = nil then exit;
   result := SKP.Cislo;
end;

function Tgis_ParcelaCast.GetSkupinaParcel: Tgis_SkupinaParcel;
var
   P: Tgis_Parcela;
begin
   result := GetPCSkupinaParcel;
   if result = nil then
   begin
      P := Parcela;
      if P = nil then exit;
      result := P.SkupinaParcel;
   end;
end;

procedure Tgis_ParcelaCast.SetKultura(const Value: integer);
var
   P: Tgis_Parcela;
begin
   P := Parcela;
   if P = nil then exit;
   P.Kultura := Value;
end;

procedure Tgis_ParcelaCast.SetLV(const Value: integer);
var
   P: Tgis_Parcela;
begin
   P := Parcela;
   if P = nil then exit;
   P.LV := Value;
end;

procedure Tgis_ParcelaCast.SetLVC(const Value: integer);
begin
   FLVC := Value;
end;

procedure Tgis_ParcelaCast.SetName(aName: string);
var
   P: Tgis_Parcela;
   S1,S2: string;
begin
   P := Parcela;
   if P = nil then exit;
   StringAsTwoParams(aName,'.',S1,S2);
   P.Name := S1;
end;

procedure Tgis_ParcelaCast.SetPAR_SKU_KN(const Value: byte);
var
   P: Tgis_Parcela;
begin
   {$IFDEF UHUL}
       if Value = 9 then  exit;
   {$ENDIF}

   GP := Value > 5;
   if Value = 3 then
      NEP := true;
   P := Parcela;
   if P = nil then exit;
   P.PAR_SKU_KN := Value;
end;

procedure Tgis_ParcelaCast.SetParcela(const Value: Tgis_Parcela);
var
   P: Tgis_Parcela;
begin
   P := Parcela;
   if P = Value then exit;
   if P <> nil then
      P.RemoveElement(Self);
   if Value <> nil then
      Value.NextElement := Self;
end;

procedure Tgis_ParcelaCast.SetPARCIS(const Value: integer);
var
   P: Tgis_Parcela;
begin
   P := Parcela;
   if P = nil then exit;
   P.PARCIS := Value;
end;

procedure Tgis_ParcelaCast.SetPARPOD(const Value: integer);
var
   P: Tgis_Parcela;
begin
   P := Parcela;
   if P = nil then exit;
   P.PARPOD := Value;
end;

procedure Tgis_ParcelaCast.SetParZar(const Value: boolean);
begin
   FPARZAR := Value;
end;

procedure Tgis_ParcelaCast.SetParZar_Text(const Value: string);
begin
   if Value = '' then exit;
   if UpperCase(Value)[1] = 'A' then
      ParZar := true
   else
      ParZar := false;
end;

procedure Tgis_ParcelaCast.SetPKCIS(const Value: integer);
begin
   FPKCIS := Value;
end;

procedure Tgis_ParcelaCast.SetPKPOD(const Value: integer);
begin
   FPKPOD := Value;
end;

procedure Tgis_ParcelaCast.SetPUPFL(const Value: boolean);
var
   P: Tgis_Parcela;
begin
   P := Parcela;
   if P = nil then exit;
   P.PUPFL := Value;
end;

procedure Tgis_ParcelaCast.SetPUPFL_Text(const Value: string);
var
   P: Tgis_Parcela;
begin
   P := Parcela;
   if P = nil then exit;
   P.PUPFL_Text := Value;
end;

procedure Tgis_ParcelaCast.SetSKUPAR_CIS(const Value: integer);
begin
   /// !!!!!!!!!!!!!!!!!
end;

procedure Tgis_ParcelaCast.SetSkupinaParcel(const Value: Tgis_SkupinaParcel);
var
   SKP: Tgis_SkupinaParcel;
   PAR_SKP: Tgis_SkupinaParcel;
   P: Tgis_Parcela;
   Only: boolean;
   i: integer;
   e: TElement;
   PC: Tgis_ParcelaCast;
   isSame: boolean;
begin
   P := Parcela;
   if P = nil then exit; // !!! very spatne to by skoro chtelo zarvat
   Only := not P.Multiparcela; // pouze jedna cast parcely
   PAR_SKP := Parcela.SkupinaParcel;
   SKP := GetSkupinaParcel;
   if SKP = Value then exit; // nic se nemeni
   if only then // 1) parcela s jednou casti
   begin
      PCSkupinaParcel := nil;  // pro jistotu vynilujeme puvodni SKP, to nemuze skodit
      P.SkupinaParcel := Value // tak to ma byt, parcela uz si to prebere ... asi
   end
   else         // 2) parcela s vice castmi
   begin
      PCSkupinaParcel := Value;
      IsSame := true;
      for i := 0 to P.LastIndex do
      begin
         e := P.Elements[i];
         if not (e is Tgis_ParcelaCast) then continue;
         PC := Tgis_ParcelaCast(e);
         if PC.PCSkupinaParcel = nil then           // pokud cast nema vlastni skupinu,
            PC.PCSkupinaParcel := P.SkupinaParcel;  // dostane ji od parcely, blahoprejeme
         if PC.PCSkupinaParcel <> Value then
            IsSame := false;
      end;
      if IsSame then  // pokud maji vsechny casti stejnou skupinu tak...
      begin
         P.SkupinaParcel := Value; // pripojimeskupinu
         for i := 0 to P.LastIndex do
         begin
            e := P.Elements[i];
            if not (e is Tgis_ParcelaCast) then continue;
            PC := Tgis_ParcelaCast(e);
            PC.PCSkupinaParcel := nil // odpojeni casti,
         end;
      end
      else
         P.SkupinaParcel := nil; // ...jinak nakonec odpojime Parcelu od skupiny
   end;
end;

function Tgis_ParcelaCast.GetPCSkupinaParcel: Tgis_SkupinaParcel;
var
   PCasti: Tgis_ParCasti;
begin
   result := nil;
   PCasti := Tgis_ParCasti(FindOwnerClass(Tgis_ParCasti));
   if PCasti = nil then exit;
   result := Tgis_SkupinaParcel(PCasti.FindOwnerClass(Tgis_SkupinaParcel));
end;

procedure Tgis_ParcelaCast.SetPCSkupinaParcel(const Value: Tgis_SkupinaParcel);
var
   SKP: Tgis_SkupinaParcel;
begin
   SKP := GetPCSkupinaParcel;
   if SKP = Value then exit;
   if SKP <> nil then
      SKP.RemoveParCast(Self);
   if Value <> nil then
      Value.NextParCast := Self;
end;


procedure Tgis_ParcelaCast.SetKatastr(const Value: Tgis_Katastr);
var
   P: Tgis_Parcela;
begin
   P := Parcela;
   if P <> nil then
      P.Katastr := Value;
end;

procedure Tgis_ParcelaCast.SetSuperID(const Value: integer);
begin
  FSuperID := Value;
end;

function Tgis_ParcelaCast.GetPKName: string;
begin
   result := IntToStr(PKCIS);
   if PKPOD > 0 then
      result := result+'/'+ IntToStr(PKPOD);
end;

procedure Tgis_ParcelaCast.SetPKName(const Value: string);
var
   S1,S2: string;
begin
   if StringAsTwoParams(Value,'/',S1,S2) then
      PKPOD := StrToIntDef(S2,0)
   else
      PKPOD := 0;
   PKCIS := StrToIntDef(S1,0);
end;

procedure Tgis_ParcelaCast.SetParName(const Value: string);
begin
   // to tak, jeste nastavovat name parcele darebaci
end;

function Tgis_ParcelaCast.GetParName: string;
var
  P: Tgis_Parcela;
begin
   result := '?';
   P := Parcela;
   if P = nil then exit;
   result := P.Name;
end;

function Tgis_ParcelaCast.GetParNameAbs: string;
var
  P: Tgis_Parcela;
begin
   result := '?';
   P := Parcela;
   if P = nil then exit;
   result := IntToStr(P.PARCISAbs);
   if P.PARPOD > 0 then
      result := result + '/'+ IntToStr(P.PARPOD);
end;

procedure Tgis_ParcelaCast.SetParNameAbs(const Value: string);
begin
end;

function Tgis_ParcelaCast.GetMultiparcela: boolean;
var
   P: Tgis_Parcela;
   //i: integer;
   //e: TElement;
begin
   result := false;
   P := Parcela;
   if P = nil then exit;
   result := P.Multiparcela;
end;

function Tgis_ParcelaCast.GetPAR_Vymera: double;
var
   P: Tgis_Parcela;
begin
   result := 0;
   P := Parcela;
   if P = nil then exit;
   result := P.Vymera;
end;

procedure Tgis_ParcelaCast.SetPAR_Vymera(const Value: double);
var
   P: Tgis_Parcela;
begin
   P := Parcela;
   if P = nil then exit;
   P.Vymera := Value;
end;

function Tgis_ParcelaCast.GetMultiVymera: double;
var
   P: Tgis_Parcela;
begin
   result := 0;
   P := Parcela;
   if P = nil then exit;
   result := P.MultiVymera;

end;

function Tgis_ParcelaCast.GetPUPFLc_Text: string;
begin
   if PUPFLc then
      result := 'ANO'
   else
      result := 'NE';
end;

procedure Tgis_ParcelaCast.SetPUPFLc(const Value: boolean);
begin
  FPUPFLc := Value;
end;

procedure Tgis_ParcelaCast.SetPUPFLc_Text(const Value: string);
begin
   if Value = '' then exit;
   if UpperCase(Value)[1] = 'A' then
      PUPFLc := true
   else
      PUPFLc := false;
end;

function Tgis_ParcelaCast.GetPK: boolean;
begin
   result := PKCIS > 0;
   {
   result := false;
   if Parcela <> nil then
      result := Parcela.PK;
   }
end;

procedure Tgis_ParcelaCast.SetPK(const Value: boolean);
begin
   if Parcela <> nil then
      Parcela.PK := Value;
end;

function Tgis_ParcelaCast.GetSKUPAR_Comment: string;
var
   SKP: Tgis_SkupinaParcel;
begin
   result := '';
   SKP := SkupinaParcel;
   if SKP = nil then exit;
   result := SKP.Comment;
end;

procedure Tgis_ParcelaCast.SetSKUPAR_Comment(const Value: string);
begin
   //--------
end;

function Tgis_ParcelaCast.GetMajitel: Tgis_Majitel;
begin
   result := KUMajitel;
   if result = nil then
      result := inherited GetMajitel;
end;

procedure Tgis_ParcelaCast.SetMajitel(const Value: Tgis_Majitel);
begin
   inherited;
end;

procedure Tgis_ParcelaCast.SetPK_Dil(const Value: integer);
begin
  FPK_Dil := Value;
end;

procedure Tgis_ParcelaCast.SetGP(const Value: boolean);
begin
   FGP := Value;
end;

function Tgis_ParcelaCast.GetGP_Text: string;
begin
   if GP then
      result := 'ANO'
   else
      result := 'NE';
end;

procedure Tgis_ParcelaCast.SetGP_Text(const Value: string);
begin
   if Value = '' then exit;
   if UpperCase(Value)[1] = 'A' then
      GP := true
   else
      GP := false;
end;

procedure Tgis_ParcelaCast.SetZmena(const Value: string);
begin
  FZmena := Value;
end;

procedure Tgis_ParcelaCast.SetPoznamka(const Value: string);
begin
  FPoznamka := Value;
end;

procedure Tgis_ParcelaCast.SetKulturaC(const Value: integer);
begin
  FKulturaC := Value;
end;

procedure Tgis_ParcelaCast.SetNEP(const Value: boolean);
begin
   FNEP := Value;
end;

function Tgis_ParcelaCast.GetNEP_TEXT: string;
begin
   if NEP then
      result := 'ANO'
   else
      result := 'NE';
end;

function Tgis_ParcelaCast.GetOLH: Tgis_OLH;
begin
   result := KUOLH;
   if result = nil then
      result := inherited GetOLH;
end;

procedure Tgis_ParcelaCast.SetNEP_Text(const Value: string);
begin
   if Value = '' then exit;
   if UpperCase(Value)[1] = 'A' then
      NEP := true
   else
      NEP := false;
end;

procedure Tgis_ParcelaCast.SetOLH(const Value: Tgis_OLH);
begin
  inherited;
end;

function Tgis_ParcelaCast.GetParNameAbsDTTO: string;
var
  P: Tgis_Parcela;
begin
   result := '?';
   P := Parcela;
   if P = nil then exit;
   result := IntToStr(P.PARCISAbs);
   if P.PARPOD > 0 then
      result := '../'+ IntToStr(P.PARPOD);
end;

function Tgis_ParcelaCast.GetPKNameDTTO: string;
begin
   result := IntToStr(PKCIS);
   if PKPOD > 0 then
      result := '../'+ IntToStr(PKPOD);
end;

function Tgis_ParcelaCast.GetKATUZE_KOD_PUV: integer;
var
  P: Tgis_Parcela;
begin
   result := 0;
   P := Parcela;
   if P = nil then exit;
   result := P.KATUZE_KOD_PUV;
end;

procedure Tgis_ParcelaCast.SetATR_PUV(const Value: integer);
begin
  FATR_PUV := Value;
end;

{ Tgis_KParcely }

function Tgis_KParcely.GetName: string;
begin
   result := 'PARCELY K';
end;

procedure Tgis_KParcely.SetName(aName: string);
begin
end;

{ Tgis_Majitel }

function Tgis_Majitel.GetFullName: string;
begin
   if SwapJmeno then
      result := Prijmeni +' '+ Jmeno
   else
      result := Jmeno +' '+Prijmeni;
end;

function Tgis_Majitel.GetMAJ_DRUH: integer;
var
   S: string;
begin
   if FixMaj then
      result := FMAJ_DRUH
   else
   begin
      S := Cislo;
      if S <> '' then
         S := S[1]
      else
         S := '0';   
      result := StrToIntDef(S,0);
   end;
end;

function Tgis_Majitel.GetMAJ_KOD: string;
var
   //S,
   S1: string;
begin
   if FixMaj then
      result := FMAJ_KOD
   else
   begin
      S1 := Cislo;
      if Length(S1) < 2 then
      begin
         result := '0';
         exit;
      end;
      result := Copy(S1,2,Length(S1)-1);
      //result := StrToFloatDef(S,0);
   end;
end;

function Tgis_Majitel.GetMultimajitel: boolean;
var
   T: Tgis_Tel;
begin
   result := false;
   T := Tel;
   if T = nil then exit;
   result := T.OwnersCount > 1;
end;

function Tgis_Majitel.GetName: string;
begin
   if FullNameToName then
   begin
       result := FullName;
       if AdresaToName then
          result := result + ' '+ Adresa;
   end
   else
      result := FCislo;
end;

function Tgis_Majitel.GetTel: Tgis_Tel;
begin
   result := Tgis_Tel(FindOwnerClass(Tgis_Tel));
end;

procedure Tgis_Majitel.SetAdresa(const Value: string);
begin
  FAdresa := Value;
end;

procedure Tgis_Majitel.SetAdresaToName(const Value: boolean);
begin
  FAdresaToName := Value;
end;

procedure Tgis_Majitel.SetCislo(const Value: string);
begin
   FCislo := Value;
end;

procedure Tgis_Majitel.SetComment(const Value: string);
begin
  FComment := Value;
end;

procedure Tgis_Majitel.SetFixMaj(const Value: boolean);
begin
  FFixMaj := Value;
end;

procedure Tgis_Majitel.SetFullNameToName(const Value: boolean);
begin
  FFullNameToName := Value;
end;

procedure Tgis_Majitel.SetJmeno(const Value: string);
begin
  FJmeno := Value;
end;

procedure Tgis_Majitel.SetMAJ_DRUH(const Value: integer);
begin
  FMAJ_DRUH := Value;
end;

procedure Tgis_Majitel.SetMAJ_KOD(const Value: string);
begin
  FMAJ_KOD := Value;
end;

procedure Tgis_Majitel.SetName(aName: string);
begin

end;

procedure Tgis_Majitel.SetPrijmeni(const Value: string);
begin
  FPrijmeni := Value;
end;

procedure Tgis_Majitel.SetSwapJmeno(const Value: boolean);
begin
  FSwapJmeno := Value;
end;

procedure Tgis_Majitel.WriteSetBy(const Value: TElement);
var
   Vla: Tgis_Vlastnictvi;
   Opsub: Tgis_Person;
   S,S1,S2: string;
begin
   if Value = nil then exit;
   Opsub := nil;
   if Value is Tgis_Vlastnictvi then
   begin
      Vla := Tgis_Vlastnictvi(Value);
      Opsub := Tgis_Person(Vla.FindOwnerClass(Tgis_Person));
   end
   else
   if Value is Tgis_Person then
      Opsub := Tgis_Person(Value);
   if Opsub = nil then exit;

   Cislo := Opsub.Name;
   Jmeno := Opsub.JMENO;
   Prijmeni := Opsub.PRIJMENI;
   S := Opsub.NAZEV;
   if S <> '' then
      Jmeno := S;
   S := Opsub.NAZEV_ULICE;
   S1 := Opsub.CISLO_DOMOVNI;
   S2 := Opsub.CISLO_ORIENTACNI;
   if (S1 <> '') and (S2 <> '') then
      S1 := S1 + '/';
   S1 := S1 + S2;
   if S1 <> '' then
      S := S +' '+S1;
   S1 := Opsub.CAST_OBCE;
   if S1 <> '' then
      S := S +' '+S1;
   S1 := Opsub.OBEC;
   if S1 <> '' then
      S := S +' '+S1;
   S1 := Opsub.MESTSKA_CAST;
   if S1 <> '' then
      S := S +' '+S1;
   Adresa := S;
end;

{ Tgis_Majitele }

function Tgis_Majitele.CreateMajitelByMajitel(Value: Tgis_Majitel): Tgis_Majitel;
begin
   result := nil;
   if Value = nil then exit;
   if Value.IsMyOwner(Self) then
   begin
      result := Value;
      exit;
   end;
   result := GetMajitelCislo(Value.Cislo);
   if result = nil then
   begin
      result := Tgis_Majitel.Create;
      result.Cislo := Value.Cislo;
      result.Jmeno := Value.Jmeno;
      result.Prijmeni := Value.Prijmeni;
      result.Adresa := Value.Adresa;
      result.Comment := Value.Comment;
      result.MAJ_DRUH := Value.MAJ_DRUH;
      result.MAJ_KOD := Value.MAJ_KOD;
      result.SwapJmeno := Value.SwapJmeno;
      result.FullNameToName := Value.FullNameToName;
      result.AdresaToName := Value.AdresaToName;
      result.FixMaj := Value.FixMaj;
      AddElement(result);
      ActualMajitel := result;
   end;
end;

function Tgis_Majitele.CreateMajitelCislo(Value: string): Tgis_Majitel;
begin
   result := GetMajitelCislo(Value);
   if result = nil then
   begin
      result := Tgis_Majitel.Create;
      result.Cislo := Value;
      AddElement(result);
      ActualMajitel := result;
   end;
end;

function Tgis_Majitele.GetMajitelCislo(Value: string): Tgis_Majitel;
var
   i: integer;
   e: TElement;
   M: Tgis_Majitel;
begin
   result := nil;
   for i := 0 to LastIndex do
   begin
      e := Elements[i];
      if not (e is Tgis_Majitel) then continue;
      M := Tgis_Majitel(e);
      if M.Cislo = Value then
      begin
         result := M;
         break;
      end;
   end;
   ActualMajitel := result;
end;

procedure Tgis_Majitele.SetActualMajitel(const Value: Tgis_Majitel);
begin
  FActualMajitel := Value;
end;

procedure Tgis_Majitele.SetFindMajitelCislo(const Value: string);
begin
   GetMajitelCislo(Value);
end;

procedure Tgis_Majitele.SetSortByCislo(const Value: boolean);
var
   Sorti: TSortElementsByString;
begin
   if not value then exit;
   Sorti := TSortElementsByString.Create;
   Sorti.PropertyName := 'Cislo';
   Sorti.Input := Self;
   Sorti.DoIt;
   Sorti.Free;
end;

{ Tgis_Vlastnictvi }


function Tgis_Vlastnictvi.GetName: string;
begin
   if AutoName then
      result := IntToStr(TYPRAV_KOD)+'-'+IntToStr(PODIL_CITATEL)+'/'+IntToStr(PODIL_JMENOVATEL)
   else
      result := inherited GetName;
end;

procedure Tgis_Vlastnictvi.SetAutoName(const Value: boolean);
begin
  FAutoName := Value;
end;

procedure Tgis_Vlastnictvi.SetName(aName: string);
begin
   if AutoName then Exit;
   inherited;
end;

procedure Tgis_Vlastnictvi.SetOPSUB_ID(const Value: string);
begin
  FOPSUB_ID := Value;
end;

procedure Tgis_Vlastnictvi.SetPODIL_CITATEL(const Value: integer);
begin
  FPODIL_CITATEL := Value;
end;

procedure Tgis_Vlastnictvi.SetPODIL_JMENOVATEL(const Value: integer);
begin
  FPODIL_JMENOVATEL := Value;
end;

procedure Tgis_Vlastnictvi.SetTEL_ID(const Value: string);
begin
  FTEL_ID := Value;
end;

procedure Tgis_Vlastnictvi.SetTYPRAV_KOD(const Value: integer);
begin
  FTYPRAV_KOD := Value;
end;

{ Tgis_Person }

procedure Tgis_Person.SetCAST_OBCE(const Value: string);
begin
  FCAST_OBCE := Value;
end;

procedure Tgis_Person.SetCISLO_DOMOVNI(const Value: string);
begin
  FCISLO_DOMOVNI := Value;
end;

procedure Tgis_Person.SetCISLO_ORIENTACNI(const Value: string);
begin
  FCISLO_ORIENTACNI := Value;
end;

procedure Tgis_Person.SetCP_CE(const Value: integer);
begin
  FCP_CE := Value;
end;

procedure Tgis_Person.SetDOPLNEK_ICO(const Value: integer);
begin
  FDOPLNEK_ICO := Value;
end;

procedure Tgis_Person.SetCHAROS_KOD(const Value: integer);
begin
  FCHAROS_KOD := Value;
end;

procedure Tgis_Person.SetICO(const Value: integer);
begin
  FICO := Value;
end;

procedure Tgis_Person.SetJMENO(const Value: string);
begin
  FJMENO := Value;
end;

procedure Tgis_Person.SetJMENO_U(const Value: string);
begin
  FJMENO_U := Value;
end;

procedure Tgis_Person.SetMESTSKA_CAST(const Value: string);
begin
  FMESTSKA_CAST := Value;
end;

procedure Tgis_Person.SetNAZEV(const Value: string);
begin
  FNAZEV := Value;
end;

procedure Tgis_Person.SetNAZEV_ULICE(const Value: string);
begin
  FNAZEV_ULICE := Value;
end;

procedure Tgis_Person.SetOBEC(const Value: string);
begin
  FOBEC := Value;
end;

procedure Tgis_Person.SetOKRES(const Value: string);
begin
  FOKRES := Value;
end;

procedure Tgis_Person.SetOPSUB_TYPE(const Value: string);
begin
  FOPSUB_TYPE := Value;
end;

procedure Tgis_Person.SetPRIJMENI(const Value: string);
begin
  FPRIJMENI := Value;
end;

procedure Tgis_Person.SetPRIJMENI_U(const Value: string);
begin
  FPRIJMENI_U := Value;
end;

procedure Tgis_Person.SetPSC(const Value: string);
begin
  FPSC := Value;
end;

procedure Tgis_Person.SetSTAT(const Value: string);
begin
  FSTAT := Value;
end;

procedure Tgis_Person.SetTITUL_PRED_JMENEM(const Value: string);
begin
  FTITUL_PRED_JMENEM := Value;
end;

procedure Tgis_Person.SetTITUL_ZA_JMENEM(const Value: string);
begin
  FTITUL_ZA_JMENEM := Value;
end;

procedure Tgis_Person.SetRODNE_CISLO(const Value: string);
begin
  FRODNE_CISLO := Value;
end;

function Tgis_Person.GetName: string;
begin
   if AutoName then
      result := Trim(JMENO + ' ' + PRIJMENI + ' ' + NAZEV)
   else
      result := FaID;
end;

procedure Tgis_Person.SetAutoName(const Value: boolean);
begin
  FAutoName := Value;
end;

procedure Tgis_Person.SetName(aName: string);
begin
   if AutoName then exit;
   FaID := aName;
end;

function Tgis_Person.GetAdresa_Full: string;
var
   S,S1,S2: string;
begin
   S := NAZEV_ULICE;
   S1 := CISLO_DOMOVNI;
   S2 := CISLO_ORIENTACNI;
   if (S1 <> '') and (S2 <> '') then
      S1 := S1 + '/';
   S1 := S1 + S2;
   if S1 <> '' then
      S := S +' '+S1;
   S1 := CAST_OBCE;
   if S1 <> '' then
      S := S +' '+S1;
   S1 := OBEC;
   if S1 <> '' then
      S := S +' '+S1;
   S1 := MESTSKA_CAST;
   if S1 <> '' then
      S := S +' '+S1;
   result := S;
end;

function Tgis_Person.GetJmeno_Full: string;
begin
   result := Trim(JMENO + ' ' + PRIJMENI + ' ' + NAZEV);
end;

function Tgis_Person.GetPartner1: Tgis_Person;
begin
   result := nil;
   if OPSUB_TYPE = 'BSM' then
      result := FindOwnerByID(ID_JE_1_PARTNER_BSM);
end;

function Tgis_Person.GetPartner2: Tgis_Person;
begin
   result := nil;
   if OPSUB_TYPE = 'BSM' then
      result := FindOwnerByID(ID_JE_2_PARTNER_BSM);
end;

procedure Tgis_Person.SetID_JE_1_PARTNER_BSM(const Value: string);
begin
  FID_JE_1_PARTNER_BSM := Value;
end;

procedure Tgis_Person.SetID_JE_2_PARTNER_BSM(const Value: string);
begin
  FID_JE_2_PARTNER_BSM := Value;
end;

procedure Tgis_Person.SetaID(const Value: string);
begin
  FaID := Value;
end;

function Tgis_Person.FindOwnerByID(Value: string): Tgis_Person;
var
   i: integer;
   e: TEntity;
begin
   result := nil;
   for i := 0 to OwnersCount - 1 do
   begin
      e := Owners[i];
      if not (e is Tgis_Person) then
         continue;
      if Value = Tgis_Person(e).aID then
      begin
         result := Tgis_Person(e);
         exit;
      end;
   end;
end;

procedure Tgis_Person.SetNAZEV_U(const Value: string);
begin
   FNAZEV_U := Value;
end;

{ tgis_Tel }

function tgis_Tel.GetName: string;
begin
   if Autoname then
      result := IntToStr(KATUZE_KOD)+'-'+IntToStr(CISLO_TEL)
   else
      result := inherited GetName;
end;

procedure tgis_Tel.SetAutoName(const Value: boolean);
begin
  FAutoName := Value;
end;

procedure tgis_Tel.SetCISLO_TEL(const Value: integer);
begin
  FCISLO_TEL := Value;
end;

procedure tgis_Tel.SetKATUZE_KOD(const Value: integer);
begin
  FKATUZE_KOD := Value;
end;

procedure tgis_Tel.SetName(aName: string);
begin
   if AutoName then exit;
  inherited;
end;

{ Tgis_ParcelaCast_Props }

procedure Tgis_ParcelaCast_Props.Assign(Source: TPersistent);
var
   parc: Tgis_ParcelaCast;
   parcp: Tgis_ParcelaCast_Props;
begin
   if Source is Tgis_ParcelaCast then
   begin
      parc := Tgis_ParcelaCast(Source);
      aID             := parc.aID              ;
      Vymera          := parc.Vymera           ;
      KU_KOD          := parc.KU_KOD           ;
      KU_KOD_         := parc.KU_KOD_          ;
      KU_Nazev        := parc.KU_Nazev         ;
      ORP             := parc.ORP              ;
      ORP_Nazev       := parc.ORP_Nazev        ;
      Kraj            := parc.Kraj             ;
      Kraj_Nazev      := parc.Kraj_Nazev       ;
      KATPAR_KOD      := parc.KATPAR_KOD       ;
      SKUPAR_CIS      := parc.SKUPAR_CIS       ;
      SKUPAR_Comment  := parc.SKUPAR_Comment   ;
      KVAL_P          := parc.KVAL_P           ;
      TEL_ID          := parc.TEL_ID           ;
      KATUZE_KOD_PUV  := parc.KATUZE_KOD_PUV   ;
      PARCIS          := parc.PARCIS           ;
      PARPOD          := parc.PARPOD           ;
      LV              := parc.LV               ;
      LVC             := parc.LVC              ;
      PAR_Vymera      := parc.PAR_Vymera       ;
      Kultura         := parc.Kultura          ;
      ParZar          := parc.ParZar           ;
      PUPFL           := parc.PUPFL            ;
      PUPFLc          := parc.PUPFLc           ;
      PKCIS           := parc.PKCIS            ;
      PKPOD           := parc.PKPOD            ;
      PK_Dil          := parc.PK_Dil           ;
      SuperID         := parc.SuperID          ;
      PK              := parc.PK               ;
      GP              := parc.GP               ;
      NEP             := parc.NEP              ;
      Zmena           := parc.Zmena            ;
      Poznamka        := parc.Poznamka         ;
      ATR_PUV         := parc.ATR_PUV          ;
      Vlastnik        := parc.Vlastnik         ;
      MAJ_DRUH        := parc.MAJ_DRUH         ;
      MAJ_KOD         := parc.MAJ_KOD          ;
      MAJ_Name        := parc.MAJ_Name         ;
      MAJ_Adresa      := parc.MAJ_Adresa       ;
   end
   else
   if Source is Tgis_ParcelaCast_Props then
   begin
      parcp := Tgis_ParcelaCast_Props(Source);
      aID             := parcp.aID              ;
      Vymera          := parcp.Vymera           ;
      KU_KOD          := parcp.KU_KOD           ;
      KU_KOD_         := parcp.KU_KOD_          ;
      KU_Nazev        := parcp.KU_Nazev         ;
      ORP             := parcp.ORP              ;
      ORP_Nazev       := parcp.ORP_Nazev        ;
      Kraj            := parcp.Kraj             ;
      Kraj_Nazev      := parcp.Kraj_Nazev       ;
      KATPAR_KOD      := parcp.KATPAR_KOD       ;
      SKUPAR_CIS      := parcp.SKUPAR_CIS       ;
      SKUPAR_Comment  := parcp.SKUPAR_Comment   ;
      KVAL_P          := parcp.KVAL_P           ;
      TEL_ID          := parcp.TEL_ID           ;
      KATUZE_KOD_PUV  := parcp.KATUZE_KOD_PUV   ;
      PARCIS          := parcp.PARCIS           ;
      PARPOD          := parcp.PARPOD           ;
      LV              := parcp.LV               ;
      LVC             := parcp.LVC              ;
      PAR_Vymera      := parcp.PAR_Vymera       ;
      Kultura         := parcp.Kultura          ;
      ParZar          := parcp.ParZar           ;
      PUPFL           := parcp.PUPFL            ;
      PUPFLc          := parcp.PUPFLc           ;
      PKCIS           := parcp.PKCIS            ;
      PKPOD           := parcp.PKPOD            ;
      PK_Dil          := parcp.PK_Dil           ;
      SuperID         := parcp.SuperID          ;
      PK              := parcp.PK               ;
      GP              := parcp.GP               ;
      NEP             := parcp.NEP              ;
      Zmena           := parcp.Zmena            ;
      Poznamka        := parcp.Poznamka         ;
      ATR_PUV         := parcp.ATR_PUV          ;
      Vlastnik        := parcp.Vlastnik         ;
      MAJ_DRUH        := parcp.MAJ_DRUH         ;
      MAJ_KOD         := parcp.MAJ_KOD          ;
      MAJ_Name        := parcp.MAJ_Name         ;
      MAJ_Adresa      := parcp.MAJ_Adresa       ;
   end;
end;

function Tgis_ParcelaCast_Props.GetGP_Text: string;
begin
   if GP then
      result := 'ANO'
   else
      result := 'NE';
end;

function Tgis_ParcelaCast_Props.GetNEP_TEXT: string;
begin
   if NEP then
      result := 'ANO'
   else
      result := 'NE';
end;

function Tgis_ParcelaCast_Props.GetPARCAST: integer;
begin
   result := 1;
end;

function Tgis_ParcelaCast_Props.GetPARCISAbs: integer;
begin
   result := Abs(PARCIS);
end;

function Tgis_ParcelaCast_Props.GetParName: string;
begin
   result := IntToStr(PARCIS);
   if PARPOD > 0 then
      result := result+'/'+ IntToStr(PARPOD);
end;

function Tgis_ParcelaCast_Props.GetParNameAbs: string;
begin
   result := IntToStr(PARCISAbs);
   if PARPOD > 0 then
      result := result+'/'+ IntToStr(PARPOD);
end;

function Tgis_ParcelaCast_Props.GetParNameAbsDTTO: string;
begin
   result := '?';
   result := IntToStr(PARCISAbs);
   if PARPOD > 0 then
      result := '../'+ IntToStr(PARPOD);
end;

function Tgis_ParcelaCast_Props.GetParZar_Text: string;
begin
   if PARZAR then
      result := 'ANO'
   else
      result := 'NE';
end;

function Tgis_ParcelaCast_Props.GetPAR_SKU_KN: byte;
begin
   result := 0;
   {
   P := Parcela;
   if P = nil then exit;
   result := P.PAR_SKU_KN;
   }
   if PARCIS < 0 then
      result := 1
   else
      result := 2;
   {$IFDEF UHUL}
   if KATUZE_KOD_PUV > 0 then
   begin
      result := 9;
      exit;
   end;
   {$ENDIF}
   if NEP then
   begin
      result := 3;
      exit;
   end;
   if GP then
      result := result + 5
   else
   if PK then
      result := result + 3;
end;

function Tgis_ParcelaCast_Props.GetPK: boolean;
begin
   result := PKCIS > 0;
end;

function Tgis_ParcelaCast_Props.GetPKName: string;
begin
   result := IntToStr(PKCIS);
   if PKPOD > 0 then
      result := result+'/'+ IntToStr(PKPOD);
end;

function Tgis_ParcelaCast_Props.GetPKNameDTTO: string;
begin
   result := IntToStr(PKCIS);
   if PKPOD > 0 then
      result := '../'+ IntToStr(PKPOD);
end;

function Tgis_ParcelaCast_Props.GetPK_Text: string;
begin
   if PK then
      result := 'ANO'
   else
      result := 'NE';
end;

function Tgis_ParcelaCast_Props.GetPUPFLc_Text: string;
begin
   if PUPFLc then
      result := 'ANO'
   else
      result := 'NE';
end;

function Tgis_ParcelaCast_Props.GetPUPFL_Text: string;
begin
   if PUPFL then
      result := 'ANO'
   else
      result := 'NE';
end;

procedure Tgis_ParcelaCast_Props.SetaID(const Value: string);
begin
   FaID := Value;
end;

procedure Tgis_ParcelaCast_Props.SetAssignBy(const Value: TElement);
begin
   Assign(Value);
end;

procedure Tgis_ParcelaCast_Props.SetATR_PUV(const Value: integer);
begin
   FATR_PUV := Value;
end;

procedure Tgis_ParcelaCast_Props.SetGP(const Value: boolean);
begin
   FGP := Value;
end;

procedure Tgis_ParcelaCast_Props.SetGP_Text(const Value: string);
begin

end;

procedure Tgis_ParcelaCast_Props.SetKATPAR_KOD(const Value: integer);
begin
  FKATPAR_KOD := Value;
end;

procedure Tgis_ParcelaCast_Props.SetKATUZE_KOD_PUV(const Value: integer);
begin
  FKATUZE_KOD_PUV := Value;
end;

procedure Tgis_ParcelaCast_Props.SetKraj(const Value: string);
begin
  FKraj := Value;
end;

procedure Tgis_ParcelaCast_Props.SetKraj_Nazev(const Value: string);
begin
  FKraj_Nazev := Value;
end;

procedure Tgis_ParcelaCast_Props.SetKultura(const Value: integer);
begin
  FKultura := Value;
end;

procedure Tgis_ParcelaCast_Props.SetKU_KOD(const Value: integer);
begin
  FKU_KOD := Value;
end;

procedure Tgis_ParcelaCast_Props.SetKU_KOD_(const Value: integer);
begin
  FKU_KOD_ := Value;
end;

procedure Tgis_ParcelaCast_Props.SetKU_Nazev(const Value: string);
begin
  FKU_Nazev := Value;
end;

procedure Tgis_ParcelaCast_Props.SetKVAL_P(const Value: byte);
begin
  FKVAL_P := Value;
end;

procedure Tgis_ParcelaCast_Props.SetLV(const Value: integer);
begin
  FLV := Value;
end;

procedure Tgis_ParcelaCast_Props.SetLVC(const Value: integer);
begin
  FLVC := Value;
end;

procedure Tgis_ParcelaCast_Props.SetMAJ_Adresa(const Value: string);
begin
  FMAJ_Adresa := Value;
end;

procedure Tgis_ParcelaCast_Props.SetMAJ_DRUH(const Value: integer);
begin
  FMAJ_DRUH := Value;
end;

procedure Tgis_ParcelaCast_Props.SetMAJ_KOD(const Value: string);
begin
  FMAJ_KOD := Value;
end;

procedure Tgis_ParcelaCast_Props.SetMAJ_Name(const Value: string);
begin
  FMAJ_Name := Value;
end;

procedure Tgis_ParcelaCast_Props.SetNEP(const Value: boolean);
begin
  FNEP := Value;
end;

procedure Tgis_ParcelaCast_Props.SetNEP_Text(const Value: string);
begin

end;

procedure Tgis_ParcelaCast_Props.SetORP(const Value: integer);
begin
  FORP := Value;
end;

procedure Tgis_ParcelaCast_Props.SetORP_Nazev(const Value: string);
begin
  FORP_Nazev := Value;
end;

procedure Tgis_ParcelaCast_Props.SetPARCIS(const Value: integer);
begin
  FPARCIS := Value;
end;

procedure Tgis_ParcelaCast_Props.SetParName(const Value: string);
begin

end;

procedure Tgis_ParcelaCast_Props.SetParNameAbs(const Value: string);
begin

end;

procedure Tgis_ParcelaCast_Props.SetPARPOD(const Value: integer);
begin
  FPARPOD := Value;
end;

procedure Tgis_ParcelaCast_Props.SetParZar(const Value: boolean);
begin
  FParZar := Value;
end;

procedure Tgis_ParcelaCast_Props.SetParZar_Text(const Value: string);
begin

end;

procedure Tgis_ParcelaCast_Props.SetPAR_SKU_KN(const Value: byte);
begin

end;

procedure Tgis_ParcelaCast_Props.SetPAR_Vymera(const Value: double);
begin
  FPAR_Vymera := Value;
end;

procedure Tgis_ParcelaCast_Props.SetPK(const Value: boolean);
begin

end;

procedure Tgis_ParcelaCast_Props.SetPKCIS(const Value: integer);
begin
  FPKCIS := Value;
end;

procedure Tgis_ParcelaCast_Props.SetPKName(const Value: string);
begin

end;

procedure Tgis_ParcelaCast_Props.SetPKPOD(const Value: integer);
begin
  FPKPOD := Value;
end;

procedure Tgis_ParcelaCast_Props.SetPK_Dil(const Value: integer);
begin
  FPK_Dil := Value;
end;

procedure Tgis_ParcelaCast_Props.SetPoznamka(const Value: string);
begin
  FPoznamka := Value;
end;

procedure Tgis_ParcelaCast_Props.SetPUPFL(const Value: boolean);
begin
  FPUPFL := Value;
end;

procedure Tgis_ParcelaCast_Props.SetPUPFLc(const Value: boolean);
begin
  FPUPFLc := Value;
end;

procedure Tgis_ParcelaCast_Props.SetPUPFLc_Text(const Value: string);
begin

end;

procedure Tgis_ParcelaCast_Props.SetPUPFL_Text(const Value: string);
begin

end;

procedure Tgis_ParcelaCast_Props.SetSKUPAR_CIS(const Value: integer);
begin
  FSKUPAR_CIS := Value;
end;

procedure Tgis_ParcelaCast_Props.SetSKUPAR_Comment(const Value: string);
begin
  FSKUPAR_Comment := Value;
end;

procedure Tgis_ParcelaCast_Props.SetSuperID(const Value: integer);
begin
  FSuperID := Value;
end;

procedure Tgis_ParcelaCast_Props.SetTEL_ID(const Value: string);
begin
  FTEL_ID := Value;
end;

procedure Tgis_ParcelaCast_Props.SetVlastnik(const Value: string);
begin
  FVlastnik := Value;
end;

procedure Tgis_ParcelaCast_Props.SetVymera(const Value: double);
begin
  FVymera := Value;
end;

procedure Tgis_ParcelaCast_Props.SetZmena(const Value: string);
begin
  FZmena := Value;
end;

{ TGis_OLHs }

function TGis_OLHs.CreateOLHByOLH(Value: TGis_OLH): TGis_OLH;
begin
   result := nil;
   if Value = nil then exit;
   if Value.IsMyOwner(Self) then
   begin
      result := Value;
      exit;
   end;
   result := GetOLH_ID(Value.OLH_ID);
   if result = nil then
   begin
      result := Tgis_OLH.Create;
      result.OLH_ID := Value.OLH_ID;
      result.OLH_PR_TIT := Value.OLH_PR_TIT;
      result.Jmeno := Value.Jmeno;
      result.Prijmeni := Value.Prijmeni;
      result.Adresa := Value.Adresa;
      result.Comment := Value.Comment;
//      result.MAJ_KOD := Value.MAJ_KOD;
//      result.SwapJmeno := Value.SwapJmeno;
//      result.FullNameToName := Value.FullNameToName;
//      result.AdresaToName := Value.AdresaToName;
//      result.FixMaj := Value.FixMaj;
      AddElement(result);
      ActualOLH := result;
   end;
end;

function TGis_OLHs.CreateOLH_ID(Value: string): TGis_OLH;
begin
   result := GetOLH_ID(Value);
   if result = nil then
   begin
      result := Tgis_OLH.Create;
      result.OLH_ID := Value;
      AddElement(result);
      ActualOLH := result;
   end;
end;

function TGis_OLHs.GetOLH_ID(Value: string): TGis_OLH;
var
   i: integer;
   e: TElement;
   O: Tgis_OLH;
begin
   result := nil;
   for i := 0 to LastIndex do
   begin
      e := Elements[i];
      if not (e is Tgis_OLH) then continue;
      O := Tgis_OLH(e);
      if O.OLH_ID = Value then
      begin
         result := O;
         break;
      end;
   end;
   ActualOLH := result;
end;

procedure TGis_OLHs.SetActualOLH(const Value: TGis_OLH);
begin
  FActualOLH := Value;
end;

procedure TGis_OLHs.SetFindOLH_ID(const Value: string);
begin

end;

{ TGis_OLH }

function TGis_OLH.GetFullName: string;
begin
   result := Jmeno + ' ' + Prijmeni;
end;

function TGis_OLH.GetName: string;
begin
   result := OLH_ID;
end;

procedure TGis_OLH.SetAdresa(const Value: string);
begin
  FAdresa := Value;
end;

procedure TGis_OLH.SetComment(const Value: string);
begin
  FComment := Value;
end;

procedure TGis_OLH.SetJmeno(const Value: string);
begin
  FJmeno := Value;
end;

procedure TGis_OLH.SetName(aName: string);
begin
  inherited;

end;

procedure TGis_OLH.SetOLH_ID(const Value: string);
begin
  FOLH_ID := Value;
end;

procedure TGis_OLH.SetOLH_PR_TIT(const Value: string);
begin
  FOLH_PR_TIT := Value;
end;

procedure TGis_OLH.SetPrijmeni(const Value: string);
begin
  FPrijmeni := Value;
end;

INITIALIZATION
   RegisterOrbisClass(Tgis_ParcelModel);
   RegisterOrbisClass(Tgis_Katastr);
   RegisterOrbisClass(Tgis_SkupinyParcel);
   RegisterOrbisClass(Tgis_Parcely);
   RegisterOrbisClass(Tgis_KParcely);
   RegisterOrbisClass(Tgis_ParCasti);
   RegisterOrbisClass(Tgis_SkupinaParcel);
   RegisterOrbisClass(Tgis_Parcela);
   RegisterOrbisClass(Tgis_ParcelaCast);
   RegisterOrbisClass(Tgis_ParcelaCast_Props);
   RegisterOrbisClass(Tgis_Majitel);
   RegisterOrbisClass(Tgis_Majitele);
   RegisterOrbisClass(Tgis_OLH);
   RegisterOrbisClass(Tgis_OLHs);
   RegisterOrbisClass(Tgis_Vlastnictvi);
   RegisterOrbisClass(Tgis_Tel);
   RegisterOrbisClass(Tgis_Person);
   RegisterOrbisClass(Tgis_People);
END.

