unit e_TaskModel;

interface
uses
   e_InhMdl,
   e_Type;

type

TTaskModel = class(TInheritanceModel)
private
   FTasks: TStringListElement;
   function GetTasks: TStringListElement;
published
   property Tasks: TStringListElement read GetTasks stored false;
end;

TTaskModelEntity= class(TInheritanceModelEntity)
  private
    function GetActualTaskModel: TTaskModel;
published
   property ActualTaskModel: TTaskModel read GetActualTaskModel stored false;
end;

implementation
uses
   e_Class;
const
   cstr_Tasks: string = 'TASKS';

{ TTaskModel }

function TTaskModel.GetTasks: TStringListElement;
begin
   if FTasks = nil then
   begin
      FTasks := TStringListElement(FindElementName(cstr_Tasks));
      if FTasks = nil then
      begin
         FTasks := TStringListElement.Create;
         FTasks.Name := cstr_Tasks;
         AddElement(FTasks);
      end;
   end;
   result := FTasks;
end;

{ TTaskModelEntity }

function TTaskModelEntity.GetActualTaskModel: TTaskModel;
begin
   result := TTaskModel(ActualItem);
 end;

INITIALIZATION
   RegisterOrbisClass(TTaskModel);
   RegisterOrbisClass(TTaskModelEntity);
END.
