unit f_ExportLCRDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  f_OrbisForm, StdCtrls, Buttons, Spin,
     Elements,
  ComCtrls;

type
  TExportLCRDialog_Form = class(TORBISForm)
    ed_Revir: TEdit;
    ed_LCR: TEdit;
    ed_Cislo: TSpinEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    l_LCRRevirPath: TLabel;
    GroupBox1: TGroupBox;
    b_REV: TBitBtn;
    b_ODD: TBitBtn;
    b_DIL: TBitBtn;
    b_PSK: TBitBtn;
    b_BZL: TBitBtn;
    b_JP: TBitBtn;
    b_OP: TBitBtn;
    b_CtiRevir: TBitBtn;
    b_CelejRevir: TButton;
    ed_LHC: TSpinEdit;
    Label4: TLabel;
    GroupBox2: TGroupBox;
    b_ZRO: TBitBtn;
    Button1: TButton;
    StatusBar: TStatusBar;
    cb_AllInOne: TCheckBox;
    b_VODKOM: TBitBtn;
    b_HOP: TBitBtn;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure ed_LCRChange(Sender: TObject);
    procedure ed_CisloChange(Sender: TObject);
    procedure ed_RevirChange(Sender: TObject);
    procedure b_CtiRevirClick(Sender: TObject);
    procedure b_REVClick(Sender: TObject);
    procedure b_ODDClick(Sender: TObject);
    procedure b_DILClick(Sender: TObject);
    procedure b_PSKClick(Sender: TObject);
    procedure b_BZLClick(Sender: TObject);
    procedure b_JPClick(Sender: TObject);
    procedure b_OPClick(Sender: TObject);
    procedure b_CelejRevirClick(Sender: TObject);
    procedure b_ZROClick(Sender: TObject);
    procedure cb_AllInOneClick(Sender: TObject);
    procedure b_VODKOMClick(Sender: TObject);
    procedure b_HOPClick(Sender: TObject);
  private
    FReviry: TEntity;
    procedure SetReviry(const Value: TEntity);
    { Private declarations }
  public
     procedure CHangeDestinationPath;
     function CheckReviry: boolean;
     procedure CHeckLHC;
     property  Reviry: TEntity read FReviry write SetReviry;
  end;


implementation
uses
   FileCtrl,
   e_Files,
   e_LHCModel,
   m_Proj,
   u_String,
   Worlds;

{$R *.DFM}

procedure TExportLCRDialog_Form.CHangeDestinationPath;
var
   S,S1: string;
begin
   S := ed_LCR.Text;
   CheckBackSlash(S);
   S1 := ed_Cislo.Text;
   if length(S1) = 1 then S1 := '0'+S1;
   l_LCRRevirPath.Caption := S + S1 +'\';
end;

procedure TExportLCRDialog_Form.SpeedButton1Click(Sender: TObject);
var
   S: string;
begin
   inherited;
   S := ed_Revir.Text;
   if not DirectoryExists(S) then S := '';
   if SelectDirectory(S, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
   begin
      ed_Revir.Text := S;
   end;
end;

procedure TExportLCRDialog_Form.SpeedButton2Click(Sender: TObject);
var
   S: string;
begin
   inherited;
   S := ed_LCR.Text;
   if not DirectoryExists(S) then S := '';
   if SelectDirectory(S, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
   begin
      ed_LCR.Text := S;
   end;
end;

procedure TExportLCRDialog_Form.ed_LCRChange(Sender: TObject);
begin
   inherited;
   CHangeDestinationPath;
end;

procedure TExportLCRDialog_Form.ed_CisloChange(Sender: TObject);
begin
   inherited;
   CHangeDestinationPath;
end;

procedure TExportLCRDialog_Form.ed_RevirChange(Sender: TObject);
var
   S,S1: string;
   i: integer;
begin
   S := '';
   S1 := '';
   S := ExtractFileName(ed_Revir.Text);
   for i := 1 to length(S) do
   begin
      if S[i] in ['0'..'9'] then
         S1 := S1 + S[i]
      else
         break;
   end;
   if S1 <> '' then
      ed_Cislo.Text := S1;
end;

procedure TExportLCRDialog_Form.b_CtiRevirClick(Sender: TObject);
var
   i: integer;
   S: string;
begin
   inherited;
   if cb_AllInOne.Checked then
      Tool.PostTextMsg(tm_Run,'LED\LCR\CtiLHC.oil',nil)
   else
      Tool.PostTextMsg(tm_Run,'LED\LCR\CtiRevir.oil',nil);
   Application.ProcessMessages;
   Application.ProcessMessages;
   if cb_AllInOne.Checked then
   begin
      if not CHeckReviry then exit;
      S := '';
      for i := 0 to Reviry.LastIndex do
      begin
         S := S + Reviry.Elements[i].Name;
         if i < Reviry.LastIndex then S := S +',';
      end;
      ShowMessage('Reviry: '+S);
   end;
end;

procedure TExportLCRDialog_Form.b_REVClick(Sender: TObject);
var
   i: integer;
   LS: Tgis_LS;
begin
  inherited;
   CheckLHC;
   if cb_AllInOne.Checked then
   begin
      Tool.PostTextMsg(tm_Run,'LED\LCR\REG1.oil',nil);
      Application.ProcessMessages;
      if not CHeckReviry then exit;
      for i := 0 to Reviry.LastIndex do
      begin
         LS := Tgis_LS(Reviry.Elements[i]);
         ed_Cislo.Value := LS.Cislo;
         Tool.PostTextMsg(tm_Run,'LED\LCR\REG2.oil',nil);
         Application.ProcessMessages;

      end;
   end
   else
      Tool.PostTextMsg(tm_Run,'LED\LCR\REG.oil',nil);
   Application.ProcessMessages;
end;

procedure TExportLCRDialog_Form.b_ODDClick(Sender: TObject);
var
   i: integer;
   LS: Tgis_LS;
begin
  inherited;
   CheckLHC;
   if cb_AllInOne.Checked then
   begin
      Tool.PostTextMsg(tm_Run,'LED\LCR\ODD1.oil',nil);
      Application.ProcessMessages;
      if not CHeckReviry then exit;
      for i := 0 to Reviry.LastIndex do
      begin
         LS := Tgis_LS(Reviry.Elements[i]);
         ed_Cislo.Value := LS.Cislo;
         Tool.PostTextMsg(tm_Run,'LED\LCR\ODD2.oil',nil);
         Application.ProcessMessages;

      end;
   end
   else
      Tool.PostTextMsg(tm_Run,'LED\LCR\ODD.oil',nil);
   Application.ProcessMessages;
end;

procedure TExportLCRDialog_Form.b_DILClick(Sender: TObject);
var
   i: integer;
   LS: Tgis_LS;
begin
  inherited;
   CheckLHC;
   if cb_AllInOne.Checked then
   begin
      Tool.PostTextMsg(tm_Run,'LED\LCR\DIL1.oil',nil);
      ed_Cislo.Value := 1;
      Application.ProcessMessages;
      Tool.PostTextMsg(tm_Run,'LED\LCR\ZRO2.oil',nil);
      Application.ProcessMessages;
      if not CHeckReviry then exit;
      for i := 0 to Reviry.LastIndex do
      begin
         LS := Tgis_LS(Reviry.Elements[i]);
         ed_Cislo.Value := LS.Cislo;
         Tool.PostTextMsg(tm_Run,'LED\LCR\DIL2.oil',nil);
         Application.ProcessMessages;

      end;
   end
   else
      Tool.PostTextMsg(tm_Run,'LED\LCR\DIL.oil',nil);
   Application.ProcessMessages;
end;

procedure TExportLCRDialog_Form.b_PSKClick(Sender: TObject);
var
   i: integer;
   LS: Tgis_LS;
begin
  inherited;
   CheckLHC;
   if cb_AllInOne.Checked then
   begin
      Tool.PostTextMsg(tm_Run,'LED\LCR\PSK1.oil',nil);
      Application.ProcessMessages;
      if not CHeckReviry then exit;
      for i := 0 to Reviry.LastIndex do
      begin
         LS := Tgis_LS(Reviry.Elements[i]);
         ed_Cislo.Value := LS.Cislo;
         Tool.PostTextMsg(tm_Run,'LED\LCR\PSK2.oil',nil);
         Application.ProcessMessages;

      end;
   end
   else
      Tool.PostTextMsg(tm_Run,'LED\LCR\PSK.oil',nil);
   Application.ProcessMessages;
end;

procedure TExportLCRDialog_Form.b_BZLClick(Sender: TObject);
var
   i: integer;
   LS: Tgis_LS;
begin
  inherited;
   CheckLHC;
   if cb_AllInOne.Checked then
   begin
      Tool.PostTextMsg(tm_Run,'LED\LCR\BZL1.oil',nil);
      Application.ProcessMessages;
      if not CHeckReviry then exit;
      for i := 0 to Reviry.LastIndex do
      begin
         LS := Tgis_LS(Reviry.Elements[i]);
         ed_Cislo.Value := LS.Cislo;
         Tool.PostTextMsg(tm_Run,'LED\LCR\BZL2.oil',nil);
         Application.ProcessMessages;

      end;
   end
   else
      Tool.PostTextMsg(tm_Run,'LED\LCR\BZL.oil',nil);
   Application.ProcessMessages;
end;

procedure TExportLCRDialog_Form.b_JPClick(Sender: TObject);
var
   i: integer;
   LS: Tgis_LS;
begin
  inherited;
   CheckLHC;
   if cb_AllInOne.Checked then
   begin
      Tool.PostTextMsg(tm_Run,'LED\LCR\JP1.oil',nil);
      Application.ProcessMessages;
      if not CHeckReviry then exit;
      for i := 0 to Reviry.LastIndex do
      begin
         LS := Tgis_LS(Reviry.Elements[i]);
         ed_Cislo.Value := LS.Cislo;
         Tool.PostTextMsg(tm_Run,'LED\LCR\JP2.oil',nil);
         Application.ProcessMessages;

      end;
   end
   else
      Tool.PostTextMsg(tm_Run,'LED\LCR\JP.oil',nil);
   Application.ProcessMessages;
end;

procedure TExportLCRDialog_Form.b_OPClick(Sender: TObject);
var
   i: integer;
   LS: Tgis_LS;
begin
  inherited;
   CheckLHC;
   if cb_AllInOne.Checked then
   begin
      Tool.PostTextMsg(tm_Run,'LED\LCR\OP1.oil',nil);
      Application.ProcessMessages;
      if not CHeckReviry then exit;
      for i := 0 to Reviry.LastIndex do
      begin
         LS := Tgis_LS(Reviry.Elements[i]);
         ed_Cislo.Value := LS.Cislo;
         Tool.PostTextMsg(tm_Run,'LED\LCR\OP2.oil',nil);
         Application.ProcessMessages;

      end;
   end
   else
      Tool.PostTextMsg(tm_Run,'LED\LCR\OP.oil',nil);
   Application.ProcessMessages;
end;

procedure TExportLCRDialog_Form.b_CelejRevirClick(Sender: TObject);
begin
   inherited;
   CheckLHC;
   if cb_AllInOne.Checked then
   begin
        b_REVClick(nil);
        b_ODDClick(nil);
        b_DILClick(nil);
        b_PSKClick(nil);
        b_BZLClick(nil);
        b_JPClick(nil);
        b_OPClick(nil);
        b_HOPClick(nil);
   end
   else
      Tool.PostTextMsg(tm_Run,'LED\LCR\CelejRevir.oil',nil);
   Application.ProcessMessages;
end;

procedure TExportLCRDialog_Form.b_ZROClick(Sender: TObject);
var
   S: string;
   D,DD: TDirectoryElement;
   i: integer;
   e: TElement;
begin
   inherited;
   CheckLHC;
   if cb_AllInOne.Checked then
   begin
      Tool.PostTextMsg(tm_Run,'LED\LCR\LHC2.oil',nil);
      Application.ProcessMessages;
      exit;
   end;
   S := ExtractFilePath(ed_Revir.Text);
   if not DirectoryExists(S) then
   begin
      ShowMessage('Adres LHC '+S +' neexistuje');
      exit;
   end;
   //ShowMessage('Adres LHC: '+S);
   //Tool.PostTextMsg(tm_Run,'LED\LCR\ZRO.oil',nil);
   D := TDirectoryElement(World.ObjectModel.FindElementClass(TDirectoryElement));
   if D <> nil then
      D.Free;
   D := TDirectoryElement.Create;
   World.ObjectModel.NextElement := D;
   D.FileName := S;
   Tool.PostTextMsg(tm_Run,'LED\LCR\ZRO_START.oil',nil);
   Application.ProcessMessages;
   for i := 0 to D.LastIndex do
   begin
      e := D.Elements[i];
      if not (e is TDirectoryElement) then continue;
      DD := TDirectoryElement(e);
      if DD.FindElementName('DET.BLK') = nil then continue; // asi nejakej zapomenutej blok
      ed_Revir.Text := DD.FileName;
      Application.ProcessMessages;
      Tool.PostTextMsg(tm_Run,'LED\LCR\ZRO_WORK.oil',nil);
      {
      b_CtiRevirClick(nil);
      Application.ProcessMessages;
      b_CelejRevirClick(nil);
      }
      Application.ProcessMessages;
   end;
   Application.ProcessMessages;
   Tool.PostTextMsg(tm_Run,'LED\LCR\ZRO_Finish.oil',nil);
   Application.ProcessMessages;
end;

procedure TExportLCRDialog_Form.cb_AllInOneClick(Sender: TObject);
begin
   if cb_AllInOne.Checked then
   begin
      Label1.Caption := 'Zdroj - adres LHC';
      b_CtiRevir.Caption := 'Nati LHC';
      b_DIL.Caption := 'DIL + ZRO';
      b_ZRO.Caption := 'LHC';
   end
   else
   begin
      Label1.Caption := 'Zdroj - adres Revru';
      b_CtiRevir.Caption := 'Nati revr';
      b_DIL.Caption := 'DIL';
      b_ZRO.Caption := 'ZRO';
   end;
   //b_ZRO.Enabled := not cb_AllInOne.Checked;
end;

procedure TExportLCRDialog_Form.SetReviry(const Value: TEntity);
begin
  FReviry := Value;
end;

procedure TExportLCRDialog_Form.b_VODKOMClick(Sender: TObject);
var
   S: string;
   D,DD: TDirectoryElement;
   i: integer;
   e: TElement;
begin
   inherited;
   CheckLHC;
   if cb_AllInOne.Checked then
   begin
      Tool.PostTextMsg(tm_Run,'LED\LCR\VODKOM2.oil',nil);
      Application.ProcessMessages;
   end
   else
   begin
      S := ExtractFilePath(ed_Revir.Text);
      if not DirectoryExists(S) then
      begin
         ShowMessage('Adres LHC '+S +' neexistuje');
         exit;
      end;
      //ShowMessage('Adres LHC: '+S);
      //Tool.PostTextMsg(tm_Run,'LED\LCR\ZRO.oil',nil);
      D := TDirectoryElement(World.ObjectModel.FindElementClass(TDirectoryElement));
      if D <> nil then
         D.Free;
      D := TDirectoryElement.Create;
      World.ObjectModel.NextElement := D;
      D.FileName := S;
      Tool.PostTextMsg(tm_Run,'LED\LCR\VODKOM_START.oil',nil);
      Application.ProcessMessages;
      for i := 0 to D.LastIndex do
      begin
         e := D.Elements[i];
         if not (e is TDirectoryElement) then continue;
         DD := TDirectoryElement(e);
         if DD.FindElementName('DET.BLK') = nil then continue; // asi nejakej zapomenutej blok
         ed_Revir.Text := DD.FileName;
         Application.ProcessMessages;
         Tool.PostTextMsg(tm_Run,'LED\LCR\VODKOM_WORK.oil',nil);
         {
         b_CtiRevirClick(nil);
         Application.ProcessMessages;
         b_CelejRevirClick(nil);
         }
         Application.ProcessMessages;
      end;
      Application.ProcessMessages;
      Tool.PostTextMsg(tm_Run,'LED\LCR\VODKOM_Finish.oil',nil);
      Application.ProcessMessages;
   end;
end;

function TExportLCRDialog_Form.CheckReviry: boolean;
var
   FM: Tgis_ForestModel;
begin
   result := false;
   if Reviry = nil then
   begin
      FM := Tgis_ForestModel(TEntity(World.ObjectModel.FindElementName('DATA')).FindElementClass(Tgis_ForestModel));
      if FM.ActualLHC = nil then
         FM.ActualLHC := Tgis_LHC(FM.FindElementClass(Tgis_LHC));
      Reviry := FM.ActualLHC.Items;
   end;
   if Reviry = nil then
      ShowMessage('Nemohu najt revry')
   else
      result := true;
end;

procedure TExportLCRDialog_Form.CHeckLHC;
var
   FM: Tgis_ForestModel;
begin
   FM := Tgis_ForestModel(TEntity(World.ObjectModel.FindElementName('DATA')).FindElementClass(Tgis_ForestModel));
   if FM.ActualLHC = nil then
      FM.ActualLHC := Tgis_LHC(FM.FindElementClass(Tgis_LHC));
   if ed_LHC.Value = 0 then exit;
   FM.ActualLHC.LHC_LCR := ed_LHC.Value;
end;

procedure TExportLCRDialog_Form.b_HOPClick(Sender: TObject);
var
   i: integer;
   LS: Tgis_LS;
begin
   inherited;
   CheckLHC;
   if cb_AllInOne.Checked then
   begin
      Tool.PostTextMsg(tm_Run,'LED\LCR\HOP1.oil',nil);
      Application.ProcessMessages;
      if not CHeckReviry then exit;
      for i := 0 to Reviry.LastIndex do
      begin
         LS := Tgis_LS(Reviry.Elements[i]);
         ed_Cislo.Value := LS.Cislo;
         Tool.PostTextMsg(tm_Run,'LED\LCR\HOP2.oil',nil);
         Application.ProcessMessages;

      end;
   end
   else
      Tool.PostTextMsg(tm_Run,'LED\LCR\HOP.oil',nil);
   Application.ProcessMessages;
end;

end.
