unit f_LHCProjectDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  f_OrbisDialog, StdCtrls, Buttons, ExtCtrls;

type
  TLHCProjectDialog_Form = class(TOrbisDialog_Form)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    ed_Name: TEdit;
    ed_Author: TEdit;
    m_Comment: TMemo;
    ed_ExternalData: TEdit;
    ed_Data: TEdit;
    ed_ParcelData: TEdit;
    b_ExtData: TSpeedButton;
    b_Data: TSpeedButton;
    b_ParcelData: TSpeedButton;
    Timer1: TTimer;
    Label7: TLabel;
    Label8: TLabel;
    ed_ExportParcel: TEdit;
    ed_ExportData: TEdit;
    b_ExportData: TSpeedButton;
    b_ExportParcel: TSpeedButton;
    procedure b_ExtDataClick(Sender: TObject);
    procedure b_DataClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure b_ParcelDataClick(Sender: TObject);
    procedure ed_ExternalDataChange(Sender: TObject);
    procedure ed_ParcelDataChange(Sender: TObject);
    procedure ed_ExportDataChange(Sender: TObject);
    procedure ed_ExportParcelChange(Sender: TObject);
    procedure b_ExportDataClick(Sender: TObject);
    procedure b_ExportParcelClick(Sender: TObject);
  private
    FExportDataModified: boolean;
    FExportParcelModified: boolean;
    procedure SetExportDataModified(const Value: boolean);
    procedure SetExportParcelModified(const Value: boolean);
    { Private declarations }
  public
     property ExportDataModified: boolean read FExportDataModified write SetExportDataModified;
     property ExportParcelModified: boolean read FExportParcelModified write SetExportParcelModified;
  end;


implementation
uses
   FileCtrl;

{$R *.DFM}

procedure TLHCProjectDialog_Form.b_ExtDataClick(Sender: TObject);
var
   S: string;
begin
   inherited;
   S := ed_ExternalData.Text;
   if not DirectoryExists(S) then S := '';
   if SelectDirectory(S, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
   begin
      ed_ExternalData.Text := S;
   end;
end;

procedure TLHCProjectDialog_Form.b_DataClick(Sender: TObject);
var
   S: string;
begin
   inherited;
   S := ed_Data.Text;
   if not DirectoryExists(S) then S := '';
   if SelectDirectory(S, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
   begin
      ed_Data.Text := S;
   end;
end;

procedure TLHCProjectDialog_Form.Timer1Timer(Sender: TObject);
begin
   inherited;
   if not Active then SetFocus;
end;

procedure TLHCProjectDialog_Form.FormHide(Sender: TObject);
begin
  inherited;
  Timer1.Enabled := false;
end;

procedure TLHCProjectDialog_Form.FormShow(Sender: TObject);
begin
  inherited;
  Timer1.Enabled := true;
end;

procedure TLHCProjectDialog_Form.b_ParcelDataClick(Sender: TObject);
var
   S: string;
begin
   inherited;
   S := ed_ParcelData.Text;
   if not DirectoryExists(S) then S := '';
   if SelectDirectory(S, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
   begin
      ed_ParcelData.Text := S;
   end;
end;

procedure TLHCProjectDialog_Form.ed_ExternalDataChange(Sender: TObject);
begin
   if not ExportDataModified then
      ed_ExportData.Text := ed_ExternalData.Text;
end;

procedure TLHCProjectDialog_Form.SetExportDataModified(
  const Value: boolean);
begin
  FExportDataModified := Value;
end;

procedure TLHCProjectDialog_Form.SetExportParcelModified(
  const Value: boolean);
begin
  FExportParcelModified := Value;
end;

procedure TLHCProjectDialog_Form.ed_ParcelDataChange(Sender: TObject);
begin
   if not ExportParcelModified then
      ed_ExportParcel.Text := ed_ParcelData.Text;
end;

procedure TLHCProjectDialog_Form.ed_ExportDataChange(Sender: TObject);
begin
   ExportDataModified := not AnsiSameText(ed_ExportData.Text, ed_ExternalData.Text);
end;

procedure TLHCProjectDialog_Form.ed_ExportParcelChange(Sender: TObject);
begin
   ExportParcelModified := not AnsiSameText(ed_ExportParcel.Text, ed_ParcelData.Text);
end;

procedure TLHCProjectDialog_Form.b_ExportDataClick(Sender: TObject);
var
   S: string;
begin
   inherited;
   S := ed_ExportData.Text;
   if not DirectoryExists(S) then S := '';
   if SelectDirectory(S, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
   begin
      ed_ExportData.Text := S;
   end;
end;

procedure TLHCProjectDialog_Form.b_ExportParcelClick(Sender: TObject);
var
   S: string;
begin
   inherited;
   S := ed_ExportParcel.Text;
   if not DirectoryExists(S) then S := '';
   if SelectDirectory(S, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
   begin
      ed_ExportParcel.Text := S;
   end;
end;

end.
