unit t_RepairSRF;

interface
uses
   Elements,
   g_Elems,
   Tools;

type
{
Input - vrstva SRF,TEZ
RefAreas - ARE_DET asi
Zkopruje linie DETu (Ref)
Zkopruje hranice ploch a posad je na DET
Peplochuje
Zjist a vyhod pseudohranice v zvislosti SRF,TEZ,DET
Zhovu peplochuje
pokud se jedn o TEZ, pipoj DET, existuje-li
}
TRepairSRF = class(TTool)
  private
    FTolerance: double;
    FRefAreas: TEntity;
    FNewAreas1: TEntity;
    FLines: TRectEntity;
    FRefLines: TRectEntity;
    FTEZ: boolean;
    FDETLines: TEntity;
    FErr1: TEntity;
    FErr: TEntity;
    FErr2: TEntity;
    FErr3: TEntity;
    procedure SetRefAreas(const Value: TEntity);
    procedure SetTolerance(const Value: double);
    procedure SetLines(const Value: TRectEntity);
    procedure SetNewAreas1(const Value: TEntity);
    procedure SetRefLines(const Value: TRectEntity);
    procedure SetTEZ(const Value: boolean);
    function GetSRFAre: TEntity;
    procedure SetDETLines(const Value: TEntity);
    procedure SetErr(const Value: TEntity);
    procedure SetErr1(const Value: TEntity);
    procedure SetErr2(const Value: TEntity);
    procedure SetErr3(const Value: TEntity);
public
   procedure DoIt; override;
   procedure FindRefLinesCopy;
   procedure FindLinesCopy;
   procedure ClearLines;
   procedure MakeNewAreas;
   procedure RemovePseudoBorders;
   procedure MakeClearAreas;
   procedure ConnectTEZ;
   property  RefLines: TRectEntity read FRefLines write SetRefLines;
   property  Lines: TRectEntity read FLines write SetLines;
   property  SRFAre: TEntity read GetSRFAre;
   property  NewAreas1: TEntity read FNewAreas1 write SetNewAreas1;
   property  TEZ: boolean read FTEZ write SetTEZ;
   property  Err1: TEntity read FErr1 write SetErr1;
   property  Err2: TEntity read FErr2 write SetErr2;
   property  Err3: TEntity read FErr3 write SetErr3;
published
   property RefAreas: TEntity read FRefAreas write SetRefAreas;
   property DETLines: TEntity read FDETLines write SetDETLines;
   property Tolerance: double read FTolerance write SetTolerance;
   property Errors: TEntity read FErr write SetErr;
end;

implementation
uses
   Forms,
   e_Class,
   e_Geometry,
   e_GeometryElement,
   e_LHCElements,
   e_QTree,
   MathLib,
   t_JoinLines,
   t_SolveErrors,
   t_QTreeTools,
   t_AreMak,
   t_LHCTestTools,
   t_LineExtractor;

{ TRepairSRF }

procedure TRepairSRF.ClearLines;
var
   CL: TClearLines;
   i: integer;
   e: TElement;
   L: TPolyLineElement;
   En: TOwnerEntity;
   SCLP: TSolveCriticalLinePointDistances;
   JSL: TJoinSimpleLines;
begin
   //Lines.AddAllFrom := RefLines;
   // vyhozen kritickch vzdlenost bod
   SCLP := TSolveCriticalLinePointDistances.Create;
   SCLP.Tolerance := Tolerance;
   for i := 0 to Lines.LastIndex do
   begin
      L := TPolyLineElement(Lines.Elements[i]);
      SCLP.Input := L;
      SCLP.DoIt;
   end;
   SCLP.Free;

   for i := RefLines.LastIndex downto 0 do
   begin
      e := RefLines.Elements[i];
      L := TPolyLineElement(e); // a kontrola ?!?
      if (L.Count < 2) or (L.Length <= 0)  then
      begin
         L.Free;
         Application.ProcessMessages;
      end;
   end;
   JSL := TJoinSimpleLines.Create;
   JSL.Input := RefLines;
   JSL.DoIt;
   JSL.Free;
   JSL := TJoinSimpleLines.Create;
   JSL.Input := Lines;
   JSL.DoIt;
   JSL.Free;
   //!!!!!!!!!
   //exit;

   Lines.Update;
   CL := TClearLines.Create;
   CL.Input := Lines;
   CL.FixedLines := RefLines;
   CL.SelfTest := true;// !!!!!!!!!!!!
   CL.SnapDistance := Tolerance;
   CL.DoIt;
   CL.Free;

   CL := TClearLines.Create;
   CL.Input := Lines;
   //CL.FixedLines := RefLines;
   CL.OnlyEnds := true;
   CL.SelfTest := false;// !!!!!!!!!!!!
   CL.SnapDistance := Tolerance;
   CL.DoIt;
   CL.Free;
   // Pro sychr se spoji vsecky linie dohromady,
   // bude dyl trvat plochovani, ale jinak supr!
   {
   for i := 0 to RefLines.LastIndex do
   begin
      e := RefLines.Elements[i];
      if not e.IsMyOwner(Lines) then
         Lines.AddAndUpdateRect(e);
   end;
   }
   // Ostrann duplicit
   //exit;    //!!!!!!!!!!!!!!!!!

   En := TOwnerEntity.Create;
   En.AddAllFrom := Lines;
   Lines.FreeAll;
   for i := 0 to En.LastIndex do
   begin
      e := En.Elements[i];
      if not e.IsMyOwner(Lines) then
         Lines.AddElement(e);
   end;
   En.Free;
   // vyhozeni chybnych linii
   for i := Lines.LastIndex downto 0 do
   begin
      e := Lines.Elements[i];
      L := TPolyLineElement(e); // a kontrola ?!?
      if (L.Count < 2) or (L.Length <= 0) or ((L.Count = 2) and (L.Length < Tolerance/2)) then
      begin
         L.Free;
         Application.ProcessMessages;
      end;
   end;
   JSL := TJoinSimpleLines.Create;
   JSL.Input := Lines;
   JSL.DoIt;
   JSL.Free;
end;

procedure TRepairSRF.ConnectTEZ;
begin

end;

procedure TRepairSRF.DoIt;
var
   e: TElement;
begin
   if Tolerance = 0 then
      Tolerance := 0.001;
   if SRFAre = nil then exit;
   if SRFAre.NoElements then exit;
   e := SRFAre.Elements[0];
   if e is TTezPlocha then
      TEZ := true
   else
   if not (e is TSRFPlocha) then exit;
   StartProgress('Oprava '+SRFAre.Name,0,0);
   ProgressText := 'Hledn ref. lini';
   Application.ProcessMessages;
   FindRefLinesCopy;
   ProgressText := 'Hledn hranic ploch...';
   Application.ProcessMessages;
   FindLinesCopy;
   ProgressText := 'perovnn lini...';
   Application.ProcessMessages;
   ClearLines;
   //
   {
   Errors := TOwnerEntity.Create;
   AddElement(Errors);
   Errors.Name := 'Chyby';
   EndProgress;
   exit;
   }
   //
   ProgressText := 'prvn peplochovn z kapsy vyhn...';
   Application.ProcessMessages;
   MakeNewAreas;
   ProgressText := 'Odstrann pseudohranic...';
   Application.ProcessMessages;
   RemovePseudoBorders;
   ProgressText := 'Konen tvorba ploch...';
   Application.ProcessMessages;
   MakeClearAreas;
   ConnectTEZ;
   EndProgress;
end;

procedure TRepairSRF.FindLinesCopy;
var
   LEX: TLineExtractor;
begin
   Lines := TPolyLineCollection.Create;
   AddElement(Lines);
   Lines.Name := 'Lines';
   LEX := TLineExtractor.Create;
   LEX.Input := Input;
   LEX.Output := Lines;
   LEX.CopyLines := true;
   LEX.NoDuplicates := true;
   LEX.DoIt;
   LEX.Free;
   Lines.Update;
end;

procedure TRepairSRF.FindRefLinesCopy;
var
   LEX: TLineExtractor;
begin
   RefLines := TPolyLineCollection.Create;
   AddElement(RefLines);
   RefLines.Name := 'RefLines';
   if (DETLines = nil) or DETLines.NoElements then exit;
   LEX := TLineExtractor.Create;
   LEX.Input := DETLines;
   LEX.Output := RefLines;
   LEX.CopyLines := true;
   LEX.NoDuplicates := true;
   LEX.DoIt;
   LEX.Free;
   RefLines.Update;
end;

function TRepairSRF.GetSRFAre: TEntity;
begin
   result := nil;
   if not (Input is TEntity) then exit;
   result := TEntity(Input);
end;

procedure TRepairSRF.MakeClearAreas;
var
   ACL: TAreasFromClearLines;
   ARes: TAreaString;
   QT: TRectEntityQTree;
   AQ: TAddEntityToQTree;
   F: TFindRectEntityInQTreeByXY;
   i: integer;
   A: TAreaElement;
   GE,GEN: TGeometryElement;
   ERE: TOwnerEntity;
   e: TElement;
   AC: TAreaCollection;
begin
   ERE := TOwnerEntity.Create;
   ACL := TAreasFromClearLines.Create;
   ACL.Input := lines;
   ACL.DoIt;
   Ares := TAreaString(ACL.Output);
   ACL.Free;
   AQ := TAddEntityToQTree.Create;
   AQ.Input := SRFAre;
   AQ.DoIt;
   QT := TRectEntityQTree(AQ.Output);
   AQ.Free;
   F := TFindRectEntityInQTreeByXY.Create;
   F.Input := QT;
   Progress := 0;
   MaxProgress := Ares.LastIndex;
   AC := TAreaCollection.Create;
   for i := 0 to Ares.LastIndex do
   begin
      A := TAreaElement(Ares.Elements[i]);
      F.X := A.X;
      F.Y := A.Y;
      F.DoIt;
      if F.Output = nil then
      begin
         if A.Area < 50 then
            Err3.AddElement(A);
         continue;
      end;
      Progress := i;
      Application.ProcessMessages;
      GE := TGeometryElement(F.Output);
      if GE.IsMyOwner(ERE) then
         //Err1.AddElement(GE) // overlay
      else
         ERE.AddElement(GE);
      GEN := TGeometryElement(CreateElementCopy(GE));
      GEN.Geometry := A;
      AC.AddAndUpdateRect(GEN);
      if A.Area < 50 then
         Err1.AddElement(GEN);
   end;
   // uloen ploch, kterch jsme se ani nedotkli
   {
   for i := 0 to SRFAre.LastIndex do
   begin
      e := SRFAre.Elements[i];
      if not e.IsMyOwner(ERE) then
         Err2.AddElement(e);
   end;
   }

   SRFAre.FreeAll;
   SRFAre.AddAllFrom := AC;

   Progress := 0;
   AC.Free;
   Ares.Free;
   QT.Free;
   F.Free;
   ERE.Free;
end;

procedure TRepairSRF.MakeNewAreas;
var
   ACL: TAreasFromClearLines;
   ARes: TAreaString;
   QT: TRectEntityQTree;
   AQ: TAddEntityToQTree;
   F: TFindRectEntityInQTreeByXY;
   i: integer;
   A: TAreaElement;
   GE,GEN: TGeometryElement;
   ERE: TOwnerEntity;
   e,ee: TElement;
begin
   Errors := TOwnerEntity.Create;
   AddElement(Errors);
   Errors.Name := 'Chyby';
   Err1 := TAreaCollection.Create;
   Errors.AddElement(Err1);
   Err3 := TAreaCollection.Create;
   Errors.AddElement(Err3);
   Err2 := TAreaCollection.Create;
   Errors.AddElement(Err2);
   Err1.Name := 'Mal plochy';
   Err2.Name := 'Ztracen plochy';
   Err3.Name := 'Mal neplochy';
   ERE := TOwnerEntity.Create;
   ACL := TAreasFromClearLines.Create;
   ACL.Input := lines;
   ACL.DoIt;
   //!!!!!!
   {
   AddElement(ACL.QTree);
   ACL.QTree.Name := 'QT';
   }
   //!!!!!!
   Ares := TAreaString(ACL.Output);
   ACL.Free;
   NewAreas1 := TAreaCollection.Create;
   AddElement(NewAreas1);
   AQ := TAddEntityToQTree.Create;
   AQ.Input := SRFAre;
   AQ.DoIt;
   QT := TRectEntityQTree(AQ.Output);
   AQ.Free;
   F := TFindRectEntityInQTreeByXY.Create;
   F.Input := QT;
   Progress := 0;
   MaxProgress := Ares.LastIndex;
   for i := 0 to Ares.LastIndex do
   begin
      A := TAreaElement(Ares.Elements[i]);
      ee := A.Elements[0];
      F.X := A.X;
      F.Y := A.Y;
      F.DoIt;
      if F.Output = nil then continue;
      Progress := i;
      Application.ProcessMessages;
      GE := TGeometryElement(F.Output);
      if GE.IsMyOwner(ERE) then
         //Err1.AddElement(GE) // overlay
      else
         ERE.AddElement(GE);
      GEN := TGeometryElement(CreateElementCopy(GE));
      GEN.Geometry := A;
      TAreaCollection(NewAreas1).AddAndUpdateRect(GEN);
   end;
   // uloen ploch, kterch jsme se ani nedotkli
   for i := 0 to SRFAre.LastIndex do
   begin
      e := SRFAre.Elements[i];
      if not e.IsMyOwner(ERE) then
         Err2.AddElement(e);
   end;
   // TEST
   //SRFAre.FreeAll;
   //SRFAre.AddAllFrom := NewAreas1;
   // TEST
   Progress := 0;
   //Ares.Free;
   // TEST
   {
   AddElement(Ares);
   Ares.Name := 'ARES';
   }
   // TEST
   QT.Free;
   F.Free;
   ERE.Free;
end;

procedure TRepairSRF.RemovePseudoBorders;
var
   i: integer;
   L: TPolyLineElement;
   T: TSRFBorderTestTool;
begin
   T := TSRFBorderTestTool.Create;
   T.TEZ := TEZ;
   for i := Lines.LastIndex downTo 0 do
   begin
      L := TPolyLineElement(Lines.Elements[i]);
      if L.IsMyOwner(RefLines) then continue;
      T.Input := L;
      T.DoIt;
      if T.Result then
         Lines.FreeElement(L);
   end;
   T.Free;
end;

procedure TRepairSRF.SetDETLines(const Value: TEntity);
begin
  FDETLines := Value;
end;

procedure TRepairSRF.SetErr(const Value: TEntity);
begin
  FErr := Value;
end;

procedure TRepairSRF.SetErr1(const Value: TEntity);
begin
  FErr1 := Value;
end;

procedure TRepairSRF.SetErr2(const Value: TEntity);
begin
  FErr2 := Value;
end;

procedure TRepairSRF.SetErr3(const Value: TEntity);
begin
  FErr3 := Value;
end;

procedure TRepairSRF.SetLines(const Value: TRectEntity);
begin
  FLines := Value;
end;

procedure TRepairSRF.SetNewAreas1(const Value: TEntity);
begin
  FNewAreas1 := Value;
end;

procedure TRepairSRF.SetRefAreas(const Value: TEntity);
begin
  FRefAreas := Value;
end;

procedure TRepairSRF.SetRefLines(const Value: TRectEntity);
begin
  FRefLines := Value;
end;

procedure TRepairSRF.SetTEZ(const Value: boolean);
begin
  FTEZ := Value;
end;

procedure TRepairSRF.SetTolerance(const Value: double);
begin
  FTolerance := Value;
end;

INITIALIZATION
   RegisterOrbisClass(TRepairSRF);
END.

