unit I_mspace;
{****************************************************************************}
{                                                                            }
{          ORBIS ... Interpret Obdelniku                                     }
{                    (c) 1996                                                }
{                                                                            }
{****************************************************************************}

interface
uses
   Elements,
   I_Basic,
   t_Recurs;

type

  TSMO_Interpret = class(TRectInterpret)
  protected
    function  QGoInside(Element: TElement): boolean; override;
    function  QProcessBefore(Element: TElement): boolean; override;
    procedure Process(Element: TElement); override;
    function  IsItsClass(AObject: TObject): boolean; override;
  public
    function  CanUniGoInside(Element: TElement): boolean; override;
  end;

  TSMO_50_Interpret = class(TRectInterpret)
  protected
    function  QGoInside(Element: TElement): boolean; override;
    function  QProcessBefore(Element: TElement): boolean; override;
    procedure Process(Element: TElement); override;
    function  IsItsClass(AObject: TObject): boolean; override;
    procedure SetSubInterprets; override;
  public
    function    CanUniGoInside(Element: TElement): boolean; override;
  end;

  TSMO_10_Interpret = class(TRectInterpret)
  protected
    function  QGoInside(Element: TElement): boolean; override;
    function  QProcessBefore(Element: TElement): boolean; override;
    procedure Process(Element: TElement); override;
    function  IsItsClass(AObject: TObject): boolean; override;
  end;

  TSMO_5_Interpret = class(TRectInterpret)
  protected
    function  QGoInside(Element: TElement): boolean; override;
    function  QProcessBefore(Element: TElement): boolean; override;
    procedure Process(Element: TElement); override;
    function  IsItsClass(AObject: TObject): boolean; override;
  end;



implementation
uses
   Graphics,
   e_Class,
   e_Device,
   e_MSpace,
   g_Elems;


{ TSMO_Interpret }



function  TSMO_Interpret.QGoInside(Element: TElement): boolean;
begin
  Result:= true;
end;

function  TSMO_Interpret.QProcessBefore(Element: TElement): boolean;
begin
  Result:= Element is TSMO_2;
end;



procedure TSMO_Interpret.Process(Element: TElement);
var
  Rect: TRectangle;
  aColor: TColor;
  aClass: TClass;
  Labels: boolean;
begin
    if TRectEntity(Element).IsOverRegion(MinX,MinY,MaxX,MaxY)then
    begin
       Labels := false;
       aClass := Element.ClassType;
       {
       if aClass = TSMO_50 then
       }
       if Element is TSMO_50 then
       begin
           aColor := clBlack;
           labels := Device.Projection.Scale < 5000000;
       end
       else
       if Element is  TSMO_25 then
       begin
          aColor := clBlue;
          labels := Device.Projection.Scale < 2500000;
       end
       else
       {
       if aClass = TSMO_10 then
       }
       if Element is  TSMO_10 then
       begin
          aColor := clRed;
          labels := Device.Projection.Scale < 1000000;
       end
       else
       {
       if aClass = TSMO_5  then
       }
       if Element is TSMO_5  then
       begin
          aColor := clGreen;
          labels := Device.Projection.Scale < 500000;
       end
       else
       if Element is TSMO_2  then
       begin
          aColor := clMaroon;
          labels := Device.Projection.Scale < 200000;
       end
       else exit;
       Device.Pen.Color := aColor;
       Device.Pen.Width := 1;
       Device.Pen.Style := psSolid;
       Device.Pen.Mode  := pmCopy;
       Device.Brush.Style := bsClear;
       Rect:= TRectEntity(Element).Rect;
       Device.Rectangle(Rect.Min.X, Rect.Min.Y, Rect.Max.X, Rect.Max.Y);
       if not Labels then exit;
       Device.Font.Name := 'Arial';
       Device.Font.Height := Device.Projection.GetPageLengthVert1(Rect.MaxY - Rect.MinY) div 7;
       Device.TextOut(Rect.Min.X, Rect.Max.Y, Element.Name);
    end;
end;



function TSMO_Interpret.IsItsClass(AObject: TObject): boolean;
begin
   result := AObject is TSMO_2;
end;

function TSMO_Interpret.CanUniGoInside(Element: TElement): boolean;
begin
   result := false;
end;


{ TSMO_50_Interpret }



procedure   TSMO_50_Interpret.SetSubInterprets;
begin
   NextInterpret := TInterpret(TSMO_10.Create);
end;


function  TSMO_50_Interpret.QGoInside(Element: TElement): boolean;
begin
  Result:= true;
end;

function  TSMO_50_Interpret.QProcessBefore(Element: TElement): boolean;
begin
  Result:= Element.ClassType = TSMO_50;
end;



procedure TSMO_50_Interpret.Process(Element: TElement);
var
  Rect: TRectangle;
begin
    if TRectEntity(Element).IsOverRegion(MinX,MinY,MaxX,MaxY)then
    begin
       Device.Pen.Color := clBlack;
       Device.Pen.Width := 1;
       Device.Pen.Style := psSolid;
       Device.Pen.Mode  := pmCopy;
       Device.Brush.Style := bsClear;
       Rect:= TRectEntity(Element).Rect;
       Device.Rectangle(Rect.Min.X, Rect.Min.Y, Rect.Max.X, Rect.Max.Y);
       if Device.Projection.Scale > 5000000 then exit;
       Device.Font.Name := 'Arial';
       Device.Font.Height := Device.Projection.GetPageLengthVert1(Rect.MaxY - Rect.MinY) div 10;
       Device.TextOut(Rect.Min.X, Rect.Max.Y, Element.Name);
    end;
end;



function TSMO_50_Interpret.IsItsClass(AObject: TObject): boolean;
begin
   result := AObject.ClassType = TSMO_50;
end;

function TSMO_50_Interpret.CanUniGoInside(Element: TElement): boolean;
begin
   result := false;
end;


{ TSMO_10_Interpret }


function  TSMO_10_Interpret.QGoInside(Element: TElement): boolean;
begin
  Result:= true;
end;

function  TSMO_10_Interpret.QProcessBefore(Element: TElement): boolean;
begin
  Result:= (Element.ClassType = TSMO_10);
end;



procedure TSMO_10_Interpret.Process(Element: TElement);
var
  Rect: TRectangle;
  H : longInt;
begin
    if TRectEntity(Element).IsOverRegion(MinX,MinY,MaxX,MaxY)then
    begin
       Device.Pen.Color := clRed;
       Device.Pen.Width := 1;
       Device.Pen.Style := psSolid;
       Device.Pen.Mode  := pmCopy;
       Device.Brush.Style := bsClear;
       Rect:= TRectEntity(Element).Rect;
       Device.Rectangle(Rect.Min.X, Rect.Min.Y, Rect.Max.X, Rect.Max.Y);
       if Device.Projection.Scale > 1000000 then exit;
       Device.Font.Name := 'Arial';
       Device.Font.Height := Device.Projection.GetPageLengthVert1(Rect.MaxY - Rect.MinY) div 10;
       Device.TextOut(Rect.Min.X, Rect.Max.Y, Element.Name);
    end;
end;



function TSMO_10_Interpret.IsItsClass(AObject: TObject): boolean;
begin
   result := AObject.ClassType = TSMO_10;
end;





{ TSMO_5_Interpret }


function  TSMO_5_Interpret.QGoInside(Element: TElement): boolean;
begin
  Result:= false
end;

function  TSMO_5_Interpret.QProcessBefore(Element: TElement): boolean;
begin
  Result:= (Element.ClassType = TSMO_5);
end;



procedure TSMO_5_Interpret.Process(Element: TElement);
var
  Rect: TRectangle;
begin
   Rect:= TRectEntity(Element).Rect;
   Device.Rectangle(Rect.Min.X, Rect.Min.Y, Rect.Max.X, Rect.Max.Y)
end;



function TSMO_5_Interpret.IsItsClass(AObject: TObject): boolean;
begin
   result := AObject.ClassType = TSMO_5;
end;




BEGIN
   RegisterOrbisClass(TSMO_Interpret);
END.
