unit TLRasMan_TLB;

{ This file contains pascal declarations imported from a type library.
  This file will be written during each import or refresh of the type
  library editor.  Changes to this file will be discarded during the
  refresh process. }

{ TLRasMan Library }
{ Version 1.0 }

interface

uses Windows, ActiveX, Classes, Graphics, OleCtrls, StdVCL;

const
  LIBID_TLRasMan: TGUID = '{E9FE7844-F9FF-11D1-91FD-0040332CDCD8}';

const

{ Component class GUIDs }
  Class_RasStore: TGUID = '{E9FE7846-F9FF-11D1-91FD-0040332CDCD8}';

type

{ Forward declarations: Interfaces }
  IRasStore = interface;
  IRasStoreDisp = dispinterface;

{ Forward declarations: CoClasses }
  RasStore = IRasStore;

{ Dispatch interface for RasStore Object }

  IRasStore = interface(IDispatch)
    ['{E9FE7845-F9FF-11D1-91FD-0040332CDCD8}']
    function RasManConnect(aHandle, aRM_ZrusitDekomprimovaneCallback, aRM_SouhlasCallback, aRM_HlaskaCallback, aRM_UmisteniPHCallback, aRM_InitAbortNMCallBack, aRM_ZmenTitleAbortNMCallBack, aRM_DalsiKrokAbortNMCallBack, aRM_BylUserAbortAbortNMCallBack, aRM_DisposeAbortNMCallBack: Integer; aViewTrf: OleVariant): SCODE; safecall;
    procedure RasManDisConnect(aHandle: Integer); safecall;
    procedure DisplayAllRasters(aHandle, DC, MemoryDC, BitMap: Integer; DoBitmapy, Kino: WordBool); safecall;
    function DisConnectRaster(aWindowHandle: Integer; V1: OleVariant): SCODE; safecall;
    function RefreshRaster(aHandle: Integer; V: OleVariant): SCODE; safecall;
    procedure GetWNDRastersRect(aHandle: Integer; var VertMin, HorMin, DVert, DHor: Double); safecall;
    function RasStoreNonEmpty: WordBool; safecall;
    procedure GetRasterLogPalette(var aPal: Integer); safecall;
    function ConnectRaster(aWindowHandle: Integer; V: OleVariant): SCODE; safecall;
    procedure DisplayRastersFromList(List: OleVariant; aHandle, DC, MemoryDC, BitMap: Integer; DoBitmapy, Kino: WordBool); safecall;
    procedure FillAllRasters(aHandle, Buffer: Integer; TrueColorBMP: WordBool); safecall;
    procedure FillRastersFromList(List: OleVariant; aHandle, Buffer: Integer; TrueColorBMP: WordBool); safecall;
  end;

{ DispInterface declaration for Dual Interface IRasStore }

  IRasStoreDisp = dispinterface
    ['{E9FE7845-F9FF-11D1-91FD-0040332CDCD8}']
    function RasManConnect(aHandle, aRM_ZrusitDekomprimovaneCallback, aRM_SouhlasCallback, aRM_HlaskaCallback, aRM_UmisteniPHCallback, aRM_InitAbortNMCallBack, aRM_ZmenTitleAbortNMCallBack, aRM_DalsiKrokAbortNMCallBack, aRM_BylUserAbortAbortNMCallBack, aRM_DisposeAbortNMCallBack: Integer; aViewTrf: OleVariant): SCODE; dispid 1;
    procedure RasManDisConnect(aHandle: Integer); dispid 2;
    procedure DisplayAllRasters(aHandle, DC, MemoryDC, BitMap: Integer; DoBitmapy, Kino: WordBool); dispid 3;
    function DisConnectRaster(aWindowHandle: Integer; V1: OleVariant): SCODE; dispid 4;
    function RefreshRaster(aHandle: Integer; V: OleVariant): SCODE; dispid 5;
    procedure GetWNDRastersRect(aHandle: Integer; var VertMin, HorMin, DVert, DHor: Double); dispid 6;
    function RasStoreNonEmpty: WordBool; dispid 7;
    procedure GetRasterLogPalette(var aPal: Integer); dispid 8;
    function ConnectRaster(aWindowHandle: Integer; V: OleVariant): SCODE; dispid 9;
    procedure DisplayRastersFromList(List: OleVariant; aHandle, DC, MemoryDC, BitMap: Integer; DoBitmapy, Kino: WordBool); dispid 10;
    procedure FillAllRasters(aHandle, Buffer: Integer; TrueColorBMP: WordBool); dispid 11;
    procedure FillRastersFromList(List: OleVariant; aHandle, Buffer: Integer; TrueColorBMP: WordBool); dispid 12;
  end;

{ RasStoreObject }

  CoRasStore = class
    class function Create: IRasStore;
    class function CreateRemote(const MachineName: string): IRasStore;
  end;



implementation

uses ComObj;

class function CoRasStore.Create: IRasStore;
begin
  Result := CreateComObject(Class_RasStore) as IRasStore;
end;

class function CoRasStore.CreateRemote(const MachineName: string): IRasStore;
begin
  Result := CreateRemoteComObject(MachineName, Class_RasStore) as IRasStore;
end;


end.
