unit U_cktm;

interface
uses
   Classes;
const

twOK         = 0;
twNoTimeWall = 1;
twDemo       = 2;
twTimeOut    = 3;
twOther      = 4;
twTimeWall   = 15;

twcTrial     = 1;
twcLicence   = 2;
twcHDControl = 4;


type


TRegRec= packed record
   Key         : integer;
   TimeWall    : TDateTime;
   Licence     : integer;
   Licence1    : integer;
   LastTime    : TDateTime;
   User        : string[30];
   Password    : string[50];
   CompanyID   : string[30];
   Company     : string[50];
   ControlCode : string[50];
   CheckSum    : double;
   ModuleName  : string[30];
   MajorVersion: word;
   MinorVersion: word;
   IsTimeWall  : boolean;
   IsTrial     : boolean;
   IsLicence   : boolean;
   IsHDControl : boolean;
   ByPhone 	   : boolean;
end;

TAppRec = packed record
   AppName      : string[30];
   MajorVersion : word;
   MinorVersion : word;
end;

TRegistrationInfo = record
   Reg: TRegRec;
   Apps: Array of TAppRec;
end;

TAppInstallInfo = class
private
    FInstaled: boolean;
    FDirs: TStringList;
    FModul: string;
    function GetDirs: TStringList;
    procedure SetDirs(const Value: TStringList);
published
   property Instaled: boolean read FInstaled write FInstaled;
   property Modul: string read FModul write FModul;
   property Dirs: TStringList read GetDirs write SetDirs;
end;


function  RBOVersionString(const R: TRegistrationInfo): string;
function  RBOUNameVersionString(const R: TRegistrationInfo): string;
function  AppVersionString(const A: TAppRec): string;
procedure SetAppVersionString(const ver: string; var A: TAppRec);

function  CheckApplicationForUpgrade(RInfo: TRegistrationInfo; AppName: string; var NewVersion,url: string): boolean;
function  CheckModulRegistration(const aName: string): boolean;
function  CheckModulReg_ByFly(const aName: string; reg: boolean; var RInfo: TRegistrationInfo; var RegOK: boolean): boolean;
function  CheckFoldersForSetup(const App: TAppRec;var R: TRegistrationInfo; IsRBO: boolean; AppInfo: TAppInstallInfo; Dialogs: boolean): boolean;
function  CheckControlCode(const R: TRegistrationInfo): boolean;
function  GetControlCode(const R: TRegistrationInfo; details: boolean): string;
procedure SetupFolders(const App: TAppRec;var R: TRegistrationInfo; IsRBO: boolean; AppInfo: TAppInstallInfo);
function  DecodeRBO(Buf: Pointer; BufSize: integer): TRegistrationInfo;
function  EncodeRBO(const R: TRegistrationInfo; var Buf: Pointer;var BufSize: integer): boolean;
function  FindRBOinFolders(const R: TRegistrationInfo; var RR: TRegistrationInfo): boolean;
function  LoadRBOFromFolders(aValue: string): TRegistrationInfo;
procedure StoreRBOToFolders(var R: TRegistrationInfo);
function  LoadRBOFromFile(aFileName: string): TRegistrationInfo;
procedure SaveRBOToFile(var R: TRegistrationInfo; aFileName: string);

function  CheckModulesInFolders(var R: TRegistrationInfo): boolean;
procedure JoinModules(var R,R1: TRegistrationInfo);

function  CodeHDC(HDC: longInt;const R: TRegistrationInfo): double;
function  DeCodeHDC(cHDC: double;const R: TRegistrationInfo): longInt;
function  GetProtectionLevel(const R: TRegistrationInfo): integer;
var
   IsDemo: boolean;
   IsTimeWall: boolean;
   TimeWall: TDateTime;
   SubjectName: string;
   Subject_ID: string;
   ModuleName: string;
   User_Name: string;
   PasHash: string;

   Licence: double;

implementation
uses
   ExtActns,
   HTTPApp,
   cHash,
   shFolder,
   Dialogs,
   Forms,
   Controls,
   WinProcs,
   {!T_Main,}
   SysUtils,
   FileVersion,
   f_CkTm,
   f_CkTmRg,
   f_YesNo,
   u_Crypt,
   u_HDTest,
   u_String;

const
  c1899 = 693594;
  rgTopolPro = 'Topol Pro';
  rgRBO      = 'SCP info';
  rgAPP      =  rgTopolPro + '\APP';
  rgModul    =  rgTopolPro + '\RBO';

    CSIDL_COMMON_STARTMENU = $0016;
    CSIDL_COMMON_PROGRAMS = $0017;
    CSIDL_COMMON_STARTUP = $0018;
    CSIDL_COMMON_DESKTOPDIRECTORY = $0019;
    CSIDL_APPDATA = $001A;
    CSIDL_LOCAL_APPDATA = $001C;
    CSIDL_COMMON_FAVORITES = $001F;
    CSIDL_COMMON_APPDATA = $0023;
    CSIDL_COMMON_TEMPLATES = $002D;
    CSIDL_COMMON_DOCUMENTS = $002E;

function DownloadURLFile(const Xml, XmlLocal: string): boolean;
var
   D: TDownLoadURL;
begin
   Result := True;
   D := TDownLoadURL.Create(nil);
   try
     D.URL := Xml;
     D.Filename := XmlLocal;
     try
       D.ExecuteTarget(nil);
     except
       Result := False;
     end;
   finally
     D.Free;
   end;
end;
function  GetXMLtext(const XMLStr: string; aTag: string): string;
var
   p1,p2,p3: integer;
   S1,S2: string;
begin
   result := '';
   S1 := '<'+aTag+'>';
   p1 := pos(S1,XMLStr);
   if p1 < 1 then exit; // neexistuje
   S2 := '</'+aTag+'>';
   p2 := pos(S2,XMLStr);
   p3 := p1 + length(S1);
   result := copy(XMLStr, p3, p2 - p3);
end;


function CheckControlCode(const R: TRegistrationInfo): boolean;
var
   user,modul,HDID,SubjektID: string;
   HS: string;
begin
   result := false;
   user := R.Reg.User;
   modul := R.Reg.ModuleName + ' ' + RBOVersionString(R);
   HDID := IntToStr(GetSystemHDSerialNumer);
   SubjektID := R.Reg.CompanyID;
   HS := SHA1DigestToHex(CalcSHA1(user+';'+modul+';'+HDID+';'+SubjektID));
   HS := Copy(HS,1,5)+'-'+Copy(HS,20,5)+'-'+Copy(HS,Length(HS)-4,5);
   result := HS = R.Reg.ControlCode;
end;

function GetControlCode(const R: TRegistrationInfo; details: boolean): string;
var
   user,modul,HDID,SubjektID: string;
   HS: string;
begin
   result := '?';
   user := R.Reg.User;
   modul := R.Reg.ModuleName + ' ' + RBOVersionString(R);
   HDID := IntToStr(GetSystemHDSerialNumer);
   SubjektID := R.Reg.CompanyID;
   HS := SHA1DigestToHex(CalcSHA1(user+';'+modul+';'+HDID+';'+SubjektID));
   HS := Copy(HS,1,5)+'-'+Copy(HS,20,5)+'-'+Copy(HS,Length(HS)-4,5);
   result := HS;
   if Details then
   begin
       result := result + ' ' +user+';'+modul+';'+HDID+';'+SubjektID;
   end;
end;

function ReadSimpleText(const aFilename: string): String;
var
  List: TStringList;
begin
   result := '';
   if (FileExists(aFilename)) then
   begin
      List := TStringList.Create;
      List.Loadfromfile(aFilename);
      Result := List.text;
      List.Free;
   end;
end;

function SaveSimpleText(const aStr: string; const aFilename: string): boolean;
var
  List: TStringList;
begin
   List := TStringList.Create;
   List.Text := aStr;
   List.SaveToFile(aFilename);
   List.Free;
end;

function GetSpecialFolderPath(folder : integer) : string;
const
  SHGFP_TYPE_CURRENT = 0;
var
  path: array [0..MAX_PATH] of char;
begin
  if SUCCEEDED(SHGetFolderPath(0,folder,0,SHGFP_TYPE_CURRENT,@path[0])) then
    Result := path
  else
    Result := '';
end;

function AppDataFolder: string;
begin
   result := includeTrailingPathdelimiter(GetSpecialFolderpath(CSIDL_COMMON_APPDATA));
end;

function  CheckApplicationForUpgrade(RInfo: TRegistrationInfo; AppName: string; var NewVersion,url: string): boolean;
var
   FV: TFileVersion;
   N: string;
   xurl: string;
   xmlFile: string;
   modul: string;
   v1,v2,v3,v4: string;
   XML,xmS: string;
begin
   result := false;
   N := ExtractFileName(AppName);
   FV := TFileVersion.Create;
   FV.FileName := AppName;
   v1 := IntToStr(FV.MajorVersion);
   v2 := IntToStr(FV.MinorVersion);
   v3 := IntToStr(FV.Release);
   v4 := IntToStr(FV.Build);
   FV.Free;
   modul := RInfo.Reg.ModuleName+' '+RBOVersionString(RInfo);
   xurl := 'https://www.tpro.cz/versiontest.php?app='+N+'&v1='+v1+'&v2='+v2+'&v3='+v3+'&v4='+v4+'&modul='+modul+'&time='+FloatToStr(now);
   //ShowMessage(xurl);
   xmlFile := IncludeTrailingPathDelimiter(AppDataFolder + rgRBO)+'version.xml';
   if DownloadURLFile(xurl,xmlFile) then
   begin
      XML := ReadSimpleText(xmlFile);
      DeleteFile(xmlFile);
      XML := HTMLDecode(XML);
      // user and password
      xmS := GetXMLtext(XML,'valid');
      if xmS = '1' then
      begin
         xmS := GetXMLtext(XML,'new');
         if xmS = '1' then
         begin
            result := true;
            NewVersion := GetXMLtext(XML,'newversion');
            url        := GetXMLtext(XML,'url');
         end
      end;
   end;
end;

function RBOFileName(Appvername: string; aFull: boolean): string;
var
   RBOFolder: string;
begin
   RBOFolder := AppDataFolder + rgRBO;
   result := UpperCase(AppverName);
   result := SHA1DigestToHex(CalcSHA1(result));
   if aFull then
      result := IncludeTrailingPathDelimiter(RBOFolder) + result;
end;

function  RBOVersionString(const R: TRegistrationInfo): string;
begin
   Result := IntToStr(R.Reg.MajorVersion)+'.'+IntToStr(R.Reg.MinorVersion);
end;

function  RBOUNameVersionString(const R: TRegistrationInfo): string;
begin
   Result := Uppercase(R.Reg.ModuleName)+ ' ' + RBOVersionString(R);
end;

function RBOKey(const R: TRegistrationInfo): string;
begin
   result := RBOFIleName(RBOUNameVersionString(R),false);
end;

function  AppVersionString(const A: TAppRec): string;
begin
   Result := IntToStr(A.MajorVersion)+'.'+IntToStr(A.MinorVersion);
end;


procedure SetAppVersionString(const ver: string; var A: TAppRec);
var
   S1,S2: string;
begin
   if not StringAsTwoParams(ver, '.', S1,S2) then S2 := '0';
   A.MajorVersion := StrToInt(S1);
   A.MinorVersion := StrToInt(S2);
end;

function  DecodeRBO(Buf: Pointer; BufSize: integer): TRegistrationInfo;
var
   PB: PByteArray;
   i,j: integer;
   ix: integer;
   AppsCount: integer;
begin
   // decode buffer
   UnCrypt(Buf, BufSize);
   PB := Buf;
   i := SizeOf(TRegRec);
   ix := SizeOf(TAppRec);
   AppsCount := (BufSize - i) div ix;
   SetLength(result.Apps,AppsCount);
   if ((BufSize - i) mod ix) > 0 then ShowMessage('Blbost');
   Move(PB^[0], result.Reg, SizeOf(TRegRec));
   for j := 0 to AppsCount - 1 do
   begin
      move(PB^[i],result.Apps[j],SizeOf(TAppRec));
      inc(i,ix);
   end;
   FreeMem(Buf,BufSize);
end;

function  EncodeRBO(const R: TRegistrationInfo; var Buf: Pointer;var BufSize: integer): boolean;
var
   PB: PByteArray;
   i,Ix,j: integer;
begin
   result := true;
   BufSize := SizeOf(TRegRec) + (High(R.Apps)+1)*SizeOf(TAppRec);
   GetMem(Buf,BufSize);
   PB := Buf;
   i := SizeOf(TRegRec);
   ix := SizeOf(TAppRec);
   Move(R.Reg,PB^[0],i);
   for j := 0 to High(R.Apps) do
   begin
      Move(R.Apps[j],PB^[i],ix);
      inc(i,ix);
   end;
   Crypt(Buf, BufSize);
   // code buffer
end;

function  FindRBOinFolders(const R: TRegistrationInfo; var RR: TRegistrationInfo): boolean;
var
   RBOFolder: string;
   FileName: string;
begin
   result := false;
   FileName := RBOFileName(RBOUNameVersionString(R),true); // AppDATA\SCP Info\sha1 MODUL 1.1
   if FileExists(FileName) then
   begin
      RR := LoadRBOFromFile(FileName);
      if (R.Reg.ModuleName = RR.Reg.ModuleName) and
         (R.Reg.MajorVersion = RR.Reg.MajorVersion) then
      begin
         Result := true;
      end;
   end;
end;

function  LoadRBOFromFolders(aValue: string): TRegistrationInfo;
var
   FileName: string;
begin
   FileName := RBOFileName(aValue,true); // AppDATA\SCP Info\sha1 MODUL 1.1
   if not FileExists(FileName) then
   begin
      ShowMessage('Chybn registrace programu');
      exit;
   end;
   result := LoadRBOFromFile(FileName);
end;

procedure StoreRBOToFolders(var R: TRegistrationInfo);
var
   Buf: Pointer;
   BufSize: integer;
   i: integer;
   aValue: integer;
   AppDataDir: string;
   ModulFileName: string;
   aDir: string;
begin
   try
   aDir := AppDataFolder + rgRBO;
   if not DirectoryExists(aDir) then
      ForceDirectories(aDir);
   SaveRBOToFile(R,RBOFileName(RBOUNameVersionString(R),true));
   except
      ShowMessage('RBO!!!');
   end;
   AppDataDir := AppDataFolder;
   for i := 0 to High(R.Apps) do
   begin
      aDir := AppDataDir + rgModul+'\'+R.Apps[i].AppName+'\'+AppVersionString(R.Apps[i]);
      try
      if not DirectoryExists(aDir) then
         ForceDirectories(aDir);
      ModulFileName := aDir +'\Modul.orm';
      SaveSimpleText(CryptString(RBOKey(R)),ModulFileName);
      except
         ShowMessage('App: '+R.Apps[i].AppName+' i:'+IntToStr(i));
      end;
   end;

   // uloen apps nebo kontrola keys !!!!!!!!!!!!!!!!!!!
end;

function  LoadRBOFromFile(aFileName: string): TRegistrationInfo;
var
   Buf: Pointer;
   BufSize: integer;
   H: integer;
   i: integer;
begin
   H := FileOpen(aFileName,fmOpenRead);
   BufSize := GetFileSize(H,@i);
   GetMem(Buf,BufSize);
   FileRead(H,Buf^,BufSize);
   result := DecodeRBO(Buf,BufSize);
   FIleClose(H);
end;

procedure SaveRBOToFile(var R: TRegistrationInfo; aFileName: string);
var
   Buf: Pointer;
   BufSize: integer;
   H: integer;
begin
   EncodeRBO(R,Buf,BufSize);
   H := FileCreate(aFileName);
   FileWrite(H,Buf^,BufSize);
   FileClose(H);
   FreeMem(Buf,BufSize);
end;

function  CheckModulesInFolders(var R: TRegistrationInfo): boolean;
var
   i: integer;
   RBO: integer;
   RBOreg: string;
   S: string;
   AppDataDir: string;
   ModulFileName: string;
begin
   result := true;
   RBO := R.Reg.Key;
   AppDataDir := AppDataFolder;
   for i := 0 to High(R.Apps) do
   begin
      S := AppDataDir + '\' + rgModul+'\'+R.Apps[i].AppName+'\'+AppVersionString(R.Apps[i]);
      if DirectoryExists(S) then
      begin
         if RBO = 0 then
         begin
            // kontrola verze
            if not YesNoDialog('Program '+R.Apps[i].AppName+' je na tomto potai ji nainstalovn, pokraovat?') then
            begin
               result := false;
               break;
            end;
         end
         else
         begin
            ModulFileName := S+'\Modul.orm';
            RBOreg := UnCryptString(ReadSimpleText(ModulFileName));
            if RBOKey(R) <> RBOreg then
            if not YesNoDialog('Program '+R.Apps[i].AppName+' je  ji nainstalovn pod jinm modulem, pokraovat?') then
            begin
               result := false;
               break;
            end;
         end;
      end;
   end;
end;

procedure JoinModules(var R,R1: TRegistrationInfo);
var
   i,j: integer;
   Maxi,Maxj: integer;
   RSize: integer;
   Found: boolean;
begin
   Maxi := High(R1.Apps);
   Maxj := High(R.Apps);
   RSize := Maxj + 1;
   for i := 0 to Maxi do
   begin
      Found := false;
      for j := 0 to Maxj do
      begin
         if CompareText(R1.Apps[i].AppName,R.Apps[j].AppName) = 0 then
         begin
            if (R1.Apps[i].MajorVersion = R.Apps[j].MajorVersion) and
               (R1.Apps[i].MinorVersion = R.Apps[j].MinorVersion) then
            begin
               Found := true;
               break;
            end;
         end;
      end;
      if Found then continue;
      inc(RSize);
      SetLength(R.Apps,RSize);
      R.Apps[RSize-1] := R1.Apps[i];
   end;
end;



procedure DecodeDate16(aDate: TDateTime; var aY, aM, aD: word);
begin
(*
{$IFDEF Win32}
  aDate:= aDate - c1899;
{$ENDIF}
*)
  DecodeDate(aDate, aY, aM, aD);
end;

function EncodeDate16(aY, aM, aD: word): TDateTime;
begin
  result:= EncodeDate(aY, aM, aD);
(*
{$IFDEF Win32}
  result:= result + c1899;
{$ENDIF}
*)
end;




function  GetProtectionLevel(const R: TRegistrationInfo): integer;
begin
   {
    trial ............. 1
    licence ........... 2
    HD ................ 4
    licence + trial ... 3
    HD + trial ........ 5
   }
   result := 0;
   if R.Reg.IsTrial then result := result or twcTrial;
   if R.Reg.IsLicence then result := result or twcLicence;
   if R.Reg.IsHDControl then result := result or twcHDControl;
end;

function  GetRandomDate: TDateTime;
begin
   Randomize;
   result := EncodeDate16(1990 + Random(6),1 + Random(11),1+random(27))+EncodeTime(random(23),random(58),random(58),0);
end;


function  CheckFoldersForSetup(const App: TAppRec;var R: TRegistrationInfo; IsRBO: boolean; AppInfo: TAppInstallInfo; Dialogs: boolean): boolean;
var
   RII: TRegistrationInfo;
   L1, L2: integer;
   isTW: boolean;
   AppKey: string;
   S: string;
   i: integer;
   ModulFileName: string;
begin
   // Kontrola aplikace
   result := true;
   AppInfo.Instaled := false;
   AppKey := AppDataFolder + rgApp + '\'+App.AppName+'\'+AppVersionString(App);
   if DirectoryExists(AppKey) then
   begin
      ModulFileName := AppKey+'\Modul.orm';
      AppInfo.Instaled := true;
      AppInfo.Modul := '-1';
      if FileExists(ModulFIleName) then
         AppInfo.Modul := UnCryptString(ReadSimpleText(ModulFileName));
      {
      Reg.OpenKey(AppKey+'\DIRS',true);
      Reg.GetValueNames(AppInfo.Dirs);
      for i := 0 to AppInfo.Dirs.Count - 1 do
      begin
         S := AppInfo.Dirs.Strings[i];
         S := S + '=' + Reg.ReadString(S);
         AppInfo.Dirs.Strings[i] := S;
      end;
      }
   end;
   if not IsRBO then exit;

   R.Reg.Key := 0;
   S := 'Aplikace '+App.AppName+' je na tomto potai ji nainstalovna pod jinm modulem, pokraovat?';
   if not FindRBOinFolders(R,RII) then
   begin
      if Dialogs then
      if AppInfo.Instaled then
      begin
         if not YesNoDialog(S) then
         begin
            result := false;
            exit;
         end;
      end;
      if not CheckModulesInFolders(R) then result := false;
      //else StoreRBOToRegistry(RI);
      exit;
   end
   else
   begin
      if Dialogs then
      if AppInfo.Modul <> RBOKey(RII) then
      begin
         if not YesNoDialog(S) then
         begin
            result := false;
            exit;
         end;
      end;
      R.Reg.Key := 1;
      L1 :=  GetProtectionLevel(RII);
      L2 :=  GetProtectionLevel(R);
      isTW := false;
      { Pure trial }
      if (L1{ and 1} = 1) and (L2{ and 1} = 1) then
      begin
         isTW := true;
         if R.Reg.TimeWall = 0 then
         begin
            ShowMessage('Tato trialov verze ji byla na potai instalovna !');
            result := false;
            exit;
         end;
      end;
      // instalovn vy verze
      if ((L2 and 6) > (L1 and 6)) then
      begin
         R.Reg.Licence1 := 0;
         R.Reg.ControlCode:= '';
         //R.CheckSum := CKSM;
         if not CheckModulesInFolders(R) then result := false
         else
         begin
            JoinModules(R,RII);
            //StoreRBOToRegistry(RI);
         end;
         exit;
      end
      else
      { peinstalovn t sam verze }
      if ((L2 and 6) = (L1 and 6)) or IsTW then
      begin
         // tady neco bylo ale vyhodil sem to cosi s tw
         //CFR.CheckSum := CKSM;
         if not CheckModulesInFolders(R) then result := false
         else
         begin
            JoinModules(RII,R);
            //StoreRBOToRegistry(RII);
            R := RII;
         end;
         exit;
      end
      else
      begin
         ShowMessage('Na potai ji byla instalovna chrnn verze, kontaktujte vrobce programu !');
         result := false;
         exit;
      end;
   end;
end;

procedure SetupFolders(const App: TAppRec;var R: TRegistrationInfo; IsRBO: boolean; AppInfo: TAppInstallInfo);
var
   AppKey: string;
   S: string;
   i: integer;
   ModulFileName: string;
begin

   if IsRBO then StoreRBOToFolders(R);

   // Kontrola aplikace
   AppKey := AppDataFolder + rgApp + '\'+App.AppName+'\'+AppVersionString(App);
   ForceDirectories(AppKey);
   ModulFileName := AppKey+'\Modul.orm';
   if IsRBO then SaveSimpleText(CryptString(RBOKey(R)),ModulFileName);
   //Reg.DeleteKey(AppKey+'\DIRS');
   ForceDirectories(AppKey+'\DIRS');
   {
   for i := 0 to AppInfo.Dirs.Count - 1 do
   begin
      S := AppInfo.Dirs.Names[i];
      Reg.WriteString(S,AppInfo.Dirs.Values[S]);
   end;
   }
end;


function CheckSumOfString(var S: string): double;
var
   i: longInt;
begin
   S := UpperCase(S);
   result := 0;
   for i := 1 to length(S) do
   begin
      if S[i] <> ' ' then result := result + Ord(S[i]);
   end;
end;

function CodeHDC(HDC: longInt;const R: TRegistrationInfo): double;
var
   D: double;
   S: string;
begin
   S := R.Reg.ModuleName;
   D := CheckSumOfString(S)+ R.Reg.MajorVersion+ R.Reg.MinorVersion;
   result := ((D + 3.14) * HDC) + 729.15 + D;
end;

function DeCodeHDC(cHDC: double;const R: TRegistrationInfo): longInt;
var
   D: double;
   S: string;
begin
   S := R.Reg.ModuleName;
   D := CheckSumOfString(S)+ R.Reg.MajorVersion+ R.Reg.MinorVersion;
   result := round((cHDC - 729.15 - D)/(3.14 + D));
end;


function CheckModulReg_ByFly(const aName: string; reg: boolean; var RInfo: TRegistrationInfo; var RegOK: boolean): boolean;
var
   App: TAppRec;
   FVer: TFileVersion;
   RBO: integer;
   RBOString: string;
   RBOFileName: string;
   N,S: string;
   NowTime: TDateTime;
   LicenceOK, HDCOK: boolean;
   HighLevelControl: boolean;
   Y,M,D: word;
   MustBeStored: boolean;
   ModulFileName: string;

   function TryToReg: boolean;
   var
      usr: string;
      pswd: string;
      hdid: string;
      modul: string;
      url: string;
      xmlFile: string;
      XML: string;
      xmS: string;
      firma: string;
      newrecord: boolean;
      code,platnost: string;
      tw: TDateTime;
   begin
      result := false;
      RegOK := false;
      MustBeStored := false;
      if LicenceOK then
      begin
         //F.lb_Licence.Visible := false;
         //F.ed_Licence.Visible := false;
      end;
      usr := RInfo.Reg.User;
      pswd := RInfo.Reg.Password;
      pswd := SHA1DigestToHex(CalcSHA1(pswd));
      modul := RBOUNameVersionString(RInfo);
      hdid := IntToStr(GetSystemHDSerialNumer);
      url := 'https://www.tpro.cz/reg.php?usr='+usr+'&pswd='+pswd+'&modul='+modul+'&hdid='+hdid+'&time='+FloatToStr(now);
      xmlFile := IncludeTrailingPathDelimiter(AppDataFolder + rgRBO)+'test.xml';
      if DownloadURLFile(url,xmlFile) then
      begin
         result := true;
         XML := ReadSimpleText(xmlFile);
         XML := HTMLDecode(XML);
         // user and password
         xmS := GetXMLtext(XML,'dbok');
         if xmS <> '1' then
         begin
            result := false;
            MustBeStored := false;
            exit;
         end;
         xmS := GetXMLtext(XML,'subjektid');
         xmS := GetXMLtext(XML,'valid');
         if xmS <> '1' then
         begin
            RInfo.Reg.ControlCode := '';
            MustBeStored := true;
            exit;
         end;
         xmS := GetXMLtext(XML,'subjektid');
         if RInfo.Reg.CompanyID <> xmS then
         begin
            RInfo.Reg.CompanyID := xmS;
            MustBeStored := true;
            xmS := GetXMLtext(XML,'subjekt');
            Firma := xmS;
            RInfo.Reg.Company := Firma;
         end;
         // kontrakt
         xmS := GetXMLtext(XML,'kontrakt');
         if xmS <> '1' then
         begin
            RInfo.Reg.ControlCode := '';
            MustBeStored := true;
            exit;
         end;
         // zaznam
         xmS := GetXMLtext(XML,'record');
         if xmS <> '1' then
         begin
            RInfo.Reg.ControlCode := '';
            MustBeStored := true;
            exit;
         end;
         xmS := GetXMLtext(XML,'newrecord');
         newrecord := xmS = '1';
         xmS := GetXMLtext(XML,'confirm');
         if xmS = '1' then
         begin
            RegOK := true;
            code := GetXMLtext(XML,'code');
            RInfo.Reg.ControlCode := code;
            platnost := GetXMLtext(XML,'platnost');
            if platnost = '0' then
            begin
               if Rinfo.Reg.IsTimeWall then
                  MustBeStored := true;
               Rinfo.Reg.IsTimeWall := false;
            end
            else
            begin
               if not Rinfo.Reg.IsTimeWall then
                  MustBeStored := true;
               Rinfo.Reg.IsTimeWall := true;
               tw := StrToDateTimeDef(platnost, IncMonth(now));
               if RInfo.Reg.TimeWall <> tw then
                  MustBeStored := true;
               RInfo.Reg.TimeWall := tw;
            end;
            MustBeStored := true;
            RInfo.Reg.ByPhone := false;
            result := true;
            HDCOK := true;
         end
         else
         begin
            RInfo.Reg.ControlCode := '';
            MustBeStored := true;
         end;
      end;
   end;


begin
   RegOK := false;
   result := true;
   IsDemo := false;
   MustBeStored := false;
   TimeWall := 0;
   N := ExtractFileName(aName);
   FVer := TFileVersion.Create;
   FVer.FileName := aName;
   App.AppName := N;
   App.MajorVersion := FVer.MajorVersion;
   App.MinorVersion := FVer.MinorVersion;
   FVer.Free;
   S := AppDataFolder + rgModul+'\'+N+'\'+AppVersionString(App);
   if not DirectoryExists(S) then
   begin
      result := false;
      exit;
   end;
   ModulFileName := S+'\Modul.orm';
   if not FileExists(ModulFileName)then
   begin
      result := false;
      exit;
   end;
   RBOString := UnCryptString(ReadSimpleText(ModulFileName));
   RBOFileName := AppDataFolder + rgRBO + '\'+ RBOString;
   if not FileExists(RBOFileName) then
   begin
      result := false;
      exit;
   end;
   RInfo := LoadRBOFromFile(RBOFileName);
   // kontrola ptomnosti applikace v RBO !!!!!!!!!

   LicenceOK := true;
   HDCOK := true;
   HighLevelControl := RInfo.Reg.IsHDControl or RInfo.Reg.IsLicence;
   if HighLevelControl then
   begin
      if RInfo.Reg.IsLicence then
      begin
         LicenceOK :=  RInfo.Reg.Licence = RInfo.Reg.Licence1;
      end
      else LicenceOK := true;
      if RInfo.Reg.IsHDControl then
      begin
         HDCOK := CheckControlCode(RInfo);
      end
      else HDCOK := true;
   end;
   RegOK := HDCOK;

   if not reg then exit;
   if RInfo.Reg.Password = '' then exit;
   if  HighLevelControl then
   begin
      if TryToReg then
      begin
         if MustBeStored then
            StoreRBOtoFolders(RInfo);
        DeleteFile(IncludeTrailingPathDelimiter(AppDataFolder + rgRBO)+'test.xml');
      end
      else
         result := false;
   end;
   SubjectName := RInfo.Reg.Company;
   Subject_ID  := RInfo.Reg.CompanyID;
   User_Name    := RInfo.Reg.User;
   PasHash     := SHA1DigestToHex(CalcSHA1(RInfo.Reg.Password));

   ModuleName := RBOUNameVersionString(RInfo);
end;

function CheckModulRegistration(const aName: string): boolean;
var
   App: TAppRec;
   FVer: TFileVersion;
   RBO: integer;
   RBOString: string;
   RBOFileName: string;
   N,S: string;
   RInfo: TRegistrationInfo;
   NowTime: TDateTime;
   LicenceOK, HDCOK: boolean;
   HighLevelControl: boolean;
   Y,M,D: word;
   MustBeStored: boolean;
   ModulFileName: string;

   procedure ShowInstallError;
   begin
      ShowMessage(ExtractFileName(aName)+': Chybn nebo pokozen instalace programu !');
   end;


   function TryToRegister: boolean;
   var
      EndOfLoop: boolean;
      usr: string;
      pswd: string;
      hdid: string;
      modul: string;
      url: string;
      xmlFile: string;
      XML: string;
      xmS: string;
      firma: string;
      FirstTime: boolean;
      newrecord: boolean;
      code,platnost: string;
      F: TRegistrationForm;
   begin
      result := false;
      EndOfLoop := false;
      F := TRegistrationForm.Create(Application);
      //Application.CreateForm(TRegistrationForm, F);
      FirstTime := true;
      repeat
         F.l_Alert.Visible := RInfo.Reg.ByPhone;
         if LicenceOK then
         begin
            //F.lb_Licence.Visible := false;
            //F.ed_Licence.Visible := false;
         end;
         //if HDCOK then F.g_HDControl.Visible := false;
         if FirstTime then
         begin
            F.lb_Modul.Caption := RInfo.Reg.ModuleName;
            F.lb_Version.Caption := RBOVersionString(RInfo);
            //if RInfo.Reg.Licence1 = 0 then F.ed_Licence.Text := ''
            //                       else F.ed_Licence.Text := floatToStr(RInfo.Reg.Licence);
            F.ed_User.Text := RInfo.Reg.User;
            F.ed_Password.Text := RInfo.Reg.Password;
            F.ed_Company.Text := RInfo.Reg.CompanyID;
            F.ed_HD.Text := IntToStr(GetSystemHDSerialNumer);
            F.ed_HD.Enabled := false;
            FirstTime := false;
         end;
         F.ShowModal;
         if F.ModalResult = mrOK then
         begin
            if not HDCOK then
            begin
               if F.Pages.ActivePage = F.web then
               begin
                  usr := F.ed_User.Text;
                  pswd := F.ed_Password.Text;
                  RInfo.Reg.User := usr;
                  RInfo.Reg.Password := pswd;
                  MustBeStored := true; // ulozeni hesla a usera
                  pswd := SHA1DigestToHex(CalcSHA1(pswd));
                  modul := RBOUNameVersionString(RInfo);
                  hdid := F.ed_hd.Text;//'2654';//IntToStr(GetSystemHDSerialNumer);
                  url := 'https://www.tpro.cz/reg.php?usr='+usr+'&pswd='+pswd+'&modul='+modul+'&hdid='+hdid+'&time='+FloatToStr(now);
                  F.Visible := true;
                  F.benable(false);
                  F.Memo.Clear;
                  //memo.Lines.Add(url);
                  F.Memo.Lines.Add('- Navazuji spojen se servrem.........');
                  xmlFile := IncludeTrailingPathDelimiter(AppDataFolder + rgRBO)+'test.xml';
//                  ShowMessage(xmlFile);
                  if DownloadURLFile(url,xmlFile) then
                  begin
                     XML := ReadSimpleText(xmlFile);
                     XML := HTMLDecode(XML);
                     // user and password
                     xmS := GetXMLtext(XML,'valid');
                     if xmS <> '1' then
                     begin
                        F.Memo.Lines.Add('! Chybn jmno nebo heslo!');
                        ShowMessage('Chybn uivatelsk jmno nebo heslo!');
                        F.EnableAndClose;
                        continue;
                     end;
                     xmS := GetXMLtext(XML,'user');
                     RInfo.Reg.User := xmS;
                     F.Memo.Lines.Add('- Uivatel OK ...'+xmS);
                     xmS := GetXMLtext(XML,'subjektid');
                     F.Memo.Lines.Add('- Subjekt: '+xmS);
                     F.ed_Company.Text := xmS;
                     RInfo.Reg.CompanyID := xmS;
                     xmS := GetXMLtext(XML,'subjekt');
                     F.Memo.Lines.Add('  '+xmS);
                     Firma := xmS;
                     RInfo.Reg.Company := Firma;
                     // kontrakt
                     xmS := GetXMLtext(XML,'kontrakt');
                     if xmS <> '1' then
                     begin
                        F.Memo.Lines.Add('! Subjekt nem licenci pro tento produkt!');
                        ShowMessage(Firma+' nem licenci pro registraci tohoto produktu!');
                        F.EnableAndClose;
                        continue;
                     end;
                     // zaznam
                     xmS := GetXMLtext(XML,'record');
                     if xmS <> '1' then
                     begin
                        F.Memo.Lines.Add('! chyba reg.zznamu!');
                        ShowMessage(Firma+' Chyba registranho zznamu, kontaktujte svho administrtora!');
                        F.EnableAndClose;
                        continue;
                     end;
                     xmS := GetXMLtext(XML,'newrecord');
                     newrecord := xmS = '1';
                     if newrecord then
                        F.Memo.Lines.Add('- dost o registraci byla vytvoena a ek')
                     else
                        F.Memo.Lines.Add('- dost o registraci ji existuje');
                     xmS := GetXMLtext(XML,'confirm');
                     if xmS = '1' then
                     begin
                        code := GetXMLtext(XML,'code');
                        RInfo.Reg.ControlCode := code;
                        platnost := GetXMLtext(XML,'platnost');
                        F.Memo.Lines.Add('- Registrace OK');
                        if platnost = '0' then
                        begin
                           Rinfo.Reg.IsTimeWall := false;
                           F.Memo.Lines.Add('- Neomezen platnost');
                           ShowMessage('Registrace probhla spn ... platnost neomezena');
                        end
                        else
                        begin
                           Rinfo.Reg.IsTimeWall := true;
                           F.Memo.Lines.Add('- Platnost do: '+platnost);
                           RInfo.Reg.TimeWall := StrToDateTimeDef(platnost, IncMonth(now));
                           ShowMessage('Registrace probhla spn ... platnost do '+platnost);
                        end;
                        MustBeStored := true;
                        RInfo.Reg.ByPhone := false;
                        result := true;
                        HDCOK := true;
                     end
                     else
                     begin
                        F.Memo.Lines.Add('- ek na zpracovn');
                        if newrecord then
                           ShowMessage('dost o registraci byla vytvoena, pro urychlen kontaktujte svho administrtora!')
                        else
                           ShowMessage('dost o registraci ek na vyzen, pro urychlen kontaktujte svho administrtora!');
                     end;
                     F.EnableAndClose;
                     EndOfLoop := true;
                  end
                  else
                  begin
                     F.Memo.Lines.Add('chyba!!!!!');
                     ShowMessage('Server Tpro je nedostupn, zkuste telefonickou registraci!');
                     F.EnableAndClose;
                  end;
               end
               else
               // registrace po telefonu
               begin
                  if RInfo.Reg.ByPhone then
                  begin
                     ShowMessage('Kupte si lep brle, nen mon provdt dv telefonn registrace za sebou!');
                     continue;
                  end;
                  usr := F.ed_User.Text;
                  RInfo.Reg.User := usr;
                  RInfo.Reg.CompanyID := F.ed_Company.Text;
                  RInfo.Reg.User := usr;
                  RInfo.Reg.ControlCode := F.ed_Code.Text;
                  HDCOK := CheckControlCode(RInfo);
                  if HDCOK then
                  begin
                     Rinfo.Reg.IsTimeWall := true;
                     RInfo.Reg.TimeWall := IncMonth(Now);
                     Rinfo.Reg.ByPhone := true;
                     MustBeStored := true;
                     EndOfLoop := true;
                     ShowMessage('Registrace probhla spn, platnost do '+DateTimeToStr(RInfo.Reg.TimeWall));
                     result := true;
                  end
                  else
                  begin
                     ShowMessage('Neplatn ovovac kd!');
                  end;
               end;
               //MustBeStored := true;
               //RInfo.Reg.HDControl := UnCryptDouble(F.ed_HDC.Text);
               //HDCOK := DecodeHDC(RInfo.Reg.HDControl,RInfo) =  GetSystemHDSerialNumer;
               //if not HDCOK then ShowMessage('Nesprvn ovovac kd ... kontaktujte vrobce programu !');
            end;
            if not LicenceOK then RInfo.Reg.Licence1 := 0;
            //if not HDCOK then RInfo.Reg.HDControl := 0;
         end
         else
            EndOfLoop := true;
      until EndOfLoop;
      F.Free;
   end;

   function RegisterOK: boolean;
   var
     RD: TRegisterDialog;
     res: integer;
     HDN: double;
     HDOK: boolean;
   begin
      result := false;
      HDOK := false;
      HDN := 0;
      Application.CreateForm(TRegisterDialog,RD);
      RD.Label1.Caption := 'Trialov verze aplikace '+ ExtractFileName(aName);
      RD.Label2.Caption := 'asov omezen do '+DateTimeToStr(RInfo.Reg.TimeWall
      (*
      {$IFDEF Win32}
      - c1899
      {$ENDIF}
      *)
      );
      RD.ShowModal;
      res := RD.ModalResult;
      RD.Free;
      if not (res = mrOK) then exit;
      TryToRegister;
      DeleteFile(IncludeTrailingPathDelimiter(AppDataFolder + rgRBO)+'test.xml');
      if HDOK then
      begin
         RInfo.Reg.IsTrial := false;
         RInfo.Reg.IsHDControl := true;
         //RInfo.Reg.HDControl := HDN;
         StoreRBOToFolders(RInfo);
         result := true;
      end;

   end;


begin
   result := true;
   IsDemo := false;
   MustBeStored := false;
   TimeWall := 0;
   N := ExtractFileName(aName);
   FVer := TFileVersion.Create;
   FVer.FileName := aName;
   App.AppName := N;
   App.MajorVersion := FVer.MajorVersion;
   App.MinorVersion := FVer.MinorVersion;
   FVer.Free;
   S := AppDataFolder + rgModul+'\'+N+'\'+AppVersionString(App);
   if not DirectoryExists(S) then
   begin
      ShowInstallError;
      result := false;
      exit;
   end;
   ModulFileName := S+'\Modul.orm';
   if not FileExists(ModulFileName)then
   begin
      ShowInstallError;
      result := false;
      exit;
   end;
   RBOString := UnCryptString(ReadSimpleText(ModulFileName));
   RBOFileName := AppDataFolder + rgRBO + '\'+ RBOString;
   if not FileExists(RBOFileName) then
   begin
      ShowInstallError;
      result := false;
      exit;
   end;
   RInfo := LoadRBOFromFile(RBOFileName);
   // kontrola ptomnosti applikace v RBO !!!!!!!!!

   LicenceOK := true;
   HDCOK := true;
   HighLevelControl := RInfo.Reg.IsHDControl or RInfo.Reg.IsLicence;
   if HighLevelControl then
   begin
      if RInfo.Reg.IsLicence then
      begin
         LicenceOK :=  RInfo.Reg.Licence = RInfo.Reg.Licence1;
      end
      else LicenceOK := true;
      if RInfo.Reg.IsHDControl then
      begin
         HDCOK := CheckControlCode(RInfo);
      end
      else HDCOK := true;
      if not (HDCOK and LicenceOK) then
      begin
         TryToRegister;
         DeleteFile(IncludeTrailingPathDelimiter(AppDataFolder + rgRBO)+'test.xml');
         if MustBeStored then
            StoreRBOtoFolders(RInfo);
      end;
   end;

   if  HighLevelControl then
   begin
      if (HDCOK and LicenceOK) then
      begin
         Licence := RInfo.Reg.Licence;
      end
      else
      begin
         result := false;
         exit;
      end;
   end;
   SubjectName := RInfo.Reg.Company;
   Subject_ID := RInfo.Reg.CompanyID;
   User_Name    := RInfo.Reg.User;
   PasHash     := SHA1DigestToHex(CalcSHA1(RInfo.Reg.Password));
   ModuleName := RBOUNameVersionString(RInfo);
   if not (RInfo.Reg.IsTrial or RInfo.Reg.IsTimeWall)  then exit;

   NowTime := Now
   (*
   {$IFDEF Win32}
   + c1899
   {$ENDIF}
   *)
   ; { delam z toho 16 bit tdatetime }
   if RInfo.Reg.IsTrial then
   if RInfo.Reg.TimeWall = 0 then
   begin
      RInfo.Reg.TimeWall :=  IncMonth(NowTime);
   end;
   IsTimeWall := RInfo.Reg.IsTimeWall;
   TimeWall := RInfo.Reg.TimeWall;

   if RInfo.Reg.IsTrial then
   if RegisterOK then
   begin
      result := true;
      exit;
   end;

   if NowTime > RInfo.Reg.TimeWall then
   begin
      if HighLevelControl then
      begin
         ShowMessage('Bylo pekroeno asov omezen ('+DateTimeToStr(RInfo.Reg.TimeWall)+')');
         HDCOK := false; // aby to probehlo
         if TryToRegister then
         begin
            DeleteFile(IncludeTrailingPathDelimiter(AppDataFolder + rgRBO)+'test.xml');
            if NowTime > RInfo.Reg.TimeWall then
               ShowMessage('asov omezen je stle pekroeno, aplikace se ukon...')
            else
            begin
               RInfo.Reg.LastTime := NowTime;
               StoreRBOToFolders(RInfo);
               exit;
            end;
         end
         else
            ShowMessage('Aplikace se ukon ...');
      end
      else
      begin
         ShowMessage('Bylo pekroeno asov omezen ('+DateTimeToStr(RInfo.Reg.TimeWall)+'), aplikace se ukon');
      end;
      result := false;

      RInfo.Reg.LastTime := NowTime;
      StoreRBOToFolders(RInfo);
      Application.Terminate;
      exit;
   end;
   if NowTime < RInfo.Reg.LastTime then
   begin
      result := false;
      ShowMessage('Bylo patrn manipulovno s asem potae, aplikace se ukon');
      Application.Terminate;
      exit;
   end;
   RInfo.Reg.LastTime := NowTime;
   StoreRBOToFolders(RInfo);
end;


{ TAppInstallInfo }

function TAppInstallInfo.GetDirs: TStringList;
begin
   if FDirs = nil then FDirs := TStringList.Create;
   result := FDirs;
end;

procedure TAppInstallInfo.SetDirs(const Value: TStringList);
begin
   if FDirs <> nil then
   begin
      Fdirs.Free;
      FDirs := nil;
   end;
   FDirs := Value;
end;


END.
