unit U_crypt;

interface

function CodeStringTrivial(const S: string): string;
function DecodeStringTrivial(const S: string): string;

procedure Crypt(var aBuffPointer: pointer; var aNumber: longInt);
procedure UnCrypt(var aBuffPointer: pointer; var aNumber: longInt);

function CryptLongInt(aVal: longInt): string;
function UnCryptLongInt(aVal: Ansistring): longInt;

function CryptDouble(aVal: double): string;
function UnCryptDouble(aVal: Ansistring): double;

function CryptString(aVal: Ansistring): string;
function UncryptString(aVal: Ansistring): string;

implementation
uses
  SysUtils;


function CodeStringTrivial(const S: string): string;
var
   i: longInt;
   Ch: char;
begin
   result := S;
   for i := 1 to Length(S) do
   begin
      result[i] := Char(Ord(result[i])+1);
      Ch := result[i];
      if Ch = ':' then Ch := '0' else
      if Ch = '[' then Ch := 'A' else
      if Ch = '{' then Ch := 'a' ;
      result[i] := Ch;
   end;
end;

function DecodeStringTrivial(const S: string): string;
var
   i: longInt;
   Ch: char;
begin
   result := S;
   for i := 1 to Length(S) do
   begin
      CH := result[i];
      if Ch = '0' then Ch := ':' else
      if Ch = 'A' then Ch := '[' else
      if Ch = 'a' then Ch := '{' ;
      result[i] := Char(Ord(Ch)-1);
   end;
end;


type
  TByteArray = array[0..1000000] of byte;



procedure RotateLeft(var aByte: Byte; aNum: byte);
var
  I: integer;
begin
  for I:= 1 to aNum do
  begin
    if (aByte and $80) <> 0 then
    begin
      aByte:= aByte and $7F;
      aByte:= aByte shl 1;
      aByte:= aByte + 1
    end
    else
      aByte:= aByte shl 1
  end
end;


procedure RotateRight(var aByte: Byte; aNum: byte);
var
  I: integer;
begin
  for I:= 1 to aNum do
  begin
    if (aByte and $01) <> 0 then
    begin
      aByte:= aByte shr 1;
      aByte:= aByte + $80
    end
    else
      aByte:= aByte shr 1
  end
end;



procedure Crypt(var aBuffPointer: pointer; var aNumber: longInt);
var
  aCryptNum: byte; // poet heslovacch byt
  aSavedNum: byte; // ukldan 1.byte
  aGoalBuff: ^TByteArray;
  aGoalNum: longInt;
  I: integer;
begin
  Randomize;
  aCryptNum:= Random(5)+2;
  aSavedNum:= Random(255);
  aSavedNum:= (aSavedNum and $C7) + (aCryptNum shl 3); // bin 11000111
  aGoalNum:= aNumber + aCryptNum + 1;
  getMem(aGoalBuff, aGoalNum);
  move(aBuffPointer^, aGoalBuff^[aCryptNum + 1], aNumber);
  freeMem(aBuffPointer, aNumber);
  aGoalBuff^[0]:= aSavedNum;
  for I:= 1 to aCryptNum do
    aGoalBuff^[I]:= Random(254)+1;
  for I:= aCryptNum + 1 to aGoalNum - 1 do
  begin
    aGoalBuff^[I]:= (aGoalBuff^[I] xor aGoalBuff^[(I mod aCryptNum) + 1]);
    RotateLeft(aGoalBuff^[I], aGoalBuff^[aCryptNum-(I mod aCryptNum)]and $3);
  end;
  aBuffPointer:= aGoalBuff;
  aNumber:= aGoalNum;
end;



procedure UnCrypt(var aBuffPointer: pointer; var aNumber: longInt);
var
  aCryptNum: byte; // poet heslovacch byt
  aSavedNum: byte; // ukldan 1.byte
  aSourceBuff: ^TByteArray;
  aGoalBuff: ^TByteArray;
  aGoalNum: longInt;
  I: integer;

begin
  pointer(aSourceBuff):= aBuffPointer;
  aSavedNum:= aSourceBuff^[0];
  aCryptNum:= (aSavedNum and $38) shr 3; //00111000

  getMem(aGoalBuff, aNumber - aCryptNum - 1);

  for I:= aCryptNum + 1 to aNumber - 1 do
  begin
    RotateRight(aSourceBuff^[I], aSourceBuff^[aCryptNum-(I mod aCryptNum)] and $3);
    aGoalBuff^[I-aCryptNum-1]:= aSourceBuff^[I] xor aSourceBuff^[(I mod aCryptNum) + 1]
  end;

  freeMem(aBuffPointer, aNumber);
  aBuffPointer:= aGoalBuff;
  aNumber:= aNumber-aCryptNum-1
end;




function CryptLongInt(aVal: longInt): string;
var
  aBuf: ^TByteArray;
  aNum: integer;
  I: integer;
begin
  result:= '';
  getMem(aBuf, 4);
  move(aVal, aBuf^, 4);
  aNum:= 4;
  Crypt(pointer(aBuf), aNum);
  for I:= 0 to aNum-1 do
  begin
    result:= result + intToHex(aBuf^[I], 2);
    if ((I+1) mod 3 = 0) and ((aNum - I) > 2) then
       result:= result + '-'
  end;
  freeMem(aBuf, aNum)
end;



function HexToByte(aChar: Ansichar): byte;
begin
  result:= 0;
  if aChar in ['0'..'9'] then
     result:= ord(aChar)-$30
  else
  begin
    aChar:= upCase(aChar);
  if aChar in ['A'..'F'] then
    result:= ord(aChar) - 55 // -'A'+10
  end
end;


function DoubleHexToByte(aChar1, aChar2: Ansichar): byte;
begin
  result:= HexToByte(aChar2) + HexToByte(aChar1)*16
end;


function UnCryptLongInt(aVal: Ansistring): longInt;
var
  I: integer;
  aBuf: ^TByteArray;
  aNum, PomVal: integer;

begin
  result:= 0;
  getMem(aBuf, length(aVal));
  aNum:= 0;
  I:= 1;
  while I <= length(aVal) do
  begin
    if (UpCase(aVal[I]) in ['0'..'9','A'..'F'])  then
    begin
      aBuf[aNum]:= DoubleHexToByte(aVal[I], aVal[I+1]);
      inc(aNum);
      inc(I);
    end;
    inc(I)
  end;
  UnCrypt(pointer(aBuf), aNum);
  if aNum > 4 then exit;
  PomVal:= 0;
  move(aBuf^, PomVal, aNum);
  freeMem(aBuf, aNum);
  result:= PomVal
end;


function CryptDouble(aVal: double): string;
var
  aBuf: ^TByteArray;
  aNum: integer;
  I: integer;
begin
  result:= '';
  getMem(aBuf, 8);
  move(aVal, aBuf^, 8);
  aNum:= 8;
  Crypt(pointer(aBuf), aNum);
  for I:= 0 to aNum-1 do
  begin
    result:= result + intToHex(aBuf^[I], 2);
    if ((I+1) mod 3 = 0) and ((aNum - I) > 2) then
       result:= result + '-'
  end;
  freeMem(aBuf, aNum)
end;



function UnCryptDouble(aVal: ANsistring): double;
var
  I: integer;
  aBuf: ^TByteArray;
  aNum: integer;
  PomVal: double;

begin
  result:= 0;
  getMem(aBuf, length(aVal));
  aNum:= 0;
  I:= 1;
  while I <= length(aVal) do
  begin
    if (UpCase(aVal[I]) in ['0'..'9','A'..'F'])  then
    begin
      aBuf[aNum]:= DoubleHexToByte(aVal[I], aVal[I+1]);
      inc(aNum);
      inc(I);
    end;
    inc(I)
  end;
  UnCrypt(pointer(aBuf), aNum);
  if aNum > 8 then exit;
  PomVal:= 0;
  move(aBuf^, PomVal, aNum);
  freeMem(aBuf, aNum);
  result:= PomVal
end;

function CryptString(aVal: Ansistring): string;
var
  aBuf: ^TByteArray;
  aNum: integer;
  I: integer;
begin
  result:= '';
  aNum := Length(aVal) *SizeOf(Char);
  getMem(aBuf, aNum);
  move(aVal[1], aBuf^, aNum);
  Crypt(pointer(aBuf), aNum);
  for I:= 0 to aNum-1 do
  begin
    result:= result + intToHex(aBuf^[I], 2);
    if ((I+1) mod 3 = 0) and ((aNum - I) > 2) then
       result:= result + '-'
  end;
  freeMem(aBuf, aNum);
end;

function UncryptString(aVal: Ansistring): string;
var
  I: integer;
  aBuf: ^TByteArray;
  aNum: integer;
  PomVal: Ansistring;

begin
  result:= '';
  getMem(aBuf, length(aVal));
  aNum:= 0;
  I:= 1;
  while I <= length(aVal) do
  begin
    if (UpCase(aVal[I]) in ['0'..'9','A'..'F'])  then
    begin
      aBuf[aNum]:= DoubleHexToByte(aVal[I], aVal[I+1]);
      inc(aNum);
      inc(I);
    end;
    inc(I)
  end;
  UnCrypt(pointer(aBuf), aNum);
  SetLength(PomVal,aNum);
  move(aBuf^, PomVal[1], aNum);
  freeMem(aBuf, aNum);
  result:= PomVal
end;

end.
