unit t_CHeck_Parcely;

interface
uses
   Elements,
   e_KatastrModel,
   t_Chk;

type

TCHeckPARDuplication = class (TCheckTool)
  private
    FsolvedParc: TOwnerEntity;
    FARE_PAR: TEntity;
    procedure SetARE_PAR(const Value: TEntity);
    function GetParC: Tgis_ParcelaCast;
    function GetSolvedParc: TOwnerEntity;
protected
  function GetErrorMsg: string; override;
public
   procedure DoIt; override;
   procedure ProcessPar;
   property  ParC: Tgis_ParcelaCast read GetParC;
   property  SolvedParc: TOwnerEntity read GetSolvedParc;
published
   property ARE_PAR: TEntity read FARE_PAR write SetARE_PAR;
end;

implementation

uses
   Classes,
   Forms,
   e_Class,
   e_Chk,
   e_Geometry,
   Tools, e_GeometryElement;

{ TCHeckAreaExists }

procedure TCHeckPARDuplication.DoIt;
var
   i: integer;
begin
   if ARE_PAR = nil then exit;
   StartProgress(Name,0,ARE_PAR.LastIndex);
   for i := 0 to ARE_PAR.LastIndex do
   begin
      if i mod 50 = 0 then
      begin
         Progress := i;
         Application.ProcessMessages;
      end;
      input := ARE_PAR.Elements[i];
      ProcessPar;
   end;
end;

function TCHeckPARDuplication.GetErrorMsg: string;
var
   PC: Tgis_ParcelaCast;
   i: integer;
   e: Telement;
   S: string;
begin
   PC := ParC;
   result := '?';
   if PC = nil then exit;
   S := PC.GetPropertyStringByName('SKUPAR_CIS');
   result := PC.Name+' ('+S+','+PC.GetPropertyStringByName('KU_KOD')+')';
end;

function TCHeckPARDuplication.GetParC: Tgis_ParcelaCast;
begin
   result := nil;
   if Input = nil then exit;
   if not (Input is Tgis_ParcelaCast) then exit;
   result := Tgis_ParcelaCast(Input);
end;

function TCHeckPARDuplication.GetSolvedParc: TOwnerEntity;
begin
   if FSolvedParc = nil then
   begin
      FSolvedParc := TOwnerEntity.Create;
      AddElement(FSolvedParc);
   end;
   result := FSolvedParc;
end;

procedure TCHeckPARDuplication.ProcessPar;
var
   P: Tgis_Parcela;
   PC: Tgis_ParcelaCast;
   K: Tgis_Katastr;
   G: TGeometry;
   i,j: integer;
   SKP: Tgis_SkupinaParcel;
   Err1: boolean;
   e: TElement;
begin
   PC := ParC;
   if PC = nil then exit;
   if PC.NoGeometry then exit;
   G := PC.Geometry;
   if G.FindOwnerClass(TErrorGeometryElement) <> nil then exit;
   P := PC.Parcela;
   if P.IsMyOwner(SolvedParc) then exit;
   SolvedParc.AddElement(P);
   SKP := PC.SkupinaParcel;
   Err1 := false;
   for i := 0 to P.LastIndex do
   begin
      e := P.Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      PC := Tgis_ParcelaCast(e);
      if PC.SkupinaParcel <> SKP then
      begin
         Err1 := true;
         break;
      end;
   end;
   if Err1 then
   for i := 0 to P.LastIndex do
   begin
      e := P.Elements[i];
      if not (e is Tgis_ParcelaCast) then continue;
      Input := e;
      AddErrorElement;
   end;
end;

procedure TCHeckPARDuplication.SetARE_PAR(const Value: TEntity);
begin
  FARE_PAR := Value;
end;


INITIALIZATION
   RegisterOrbisClass(TCheckPARDuplication);
END.

