unit E_bgif;
{
****************************************************************
**                                                            **
**                 ORBIS ... model TopoL                      **
**  Jednotka pro praci s Vektorovmi symboly na bzi BGI,     **
**  Vyuit pro bodov symboly a u. znaky                   **
**                                                            **
**                         (c)  -PPK-96-                      **
****************************************************************
}

INTERFACE
{****************************************************************}

uses
// KERNEL
   Elements,
// GLIB
   g_Elems,
// DEVICE
   e_Device,
// SYMBOL
   u_Symbol,
   u_xeString;
(*
{$IFDEF WINDOWS}
   BlokType,
   BPrevody,
   CtiPar, TxRuzne,
   Hlasky,
   MatProc,
   StrProc,
   BPObject,
   BPWindow,
   BPWinTyp;
{$ELSE}
   BlokType,
   BPrevody,
   CtiPar,
   Dos,
   Objects,
   Graph,
   MatProc,
   ZobraObj;
{$ENDIF}
*)
{****************************************************************}

const

      moStandard  = $02; { Read and write access }
      moOpenRead  = $00; { Read access only }
      moOpenWrite = $01; { Write access only }
      moOpen      = $02; { Read and write access }
      moOpenRWDD  = $12; { Read and write, deny all }
      moOpenRWND  = $22; { Read and write, deny write but enabled read }
      moOpenRWNN  = $42; { Read and write, enabled all }
      moOpenROND  = $20; { Read only, deny write but enabled read }
      moOpenRONN  = $40; { Read only, enabled all }

      moClosed    = $FF;

{Typy Borlandskych fontu}
   PocetFontu = 10;

   BOLD =  1;
   EURO =  2;
   GOTH =  3;
   LCOM =  4;
   LITT =  5;
   SANS =  6;
   SCRI =  7;
   SIMP =  8;
   TRIP =  9;
   TSCR = 10;



   Ano                = True;
   Ne                 = False;
   UniverzalniDelitel = 1000;

{ Velikost 1 typografickeho bodu v metrech }
{ ---------------------------------------- }

   TypBod = 0.000376;

{ Chybove konstanty }
{ ***************** }
  errCannotOpenTextStyles = 1;
  errCannotOpenVectorFont = 2;
  errOutOfMemory          = 3;
  errWrongVectorFont      = 4;

{
***********************
*                     *
*       BGIFont       *
*                     *
***********************
}
type


  PVektory = ^Tvektory;
  TVektory = packed Array[0..65520] of byte;

  PFontFileInfo = ^RFontFileInfo;
  RFontFileInfo = packed record
                          nic1 : byte;
                    PocetZnaku : byte;
                          nic2 : word;
                    PrvniZnak  : byte;
                    Vektory    : word;
                          nic3 : byte;
                    VyskaZnaku : byte;
                          nic4 : packed Array[1..7] of Byte;
                    Adresy     : packed Array[0..255] of Word;
                  end;

(*
  PRychleInfo = ^RRychleInfo;
  RRychleInfo = record
               {$IFDEF WINDOWS}
                VychoziBod  : TPoint;
               {$ELSE}
                VychoziBod  : PointType;
               {$ENDIF}
                KoefVysky   : LongInt;
                KoefSirky   : LongInt;
                Smer        : RUhel;     { Uhel v Radianech }
                Sklon       : RUhel;     { Uhel v Radianech }
                Rozestupy   : LongInt;   { Zvetseni default hodnoty v Bodech }
              end;

*)
  { Zakladni objekt pro praci s vektorovym textem }
  { ********************************************* }

  TTextStyles = class;

  TBGIFont = class(TOwnerElement)
  protected
    FTextInfo   : TBGIText;              { Definice textu obsahujici parametry zobrazeni }
    FFreeTextInfo: boolean;
    FChybaFontu: boolean;
    FTextStyles: TTextStyles;
    function   GetTextInfo: TBGIText;
    procedure  SetTextInfo(aTextInfo: TBGIText);
  public
    AktualniFont: byte;              { Vektorovy font natazeny momentalne v pameti }
    AktualniKod : TCodePage;          { Jeho kod ... jde o cestinu }
    PFont       : Pointer;            { Ukazatel na font v pameti }
    DelkaFontu  : LongInt;            { Velikost fontu ... pro alokaci pameti }
    Udaje       : PFontFileInfo;      { Taky ukazuje na font, ale s jinym pristupem }
    (*
    RychleInfo  : RRychleInfo;        { Jeji celociselna verze }
    *)
    Sila        : integer;            { Tloustka cary pro vykresleni }
    OuKej       : boolean;            { kontrola korektnosti natazeni fontu a tak }
    Device      : TDevice;            { zazen pro vstup }
    Constructor   Create; override;
    Destructor    Destroy; override;
    procedure     SetDevice(aDevice: TDevice);
    function      VyskaTextuVMetrech:double;
    function      ZaklSirkaTextu(var T: String):Integer ;
    function      SirkaTextu(var T: String):double;

    {procedure     PisZnakFinal(Znak: char);}
    procedure     PisTextFinal(const TextString: _xString);
    function      NovyFont(TypFontu: Byte; KodJazyka: TCodePage): boolean;

    function      NovyFontProBody(TypFontu: byte;
                                   var DynCiStat: char;
                                   var VelikostFontu: double;
                                   var RSila: double): boolean;

    function      VratKoncovkuDleKodu(KodJazyka: TCodePage): string;
    procedure     NastavVychoziBod(Bod: TDoubleCoord);
    procedure     NastavText(TextString: String);
    procedure     NastavSmerTextu(Smer: double);   { Uhel ve Stupnich }
    procedure     NastavSmerNapevno (SmerNap: boolean);
    procedure     NastavSklonTextu(Sklon: double); { Uhel ve Stupnich }
    procedure     NastavVyskuTextu(aVyska: double);
    procedure     NastavVyskuTextuVMetrech(aVyska: double);
    procedure     NastavKoefSirkyZnaku(Koef: double);
    procedure     NastavRozestupy(Roz: double);
    procedure     NastavRezimTextu(Rezim: byte);
    procedure     NastavBarvu(Barva: Word);
    procedure     NastavDruhCary(Cara: Integer);
    procedure     NastavInfo(Info: TBGIText);
    procedure     NastavInfoPodleDruhu(ADruh: Integer); virtual;
    procedure     ZobrazText(NastavitDruh: boolean);
    function      FontTypNaSoubor(TypF: byte): String;
    function      FontSouborNaTyp(Soubor: String): byte;
    function      Meritko: double; virtual;
    function      BodyNaMetry(Body: double): double;
    function      MetryNaBody(Metry: double): double;
    function      PrevedBodyNaKoef: double;
    function      MeritkoNaMetry(Mer: double): double;
    function      MetryNaMeritko(Metry: double): double;
    function      VratKoefVysky: double;
    function      VratRozestupy: double;
    procedure     UpravR (PozX,PozY: double; var x,y: double; Sm,Skl: double);
    procedure     VratNastaveniTextu(var Info:TBGIText);
    function      VratVektory: PVektory;
    procedure     CalculateOpsanyObdelnik;
    procedure     OpsanyKosodelnik (var LLD,PPD,LLH,PPH: TDoubleCoord);
    procedure     Chyba(Jaka: word; Dodatek: String); virtual;

    property      TextInfo: TBGIText read GetTextInfo write SetTextInfo;
    property      FreeTextInfo: Boolean read FFreeTextInfo write FFreeTextInfo;
    property      ChybaFontu: boolean read FChybaFontu write FChybaFontu default false;
    property      TextStyles: TTextStyles read FTextStyles write FTextStyles;
                  { Definice textu obsahujici parametry zobrazeni }

  end;


  TTextStyle = class(TOwnerElement)
  public
    Druh          : integer;
    RezimTextu    : byte;
    Font          : byte;
    Vyska         : double;
    KoefSirky     : double;
    Sklon         : real48; { Uhel v Radianech }
    Rozestupy     : real48; { Zvetseni default hodnoty v Bodech }
    Barva         : Integer;
    DruhCary      : Integer;
    SilaPera      : real48; { Sila pera pro HPGL2 }
  end;


  TTextStyles = class(TOwnerEntity)
  private
     FFileName: string;
     procedure SetFileName(aVal: string);
     function  GetStyleOfCode(aValue: longInt): TTextStyle;
  public
     property StyleOfCode[aCode: longInt]: TTextStyle read GetStyleOfCode;
  published
     property FileName: string read FFileName write SetFileName;
  end;

  (*

  { Kolekce Textovych druhu }
  { *********************** }

  TDruhyTextu = class(TOwnerEntity)
  public
    Soubor  : String;        { Textovy soubor obsahujici definice druhu }
    StylyOK : boolean;        { Informace o existenci souboru stylu }
    constructor Init(ASoubor: string);
    function    ExistujeDruhSNazvem(ANazev: TNazevDruhu): boolean;
    function    ExistujeDruhSKodem(AKod: longInt): boolean;
    procedure   FreeItem(Item: Pointer); virtual;
    procedure   NactiDruhyZeSouboru;
    function    PridejDruhDleKodu(AKod: longInt): PDruhTextu;
    function    PridejDruhDleNazvu(ANazev:TNazevDruhu): PDruhTextu;
    function    UlozGlobalJakoDruh(var AKod: integer; Nazev: TNazevDruhu): boolean;
    function    VratDruhDleKodu(AKod: longInt): PDruhTextu;
    function    VratDruhDleNazvu(ANazev: TNazevDruhu): PDruhTextu;
    function    VratKod(ANazev: TNazevDruhu): longInt;
    function    VratNeexistujiciKod: longInt;
    function    VratNazev(AKod: longInt): TNazevDruhu;
    function    VyberDruhu: PDruhTextu;
    procedure   Chyba(Jaka: word; Dodatek: String); virtual;
  end;

  { Objekt pro nacitani Druhu textu z textoveho souboru }
  { *************************************************** }

  TCteniDruhuTextu = object(TCteniParametru)
    function  CtiDruhKodem(Kod: longInt): PDruhTextu;
    function  CtiDruhNazvem(ANazev: TNazevDruhu): PDruhTextu;
    function  DejIntParametr: Integer;
    function  NajdiDalsiDruh: boolean;
    procedure VexlujRezim(Hodn: String; var RT: TRezimTextu);
    procedure Chyba(Jaka: word; Dodatek: String); virtual;
  end;


const

  { Kolekce textovych druhu }
  { *********************** }
  DruhyTextu: PDruhyTextu = nil;

  { Zakladni Druh textu }
  { ******************* }
  ZaklDruhTextu: TDruhTextu =(
    Nazev     : {$IFDEF WINDOWS}Vyb_UzivTyp;{$ELSE}'Styl 007';{$ENDIF}
    Druh      : 0;
    RezimTextu: Relativne;
    Font      : 5;
    Vyska     : 100;
    KoefSirky : 1;
    Sklon     : 0;
    Rozestupy : 0;
    Barva     : 13;
    DruhCary  : 0 ;
    SilaPera  : 0.35);
*)
IMPLEMENTATION
{****************************************************************}

uses
   Classes,
   Dialogs,
   SysUtils,
// KERNEL
   u_String,
   Worlds,
// GLIB
   MathLib,
// DEVICE
   e_proje;

{****************************************************************}

const



{ Symboly pro ncitani stylu textu }
{ ******************************* }
  txtStyl      = 'STYL';
  txtNazev     = 'NAZEV';
  txtDruh      = 'DRUH';
  txtRezim     = 'REZIM';
  txtFont      = 'FONT';
  txtVyska     = 'VYSKA';
  txtSirka     = 'SIRKA';
  txtSklon     = 'SKLON';
  txtRozestupy = 'ROZESTUPY';
  txtBarva     = 'BARVA';
  txtDruhCary  = 'DRUHCARY';
  txtSilaPera  = 'SILAPERA';
  txtEnd       = 'END';



(*
   procedure Troj(var Uh:RUhel; U:real48);
     Var
        R : real48;
      begin
         With Uh do begin
           c := UniverzalniDelitel;
           a := Round(Sin(U)*c);
           b := Round(Cos(U)*c);
         end;
      end;

*)
{
  **********************************************************
  *                                                        *
  *                  Tela metod BGIFont                    *
  *                                                        *
  **********************************************************
}


procedure  TBGIFont.SetDevice(aDevice: TDevice);
begin
   Device := aDevice;
end;


function   TBGIFont.GetTextInfo: TBGIText;
begin
   result := FTextInfo;
end;

procedure  TBGIFont.SetTextInfo(aTextInfo: TBGIText);
begin
   FTextInfo := aTextInfo;
end;

Constructor   TBGIFont.Create;
var
  S: string;
begin
  inherited Create;
  TextStyles := TTextStyles.Create;


  s := PathOfLibraries;{TMainTool(World.MainTool).Options.ServiceDirectory;}

  TextStyles.FileName := CheckBackSlash(S)+'Styly.txt';
  {
  OuKej      := ANO;
  PFont      := NIL;
  AktualniFont := 0;
  AktualniKod  := 0;
  NastavKoefSirkyZnaku(1);
  NastavSmerTextu(0);
  NastavSklonTextu(0);
  NastavRozestupy(0);
  NastavText('');
  }
end;

{------------------------------------------------}
Destructor    TBGIFont.Destroy;
  begin
    if PFont <> NIL then
    begin
       FreeMem (PFont,Delkafontu);
    end;
    if TextStyles <> nil then TextStyles.Free;
    if assigned(FTextInfo) and FreeTextInfo then FTextInfo.Free;
  end;

{------------------------------------------------}

function      TBGIFont.VyskaTextuVMetrech:double;
  begin
    With TextInfo do begin
       if T30 in Atributy then
       begin
          case RezimTextu of
             Meritkove:
               VyskaTextuVMetrech := MeritkoNaMetry(Vyska);
             Absolutne:
               VyskaTextuVMetrech := BodyNaMetry(Vyska);
             else
               VyskaTextuVMetrech := Vyska;
          end
       end
       else
       begin
          if RezimTextu = Relativne then begin
             VyskaTextuVMetrech := Vyska * Udaje^.VyskaZnaku;
          end
          else begin
             VyskaTextuVMetrech := BodyNaMetry(Vyska);
          end;
       end;
    end;
  end;

{------------------------------------------------}
function      TBGIFont.ZaklSirkaTextu (var T: String): Integer;
type
   PDelky = ^TDelky;
   TDelky = packed Array[0..65520] of byte;
var
   Delky    : PDelky;
   Delka    : Integer;
   DelkaStr : integer;
   i        : Byte;
  begin
     DelkaStr := length(T);
     Delka  := 0;
     Delky := Pointer(NativeInt(@Udaje^.Adresy)+(Udaje^.PocetZnaku shl 1));
     for i := 1 to DelkaStr do begin
        Delka := Delka + Delky^[Ord(T[i])-Udaje^.PrvniZnak];
     end;
     result := Delka;
  end;



{------------------------------------------------}
function      TBGIFont.SirkaTextu (var T: String): double;
var
   DelkaStr : Byte;
begin
   DelkaStr := Length(T);
   With TextInfo do begin
      if not OuKej or (Font <> AktualniFont) then
      begin
         NovyFont(Font, CodePage{UzivatelskyJazyk});  {!!!!!!!!!!!!!!!!! etina }
      end;
      if T30 in Atributy then
      begin
      case RezimTextu of
         Meritkove:
            begin
               SirkaTextu := ZaklSirkaTextu(T)*
                             (MeritkoNaMetry(Vyska)/Udaje^.VyskaZnaku) *
                              KoefSirky + MeritkoNaMetry((DelkaStr-1) * Rozestupy)
            end;
         Absolutne:
            begin
               SirkaTextu := ZaklSirkaTextu(T) * PrevedBodyNaKoef * KoefSirky
                             + BodyNaMetry(((DelkaStr-1) * Rozestupy));
            end;
         else
            begin
               SirkaTextu := ZaklSirkaTextu(T) * (Vyska/Udaje^.VyskaZnaku)
                             * KoefSirky + ((DelkaStr-1) * Rozestupy);
            end;
      end;
      end
      else
      begin
      case RezimTextu of
         Absolutne:
            begin
               SirkaTextu := ZaklSirkaTextu(T) * PrevedBodyNaKoef * KoefSirky
                             + BodyNaMetry(((DelkaStr-1) * Rozestupy));
            end;
         else
            begin
               SirkaTextu := ZaklSirkaTextu(T) * (Vyska)
                             * KoefSirky + ((DelkaStr-1) * Rozestupy);
            end;
      end;
      end;
   end;
end;



{------------------------------------------------}
procedure     TBGIFont.UpravR (PozX,PozY: double;var x,y: double;Sm,Skl: double);
  var
    hX : double;
    begin
       x  := x + (y * Sin(Skl) / Cos(Skl));
       hX := PozX + (x*Cos(Sm) - y*Sin(Sm));
       y  := PozY + (x*Sin(Sm) + y*Cos(Sm));
       x  := hX;
    end;



{------------------------------------------------}

(*
procedure     TBGIFont.PisZnakFinal(Znak: char);
var
  Vektor       : PVektory;
  Index        : Word;
  i            : Byte;
  xB,yB        : Byte;
  xx,yy,
  PozX,PozY    : double;
  PomKoefVysky : double;
  PomkoefSirky : double;
  PomRozestupy : double;
  Kladna,
  Spoj         : boolean;

begin
  if OuKej then
  begin
    Vektor := VratVektory;
    With TextInfo do
    begin;
         if T30 in Atributy then
         begin
            PomKoefVysky := VratKoefVysky;
            PomRozestupy := VratRozestupy;
         end
         else
         begin
            if TextInfo.RezimTextu = Relativne then begin
               PomKoefVysky := Vyska;
               PomRozestupy := Rozestupy;
            end
            else begin
               PomKoefVysky := PrevedBodyNaKoef;
               PomRozestupy := BodyNaMetry(Rozestupy);
            end;
         end;
         PomKoefSirky := PomKoefVysky*KoefSirky;
         PozX := VychoziBod.x;
         PozY := VychoziBod.y;

         Device.MoveTo(PozX, PozY);
    end;

    Index := Ord(Znak)-Udaje^.PrvniZnak;

    Index := Udaje^.Adresy[Index];
    While (Vektor^[Index] OR Vektor^[Index+1]) <> 0 do begin
      Kladna := True;
      xB := Vektor^[Index];
      yB := Vektor^[index+1];
      asm
         mov    al,xB         {Kopiruji 6.bit (znamenko)}
         mov    ah,al
         and    ah,01111111B
         and    al,01000000B  {na pozici 7. ... pak se  }
         shl    al,1          {s cislem zachazi jako s  }
         or     ah,al         {normalnim ShortIntem.    }
         mov    xB,ah
      end;
      With TextInfo do begin
        x := PomKoefSirky * ShortInt(xB);
      end;
      asm
         mov    al,yB
         mov    ah,al
         and    ah,10000000B
         mov    Spoj,ah

         mov    ah,al
         and    ah,01111111B
         and    al,01000000B
         shl    al,1
         or     ah,al
         mov    yB,ah
      end;
      With TextInfo do
      begin
         y := PomKoefVysky * ShortInt(yB);
           UpravR(PozX,PozY,xx,yy,Smer,Sklon);

           if Spoj then begin
              { LineTo(x,y) ***** Novy lomovy bod ***** }

              Device.LineTo(xx,yy);
           end
           else begin
              { MoveTo(x,y) ***** Nova Linie ***** }

              Device.MoveTo(xx,yy);
           end;
      end;
      Inc(Index,2);
    end
  end
end;

*)


{------------------------------------------------}
procedure     TBGIFont.PisTextFinal(const TextString: _xString);
var
  Vektor       : PVektory;
  DelkaStr     : integer;
  Index        : Word;
  i            : Byte;
  xB,yB        : Byte;
  xD,yD,
  PozX,PozY    : double;
  PomKoefVysky : double;
  PomkoefSirky : double;
  PomRozestupy : double;
  SinSkl,CosSkl,
  SinSm,CosSm  : double;
  //Kladna,
  Spoj         : boolean;
  BezeSklonu   : boolean;
  BezeSmeru    : boolean;

  procedure Uprav; near;
  var
     hX : double;
  begin
     if not BezeSklonu then
        xD  := xD + (yD * SinSkl / CosSkl);
     if not BezeSmeru then
     begin
        hX := PozX + (xD*CosSm - yD*SinSm);
        yD  := PozY + (xD*SinSm + yD*CosSm);
        xD  := hX;
     end
     else
     begin
        hX := PozX + xD;
        yD  := PozY + yD;
        xD  := hX;
     end;
  end;


  begin
     if OuKej and (TextString <> '') Then begin
        DelkaStr := Length(TextString);
        Vektor := VratVektory;
        With TextInfo do
        begin
             BezeSmeru  := Smer  = 0;
             BezeSklonu := Sklon = 0;
             if T30 in Atributy then
             begin
                PomKoefVysky := VratKoefVysky;
                PomRozestupy := VratRozestupy;
             end
             else
             begin
                if TextInfo.RezimTextu = Relativne then begin
                   PomKoefVysky := Vyska;
                   PomRozestupy := Rozestupy;
                end
                else begin
                   PomKoefVysky := PrevedBodyNaKoef;
                   PomRozestupy := BodyNaMetry(Rozestupy);
                end;
             end;
             PomKoefSirky := PomKoefVysky*KoefSirky;
             PozX := VychoziBod.x;
             PozY := VychoziBod.y;

             Device.MoveTo(PozX, PozY);

             SinSkl := Sin(Sklon);
             CosSkl := Cos(Sklon);
             SinSm  := Sin(Smer);
             CosSm  := Cos(Smer);
        end;

        For i := 1 to DelkaStr do begin
           Index := (Ord(TextString[i])-Udaje^.PrvniZnak);
           Index := Udaje^.Adresy[Index];
           While (Vektor^[Index] OR Vektor^[Index+1]) <> 0 do begin
             //Kladna := True;
             xB := Vektor^[Index];
             yB := Vektor^[index+1];
            {$IFNDEF WIN64}
             asm
                mov    al,xB         {Kopiruji 6.bit (znamenko)}
                mov    ah,al
                and    ah,01111111B
                and    al,01000000B  {na pozici 7. ... pak se  }
                shl    al,1          {s cislem zachazi jako s  }
                or     ah,al         {normalnim ShortIntem.    }
                mov    xB,ah
             end;
             {$ELSE}
             xB := (xB and 127) or ((xB and 64) shl 1);
             {$ENDIF}
             With TextInfo do begin
               xD := PomKoefSirky * ShortInt(xB);
             end;
            {$IFNDEF WIN64}
             asm
                mov    al,yB
                mov    ah,al
                and    ah,10000000B
                mov    Spoj,ah

                mov    ah,al
                and    ah,01111111B
                and    al,01000000B
                shl    al,1
                or     ah,al
                mov    yB,ah
             end;
             {$ELSE}
             Spoj := (yB and 128) <> 0;
             yB := (yB and 127) or ((yB and 64) shl 1);
             {$ENDIF}

             With TextInfo do
             begin
                yD := PomKoefVysky * ShortInt(yB);
                Uprav;

                if Spoj then begin
                   { LineTo(x,y) ***** Novy lomovy bod ***** }
                  Device.LineTo(xD, yD);
                end
                else begin
                   { MoveTo(x,y) ***** Nova Linie ***** }
                  Device.MoveTo(xD, yD);
                end;
             end;
             Inc(Index,2);
           end;
           With TextInfo do begin
              PozX := xD ;
              PozY := yD ;
              XD := PomRozestupy;
              YD := 0;
              Uprav;
              PozX := xD ;
              PozY := yD ;
           end;{With}
        end;{For}
     end;{if}
  end;




{------------------------------------------------}



function      TBGIFont.NovyFont(TypFontu: byte; KodJazyka: TCodePage): boolean;
var
  FontF      : file;
  NazevFontu : String;
  //Handle: integer;
begin
  NovyFont := Ano;
  OuKej    := Ano;
  if (TypFontu <> AktualniFont) or (KodJazyka <> AktualniKod) then
  begin
     if PFont <> NIL then begin
        FreeMem(PFont,DelkaFontu);
        AktualniFont := 0;
        PFont := NIL;
     end;

     {!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
     //NazevFontu := {CestaKSpoustecimuProgramu}ExtractFilePath(ParamStr(0)) + FontTypNaSoubor(TypFontu) +
     //              VratKoncovkuDleKodu(KodJazyka);

     NazevFontu := GetAbsolutePath(FontTypNaSoubor(TypFontu) +
                   VratKoncovkuDleKodu(KodJazyka));

     System.Assign (FontF, NazevFontu);
     System.fileMode:= moOpenRONN;
     {$I-}
     Reset  (FontF, 1);
     {$I+}
     fileMode:= moStandard;

     if IOResult <> 0 then
     begin
        Chyba(errCannotOpenVectorFont,NazevFontu);
        Oukej    := Ne;
        NovyFont := Ne;
     end
     else begin
        DelkaFontu := FileSize (FontF)-$80;
        GetMem (PFont,DelkaFontu);
        if PFont = NIL then
        begin
           Chyba(errOutOfMemory,'');
           OuKej    := Ne;
           NovyFont := Ne;
        end
        else begin
           Seek (FontF,$80);
           BlockRead (FontF, PFont^,DelkaFontu);
           AktualniFont := TypFontu;
           AktualniKod  := KodJazyka;
           TextInfo.Font:= TypFontu;
           Udaje        := PFont;
        end;
        Close (FontF);
     end;
  end;
end;



{----------------------------------------------------}



function      TBGIFont.NovyFontProBody(TypFontu: byte;
                                       var DynCiStat: char;
                                       var VelikostFontu: double;
                                       var RSila: double): boolean;
//var
  //FontF      : file;
  //NazevFontu : String;
  //Nalezl: boolean;

begin
   result := false;
(*
  NovyFontProBody := false;
  OuKej    := false;

  if (PFont = nil) or (TypFontu < 1) or
     (DrzakFontuPtr^.AktFontPtr^.CisloFontu <> TypFontu) or
     (TypFontu <> AktualniFont) then
  begin
    if PFont <> NIL then
    begin
      FreeMem(PFont,DelkaFontu);
      AktualniFont := 0;
      PFont := NIL;
    end;

    VelikostFontu:= 0;

    if (DrzakFontuPtr <> nil) and (DrzakFontuPtr^.OKNajdiFontCislo(TypFontu)) then
    begin
      NazevFontu   := DrzakFontuPtr^.DejJmFontu;
      DynCiStat    := DrzakFontuPtr^.DejTypFontu;
      VelikostFontu:= DrzakFontuPtr^.DejVelikostFontu;
      RSila        := DrzakFontuPtr^.DejSilu;
{$IFDEF WINDOWS}
      Nalezl := true;
      if NazevFontu = '' then
        NazevFontu := '!';
      Assign (FontF, NazevFontu);

      fileMode:= moOpenRONN;
{$I-}
      Reset  (FontF, 1);
{$I+}
      fileMode:= moStandard;

      if IOResult <> 0 then
      begin
        NazevFontu := StrPas(PracovniAdresar) + '\'+NazevFontu;
        Assign (FontF, NazevFontu);

        fileMode:= moOpenRONN;
{$I-}
        Reset  (FontF, 1);
{$I+}
        fileMode:= moStandard;
        if IOResult <> 0 then
        begin
          NazevFontu := StrPas(CestaKSpoustecimuProgramu) + '\'+NazevFontu;
          Assign (FontF, NazevFontu);

          fileMode:= moOpenRONN;
{$I-}
          Reset  (FontF, 1);
{$I+}
          fileMode:= moStandard;
          if IOResult <> 0 then
            Nalezl := false;
        end;
      end;

      if not Nalezl then
      begin
{$ELSE}
      NazevFontu:=
         fSearch (NazevFontu,
                  '.;..;..\..;..\..\..;..\..\..\..;'
                  +CestaKSpoustecimuProgramu+';');

      if NazevFontu <> '' then
      begin
        Assign (FontF, NazevFontu);

        fileMode:= moOpenRONN;
        {$I-}
        Reset  (FontF, 1);
        {$I+}
        fileMode:= moStandard;

        if IOResult <> 0 then
        begin
{$ENDIF}
          Chyba(errCannotOpenVectorFont,NazevFontu);
          Oukej    := Ne;
        end
        else
        begin
          DelkaFontu := FileSize (FontF)-$80;
          GetMem (PFont,DelkaFontu);
          if PFont = NIL then
          begin
             Chyba(errOutOfMemory,'');
             OuKej    := Ne;
          end
          else
          begin
             OuKej:= true;
             NovyFontProBody:= true;
             Seek (FontF,$80);
             BlockRead (FontF, PFont^,DelkaFontu);
             AktualniFont := TypFontu;
             TextInfo.Font:= TypFontu;
             Udaje        := PFont;
          end;
          Close (FontF)
        end;
{$IFNDEF Windows}
      end { if NazevFontu <> '' }
{$ENDIF}
    end { if Drzak OKEJ }
  end
  else
  begin
     {!!!!!!!!!!!! tohle je taky pekna blbost, Nazdar Oldo !}
     {Pozor ! nenastavuje jmeno souboru ani ostatni ptakoviny ... uz jo !}
     DynCiStat       := DrzakFontuPtr^.DejTypFontu;
     VelikostFontu   := DrzakFontuPtr^.DejVelikostFontu;
     RSila           := DrzakFontuPtr^.DejSilu;
     NovyFontProBody := true;
     OuKej           := true;
  end;
*)
end;





{------------------------------------------------}
function      TBGIFont.VratKoncovkuDleKodu(KodJazyka: TCodePage): string;
begin
   case TCodePage(KodJazyka) of
      cpIBM       : result := '.CHR';
      cpLatin2    : result := '.LVF';
   else
      { cpKamenicky }
      result := '.KVF';
   end;
end;



{------------------------------------------------}
procedure     TBGIFont.NastavVychoziBod(Bod: TDoubleCoord);
  begin
     TextInfo.VychoziBod.x := Bod.x;
     TextInfo.VychoziBod.y := Bod.y;
  end;

{------------------------------------------------}
procedure     TBGIFont.NastavText(TextString: String);
  begin
     if not assigned(FTextInfo) then exit;
     TextInfo.Veta := TextString;
  end;

{------------------------------------------------}
procedure     TBGIFont.NastavSmerTextu(Smer: double);   { Uhel ve Stupnich }
  begin
     TextInfo.Smer  := DejRADZeStupnu(Smer);
  end;

{------------------------------------------------}
procedure     TBGIFont.NastavSmerNapevno(SmerNap: boolean);
  begin
     {
     TextInfo.SmerNapevno := SmerNap;
     }
  end;

{------------------------------------------------}
procedure     TBGIFont.NastavSklonTextu(Sklon: double); { Uhel ve Stupnich }
  begin
     TextInfo.Sklon := DejRadZeStupnu(Sklon);
  end;

{------------------------------------------------}
procedure     TBGIFont.NastavVyskuTextu(aVyska: double);
  begin
     With TextInfo do begin
        if not OuKej or (Font <> AktualniFont) then begin
           NovyFont(Font, {UzivatelskyJazyk}CodePage); {!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
        end;
        if OuKej then
        begin
           if Udaje^.VyskaZnaku > 0 then
              Vyska := aVyska
           else Vyska:= 1;
        end
        else begin
           Vyska:= 1;
        end;
     end;
  end;

{------------------------------------------------}
procedure     TBGIFont.NastavVyskuTextuVMetrech(aVyska: double);
  begin
     With TextInfo do begin
        if not OuKej or (Font <> AktualniFont) then begin
           NovyFont(Font, {UzivatelskyJazyk}CodePage);{!!!!!!!!!!!!!!!!!!!!!!!!!}
        end;
        if OuKej then
        begin
           if Udaje^.VyskaZnaku > 0 then
           begin
              case RezimTextu of
                 Meritkove:
                   Vyska := aVyska/Device.Projection.VirtualScale*1000 ;
                 Absolutne:
                   Vyska := MetryNaBody(aVyska);
                 else
                   Vyska := aVyska;
              end;
           end
           else Vyska:= 1;
        end
        else Vyska:= 1;
     end;
  end;

{------------------------------------------------}
procedure     TBGIFont.NastavKoefSirkyZnaku(Koef: double);
  begin
     With TextInfo do begin
        Vyska := Koef;
     end;
  end;

{------------------------------------------------}
procedure     TBGIFont.NastavRozestupy(Roz: double);
  begin
     With TextInfo do begin
        Rozestupy := Roz;
     end;
  end;

{------------------------------------------------}
procedure     TBGIFont.NastavBarvu(Barva: Word);
  begin
     TextInfo.Barva := Barva;
  end;

{------------------------------------------------}
procedure     TBGIFont.NastavDruhCary(Cara: Integer);
  begin
     TextInfo.Znacka := Cara;
  end;

{------------------------------------------------}
procedure     TBGIFont.NastavInfo(Info: TBGIText);
   begin
      TextInfo := Info;
   end;

{------------------------------------------------}
procedure     TBGIFont.NastavInfoPodleDruhu(ADruh: Integer);
var
    DT: TTextStyle;
begin
  DT := nil;
  if TextStyles <> nil then DT := TextStyles.GetStyleofCode(ADruh);
  if DT = nil then exit;
  with TextInfo do
  begin
    RezimTextu := DT.RezimTextu;
    Font       := DT.Font;
    Vyska      := DT.Vyska;
    KoefSirky  := DT.KoefSirky;
    Sklon      := DejRadZeStupnu(DT.Sklon);
    Rozestupy  := DT.Rozestupy;
    Barva      := DT.Barva;
    Znacka     := DT.DruhCary;
  end;
  { Nastaveni sily pera ... pro Windows WYSIWYG, pro DOS primerene }
  { -------------------------------------------------------------- }
  Sila := Device.Projection.GetPageLengthHoriz1(DT.SilaPera/1000 * Device.Projection.VirtualScale);
end;

{------------------------------------------------}
procedure     TBGIFont.ZobrazText(NastavitDruh: boolean);
var
  //Mazani: boolean;
  //PodleDruhu: boolean;

  //SkutStyl, SkutSila: integer;
  S: _xString;
  ByStyle: boolean;
begin
  {
  Mazani     := TextInfo.Barva = BarvaPozadi;

  PodleDruhu := not (txtZmena in TextInfo.Atributy) and (T30 in TextInfo.Atributy);
  if NastavitDruh and PodleDruhu then
     Nastav  InfoPodleDruhu(TextInfo.Druh);
  }
  ByStyle := not (txtZmena in TextInfo.Atributy) and (T30 in TextInfo.Atributy);
  if (TextStyles <> nil) and (TextStyles.Count > 0) and ByStyle then
  begin
     Sila:= 0;
     NastavInfoPodleDruhu(TextInfo.Druh);
     Device.Pen.Width := Sila;
  end
  else
     Device.Pen.Width := Device.Projection.GetPageLengthHoriz1(VyskaTextuVMetrech/10);
  with TextInfo do
  begin
     if not OuKej or (Font <> AktualniFont) or (CodePage <> AktualniKod)then begin
        NovyFont(Font, {UzivatelskyJazyk}CodePage); {!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
     end;
     if OuKej then
     begin
        {
        if Mazani then SetColor(BarvaPozadi)
                  else SetColor(Barva);
        if PodleDruhu then SetLineStyle( SolidLn, 0, Sila)
                       else NastaveniTypuCary(DruhCary);
         }
        S:= Veta;
        PisTextFinal (S);
     end;
  end;
end;


{------------------------------------------------}

function      TBGIFont.FontSouborNaTyp(Soubor: string): byte;
begin
   FontSouborNaTyp := SIMP;
   if Soubor = 'Bold'then
   begin
      FontSouborNaTyp := BOLD;
      exit;
   end;
   if Soubor = 'Euro'then
   begin
      FontSouborNaTyp := EURO;
      exit;
   end;
   if Soubor = 'Goth'then
   begin
      FontSouborNaTyp := GOTH;
      exit;
   end;
   if Soubor = 'Lcom'then
   begin
      FontSouborNaTyp := LCOM;
      exit;
   end;
   if Soubor = 'Litt'then
   begin
      FontSouborNaTyp := LITT;
      exit;
   end;
   if Soubor = 'Sans'then
   begin
      FontSouborNaTyp := SANS;
      exit;
   end;
   if Soubor = 'Scri'then
   begin
      FontSouborNaTyp := SCRI;
      exit;
   end;
   if Soubor = 'Simp'then
   begin
      FontSouborNaTyp := SIMP;
      exit;
   end;
   if Soubor = 'Trip'then
   begin
      FontSouborNaTyp := TRIP;
      exit;
   end;
   if Soubor = 'Tscr'then
   begin
      FontSouborNaTyp := TSCR;
   end
   else
   if copy(Soubor,1,4) = 'FONT' then FontSouborNaTyp := 99
end;

{------------------------------------------------}
function      TBGIFont.FontTypNaSoubor(TypF: byte): String;
  begin
    Case TypF of
       BOLD : FontTypNaSoubor := 'Bold';
       EURO : FontTypNaSoubor := 'Euro';
       GOTH : FontTypNaSoubor := 'Goth';
       LCOM : FontTypNaSoubor := 'Lcom';
       LITT : FontTypNaSoubor := 'Litt';
       SANS : FontTypNaSoubor := 'Sans';
       SCRI : FontTypNaSoubor := 'Scri';
       SIMP : FontTypNaSoubor := 'Simp';
       TRIP : FontTypNaSoubor := 'Trip';
       TSCR : FontTypNaSoubor := 'Tscr';
       else
         FontTypNaSoubor := 'Simp';
(*
         FontTypNaSoubor   := 'FONTXX' + LStr0(TypF, 2)
*)
    end;
  end;

{------------------------------------------------}
procedure     TBGIFont.NastavRezimTextu(Rezim: byte);
  begin
     With TextInfo do begin
        RezimTextu := Rezim;
     end;
  end;

{------------------------------------------------}

function      TBGIFont.Meritko: double;
begin
   result := Device.Projection.Scale;
end;
{------------------------------------------------}
function      TBGIFont.BodyNaMetry(Body: double): double;
begin
   BodyNaMetry := Body * TypBod * Meritko;
end;



{------------------------------------------------}
function      TBGIFont.MetryNaBody(Metry: double): double;
  begin
     MetryNaBody := Metry / (TypBod * Meritko);
  end;



{------------------------------------------------}
function      TBGIFont.PrevedBodyNaKoef: double;
begin
   result := 0;
   With TextInfo do
      if not boolean(Udaje^.VyskaZnaku) then
      begin
          Chyba(errWrongVectorFont,'');
      end
      else
         PrevedBodyNaKoef := BodyNaMetry(Vyska)/Udaje^.VyskaZnaku;
end;



{------------------------------------------------}
function      TBGIFont.MeritkoNaMetry(Mer: double): double;
  begin
     MeritkoNaMetry := Mer / 1000 * Device.Projection.VirtualScale;
  end;



{------------------------------------------------}
function      TBGIFont.MetryNaMeritko(Metry: double): double;
  begin
     MetryNaMeritko := Metry / Device.Projection.VirtualScale * 1000;
  end;



{------------------------------------------------}
function      TBGIFont.VratKoefVysky: double;
begin
  result := 0;
  with TextInfo do
  begin
     if not boolean(Udaje^.VyskaZnaku) then
     begin
         Chyba(errWrongVectorFont,'');
     end
     else
     case RezimTextu of
        Meritkove:
           begin
              VratKoefVysky := Vyska / 1000 * Device.Projection.VirtualScale / Udaje^.VyskaZnaku;
           end;
        Absolutne:
           begin
              VratKoefVysky := BodyNaMetry(Vyska)/Udaje^.VyskaZnaku;
           end;
        else
        {Relativne}
           begin
              VratKoefVysky := Vyska/Udaje^.VyskaZnaku;
           end;
     end;
  end;
end;

{------------------------------------------------}
function      TBGIFont.VratRozestupy: double;
begin
  with TextInfo do
  begin
     if not boolean(Udaje^.VyskaZnaku) then
     begin
        Chyba(errWrongVectorFont,'');
        VratRozestupy := 0;
     end
     else
     case RezimTextu of
        Meritkove:
           begin
              VratRozestupy := Rozestupy / 1000 * Device.Projection.VirtualScale;
           end;
        Absolutne:
           begin
              VratRozestupy := BodyNaMetry(Rozestupy);
           end;
        else
        {Relativne}
           begin
              VratRozestupy := Rozestupy;
           end;
     end;
  end;
end;

{------------------------------------------------}
procedure     TBGIFont.VratNastaveniTextu(var Info:TBGIText);
begin
  Info := TextInfo;
end;

{------------------------------------------------}
function      TBGIFont.VratVektory: PVektory;
begin
   VratVektory := Pointer(NativeInt(PFont) + Udaje^.Vektory );
end;

{------------------------------------------------}
procedure     TBGIFont.Chyba(Jaka: word; Dodatek: String);
begin
  case Jaka of
     { Nelze otevrit soubor vektoroveho fontu }
     { -------------------------------------- }
     errCannotOpenVectorFont:
     if not ChybaFontu then
     begin
        MessageDlg('Nelze otevt soubor vektorovho fontu: '+ Dodatek, mtError, [mbOK], 0);
        ChybaFontu := true;
     end;

     { Nedostatecna velikost pameti }
     { ---------------------------- }
     errOutOfMemory:
     begin
        MessageDlg('Nedostaten velikost pamti', mtError, [mbOK], 0);
     end;

     { Chyba v nacteni vektoroveho Fontu }
     { --------------------------------- }
     errWrongVectorFont:
     begin
        MessageDlg('Chyba v naten vektorovho fontu ' + Dodatek, mtError, [mbOK], 0);
     end;
  end;
end;

{----------------------------------------------------------}
procedure TBGIFont.OpsanyKosodelnik (var LLD,PPD,LLH,PPH: TDoubleCoord);
var
   S: string;
begin
   with TextInfo do
   begin
      if not OuKej or (Font <> AktualniFont) then
        NovyFont(Font, {UzivatelskyJazyk} CodePage); {!!!!!!!!!!!!!!!!!!!!!!!}

      LLD.x   := VychoziBod.x;
      LLD.y   := VychoziBod.y;
      s := Veta;
      PPD.x := SirkaTextu(s);
      PPD.y := 0;
      LLH.x := 0;
      LLH.y := VyskaTextuVMetrech;
      PPH.x := PPD.x;
      PPH.y := LLH.y;
      UpravR(LLD.X, LLD.Y, PPD.x, PPD.y, Smer, Sklon);
      UpravR(LLD.X, LLD.Y, LLH.x, LLH.y, Smer, Sklon);
      UpravR(LLD.X, LLD.Y, PPH.x, PPH.y, Smer, Sklon);
   end;
end;


{------------------------------------------------}


procedure  TBGIFont.CalculateOpsanyObdelnik;
var
   A,B,C,D: TDoubleCoord;
   R: TDoubleRect;
begin
   OpsanyKosodelnik(A,B,C,D);
   with R do
   begin
      Min.x := A.x;
      if B.x < Min.x then Min.x := B.x;
      if C.x < Min.x then Min.x := C.x;
      if D.x < Min.x then Min.x := D.x;
      Min.y := A.y;
      if B.y < Min.y then Min.y := B.y;
      if C.y < Min.y then Min.y := C.y;
      if D.y < Min.y then Min.y := D.y;
      Max.x := A.x;
      if B.x > Max.x then Max.x := B.x;
      if C.x > Max.x then Max.x := C.x;
      if D.x > Max.x then Max.x := D.x;
      Max.y := A.y;
      if B.y > Max.y then Max.y := B.y;
      if C.y > Max.y then Max.y := C.y;
      if D.y > Max.y then Max.y := D.y;
   end;
   with TextInfo do
   begin
      Rect.Min.x := R.Minx;
      Rect.Min.y := R.Miny;
      Rect.Max.x := R.Maxx;
      Rect.Max.y := R.Maxy;
   end;
end;

{------------------------------------------------}

function GetRezim(Hodn: String): byte;
begin
  if UpperCase(Hodn) = 'M' then result := Meritkove
  else
  if UpperCase(Hodn) = 'D' then result := Relativne
  else
  if UpperCase(Hodn) = 'S' then result := Absolutne
  else
  result := Relativne;
end;

function GetFloatFS(aVal: string): double;
begin
   result:= StrToExtended(aVal)
{  zrusit po 30.4.97
   try

     if DecimalSeparator = ',' then
        result:= StrToFloat(aVal)
     else
        result:= StrToFloat(aVal)
     else
   except
     try
        SwapChars(aVal, '.', ',');
        result:= StrToFloat(aVal);
     except
        result:= 0;
     end;
   end;
}
end;

procedure TTextStyles.SetFileName(aVal: string);
var
   S: TStringList;
   i: longInt;
   SS, L, R: string;
   TS: TTextStyle;
begin
   if not FileExists(aVal) then exit;
   S := TStringList.Create;
   S.Sorted := false;
   S.LoadFromFile(aVal);
   TS := nil;
   for i := 0 to S.Count-1 do
   begin
      SS := S.Strings[i];
      if not StringAsParameter(SS,L,R )then
      begin
         L := UpperCase(L);
         if L = '[STYL]' then
         begin
            TS := TTextStyle.Create;
         end
         else if L ='[END]' then
         begin
            if TS <> nil then
            begin
               AddElement(TS);
               TS := nil;
            end;
         end;
      end
      else
      begin
         if not assigned(TS) then Continue;
         L := UpperCase(L);
         if L = txtNazev     then TS.Name  := R else
         if L = txtDruh      then TS.Druh  := StrToInt(R) else
         if L = txtRezim     then TS.RezimTextu := GetRezim(R) else
         if L = txtFont      then TS.Font  := StrToInt(R) else
         if L = txtVyska     then TS.Vyska     := GetFloatFS(R) else
         if L = txtSirka     then TS.KoefSirky := GetFloatFS(R) else
         if L = txtSklon     then TS.Sklon := GetFloatFS(R) else
         if L = txtRozestupy then TS.Rozestupy := GetFloatFS(R) else
         if L = txtBarva     then TS.Barva := StrToInt(R) else
         if L = txtDruhCary  then TS.DruhCary := StrToInt(R) else
         if L = txtSilaPera  then TS.SilaPera := GetFloatFS(R);
      end;
   end;
   S.Free;
end;

function  TTextStyles.GetStyleOfCode(aValue: longInt): TTextStyle;
var
   i: longInt;
begin
   result := nil;
   for i := 0 to Count -1 do
   begin
      if TTextStyle(Elements[i]).Druh = aValue then
      begin
         result := TTextStyle(Elements[i]);
         exit;
      end;
   end;
end;



{
  **********************************************************
  *                                                        *
  *              Tela metod TDruhyTextu                 *
  *                                                        *
  **********************************************************
}


(*
{$IFDEF WINDOWS}
constructor TDruhyTextu.Init(ASoubor: TPathStr);
{$ELSE}
constructor TDruhyTextu.Init(ASoubor: PathStr);
{$ENDIF}
begin
  inherited Init(5,5);
{$IFDEF WINDOWS}
  StrCopy(Soubor, ASoubor);
  ZobMessage:= nil;
{$ELSE}
  Soubor  := ASoubor;
{$ENDIF}
  StylyOK := Ano;
end;

{-----------------------------------------------------------}
function  TDruhyTextu.ExistujeDruhSKodem(AKod: longInt): boolean;
begin
   ExistujeDruhSKodem := VratDruhDleKodu(AKod) <> @ZaklDruhTextu;;
end;

{-----------------------------------------------------------}
function  TDruhyTextu.ExistujeDruhSNazvem(ANazev: TNazevDruhu): boolean;
begin
   ExistujeDruhSNazvem := VratDruhDleNazvu(ANazev) <> @ZaklDruhTextu;
end;

{-----------------------------------------------------------}
procedure TDruhyTextu.FreeItem(Item: Pointer);
begin
  Dispose(PDruhTextu(Item));
end;

{-----------------------------------------------------------}
procedure TDruhyTextu.NactiDruhyZeSouboru;
var
  Ctenar       : TCteniDruhuTextu;
  OK           : boolean;
  DT           : PDruhTextu;
begin
  DruhyTextu^.FreeAll;
  Ctenar.Init(Soubor, OK);
  if OK then with Ctenar do
  begin
     while NajdiDalsiDruh do
     begin
        DT := CtiDruhKodem(0);
        if Assigned(DT) then Insert(DT);
     end;
  end
  else
  begin
     if StylyOK then
     begin
        Chyba(errCannotOpenTextStyles, Soubor);
        StylyOK := Ne;
     end;
  end;
  Ctenar.Done;
end;

{-----------------------------------------------------------}
function  TDruhyTextu.PridejDruhDleKodu(AKod: longInt): PDruhTextu;
var
  Ctenar       : TCteniDruhuTextu;
  OK           : boolean;
  DTextu       : PDruhTextu;
begin
  Ctenar.Init(Soubor, OK);
  if OK then with Ctenar do
  begin
     DTextu := CtiDruhKodem(AKod);
     if Assigned(DTextu) then Insert(DTextu);
     PridejDruhDleKodu := DTextu;
  end
  else
  begin
     PridejDruhDleKodu := nil;
     if StylyOK then
     begin
        Chyba(errCannotOpenTextStyles, Soubor);
        StylyOK := NE;
     end;
  end;
  Ctenar.Done;
end;

{-----------------------------------------------------------}
function  TDruhyTextu.PridejDruhDleNazvu(ANazev: TNazevDruhu): PDruhTextu;
var
  Ctenar       : TCteniDruhuTextu;
  OK           : boolean;
  DTextu       : PDruhTextu;
begin
  Ctenar.Init(Soubor, OK);
  if OK then with Ctenar do
  begin
     DTextu := CtiDruhNazvem(ANazev);
     if Assigned(DTextu) then Insert(DTextu);
     PridejDruhDleNazvu := DTextu;
  end
  else
  begin
     PridejDruhDleNazvu := nil;
     if StylyOK then
     begin
        Chyba(errCannotOpenTextStyles, Soubor);
        StylyOk := NE;
     end;
  end;
  Ctenar.Done;
end;

{-----------------------------------------------------------}
function TDruhyTextu.UlozGlobalJakoDruh(var AKod: integer; Nazev: TNazevDruhu): boolean;
var
  F: Text;
  DT: PDruhTextu;
  PomS: String;
  SouborExistuje: boolean;
begin
   { Pokud je kod 0, najdu novou neexistujici hodnotu sam }
   { ----------------------------------------------------- }
   if AKod = 0 then AKod := VratNeexistujiciKod;
   Assign(F,Soubor);
   {$I-}
   Reset(F);
   {$I+}
   SouborExistuje := IOResult = 0;

   { Kontrola existence stylu }
   { ------------------------ }
   if SouborExistuje and (ExistujeDruhSNazvem(Nazev) or ExistujeDruhSKodem(AKod)) then
   begin
     Close(F);
     UlozGlobalJakoDruh := Ne;
     exit;
   end;

   UlozGlobalJakoDruh := Ano;
   {$I-}
   Append(F);
   {$I+}
   if IOResult <> 0 then Rewrite(F);
   new(DT);
{$IFNDEF WINDOWS}
   TestNew(DT);
{$ENDIF}
   DT^.Nazev      := Nazev;
   DT^.Druh       := AKod;
   DT^.RezimTextu := RezimTextu;
   DT^.Font       := DruhPisma;
   DT^.Vyska      := VyskaPisma;
   DT^.KoefSirky  := KoefSirkyPisma;
   DT^.Sklon      := SklonPisma;
   DT^.Rozestupy  := RozestupyPisma;
   DT^.Barva      := BarvaTextu;
   DT^.DruhCary   := DruhCaryPisma;
   DruhTextu := AKod;
   Insert(DT);
 { vlozeni do souboru Znacky.DBF }
{
   Znacky.PridejZaznam(AKod, 'T', Nazev, BarvaTextu, 0, '', '', 1, 0, 1, 0.18);
}
   Writeln(F);
   PomS := '[Styl]';
   Writeln(F,PomS);
   Str(DT^.Druh,PomS);
   PomS := '   Druh = ' + PomS;
   Writeln(F,PomS);
   PomS := '   Nazev = ' + DT^.Nazev;
   Writeln(F,PomS);
   case DT^.RezimTextu of
     Absolutne: PomS := 'S';
     Relativne: PomS := 'D';
     Meritkove: PomS := 'M';
   end;
   PomS := '   Rezim = ' + PomS;
   Writeln(F,PomS);
   Str(DT^.Font,PomS);
   PomS := '   Font = ' + PomS;
   Writeln(F,PomS);
   Str(DT^.Vyska:8:2,PomS);
   PomS := '   Vyska = ' + PomS;
   Writeln(F,PomS);
   Str(DT^.KoefSirky:8:2,PomS);
   PomS := '   Sirka = ' + PomS;
   Writeln(F,PomS);
   Str(DT^.Sklon:8:2,PomS);
   PomS := '   Sklon = ' + PomS;
   Writeln(F,PomS);
   Str(DT^.Rozestupy:8:2,PomS);
   PomS := '   Rozestupy = ' + PomS;
   Writeln(F,PomS);
   Str(DT^.Barva,PomS);
   PomS := '   Barva = ' + PomS;
   Writeln(F,PomS);
   Str(DT^.DruhCary,PomS);
   PomS := '   DruhCary = ' + PomS;
   Writeln(F,PomS);
   PomS := '[End]';
   Writeln(F,PomS);
   Close(F);
   StylyOK := Ano;
end;

{-----------------------------------------------------------}
function  TDruhyTextu.VratDruhDleKodu(AKod: longInt): PDruhTextu;
var
  DT: PDruhTextu;

  {............................................}
  function KodSedi(Item: Pointer): boolean; far;
    begin
       KodSedi := PDruhTextu(Item)^.Druh = AKod;
    end;
  {............................................}
begin
   if AKod = 0 then
      DT := @ZaklDruhTextu
   else
   begin
      DT := FirstThat(@KodSedi);
      if not Assigned(DT) then DT := PridejDruhDleKodu(AKod);
   end;
   if not Assigned(DT) then DT := @ZaklDruhTextu;
   VratDruhDleKodu := DT;
end;

{-----------------------------------------------------------}
function  TDruhyTextu.VratDruhDleNazvu(ANazev: TNazevDruhu): PDruhTextu;
var
  DT: PDruhTextu;
  {............................................}
  function NazevSedi(Item: Pointer): boolean; far;
    begin
       NazevSedi := PDruhTextu(Item)^.Nazev = ANazev;
    end;
  {............................................}
begin
   DT := FirstThat(@NazevSedi);
   if not Assigned(DT) then DT := PridejDruhDleNazvu(ANazev);
   if not Assigned(DT) then DT := @ZaklDruhTextu;
   VratDruhDleNazvu := DT;
end;

{-----------------------------------------------------------}
function    TDruhyTextu.VratNeexistujiciKod: longInt;
var
  DT: PDruhTextu;
  NovyKod: longInt;
begin
  NovyKod := 0;
  repeat
     Inc(NovyKod);
     DT := VratDruhDleKodu(NovyKod);
  until DT = @ZaklDruhTextu;
  VratNeexistujiciKod := NovyKod;
end;

{-----------------------------------------------------------}
function    TDruhyTextu.VratKod(ANazev: TNazevDruhu): longInt;
var
  DT: PDruhTextu;
begin
  DT := VratDruhDleNazvu(ANazev);
  if Assigned(DT) then VratKod := DT^.Druh
                  else VratKod := 0;
end;

{-----------------------------------------------------------}
function    TDruhyTextu.VratNazev(AKod: longInt): TNazevDruhu;
var
  DT: PDruhTextu;
begin
  DT := VratDruhDleKodu(AKod);
  if Assigned(DT) then VratNazev := DT^.Nazev
                  else VratNazev := '';
end;

{-----------------------------------------------------------}
function  TDruhyTextu.VyberDruhu: PDruhTextu;
{$IFDEF WINDOWS}
type
  TBuffer = record
     Col: PStrCollection;
     Sel: array[0..30] of char;
  end;

var
  VyberDlg: PHelpDialog;
  Buffer  : TBuffer;
  PomChr  : array[0..30]of char;
  Combo   : PComboBox;
  Kod,
  Code    : integer;

  procedure ZaradNazevDoVyberu(P: PDruhTextu); far;
  var
    PomS: String;
  begin
    Str(P^.Druh,PomS);
    StrPCopy(PomChr, P^.Nazev + ' <'+ PomS + '>');
    Buffer.Col^.Insert(StrNew(PomChr));
  end;

const
  id_Combo = 101;

begin
  { pro Windows by se mohla tahle metoda asi vyhodit uplne !
  Myslim ze NE!!!!!    KV 11.1.1995}
  VyberDruhu := nil;
  NactiDruhyZeSouboru;
  New(VyberDlg, Init(Application^.MainWindow, 'VyberDruhuTextu', dg_VyberDruhuTextu));
  New(Combo, InitResource(VyberDlg, id_Combo, 31));
  New(Buffer.Col, Init(4,4));
  ForEach(@ZaradNazevDoVyberu);
  if (Buffer.Col <> nil) and (Buffer.Col^.Count > 0) then
  begin
    StrCopy(Buffer.Sel, PChar(Buffer.Col^.At(0)));
    VyberDlg^.TransferBuffer:= @Buffer;
    if Application^.ExecDialog(VyberDlg) = id_OK then
    begin
      StrCopy(PomChr, AnsiNext(StrScan(Buffer.Sel, '<')));
      StrPCopy(PomChr, BezVnejsichMezer(DejStrPoZnak(StrPas(PomChr), '>')));
      val(PomChr, Kod, Code);
      VyberDruhu:= VratDruhDleKodu(Kod);
    end;
  end
  else
    MessageBeep(mb_IconExclamation);
end;

{$ELSE}
var
  Vyber : TVyber;
  PD    : pointType;
  PolozkaPtr: TPolozkaPtr;
  Kod   : integer;
  EscDone, VyberKodem: boolean;
  PomStr: String;
  PomInt: integer;

  { Lokalni procedury }
  {............................................}
  procedure ZaradNazevDoVyberu(P: PDruhTextu); far;
  var
    PomS: String;
  begin
    if P^.Nazev = '' then
    begin
       Str(P^.Druh,PomS);
       PomS := '<'+ PomS + '>';
    end
    else PomS := P^.Nazev;
    if Vyber.OKVytvorPolozku then
    begin
       Vyber.VlozTx (PomS);
       Vyber.ZaradPolozku;
    end;
  end;
  {............................................}

{ Main (TDruhyTextu.VyberDuhu) }
begin
  NactiDruhyZeSouboru;
  Vyber.Init;
  ForEach(@ZaradNazevDoVyberu);
  with Vyber do
  begin
    SrovnejPolozky;
    DejPD (StavLH, PD);
    NovyPort (StavLH, PD);
    UlozBitMapDoHeapu;
    Zaramuj;
    VymazOkno;
    Nastav1Polozku;
    PisStranuTx;
    Nastav1Polozku;
    RozsvitPolozku;

    Dialog1;

    PolozkaPtr:= VybranaPolozkaPtr;

    if (PolozkaPtr = nil) or (PolozkaPtr^.Tx = '') then
       VyberDruhu := nil
    else
    begin
      if (PolozkaPtr^.Tx[1] = '<') then
      begin
         PomStr := Copy(PolozkaPtr^.Tx,2,Length(PolozkaPtr^.Tx)-2);
         Val(PomStr,Kod,PomInt);
         VyberDruhu := VratDruhDleKodu(Kod);
      end
      else
      begin
         VyberDruhu := VratDruhDleNazvu(PolozkaPtr^.Tx);
      end;

    end;

    CtiBitMapZHeapu;
    Done;
  end;
end; { TDruhyTextu.VyberDruhu }
{$ENDIF}

{----------------------------------------------------------}
procedure     TDruhyTextu.Chyba(Jaka: word; Dodatek: String);
{$IFDEF WINDOWS}
var
  Retezec1: array[0..255]of char;
{$ENDIF}
begin
  case Jaka of

     { Nelze otevrit soubor textovych stylu }
     { ------------------------------------ }
     errCannotOpenTextStyles :
     begin
{$IFDEF WINDOWS}
        {!!!!!!!!!!!!!!!!}
        LoadString(HInstance, 8002, Retezec1, 256);
        NastavMessage(ZobMessage, StrPas(Retezec1)+Dodatek+' !' )
        { Nelze otevrit soubor textovych stylu }
{$ELSE}
        Hlaska('@@@ Nelze otevrit soubor '+ Dodatek);
{$ENDIF}
     end;
     errOutOfMemory:
     begin
     end;
  end;
end;

{$IFDEF WINDOWS}
procedure TDruhyTextu.NastavZobMessage(aZobMessage: PZobMessage);
begin
  ZobMessage:= aZobMessage;
end;
{$ENDIF}



{----------------------------------------------------------}


{
  **********************************************************
  *                                                        *
  *               Tela metod TCteniDruhuTextu              *
  *                                                        *
  **********************************************************
}

function  TCteniDruhuTextu.CtiDruhKodem(Kod: longInt): PDruhTextu;
var
  DT: PDruhTextu;
  JeToParametr,
  JeToInfo,
  PosledniRadek: boolean;
  NazevParametru,
  HodnotaParametru: string;

begin
  new(DT);
  DT^.SilaPera := 0.01;

  { Nacitame Druh s konkretnim kodem - ten se musi ovsem nejdriv najit }
  { ------------------------------------------------------------------ }
  if longBool(Kod) then
  begin
     DT^.Druh := -1;
     repeat
        { Hledam Druh }
        { ----------- }
        if NajdiDalsiDruh then
        begin
           { Kontrola kodu }
           { ------------- }
           repeat
              DejRadek ( JeToParametr, JeToInfo, PosledniRadek,
                         NazevParametru, HodnotaParametru);
              if JeToParametr and (NazevParametru = txtNazev) then
                 DT^.Nazev :=  HodnotaParametru;
           until (JeToParametr and (NazevParametru = txtDruh)) or PosledniRadek;
           if not PosledniRadek then DT^.Druh := DejLongIntParametr ;
        end
        else
           PosledniRadek := Ano;
     until (DT^.Druh = Kod) or PosledniRadek ;
     if PosledniRadek then
     begin
        { Zadny takovy druh tady nikdy nebyl }
        { ---------------------------------- }
        dispose(DT);
        CtiDruhKodem := nil;
        exit;
     end;
  end;
  { Vlastni nacitani druhu }
  { ---------------------- }
  repeat
     DejRadek ( JeToParametr, JeToInfo, PosledniRadek,
                NazevParametru, HodnotaParametru);
     { Druh }
     { ---- }
     if JeToParametr and (NazevParametru = txtDruh) then
        DT^.Druh :=  DejLongIntParametr
     else
     { Nazev }
     { ----- }
     if JeToParametr and (NazevParametru = txtNazev) then
        DT^.Nazev :=  HodnotaParametru
     else
     { Rezim }
     { ----- }
     if JeToParametr and (NazevParametru = txtRezim) then
     begin
        VexlujRezim(HodnotaParametru,DT^.RezimTextu);
     end
     else
     { Font }
     { ---- }
     if JeToParametr and (NazevParametru = txtFont) then
        DT^.Font := DejIntParametr
     else
     { Vyska }
     { ----- }
     if JeToParametr and (NazevParametru = txtVyska) then
        DT^.Vyska := DejRealParametr
     else
     { Sirka }
     { ----- }
     if JeToParametr and (NazevParametru = txtSirka) then
        DT^.KoefSirky := DejRealParametr
     else
     { Sklon }
     { ----- }
     if JeToParametr and (NazevParametru = txtSklon) then
        DT^.Sklon := DejRealParametr
     else
     { Rozestupy }
     { --------- }
     if JeToParametr and (NazevParametru = txtRozestupy) then
        DT^.Rozestupy := DejRealParametr
     else
     { Barva }
     { ----- }
     if JeToParametr and (NazevParametru = txtBarva) then
        DT^.Barva := DejIntParametr
     else
     { DruhCary }
     { -------- }
     if JeToParametr and (NazevParametru = txtDruhCary) then
        DT^.DruhCary := DejIntParametr
     else
     { SilaPera }
     { -------- }
     if JeToParametr and (NazevParametru = txtSilaPera) then
        DT^.SilaPera := DejRealParametr;

  until JeToInfo and (HodnotaParametru = txtEnd);

  if (DT^.Druh > -1)  then
     CtiDruhKodem := DT
  else
  begin
     CtiDruhKodem := nil;
     dispose(DT);
  end;
end;

{-----------------------------------------------------------}
function  TCteniDruhuTextu.CtiDruhNazvem(ANazev: TNazevDruhu): PDruhTextu;
var
  DT: PDruhTextu;
  JeToParametr,
  JeToInfo,
  PosledniRadek: boolean;
  NazevParametru,
  HodnotaParametru: string;

begin
  new(DT);
  DT^.SilaPera := 0.01;
  { Nacitame Druh s konkretnim nazev - ten se musi ovsem nejdriv najit }
  { ------------------------------------------------------------------ }
  if ANazev <> '' then
  begin
     DT^.Nazev := 'PWGDRK NGDRTX';
     repeat
        { Hledam Druh }
        { ----------- }
        if NajdiDalsiDruh then
        begin
           { Kontrola Nazvu }
           { -------------- }
           repeat
              DejRadek ( JeToParametr, JeToInfo, PosledniRadek,
                         NazevParametru, HodnotaParametru);
              if JeToParametr and (NazevParametru = txtDruh) then
                 DT^.Druh :=  DejLongIntParametr;
           until (JeToParametr and (NazevParametru = txtDruh)) or PosledniRadek;
           if not PosledniRadek then DT^.Nazev := HodnotaParametru;
        end
        else
           PosledniRadek := Ano;
     until (DT^.Nazev = ANazev) or PosledniRadek ;
     if PosledniRadek then
     begin
        { Zadny takovy Nazev tady nikdy nebyl }
        { ---------------------------------- }
        dispose(DT);
        CtiDruhNazvem := nil;
        exit;
     end;
  end;
  { Vlastni nacitani druhu }
  { ---------------------- }
  repeat
     DejRadek ( JeToParametr, JeToInfo, PosledniRadek,
                NazevParametru, HodnotaParametru);
     { Druh }
     { ---- }
     if JeToParametr and (NazevParametru = txtDruh) then
        DT^.Druh := DejLongIntParametr
     else
     { Nazev }
     { ----- }
     if JeToParametr and (NazevParametru = txtNazev) then
        DT^.Nazev :=  HodnotaParametru
     else
     { Rezim }
     { ----- }
     if JeToParametr and (NazevParametru = txtRezim) then
     begin
        VexlujRezim(HodnotaParametru,DT^.RezimTextu);
     end
     else
     { Font }
     { ---- }
     if JeToParametr and (NazevParametru = txtFont) then
        DT^.Font := DejIntParametr
     else
     { Vyska }
     { ----- }
     if JeToParametr and (NazevParametru = txtVyska) then
        DT^.Vyska := DejRealParametr
     else
     { Sirka }
     { ----- }
     if JeToParametr and (NazevParametru = txtSirka) then
        DT^.KoefSirky := DejRealParametr
     else
     { Sklon }
     { ----- }
     if JeToParametr and (NazevParametru = txtSklon) then
        DT^.Sklon := DejRealParametr
     else
     { Rozestupy }
     { --------- }
     if JeToParametr and (NazevParametru = txtRozestupy) then
        DT^.Rozestupy := DejRealParametr
     else
     { Barva }
     { ----- }
     if JeToParametr and (NazevParametru = txtBarva) then
        DT^.Barva := DejIntParametr
     else
     { DruhCary }
     { -------- }
     if JeToParametr and (NazevParametru = txtDruhCary) then
        DT^.DruhCary := DejIntParametr
     else
     { SilaPera }
     { -------- }
     if JeToParametr and (NazevParametru = txtSilaPera) then
        DT^.SilaPera := DejRealParametr;

  until JeToInfo and (HodnotaParametru = txtEnd);

  if (DT^.Druh > -1)  then
     CtiDruhNazvem := DT
  else
  begin
     CtiDruhNazvem := nil;
     dispose(DT);
  end;
end;

{-----------------------------------------------------------}
function  TCteniDruhuTextu.DejIntParametr: Integer;
var
  CtiR: TCtiRadek;

begin
  CtiR.Init(Hodnota);
  DejIntParametr:= CtiR.DejInteger;
  CtiR.Done
end;

{-----------------------------------------------------------}
function  TCteniDruhuTextu.NajdiDalsiDruh: boolean;
var
  JeToParametr,
  JeToInfo,
  PosledniRadek: boolean;
  NazevParametru,
  HodnotaParametru: string;
begin
  PosledniRadek := Ne;
  repeat
     DejRadek ( JeToParametr, JeToInfo, PosledniRadek,
                NazevParametru, HodnotaParametru);
  until (JeToInfo and (HodnotaParametru = txtStyl)) or (PosledniRadek);
  NajdiDalsiDruh := not PosledniRadek;
end;

{-----------------------------------------------------------}
procedure TCteniDruhuTextu.VexlujRezim(Hodn: String; var RT: TRezimTextu);
begin
  if UpStr(Hodn) = 'M' then RT := Meritkove
  else
  if UpStr(Hodn) = 'D' then RT := Relativne
  else
  if UpStr(Hodn) = 'S' then RT := Absolutne
  else
  RT := Relativne;
end;

{-----------------------------------------------------------}
procedure     TCteniDruhuTextu.Chyba(Jaka: word; Dodatek: String);
{$IFDEF WINDOWS}
var
  Retezec1: array[0..255]of char;
{$ENDIF}
begin
end;

{----------------------------------------------------------}

*)

END.
