unit E_SpaPrp;
{
Created Olda 19970721

}
interface
uses
// KERNEL
  Elements,
  U_Props,
// GLIB
  G_Elems,
// SPACE
  E_Space,
  E_Reg;


Type

  TSpaceEntityProps = class(TOwnerEntity)
  private
    FDone: boolean;
    FSpaceEntity: TSpaceEntity;
  protected
    function   GetSpaceID: longInt; virtual;
    function   GetObjectRegister: TObjectRegister; virtual;
    function   GetBlockRegister: TBlockRegister; virtual;
    function   GetOrigProps: TSpaceEntityProps; virtual;
    function   GetOrigNo: longInt; virtual;
    function   GetBlockName: string; virtual;
  public
    function   HasDBFItem(aItem: string): boolean; virtual;
    function   GetDBFFieldAsString(aItem: string): string; virtual;
    procedure  SetDBFFieldAsString(aItem, aValue: string); virtual;
    function   SetDBFRecord: boolean; virtual;
    function   HasPropertyByName(aName: string): boolean; override;
    procedure  SetPropertyStringByName(AName: string; aValue: string); override;
    function   GetPropertyStringByName(AName: string): string; override;
    function CreateDuplicate: TElement; virtual;
  published
    property SpaceEntity: TSpaceEntity read FSpaceEntity write FSpaceEntity;
    property SpaceID:  longInt read GetSpaceId stored false;
    property OrigNo:   longInt read GetOrigNo stored false;
    property IsDone: boolean   read FDone     write FDone default false;
    property ObjectRegister: TObjectRegister read GetObjectRegister stored false;
    property BlockRegister: TBlockRegister read GetBlockRegister stored false;
    property BlockName: string read GetBlockName stored false;
  end;


implementation



function  TSpaceEntityProps.GetObjectRegister: TObjectRegister;
var
  ObjOwn: TObjectOwner;
begin
  result:= nil;
  if SpaceEntity = nil then exit;
  ObjOwn:= TObjectOwner(SpaceEntity.FindOwnerClass(TObjectOwner));
  if ObjOwn <> nil then
     result:= TObjectRegister(ObjOwn.FindOwnerClass(TObjectRegister))
end;



function   TSpaceEntityProps.GetBlockRegister: TBlockRegister;
var
  ObjReg: TObjectRegister;
begin
  result:= nil;
  ObjReg:= ObjectRegister;
  if ObjReg = nil then exit;
  result:= TBlockRegister(ObjReg.FindOwnerClass(TBlockRegister));
end;


function  TSpaceEntityProps.GetOrigProps: TSpaceEntityProps;
var
  ObjOwn: TObjectOwner;
  origSE: TSpaceEntity;
begin
  result:= nil;
  if SpaceEntity = nil then exit;
  ObjOwn:= TObjectOwner(SpaceEntity.FindOwnerClass(TObjectOwner));
  if ObjOwn = nil then exit;

  if ObjOwn.Count = 1 then
     result:= self
  else
  begin
    origSE:= TSpaceEntity(ObjOwn.Elements[0]);
    if not (TElement(origSE) is TSpaceEntity) then exit;
    result:= TSpaceEntityProps(origSE.Properties)
  end
end;



function  TSpaceEntityProps.GetOrigNo: longInt;
var
  aReg: TObjectRegister;
  ObjOwn: TObjectOwner;
begin
  result:= -1;

  if SpaceEntity = nil then exit;
  ObjOwn:= TObjectOwner(SpaceEntity.FindOwnerClass(TObjectOwner));
  if ObjOwn = nil then exit;
  aReg:= TObjectRegister(ObjOwn.FindOwnerClass(TObjectRegister));
  if aReg = nil then exit;
  result:= aReg.IndexOf(ObjOwn);
end;



function  TSpaceEntityProps.GetBlockName: string;
begin
  result:= '';
  if not (TElement(ObjectRegister) is TObjectRegister) then exit;

  result:= TObjectRegister(ObjectRegister).BlockName;
end;



function TSpaceEntityProps.SetDBFRecord: boolean;
begin
  result:= false
end;


function TSpaceEntityProps.HasDBFItem(aItem: string): boolean;
begin
  result:= false
end;


function  TSpaceEntityProps.HasPropertyByName(aName: string): boolean;
begin
  result:= inherited HasPropertyByName(aName);
  if result then exit;

  try
    if ObjectRegister = nil then exit;
    result:= HasDBFItem(aName)
  except
     result := false;
  end;
end;





function TSpaceEntityProps.GetDBFFieldAsString(aItem: string): string;
begin
  result:= ''
end;


procedure TSpaceEntityProps.SetDBFFieldAsString(aItem, aValue: string);
begin
end;

function   TSpaceEntityProps.GetPropertyStringByName(AName: string): string;
begin
  result:= inherited GetPropertyStringByName(aName);
  if result <> '' then exit;

  try
    if ObjectRegister = nil then
       exit;
    if SetDBFRecord then
       result:= GetDBFFieldAsString(aName);
  except
     result := '';
  end;
end;



procedure   TSpaceEntityProps.SetPropertyStringByName(AName: string; aValue: string);
begin
  if GetPropIndex(Self, aName) > -1 then
  begin
     inherited SetPropertyStringByName(aName, aValue);
     exit;
  end;
  try
    if ObjectRegister = nil then exit;
    if SetDBFRecord then
       SetDBFFieldAsString(aName, aValue);
{    TTopolDBFTable(TTopolObjectRegister(Register).DBF).FieldAsString(aName); }
  except
  end;
end;


function  TSpaceEntityProps.GetSpaceID: longInt;
begin
  result:= -1
end;


function TSpaceEntityProps.CreateDuplicate: TElement;
var
  I, aStart: longInt;
begin
  Result:= TElement(TElementClass(self.ClassType).Create);

  aStart:= GetPropIndex(Self,'LastIndex')+1;

  for I:= aStart to GetPropCount(self)-1 do { misto startovani od nuly }
  begin
    SetPropString(Result, I, GetPropString(self, I))
  end;
end;



end.
