{$D+}
unit E_TplReg;

interface
{$I ..\_conditions.inc}
uses
{$IFNDEF WIN64}
{$IFNDEF NOBDE}
   DBTables,
{$ENDIF}
{$ENDIF}
   DB,
// KERNEL
   Elements,
   e_DataSet,
   E_Type,
// SPACE
   //E_Space,
   E_Reg;

const
  MaxTopolObjectsCount = 500000;

type

TTopolDruh = class(TStringListElement)
end;


TTopolObjectOwner = class(TObjectOwner)
public
  procedure   AddElement(aElement: TElement); override;
end;


TTopolObjectRegister = class(TObjectRegister)
protected
  function CreateObjectOwner: TObjectOwner; override;
{ TODO -oO.S. -cZmeny pro ADO : 11.11.99 }
//  function GetDBF: TTable; override;
  function GetDBF: TDataSetElement; override;
end;


TTopolBlockRegister = class(TBlockRegister)
public
  function GetObjectRegister(aType: char): TObjectRegister; override;
end;

{
TTopolRegister = class(TRegister)
public
  function GetBlockRegister(aName: string): TBlockRegister; override;
end;
}


function GetDBFNameForTopolObject(BlockDir: string; ObjType: char; Druh: smallInt): string;



implementation
uses
  SysUtils, Forms,
// KERNEL
  M_Orbis,
  e_Class,
// TOPOL
  C_TLDBF,
  e_TopoLElements;
  //E_TplPrp;


function GetDBFNameForTopolObject(BlockDir: string; ObjType: char; Druh: smallInt): string;
begin
  Result:= BlockDir + '\' + ObjType + Format('%4.4d', [Druh]) + '.DBF';
end;




               { TTopolObjectOwner }



procedure   TTopolObjectOwner.AddElement(aElement: TElement);
var
  TypStr, CisloStr, DruhStr: string;
  TE: TTopolElement;
begin
  inherited AddElement(aElement);

  { vloen jmna podle prvnho vkldanho elementu }
  if FName <> '' then exit;
  if aElement = nil then exit;

  if not (aElement is TTopoLElement) then exit;

  TE:= TTopolElement(aElement);
  TypStr  := TE.OBJECTTYPE;
  CisloStr:= IntToStr(TE.CISLO);
  DruhStr := IntToStr(TE.DRUH);
  Name:= TypStr + CisloStr + ':' + DruhStr;
end;








                    { TTopolObjectRegister }



function TTopolObjectRegister.CreateObjectOwner;
begin
  result:= TTopolObjectOwner.Create;
end;



function TTopolObjectRegister.GetDBF: TDataSetElement;
begin
  result:= nil;
  if FDBF = nil then
  begin
    FDBF:= TTopolDBFTable.CreateWithOwner(Application);
    FDBF.ReadOnly:= true
  end;
  if FDBF = nil then exit;
  result:= FDBF;
end;



                  { TTopolBlockRegister }



function TTopolBlockRegister.GetObjectRegister(aType: char): TObjectRegister;
begin
  result:= TObjectRegister(FindElementName(aType));
  if result <> nil then exit;
  result:= TTopolObjectRegister.Create;
  result.Name:= aType;
  AddElement(result)
end;




initialization
   RegisterOrbisClass(TTopolObjectOwner);
   RegisterOrbisClass(TTopolObjectRegister);
   RegisterOrbisClass(TTopolBlockRegister);
end.
