unit T_samake;
{
***********************************************************************
**                                                                   **
**  ORBIS ... Enklvovn Topolskch ploch                           **
**                                                                   **
**                       Topol Pro 1996                             **
**                                                                   **
***********************************************************************

TSubAreaMaker je sekvenn technologie, kter Entitu ploch nejprve setd
podle velikosti (TClassByAreaSize) a sice vzestupn. V takto vytvoenm
seznamu vytvo enklvoidn hierarchii (TSAMaker)

CLASS: TSubAreaMaker
INPUT:  TEntita ... inern seznam nesetdnch ploch
OUTPUT: TTopolPlochy ... Strom Ploch s Enklvami
}

interface
uses
// KERNEL
   Elements,
   Tools,
// SPACE
   e_Geometry,
   //e_Space,
   e_QTree,
// SPACETOOL
   T_ToTool;

type

(*
TClassByAreaSize = class(TTool)
private
   procedure Zarad(Poc, Kon: longInt; anArea: TPolyLineAreaElement);
   procedure AddToOutput(AnArea: TPolyLineAreaElement);
public
   procedure DoIt; override;
end;

TQClassByAreaSize = class(TTool)
public
   procedure DoIt; override;
end;

*)
{
TSAMaker = class(TTool)
private
   procedure FindFather(aIndex: longInt; anArea: TPolyLineAreaElement);
public
   procedure DoIt; override;
end;

TSubAreaMaker = class(TSeqTechnology)
public
   constructor Create; override;
end;
}

TSubAreaMakerInQTree = class(TProchazecPlochGauge)
// zarazuje diry do ploch. Diry jsou plochy se zapornym znaminkem
private
  FQTree: TRectEntityQTree;
public
   procedure Process(Element: TElement); override;
   procedure DoIt; override;
published
  property AreaQTree: TRectEntityQTree read FQTree write FQTree;
end;



implementation

uses
   SysUtils, Dialogs, Forms, Controls,
// KERNEL
   e_Class,
   U_String,
// GLIB
   AnalInt,
   g_Elems,
// DIALOG
   //F_Gauge,
// SPACETOOL
   T_Topol;
(*

{ TClassByAreaSize }

procedure TClassByAreaSize.Zarad(Poc, Kon: longInt; anArea: TPolyLineAreaElement);
var
  I: longInt;
begin
  if AnArea.WholeArea < TPolyLineAreaElement(TEntity(OutPut).Elements[Poc]).WholeArea then
  begin
    TEntity(OutPut).InsertElement(Poc, AnArea);
    exit;
  end;

  if Kon-Poc < 20 then
  begin
      for i := Poc to Kon do
      begin
         if AnArea.WholeArea < TPolyLineAreaElement(TEntity(OutPut).Elements[i]).WholeArea then
         begin
            TEntity(OutPut).InsertElement(i, AnArea);
            exit;
         end;
      end
  end
  else
  if AnArea.WholeArea < TPolyLineAreaElement(TEntity(OutPut).Elements[(Poc + Kon) div 2]).WholeArea then
     Zarad(Poc+1, (Poc + Kon) div 2, AnArea)
  else
     Zarad((Poc + Kon) div 2 + 1, Kon, AnArea)
end;



procedure TClassByAreaSize.AddToOutput(AnArea: TPolyLineAreaElement);
var
   E: TEntity;
begin
   E := TEntity(Output);
   if E.NoElements then E.AddElement(AnArea)
   else
   begin
      if AnArea.WholeArea > TPolyLineAreaElement(E.Elements[E.Count - 1]).WholeArea then
      begin
         E.AddElement(AnArea);
         exit;
      end;

      Zarad(0, E.Count-1, anArea);
{
      for i := 0 to E.Count - 1 do
      begin
         TP := TPolyLineAreaElement(E.Elements[i]);
         if AnArea.Area < TP.Area then
         begin
            E.InsertElement(i, AnArea);
            exit;
         end;
      end;
}
   end;
end;


procedure TClassByAreaSize.DoIt;
var
   InEntity: TEntity;
   TP: TPolyLineAreaElement;
   i: longInt;
   Gauge: TF_gaugeForm;
begin
   Output := TEntity.Create;
   InEntity := TEntity(Input);
   if not assigned(InEntity) then exit;

   Application.CreateForm(TF_GaugeForm, Gauge);
   Gauge.MaxValue:= InEntity.Count;
   Gauge.Show;

   for i := 0 to InEntity.Count - 1 do
   begin
{      if (i mod 10) = 0 then }
      begin
        Gauge.Progress:= I;
        Gauge.Caption:= 'Tdn ploch pro zaazovn enklv: ' + IntToStr(I);
        Application.ProcessMessages
      end;

      TP := TPolyLineAreaElement(InEntity.Elements[i]);
{      TP.Pater := -1; }
      AddToOutput(TP);
   end;

   Gauge.Free;
   TEntity(Input).Free;
end;



procedure TQClassByAreaSize.DoIt;
var
   InEntity: TEntity;
   i: longInt;
   Gauge: TF_gaugeForm;
//   anArea: double;

   procedure QuickSort(aEnt: TEntity; iLo, iHi: longInt);
   var
     Lo, Hi: longInt;
     MidAr: double;
     T: TPolyLineAreaElement;
   begin
     Lo := iLo;
     Hi := iHi;
     MidAr := TPolyLineAreaElement(aEnt.Elements[(Lo + Hi) div 2]).SavedArea;
     repeat
       while TPolyLineAreaElement(aEnt.Elements[Lo]).SavedArea < MidAr do
             Inc(Lo);
       while TPolyLineAreaElement(aEnt.Elements[Hi]).SavedArea > MidAr do
             Dec(Hi);
       if Lo <= Hi then
       begin
         T := TPolyLineAreaElement(aEnt.Elements[Lo]);
         aEnt.Elements[Lo] := aEnt.Elements[Hi];
         aEnt.Elements[Hi] := T;
         Inc(Lo);
         Dec(Hi);

         Gauge.Progress:= Lo;
         Gauge.Caption:= 'Tdn ploch pro zaazovn enklv: ' + IntToStr(Lo)+
                         ' ' + IntToStr(Hi);
         Application.ProcessMessages
       end;
     until Lo > Hi;
     try
     if Hi > iLo then
        QuickSort(aEnt, iLo, Hi);
     except
     end;
     try
     if Lo < iHi then
        QuickSort(aEnt, Lo, iHi);
     except
     end;
{     if Terminated then Exit; }
   end;


begin
   Output := TEntity.Create;
   InEntity := TEntity(Input);
   if not assigned(InEntity) then exit;

   Application.CreateForm(TF_GaugeForm, Gauge);
   Gauge.MaxValue:= InEntity.Count;
   Gauge.Show;

   for I:= 0 to InEntity.Count-1 do
   begin
//     anArea:= TPolyLineAreaElement(InEntity.Elements[I]).SavedArea;
     Gauge.Progress:= I;
     Gauge.Caption:= 'Nastaven ploch pro zaazovn enklv: ' + IntToStr(I);
     Application.ProcessMessages
   end;

   Gauge.MaxValue:= InEntity.Count;
   try
     QuickSort(InEntity, 0, InEntity.Count - 1);
   except
   end;
   Gauge.Free;
   Output:= Input
end;
*)

(*
{ TSAMaker }

procedure  TSAMaker.FindFather(aIndex: longInt; anArea: TPolyLineAreaElement);
var
   i: longInt;
   TP: TPolyLineAreaElement;
   B: TAreaElement;
   Coord: T2DCoordinate;
begin
   Coord := T2DCoordinate.Create;
   for i := aIndex + 1 to TEntity(Input).Count - 1 do
   begin
      TP := TPolyLineAreaElement(TEntity(Input).Elements[i]);
      try
        if  anArea.IsInsideRegion(TP.MinX, TP.MinY, TP.MaxX, TP.MaxY) then
        begin
           B := TP.CreateAreaElement;
           Coord.x := anArea.X;
           Coord.y := anArea.Y;
           if InsideTest(B, Coord) then
           begin
{              anArea.Pater := 1; }
{
              TP.AddArea(anArea);
}
              B.Free;
              Coord.Free;
              Exit;
           end;
           B.Free;
        end;
        Application.ProcessMessages
     except
       on E:Exception do
       begin
          ShowMessage(E.Message);
          Screen.Cursor:= crDefault;
       end
     end
   end;
   Coord.Free;
end;


procedure TSAMaker.DoIt;
var
   E: TEntity;
   TP: TPolyLineAreaElement;
   i: longInt;
   P: TUkladacPloch;
   Gauge: TF_gaugeForm;
begin
    E := TEntity(Input);
    Application.CreateForm(TF_GaugeForm, Gauge);
    Gauge.Gauge.MaxValue:= E.Count;
    Gauge.Show;
    for i := 0 to E.Count - 2 do
    begin
      if (i mod 10) = 0 then
      begin
        Gauge.Gauge.Progress:= I;
        Gauge.Caption:= 'Zaazovn enklv ' + IntToStr(I);
        Application.ProcessMessages
      end;

      TP := TPolyLineAreaElement(E.Elements[i]);
      FindFather(i, TP);
    end;

    { pesypn do TTopolPlochy }
    P := TUkladacPloch.Create;
    Output := P;
    for i := 0 to E.Count - 1 do
    begin
       TP := TPolyLineAreaElement(E.Elements[i]);
{       if TP.Pater = -1 then P.AddAndUpdateRect(TP); }
       Application.ProcessMessages
    end;

    Gauge.Free;
    E.Free;
end;

{ TSubAreaMaker }

constructor TSubAreaMaker.Create;
begin
  inherited Create;
   Addtool(TQClassByAreaSize.Create);
   Addtool(TSAMaker.Create);
end;

*)

             { TSubAreaMakerInQTree }





procedure TSubAreaMakerInQTree.Process(Element: TElement);
var
  aHole, anArea, OverArea: TAreaElement;
  QTW: TQTreeWalker;
  aHole_A, anArea_A, OverArea_A: double;
begin
  if not (Element is TAreaElement) then exit;
  aHole:= TAreaElement(Element);

  inc(FPocetPloch);
  GaugeSet(FPocetPloch);
{
  GaugeCaption:= 'SAMIQ:' + DoubleToStr(aHole.Xi[0], 11, 2) + ' ' + DoubleToStr(aHole.Yi[0],12, 2) +
                 ' ' + IntToStr(FPocetPloch);
}

  if aHole.IsDone then exit;
  if not aHole.IsHole then exit;

  { nalezen seznamu ploch pekrvajcch Plochu,
    Nalezne se ta nejmen, ve kter se nachzme }
  QTW:= TQTreeWalker.Create;
  anArea:= TAreaElement(QTW.GetFirstElementForRectangle(FQTree,
                        aHole.Xi[0], aHole.Yi[0], aHole.Xi[0], aHole.Yi[0], 0));
  OverArea:= nil;
  OverArea_A := 0;
  while anArea <> nil do
  begin
    if not anArea.IsHole then
    begin
      if anArea.RegionIsInside(aHole.MinX, aHole.MinY, aHole.MaxX, aHole.MaxY) then
      begin
        anArea_A := anArea.FixedArea;
        aHole_A := aHole.FixedArea;
        if (anArea_A > {- tady bylo minus?}aHole_A) then
        begin
          if  aHole.IsIsolatedFrom(anArea) then
          begin
            if  anArea.XYIsInside(aHole.Xi[0], aHole.Yi[0]) then
            begin
              if OverArea = nil then
              begin
                 OverArea:= anArea;
                 OverArea_A := anArea_A;
              end
              else
              begin
                if OverArea_A > anArea_A then
                begin
                   OverArea:= anArea;
                   OverArea_A := anArea_A;
                end;
              end
            end { 1.bod dry le uvnit plochy }
          end { dra nem s plochou spolenou linii }
        end  { obdlnk dry le uvnit anArey }
      end; { anArea je vt ne dra }
    end; { anArea nen dra}
    anArea:= TAreaElement(QTW.GetNextElement);
    Application.ProcessMessages
  end;
  QTW.Free;
  if OverArea <> nil then
     OverArea.AddHole(aHole);

  aHole.IsDone:= true
end;


procedure TSubAreaMakerInQTree.DoIt;
begin
  if not (input is TRectEntityQTree) then exit;
  AreaQTree:= TRectEntityQTree(input);
  inherited DoIt
end;



initialization
   RegisterOrbisClass(TSubAreaMakerInQTree);
end.

