unit TrTab;

interface

uses {$IFDEF Delphi} Messages, {$ENDIF}
     WinTypes, Objects, ODialogs, OWindows,
     StrProc, TranType;

const
  id_DalsiIdB   = 104;
  id_OpravIdB   = 110;

type
  TTypIdBodu = (Transformacni, Kontrolni, Pasivni);

{ **************************************************************************************** }

  PIdBod = ^TIdBod;
  TIdBod = object(TObject)

    Cislo: integer;
    cX, cY, cZ,
    zX, zY, zZ,
    OdchX, OdchY, OdchZ: extended;
    Vaha: extended;
    Poznamka: TPoznamka;
    TypIdBodu: TTypIdBodu;
    Rastr: boolean;

    constructor Init(aCislo: integer; aRastr: boolean);
    destructor  Done; virtual;
    procedure   VlozCilSour(acX, acY, acZ: double);
    procedure   VlozZdrSour(azX, azY, azZ: double);
    procedure   VlozVahu(aVaha: double);
    procedure   VlozPoznamku(aPoznamka: TPoznamka);
    procedure   VlozTypIdBodu(aTypIdBodu: TTypIdBodu);
    procedure   KresliCilSourBod(DCh: HDC; P: PWindowsObject);
    procedure   KresliZdrSourBod(DCh: HDC; P: PWindowsObject);
    procedure   KresliCilSourBMPBod(DCh: HDC; P: PWindowsObject);
    procedure   KresliZdrSourBMPBod(DCh: HDC; P: PWindowsObject);
  end;

{ **************************************************************************************** }

  PIdBodCollection = ^TIdBodCollection;
  TIdBodCollection = object(TCollection)

    procedure FreeItem(Item: Pointer); virtual;
    procedure KresliCilSourCol(DCh: HDC; P: PWindowsObject);
    procedure KresliZdrSourCol(DCh: HDC; P: PWindowsObject);
    procedure KresliCilSourBMPCol(DCh: HDC; P: PWindowsObject);
    procedure KresliZdrSourBMPCol(DCh: HDC; P: PWindowsObject);
  end;

{ **************************************************************************************** }


function TransformacniTabulka(
                                  aRastr: boolean;
                              var aBodColl: PIdBodCollection;
                              var aTransformace: pointer;
                              var aNazevTransformace: TNazevTran;
                              var aJmenoTrTab, aOldName: TPathStr): integer;

{ **************************************************************************************** }

var
  CisAktIdBodu: integer;

const
  Dimenze: byte = 2;

{ **************************************************************************************** }

procedure DejBufferAPocet(
                              BodColl      : PIdBodCollection;
                          var PPtr         : PExtVector;
                          var PocetTrIdBodu: longInt);

procedure DisposeBuffer(
                        var PPtr         : PExtVector;
                            PocetTrIdBodu: longInt);

function PrectiTransfTabulku(var BodColl: PIdBodCollection; const JmTrTab: TPathStr;
                            var NazevTransformaceIdB: TNazevTran): boolean;

function NactiRohy(
                   const JmenoSouboruROH          : TPathStr;
                   var   MinSRadkuN, MinSSloupcuN,
                         MaxSRadkuN, MaxSSloupcuN,
                         CRadkuN, CSloupcuN       : extended;
                   var   RadkuN, SloupcuN         : word): boolean;


implementation

uses WinProcs, Strings, WinDos, {$IFNDEF BezBWCC}BWCC, {$ENDIF BezBWCC}
     MatProc, FilProc, NadGraph, PomTypy,
     DialInc, Help_Dlg, Hlasky, CtiRadek,
     RasOpDLL, EditGlob,
     TopolInc, PomDlg,
     RasMNDll,
     VektoOkn;


const
  id_OwDr       = 101;
  id_TypTr      = 102;
  id_VypTrKl    = 103;
  id_VymazIdB   = 105;
  id_VymazVsIdB = 106;
  id_VypniIdB   = 107;
  id_ZapniIdB   = 108;
  id_EditujIdB  = 109;
  id_IdB        = 111;
  id_JmTrTab    = 112;
  id_ScBV       = 113;
  id_ScBH       = 114;
  id_PopisCIdB  = 115;
  id_Nahoru     = 312;
  id_Dolu       = 313;

  id_Cislo      = 101;
  id_Poznamka   = 102;
  id_Vaha       = 103;
  id_X          = 105;
  id_Y          = 104;
  id_Z          = 106;
  id_U          = 107;
  id_V          = 108;
  id_W          = 109;

{ **************************************************************************************** }

type
  PEditCisIdB = ^TEditCisIdB;
  TEditCisIdB = object(TPraEdit)

    BodColl: PIdBodCollection;

    function  IsValid: boolean; virtual;
  end;

{ **************************************************************************************** }

  PEditIdB2D = ^TEditIdB2D;
  TEditIdB2D = object(THelpDialog)

    EdPoznamka: PEdit;
    EdVaha: PEditVahu;
    EdX, EdY, EdU, EdV: PEditCislo;

    Cislo: integer;
    Poznamka: ^TPoznamka;
    Vaha, X, Y, U, V: ^Extended;

    constructor Init(const aParent: PWindowsObject; aCislo: integer;
                     var aPoznamka: TPoznamka;
                     var aVaha, aX, aY, aV, aU: extended);
    procedure   SetUpWindow; virtual;
    procedure   DefWndProc(var Msg: TMessage); virtual;
    function    CanClose: boolean; virtual;
  end;

{ **************************************************************************************** }

  PEditIdB3D = ^TEditIdB3D;
  TEditIdB3D = object(TEditIdB2D)

    EdZ, EdW: PEditCislo;

    Z, W: ^Extended;

    constructor Init(const aParent: PWindowsObject;
                     aCislo: integer; var aPoznamka: TPoznamka;
                     var aVaha, aX, aY, aZ, aV, aU, aW: extended);
    procedure   SetUpWindow; virtual;
    procedure   DefWndProc(var Msg: TMessage); virtual;
    function    CanClose: boolean; virtual;
  end;

{ **************************************************************************************** }

  TComboData = record
    Typy: PPomColl;
    Vybrany: TNazevTran;
  end;

{ **************************************************************************************** }

  PTrTab = ^TTrTab;
  TTrTab = object(THelpDialog)

    BodColl: PIdBodCollection;
    Transformace: pointer;
    NazevTransformace: ^TNazevTran;
    JmenoTrTab, OldName: ^TPathStr;

    constructor Init(aRastr: boolean; var aBodColl: PIdBodCollection;
                     var aTransformace: pointer; var aNazevTransformace: TNazevTran;
                     var aJmenoTrTab, aOldName: TPathStr);
    destructor  Done; virtual;
    procedure   SetUpWindow; virtual;
    procedure   DefWndProc(var Msg: TMessage); virtual;
    function    CanClose: boolean; virtual;

    procedure   WMOwnerDraw(var Msg: TMessage);
      virtual wm_First + wm_DrawItem;
    procedure   WMClickTrTab(var Msg: TMessage);
      virtual wm_First + wm_ClickTrTab;
    procedure   WMDblClickTrTab(var Msg: TMessage);
      virtual wm_First + wm_DblClickTrTab;

    procedure   Cancel(var Msg: TMessage);
      virtual id_First + id_Cancel;
    procedure   WMCommand(var Msg: TMessage); virtual wm_Command;
    procedure   WMNovyIdB(var Msg: TMessage);
      virtual wm_First + wm_NovyIdB;

    procedure   WMVypoctiTrKlic;

    procedure   WMDalsiIdB;
    procedure   WMVymazIdB;
    procedure   WMVymazVsIdB;
    procedure   WMVypniIdB;
    procedure   WMZapniIdB;
    procedure   WMEditujIdB;
    procedure   WMOpravIdB;
    procedure   WMScBH(var Msg: TMessage);
      virtual id_First + id_ScBH;
    procedure   WMScBV(var Msg: TMessage);
      virtual id_First + id_ScBV;
(*
    procedure   WMScBH;
    procedure   WMScBV;
*)
    procedure   WMNahoru;
    procedure   WMDolu;

  private
    Rastr: boolean;

    CBTypTr: PComboBox;
    EdJmTrTab: PEdit;
    EdCisIdB: PEditCisIdB;
    RBOwDr: POwnDraw;
    ScBH, ScBV: PScrollBar;

    OldyPos, yPos, OldxPos, xPos, MaxLen: integer;

    Size: record
            Width, Height: integer;
          end;
    Obdelnik: TRect;
    Delka, Vyska: integer;

    CCislo: array[0..9] of char;
    CPoznamka, CcX, CcY, CcZ, CzX, CzY, CzZ, COdchX, COdchY, COdchZ: TPoznamka;
    CVaha: array[0..7] of char;

    CPodobn_2D, CAfinn__2D, CKolin__2D, CPodobn_3D, CAfinn__3D, CKolin__3D,
    C2_ST_POL_, C3_ST_POL_: TNazevTran;

    mX, mY, mZ, mP: double;

    ComboData: TComboData;

    procedure NastavCisIdB;
    procedure Kresli(DC: HDC);
    procedure KresliZapnuti(DC: HDC; CisloRad: integer; TypIdBodu: TTypIdBodu);
    procedure KresliRamecekAktIdBodu(DC: HDC);
    procedure EditujAktIdBod;
    procedure VypniAktIdBod;
    procedure ZapniAktIdBod;

    procedure VypoctiTrKlic;
    procedure VyplneniOdchylek;
    procedure VypocetOdchylek;
    procedure ZapisDoSouboru;
  end;

{ **************************************************************************************** }

constructor TIdBod.Init(
                        aCislo: integer;
                        aRastr: boolean);
begin
  inherited Init;
  Cislo := aCislo;
  cX    := 0;
  cY    := 0;
  cZ    := 0;
  zX    := 0;
  zY    := 0;
  zZ    := 0;
  OdchX := 0;
  OdchY := 0;
  OdchZ := 0;
  Vaha  := 1;
  StrPCopy(Poznamka, LStr(Cislo));
  TypIdBodu := pasivni;
  Rastr     := aRastr;
end;


procedure TIdBod.VlozCilSour(
                             acX, acY, acZ: double);
begin
  cX := acX;
  cY := acY;
  cZ := acZ;
end;

procedure TIdBod.VlozZdrSour(
                             azX, azY, azZ: double);
begin
  zX := azX;
  zY := azY;
  zZ := azZ;
end;

procedure TIdBod.VlozVahu(
                          aVaha: double);
begin
  Vaha := aVaha;
end;

procedure TIdBod.VlozPoznamku(
                              aPoznamka: TPoznamka);
begin
  StrCopy(Poznamka, aPoznamka);
end;

procedure TIdBod.VlozTypIdBodu(
                               aTypIdBodu: TTypIdBodu);
begin
  TypIdBodu := aTypIdBodu;
end;

procedure TIdBod.KresliCilSourBod(
                                  DCh: HDC; P: PWindowsObject);
var
  Sour: TSour;
  Bod: TPoint;
  OldColor: TColorRef;
begin
  if TypIdBodu = Transformacni then
  begin
    with Sour do
      if Rastr then
        case SourSystem of
          JTSK,
          Gauss      : begin
                         Y := cY;
                         X := cX;
                       end;
          Matematicky: begin
                         X := cY;
                         Y := cX;
                       end;
        end
      else
      begin
        Y := cY;
        X := cX;
      end;

    with PVektorOkno(P)^ do
      if BodVObdelniku(Sour, RozmerJTSK, 10*kHoriz) then
      begin
        SourNaObrBod(Sour, Bod);

        KresliBodZnackou(DCh, Bod.X, Bod.Y, 6, 1, RGB($FF, $00, $00));
        SetTextAlign(DCh, ta_Bottom or ta_Left);
        OldColor  := SetTextColor(DCh, RGB($FF, $00, $00));
        TextOut(DCh, Bod.X+3, Bod.Y-3, Poznamka, StrLen(Poznamka));
        SetTextColor(DCh, OldColor);
      end;
  end;
end;

procedure TIdBod.KresliZdrSourBod(
                                  DCh: HDC; P: PWindowsObject);
var
  Sour: TSour;
  Bod: TPoint;
  OldColor: TColorRef;
  RastrPtr: pointer;

begin
  if TypIdBodu = Transformacni then
  begin
    if Rastr then
    begin
      RastrPtr:= SRGetAktRastr;

      with Sour do
        case SourSystem of
          JTSK,
          Gauss      : begin
                         Y := (zY-1)*RastObjGetHorzRez(RastrPtr) + RastObjGetMinY(RastrPtr);
                         X := (zX-1)*RastObjGetVertRez(RastrPtr) + RastObjGetMinX(RastrPtr);
                       end;
          Matematicky: begin
                         Y := (zX-1)*RastObjGetVertRez(RastrPtr) + RastObjGetMinY(RastrPtr);
                         X := (zY-1)*RastObjGetHorzRez(RastrPtr) + RastObjGetMinX(RastrPtr);
                       end;
        end
    end
    else
    begin
      Sour.Y := zY;
      Sour.X := zX;
    end;

    with PVektorOkno(P)^ do
      if BodVObdelniku(Sour, RozmerJTSK, 10*kHoriz) then
      begin
        SourNaObrBod(Sour, Bod);

        KresliBodZnackou(DCh, Bod.X, Bod.Y, 12, 1, RGB($00, $00, $00));
        SetTextAlign(DCh, ta_Bottom or ta_Left);
        OldColor := SetTextColor(DCh, RGB($00, $00, $00));
        TextOut(DCh, Bod.X+3, Bod.Y-3, Poznamka, StrLen(Poznamka));
        SetTextColor(DCh, OldColor);
      end;
  end;
end;


procedure TIdBod.KresliCilSourBMPBod(
                                      DCh: HDC;
                                      P: PWindowsObject);
var
  Sour: TSour;
  Bod: TPoint;
  OldColor: TColorRef;

begin
  if TypIdBodu = Transformacni then
  begin
    with Sour do
      if Rastr then
        case SourSystem of
          JTSK,
          Gauss      : begin
                         Y := cY;
                         X := cX;
                       end;
          Matematicky: begin
                         X := cY;
                         Y := cX;
                       end;
        end
      else
      begin
        Y := cY;
        X := cX;
      end;

    with PVektorOkno(P)^ do
      if BodVObdelniku(Sour, RozmerJTSK, 10*kHoriz) then
      begin
        SourNaObrBodPaint(Sour, Bod);

        KresliBodZnackou(DCh, Bod.X, Bod.Y, 6, 1, RGB($FF, $00, $00));
        SetTextAlign(DCh, ta_Bottom or ta_Left);
        OldColor  := SetTextColor(DCh, RGB($FF, $00, $00));
        TextOut(DCh, Bod.X+3, Bod.Y-3, Poznamka, StrLen(Poznamka));
        SetTextColor(DCh, OldColor);
      end;
  end;
end;

procedure TIdBod.KresliZdrSourBMPBod(
                                         DCh: HDC;
                                     P: PWindowsObject);
var
  Sour: TSour;
  Bod: TPoint;
  OldColor: TColorRef;
  RastrPtr: pointer;

begin
  if TypIdBodu = Transformacni then
  begin
    if Rastr then
    begin
      RastrPtr:= SRGetAktRastr;

      with Sour do
        case SourSystem of
          JTSK,
          Gauss      : begin
                         Y := (zY-1)*RastObjGetHorzRez(RastrPtr) + RastObjGetMinY(RastrPtr);
                         X := (zX-1)*RastObjGetVertRez(RastrPtr) + RastObjGetMinX(RastrPtr);
                       end;
          Matematicky: begin
                         Y := (zX-1)*RastObjGetVertRez(RastrPtr) + RastObjGetMinY(RastrPtr);
                         X := (zY-1)*RastObjGetHorzRez(RastrPtr) + RastObjGetMinX(RastrPtr);
                       end;
        end
    end
    else
    begin
      Sour.Y := zY;
      Sour.X := zX;
    end;

    with PVektorOkno(P)^ do
      if BodVObdelniku(Sour, RozmerJTSK, 10*kHoriz) then
      begin
        SourNaObrBodPaint(Sour, Bod);

        KresliBodZnackou(DCh, Bod.X, Bod.Y, 12, 1, RGB($00, $00, $00));
        SetTextAlign(DCh, ta_Bottom or ta_Left);
        OldColor := SetTextColor(DCh, RGB($00, $00, $00));
        TextOut(DCh, Bod.X+3, Bod.Y-3, Poznamka, StrLen(Poznamka));
        SetTextColor(DCh, OldColor);
      end;
  end;
end;

destructor TIdBod.Done;
begin
  inherited Done;
end;

{ **************************************************************************************** }

procedure TIdBodCollection.FreeItem(
                                    Item: Pointer);
begin
  if Item <> nil then
    Dispose(PIdBod(Item), Done);
end;

procedure TIdBodCollection.KresliCilSourCol(
                                            DCh: HDC;
                                            P: PWindowsObject);
  procedure Zobraz(Item: Pointer); far;
  begin    with PIdBod(Item)^ do
      KresliCilSourBod(DCh, P);
  end;

begin
  ForEach(@Zobraz);
end;

procedure TIdBodCollection.KresliZdrSourCol(
                                            DCh: HDC;
                                            P: PWindowsObject);
  procedure Zobraz(Item: Pointer); far;
  begin
    with PIdBod(Item)^ do
      KresliZdrSourBod(DCh, P);
  end;

begin
  ForEach(@Zobraz);
end;


procedure TIdBodCollection.KresliCilSourBMPCol(
                                               DCh: HDC;
                                               P: PWindowsObject);
  procedure Zobraz(Item: Pointer); far;
  begin
    with PIdBod(Item)^ do
      KresliCilSourBMPBod(DCh, P);
  end;

begin
  ForEach(@Zobraz);
end;

procedure TIdBodCollection.KresliZdrSourBMPCol(
                                               DCh: HDC;
                                               P: PWindowsObject);
  procedure Zobraz(Item: Pointer); far;
  begin
    with PIdBod(Item)^ do
      KresliZdrSourBMPBod(DCh, P);
  end;

begin
  ForEach(@Zobraz);
end;

{ **************************************************************************************** }

function TEditCisIdB.IsValid: boolean;
var
  Temp: longInt;
  ErrorPos, i: integer;
  PomStr: array[0..5] of char;

begin
  GetText(PomStr, 5);
  val(PomStr, Temp, ErrorPos);
  if ErrorPos <> 0 then
  begin
    Stav    := -1;
    IsValid := false;
  end else
  begin
    Stav    := -2;
    IsValid := false;
    for i := 0 to pred(BodColl^.Count) do
      if PIdBod(BodColl^.At(i))^.Cislo = Temp then
      begin
        IsValid      := true;
        SendMessage(Parent^.HWindow, wm_NovyIdB, i, 0);
        exit;
      end;
  end;
end;

{ **************************************************************************************** }

constructor TEditIdB2D.Init(
                            const aParent              : PWindowsObject;
                                  aCislo               : integer;
                            var   aPoznamka            : TPoznamka;
                            var   aVaha, aX, aY, aV, aU: extended);
var
  PomChar: array[0..10] of char;
begin
  strPCopy(PomChar, 'IdBod2D');
  THelpDialog.Init(aParent, PomChar, dg_EditujIdBod);

  Cislo    := aCislo;
  Poznamka := @aPoznamka;
  Vaha     := @aVaha;
  X        := @aX;
  Y        := @aY;
  U        := @aU;
  V        := @aV;

  EdPoznamka := New(PEdit, InitResource(@Self, id_Poznamka, 12));
  EdVaha     := New(PEditVahu, InitResource(@Self, id_Vaha, 7));
  EdX        := New(PEditCislo, InitResource(@Self, id_X, 12));
  EdY        := New(PEditCislo, InitResource(@Self, id_Y, 12));
  EdU        := New(PEditCislo, InitResource(@Self, id_U, 12));
  EdV        := New(PEditCislo, InitResource(@Self, id_V, 12));
end;

procedure TEditIdB2D.SetUpWindow;
var
  Pom: TPoznamka;

begin
  inherited SetUpWindow;

  StrPCopy(Pom, LStr(Cislo));
  SetDlgItemText(HWindow, id_Cislo, Pom);

  SetDlgItemText(HWindow, id_Poznamka, Poznamka^);

  StrPCopy(Pom, RStrSp(Vaha^, 6, 4));
  SetDlgItemText(HWindow, id_Vaha, Pom);

  StrPCopy(Pom, RStrSp(X^, 11, 3));
  SetDlgItemText(HWindow, id_X, Pom);

  StrPCopy(Pom, RStrSp(Y^, 11, 3));
  SetDlgItemText(HWindow, id_Y, Pom);

  StrPCopy(Pom, RStrSp(U^, 11, 3));
  SetDlgItemText(HWindow, id_U, Pom);

  StrPCopy(Pom, RStrSp(V^, 11, 3));
  SetDlgItemText(HWindow, id_V, Pom);
end;

procedure TEditIdB2D.DefWndProc(var Msg: TMessage);
var
  Retezec1: array[0..80] of char;

begin
  if Msg.Message = wm_Back then
    if Msg.wParam = GetDlgItem(HWindow, id_Vaha) then
    begin
      case Msg.lParam of
        -1: begin
              LoadString(HInstance, 59, Retezec1, sizeOf(Retezec1));
              Hlaska1(HWindow, StrPas(Retezec1));
              {Nekorektni vstup !}
            end;
        -2: begin
              LoadString(HInstance, 186, Retezec1, sizeOf(Retezec1));
              Hlaska1(HWindow, StrPas(Retezec1));
              {Vaha musi byt v rozsahu 0 az 1 !}
            end;
      end;
      SetFocus(EdVaha^.HWindow);
      SendMessage(GetDlgItem(HWindow, id_Vaha), em_setSel, 0, 0);
    end else
    begin
      LoadString(HInstance, 59, Retezec1, sizeOf(Retezec1));
      Hlaska1(HWindow, StrPas(Retezec1));
      {Nekorektni vstup !}
      if Msg.wParam = GetDlgItem(HWindow, id_X) then
      begin
        SetFocus(EdX^.HWindow);
        SendMessage(GetDlgItem(HWindow, id_X), em_setSel, 0, 0);
      end
      else
        if Msg.wParam = GetDlgItem(HWindow, id_Y) then
        begin
          SetFocus(EdY^.HWindow);
          SendMessage(GetDlgItem(HWindow, id_Y), em_setSel, 0, 0);
        end
        else
          if Msg.wParam = GetDlgItem(HWindow, id_U) then
          begin
            SetFocus(EdU^.HWindow);
            SendMessage(GetDlgItem(HWindow, id_U), em_setSel, 0, 0);
          end
          else
            if Msg.wParam = GetDlgItem(HWindow, id_V) then
            begin
              SetFocus(EdV^.HWindow);
              SendMessage(GetDlgItem(HWindow, id_V), em_setSel, 0, 0);
            end;
    end;
  THelpDialog.DefWndProc(Msg);
end;

function TEditIdB2D.CanClose: boolean;
var
  Pom: TPoznamka;
  ErrorPos: integer;

begin
  GetDlgItemText(HWindow, id_Poznamka, Poznamka^, 12);

  GetDlgItemText(HWindow, id_Vaha, Pom, 12);
  val(Pom, Vaha^, ErrorPos);

  GetDlgItemText(HWindow, id_X, Pom, 12);
  val(Pom, X^, ErrorPos);

  GetDlgItemText(HWindow, id_Y, Pom, 12);
  val(Pom, Y^, ErrorPos);

  GetDlgItemText(HWindow, id_U, Pom, 12);
  val(Pom, U^, ErrorPos);

  GetDlgItemText(HWindow, id_V, Pom, 12);
  val(Pom, V^, ErrorPos);

  CanClose := true;
end;

{ **************************************************************************************** }

constructor TEditIdB3D.Init(
                            const aParent                      : PWindowsObject;
                                  aCislo                       : integer;
                            var   aPoznamka                    : TPoznamka;
                            var   aVaha, aX, aY, aZ, aV, aU, aW: extended);
var
  PomChar: array[0..10] of char;

begin
  strPCopy(PomChar, 'IdBod3D');
  THelpDialog.Init(aParent, PomChar, dg_EditujIdBod);

  Cislo    := aCislo;
  Poznamka := @aPoznamka;
  Vaha     := @aVaha;
  X        := @aX;
  Y        := @aY;
  U        := @aU;
  V        := @aV;

  EdPoznamka := New(PEdit, InitResource(@Self, id_Poznamka, 12));
  EdVaha     := New(PEditVahu, InitResource(@Self, id_Vaha, 7));
  EdX        := New(PEditCislo, InitResource(@Self, id_X, 12));
  EdY        := New(PEditCislo, InitResource(@Self, id_Y, 12));
  EdU        := New(PEditCislo, InitResource(@Self, id_U, 12));
  EdV        := New(PEditCislo, InitResource(@Self, id_V, 12));
end;

procedure TEditIdB3D.SetUpWindow;
var
  Pom: TPoznamka;

begin
  inherited SetUpWindow;

  StrPCopy(Pom, RStrSp(Z^, 11, 3));
  SetDlgItemText(HWindow, id_Z, Pom);

  StrPCopy(Pom, RStrSp(W^, 11, 3));
  SetDlgItemText(HWindow, id_W, Pom);
end;

procedure TEditIdB3D.DefWndProc(var Msg: TMessage);
var
  Retezec1: array[0..80] of char;

begin
  if Msg.Message = wm_Back then
    if Msg.wParam = GetDlgItem(HWindow, id_Vaha) then
    begin
      case Msg.lParam of
        -1: begin
              LoadString(HInstance, 59, Retezec1, sizeOf(Retezec1));
              Hlaska1(HWindow, StrPas(Retezec1));
              {Nekorektni vstup !}
            end;
        -2: begin
              LoadString(HInstance, 186, Retezec1, sizeOf(Retezec1));
              Hlaska1(HWindow, StrPas(Retezec1));
              {Vaha musi byt v rozsahu 0 az 1 !}
            end;
      end;
      SetFocus(EdVaha^.HWindow);
      SendMessage(GetDlgItem(HWindow, id_Vaha), em_setSel, 0, 0);
    end else
    begin
      LoadString(HInstance, 59, Retezec1, sizeOf(Retezec1));
      Hlaska1(HWindow, StrPas(Retezec1));
      {Nekorektni vstup !}
      if Msg.wParam = GetDlgItem(HWindow, id_X) then
      begin
        SetFocus(EdX^.HWindow);
        SendMessage(GetDlgItem(HWindow, id_X), em_setSel, 0, 0);
      end
      else
        if Msg.wParam = GetDlgItem(HWindow, id_Y) then
        begin
          SetFocus(EdY^.HWindow);
          SendMessage(GetDlgItem(HWindow, id_Y), em_setSel, 0, 0);
        end
        else
          if Msg.wParam = GetDlgItem(HWindow, id_Z) then
          begin
            SetFocus(EdZ^.HWindow);
            SendMessage(GetDlgItem(HWindow, id_Z), em_setSel, 0, 0);
          end
          else
            if Msg.wParam = GetDlgItem(HWindow, id_U) then
            begin
              SetFocus(EdU^.HWindow);
              SendMessage(GetDlgItem(HWindow, id_U), em_setSel, 0, 0);
            end
            else
              if Msg.wParam = GetDlgItem(HWindow, id_V) then
              begin
                SetFocus(EdV^.HWindow);
                SendMessage(GetDlgItem(HWindow, id_V), em_setSel, 0, 0);
              end
              else
                if Msg.wParam = GetDlgItem(HWindow, id_W) then
                begin
                  SetFocus(EdW^.HWindow);
                  SendMessage(GetDlgItem(HWindow, id_W), em_setSel, 0, 0);
                end;
    end;
  THelpDialog.DefWndProc(Msg);
end;

function TEditIdB3D.CanClose: boolean;
var
  Pom: TPoznamka;
  ErrorPos: integer;

begin
  inherited CanClose;

  GetDlgItemText(HWindow, id_Z, Pom, 12);
  val(Pom, Z^, ErrorPos);

  GetDlgItemText(HWindow, id_W, Pom, 12);
  val(Pom, W^, ErrorPos);

  CanClose := true;
end;

{ **************************************************************************************** }

constructor TTrTab.Init(
                            aRastr               : boolean;
                        var aBodColl             : PIdBodCollection;
                        var aTransformace        : pointer;
                        var aNazevTransformace   : TNazevTran;
                        var aJmenoTrTab, aOldName: TPathStr);

var
  PomChar: array[0..10] of char;

begin
  strPCopy(PomChar, 'TrTab');
  inherited Init(Application^.MainWindow, PomChar, dg_TransformacniTabulka);

  BodColl           := aBodColl;
  Transformace      := @aTransformace;
  NazevTransformace := @aNazevTransformace;
  JmenoTrTab        := @aJmenoTrTab;
  OldName           := @aOldName;

  Rastr             := aRastr;

  EdJmTrTab          := New(PEdit, InitResource(@Self, id_JmTrTab  , fsPathName+1));

  EdCisIdB          := New(PEditCisIdB, InitResource(@Self, id_IdB, 5));
  EdCisIdB^.BodColl := aBodColl;

  RBOwDr := New(POwnDraw, InitResource(@Self, id_OwDr));

  ScBH := New(PScrollBar, InitResource(@Self, id_ScBH));
  ScBV := New(PScrollBar, InitResource(@Self, id_ScBV));

  CBTypTr := New(PComboBox, InitResource(@Self, id_TypTr, 10));

  CisAktIdBodu := -1;

  LoadString(HInstance, 601, CCislo, 9);
  LoadString(HInstance, 602, CPoznamka, 12);
  if SourSystem = Matematicky then
  begin
    LoadString(HInstance, 604, CcX, 12);
    LoadString(HInstance, 603, CcY, 12);
  end else
  begin
    LoadString(HInstance, 603, CcX, 12);
    LoadString(HInstance, 604, CcY, 12);
  end;
  LoadString(HInstance, 605, CcZ, 12);
  LoadString(HInstance, 606, CzX, 12);
  LoadString(HInstance, 607, Czy, 12);
  LoadString(HInstance, 608, CzZ, 12);
  LoadString(HInstance, 609, COdchX, 12);
  LoadString(HInstance, 610, COdchY, 12);
  LoadString(HInstance, 611, COdchZ, 12);
  LoadString(HInstance, 612, CVaha, 7);

  LoadString(HInstance, 621, CPodobn_2D, 20);
  LoadString(HInstance, 622, CAfinn__2D, 20);
  LoadString(HInstance, 623, CKolin__2D, 20);
  LoadString(HInstance, 624, CPodobn_3D, 20);
  LoadString(HInstance, 625, CAfinn__3D, 20);
  LoadString(HInstance, 626, CKolin__3D, 20);
  LoadString(HInstance, 627, C2_ST_POL_, 20);
  LoadString(HInstance, 628, C3_ST_POL_, 20);

  VypoctiTrKlic;

  if Dimenze = 2 then
    MaxLen := 100
  else
    MaxLen := 135;
  ComboData.Typy := nil;
end;

destructor TTrTab.Done;
begin
  inherited Done;
  if ComboData.Typy <> nil then
    Dispose(ComboData.Typy, Done);
end;

procedure TTrTab.SetUpWindow;
var
  PomStr: array[0..5] of char;
  DC: HDC;
  TextMetric: TTextMetric;
  OldFont: HFont;

begin
  inherited SetUpWindow;

  SetDlgItemText(HWindow, id_JmTrTab, JmenoTrTab^);

  if BodColl^.Count = 0 then
  begin
    StrPCopy(PomStr, ' ');
    SetDlgItemText(HWindow, id_IdB, PomStr);

    EnableWindow(GetDlgItem(HWindow, id_VypTrKl)   , false);
    EnableWindow(GetDlgItem(HWindow, id_VymazIdB)  , false);
    EnableWindow(GetDlgItem(HWindow, id_VymazVsIdB), false);
    EnableWindow(GetDlgItem(HWindow, id_VypniIdB)  , false);
    EnableWindow(GetDlgItem(HWindow, id_ZapniIdB)  , false);
    EnableWindow(GetDlgItem(HWindow, id_EditujIdB) , false);
    EnableWindow(GetDlgItem(HWindow, id_OpravIdB)  , false);
    EnableWindow(GetDlgItem(HWindow, id_IdB)       , false);
    EnableWindow(GetDlgItem(HWindow, id_PopisCIdB) , false);
    EnableWindow(GetDlgItem(HWindow, id_Nahoru)    , false);
    EnableWindow(GetDlgItem(HWindow, id_Dolu)      , false);
  end else
  begin
    CisAktIdBodu := 0;
    StrPCopy(PomStr, LStr(PIdBod(BodColl^.At(CisAktIdBodu))^.Cislo));
    SetDlgItemText(HWindow, id_IdB, PomStr);
  end;

  DC := GetDC(RBOwDr^.HWindow);
  OldFont := SelectObject(DC, GetStockObject(System_Fixed_Font));
  GetTextMetrics(DC, TextMetric);
  with TextMetric do
  begin
    Size.Width  := tmAveCharWidth;
    Size.Height := tmHeight + tmExternalLeading;
  end;
  SelectObject(DC, OldFont);
  ReleaseDC(RBOwDr^.HWindow, DC);

  GetClientRect(RBOwDr^.HWindow, Obdelnik);

  Delka := (Obdelnik.right  - Obdelnik.left) div Size.Width;
  Vyska := (Obdelnik.bottom - Obdelnik.top ) div Size.Height;

  if Delka < MaxLen then
    ScBH^.SetRange(0, MaxLen - Delka)
  else
    ScBH^.SetRange(0, 0);
  ScBH^.SetPosition(0);
  xPos    := 0;
  OldxPos := 0;

  if Vyska <= BodColl^.Count then
    ScBV^.SetRange(0, BodColl^.Count-Vyska+1)
  else
    ScBV^.SetRange(0, 0);
  ScBV^.SetPosition(0);
  yPos    := 0;
  OldyPos := 0;

  if Rastr then
    with ComboData do
    begin
      Typy := New(PPomColl, Init(5, 1));
      Typy^.Insert(StrNew(CPodobn_2D));
      Typy^.Insert(StrNew(CAfinn__2D));
      Typy^.Insert(StrNew(CKolin__2D));
      Typy^.Insert(StrNew(C2_ST_POL_));
      Typy^.Insert(StrNew(C3_ST_POL_));
      StrCopy(Vybrany, NazevTransformace^);
    end
  else
    with ComboData do
    begin
      Typy := New(PPomColl, Init(3, 1));
      Typy^.Insert(StrNew(CPodobn_2D));
      Typy^.Insert(StrNew(CAfinn__2D));
      Typy^.Insert(StrNew(CKolin__2D));
      StrCopy(Vybrany, NazevTransformace^);
    end;

  CBTypTr^.Transfer(@ComboData, tf_SetData);
end;

procedure TTrTab.DefWndProc(var Msg: TMessage);
var
  JmenoSouboru: TPathStr;
  Retezec1: array[0..80] of char;

begin
  if Msg.Message = wm_Back then
    if Msg.wParam = GetDlgItem(HWindow, id_IdB) then
    begin
      case Msg.lParam of
        -1: begin
              LoadString(HInstance, 59, Retezec1, sizeOf(Retezec1));
              Hlaska1(HWindow, StrPas(Retezec1));
              {Nekorektni vstup !}
            end;
        -2: begin
              LoadString(HInstance, 185, Retezec1, sizeOf(Retezec1));
              Hlaska1(HWindow, StrPas(Retezec1));
              {Takovyto id.bod neexistuje !}
            end;
      end;
      SetFocus(EdCisIdB^.HWindow);
      SendMessage(GetDlgItem(HWindow, id_IdB), em_setSel, 0, 0);
    end;
  inherited DefWndProc(Msg);
end;

procedure TTrTab.Cancel(var Msg: TMessage);
var
  Retezec1: array[0..80] of char;

begin
  LoadString(HInstance, 187, Retezec1, sizeOf(Retezec1));
  {Chces opravdu opustit transformacni tabulku?}
  if Souhlas1(HWindow, strpas(Retezec1)) then
    EndDlg(id_Cancel);
end;

procedure TTrTab.WMCommand(var Msg: TMessage);
begin
  inherited WMCommand(Msg);
  case Msg.wParam of
    id_VypTrKl   : WMVypoctiTrKlic;
    id_DalsiIdB  : WMDalsiIdB;
    id_VymazIdB  : WMVymazIdB;
    id_VymazVsIdB: WMVymazVsIdB;
    id_VypniIdB  : WMVypniIdB;
    id_ZapniIdB  : WMZapniIdB;
    id_EditujIdB : WMEditujIdB;
    id_OpravIdB  : WMOpravIdB;
(*
    id_ScBH      : WMScBH;
    id_ScBV      : WMScBV;
*)
    id_Nahoru    : WMNahoru;
    id_Dolu      : WMDolu;
  end;
end;


function TTrTab.CanClose: boolean;
var
  JmenoSouboru: TPathStr;
  Cesta: TDirStr;
  Jmeno: TNameStr;
  Ext: TExtStr;
  Retezec1: array[0..80] of char;
  Pom: boolean;

begin
  Pom := inherited CanClose;
  if Pom then
  begin
    GetDlgItemText(HWindow, id_JmTrTab, JmenoSouboru, fsPathName+1);
    FileSplit(JmenoSouboru, Cesta, Jmeno, Ext);
    if (StrLen(Jmeno) = 0 ) or (StrIComp(Ext, '.Trt') <> 0) or not DirExists(Cesta) then
    begin
      LoadString(HInstance, 141, Retezec1, sizeOf(Retezec1));
      Hlaska1(HWindow, StrPas(Retezec1));
    {'Takovyto soubor nelze vytvorit !}
      SetFocus(GetDlgItem(HWindow, id_JmTrTab));
      SendMessage(GetDlgItem(HWindow, id_JmTrTab), em_setSel, 0, 0);
      CanClose := false;
    end
    else
      if FileExists(JmenoSouboru) and (StrIComp(JmenoSouboru, OldName^) <> 0) then
      begin
        LoadString(HInstance, 142, Retezec1, sizeOf(Retezec1));
        if Souhlas1(HWindow, JmenoSouboruNa30(JmenoSouboru)+ '  '+ StrPas(Retezec1)) then
        {'Takovyto soubor jiz existuje!   Prepsat? '}
        begin
          StrCopy(JmenoTrTab^, JmenoSouboru);
          ZapisDoSouboru;
          CanClose := true;
        end else
        begin
          SetFocus(GetDlgItem(HWindow, id_JmTrTab));
          SendMessage(GetDlgItem(HWindow, id_JmTrTab), em_setSel, 0, 0);
          CanClose := false;
        end;
      end else
      begin
        StrCopy(JmenoTrTab^, JmenoSouboru);
        ZapisDoSouboru;
        CanClose := true;
      end;
  end
  else
    CanClose := false;
end;

procedure TTrTab.WMOwnerDraw(var Msg: TMessage);
begin
  with PDrawItemStruct(Msg.lParam)^ do
  begin
    Kresli(hDC);
    KresliRamecekAktIdBodu(hDC);
  end;
end;

procedure TTrTab.WMScBH(var Msg: TMessage);
var
  DC: HDC;
  Pom: integer;

begin
  Pom := ScBH^.GetPosition;
  if Pom <> OldxPos then
  begin
    DC := GetDC(RBOwDr^.HWindow);
    KresliRamecekAktIdBodu(DC);
    xPos := Pom;
    Kresli(DC);
    KresliRamecekAktIdBodu(DC);
    ReleaseDC(RBOwDr^.HWindow, DC);
    OldxPos := xPos;
  end;
end;

procedure TTrTab.WMScBV(var Msg: TMessage);
var
  DC: HDC;
  Pom: integer;

begin
  Pom := ScBV^.GetPosition;
  if Pom <> OldyPos then
  begin
    DC := GetDC(RBOwDr^.HWindow);
    KresliRamecekAktIdBodu(DC);
    yPos := Pom;
    Kresli(DC);
    KresliRamecekAktIdBodu(DC);
    ReleaseDC(RBOwDr^.HWindow, DC);
    OldyPos := yPos;
  end;
end;

procedure TTrTab.KresliZapnuti(
                               DC       : HDC;
                               CisloRad : integer;
                               TypIdBodu: TTypIdBodu);
var
  Rect: TRect;
  Pen, OldPen: HPen;

begin
  with Rect, Size do
  begin
    top    := CisloRad * Height + 2;
    bottom := CisloRad * Height + Height - 5;
    left   := 2;
    right  := 2*Width - 1;
  end;

  FillRect(DC, Rect, GetStockObject(LtGray_Brush));
  if TypIdBodu = Transformacni then
  begin
    Pen    := CreatePen(ps_Solid, 1, RGB($FF, $00, $00));
    OldPen := SelectObject(DC, Pen);
    with Rect, Size do
    begin
      moveTo(DC, left + 4                   , top + (bottom - top) div 3);
      lineTo(DC, left + (right - left) div 2, bottom - 2);
      lineTo(DC, right - 2                  , top);
    end;
    SelectObject(DC, OldPen);
    DeleteObject(Pen);
  end;
end;


procedure TTrTab.Kresli(
                        DC  : HDC);

var
  i: integer;
  PomStr: string[136];
  OutStr: array[0..100] of char;
  Bod: PIdBod;
  TempStr: TPoznamka;
  Line, First, Last, iBod, Pom1, Pom2: integer;
  OldFont: HFont;
  Brush: HBrush;
  OldMode: integer;

begin
  Brush := GetStockObject(LtGray_Brush);
  FillRect(DC, Obdelnik, Brush);

  OldMode := SetBkMode(DC, Transparent);

  OldFont := SelectObject(DC, GetStockObject(System_Fixed_Font));
  Pom1    := 9*Size.Width;
  Pom2    := Delka-9;

  PomStr := StrPas(CCislo);
  StrPCopy(OutStr, PomStr);
  TextOut(DC, 0, 0, OutStr, StrLen(OutStr));

  PomStr := DejDoplSPZPrava(StrPas(CPoznamka), 12);
  PomStr := ConCat(PomStr, DejDoplSPZPrava(Strpas(CVaha), 7));
  PomStr := ConCat(PomStr, DejDoplSPZPrava(StrPas(COdchY), 12));
  PomStr := ConCat(PomStr, DejDoplSPZPrava(StrPas(COdchX), 12));
  if Dimenze = 2 then
  begin
    PomStr := ConCat(PomStr, DejDoplSPZPrava(StrPas(CcY), 12));
    PomStr := ConCat(PomStr, DejDoplSPZPrava(StrPas(CcX), 12));
    PomStr := ConCat(PomStr, DejDoplSPZPrava(StrPas(CzX), 12));
    PomStr := ConCat(PomStr, DejDoplSPZPrava(StrPas(CzY), 12));
  end else
  begin
    PomStr := ConCat(PomStr, DejDoplSPZPrava(StrPas(COdchZ), 12));
    PomStr := ConCat(PomStr, DejDoplSPZPrava(StrPas(CcY), 12));
    PomStr := ConCat(PomStr, DejDoplSPZPrava(StrPas(CcX), 12));
    PomStr := ConCat(PomStr, DejDoplSPZPrava(StrPas(CcZ), 12));
    PomStr := ConCat(PomStr, DejDoplSPZPrava(StrPas(CzX), 12));
    PomStr := ConCat(PomStr, DejDoplSPZPrava(StrPas(CzY), 12));
    PomStr := ConCat(PomStr, DejDoplSPZPrava(StrPas(CzZ), 12));
  end;
  StrPCopy(OutStr, Copy(PomStr, succ(xPos), Pom2));
  TextOut(DC, Pom1, 0, OutStr, StrLen(OutStr));

  First := yPos;
  Last  := First + pred(Vyska);

  Line := 1;
  for iBod := First to pred(Last) do
  begin
    if BodColl^.Count > iBod then
    begin
      Bod := BodColl^.At(iBod);
      if Bod <> nil then
      begin
        PomStr := '   ';
        PomStr := ConCat(PomStr, DejDoplSPZPrava(LStr(Bod^.Cislo), 6));
        StrPCopy(OutStr, PomStr);
        TextOut(DC, 0, Line*Size.Height, OutStr, StrLen(OutStr));

        KresliZapnuti(DC, Line, Bod^.TypIdBodu);

        PomStr := DejDoplSPZPrava(StrPas(Bod^.Poznamka), 12);
        PomStr := ConCat(PomStr, DejDoplSPZPrava(RStrSp(Bod^.Vaha, 6, 4), 7));
        PomStr := ConCat(PomStr, DejDoplSPZPrava(RStrSp(Bod^.OdchY, 11, 3), 12));
        PomStr := ConCat(PomStr, DejDoplSPZPrava(RStrSp(Bod^.OdchX, 11, 3), 12));
        if Dimenze = 2 then
        begin
          PomStr := ConCat(PomStr, DejDoplSPZPrava(RStrSp(Bod^.cY, 11, 3), 12));
          PomStr := ConCat(PomStr, DejDoplSPZPrava(RStrSp(Bod^.cX, 11, 3), 12));
          PomStr := ConCat(PomStr, DejDoplSPZPrava(RStrSp(Bod^.zY, 11, 3), 12));
          PomStr := ConCat(PomStr, DejDoplSPZPrava(RStrSp(Bod^.zX, 11, 3), 12));
        end else
        begin
          PomStr := ConCat(PomStr, DejDoplSPZPrava(RStrSp(Bod^.OdchZ, 11, 3), 12));
          PomStr := ConCat(PomStr, DejDoplSPZPrava(RStrSp(Bod^.cY, 11, 3), 12));
          PomStr := ConCat(PomStr, DejDoplSPZPrava(RStrSp(Bod^.cX, 11, 3), 12));
          PomStr := ConCat(PomStr, DejDoplSPZPrava(RStrSp(Bod^.cZ, 11, 3), 12));
          PomStr := ConCat(PomStr, DejDoplSPZPrava(RStrSp(Bod^.zY, 11, 3), 12));
          PomStr := ConCat(PomStr, DejDoplSPZPrava(RStrSp(Bod^.zX, 11, 3), 12));
          PomStr := ConCat(PomStr, DejDoplSPZPrava(RStrSp(Bod^.zZ, 11, 3), 12));
        end;

        StrPCopy(OutStr, Copy(PomStr, succ(xPos), Pom2));
        TextOut(DC, Pom1, Line*Size.Height, OutStr, StrLen(OutStr));

        inc(Line);
      end;
    end else
    begin
      PomStr := ' ';
      PomStr := DejDoplSPZPrava(PomStr, Delka);
      StrPCopy(OutStr, PomStr);
      TextOut(DC, 0, Line*Size.Height, OutStr, StrLen(OutStr));
      inc(Line);
    end;
  end;
  SelectObject(DC, OldFont);

  SetBkMode(DC, OldMode);
end;

procedure TTrTab.KresliRamecekAktIdBodu(
                                        DC: HDC);
var
  OldPen: HPen;
  StaryROP2, First, Last: integer;

begin
  First := yPos;
  Last  := First + Vyska;

  if (CisAktIdBodu >= First) and (CisAktIdBodu < Last) then
  begin
    OldPen    := SelectObject(DC, GetStockObject(Black_Pen));
    StaryROP2 := SetROP2(DC, r2_NotXorPen);

    moveTo(DC, Obdelnik.right-3, (CisAktIdBodu - First + 1)*Size.Height-1);
    lineTo(DC, Obdelnik.left   , (CisAktIdBodu - First + 1)*Size.Height-1);
    moveTo(DC, Obdelnik.left +1, (CisAktIdBodu - First + 1)*Size.Height-1);
    lineTo(DC, Obdelnik.left +1, (CisAktIdBodu - First + 1)*Size.Height+Size.Height-1);
    moveTo(DC, Obdelnik.left +1, (CisAktIdBodu - First + 1)*Size.Height+Size.Height-2);
    lineTo(DC, Obdelnik.right-2, (CisAktIdBodu - First + 1)*Size.Height+Size.Height-2);
    if xPos = MaxLen - Delka then
    begin
      moveTo(DC, Obdelnik.right-3, (CisAktIdBodu - First + 1)*Size.Height+Size.Height-2);
      lineTo(DC, Obdelnik.right-3, (CisAktIdBodu - First + 1)*Size.Height-1);
    end;

    SetROP2(DC, StaryROP2);
    SelectObject(DC, OldPen);
  end;
end;

procedure TTrTab.NastavCisIdB;
var
  PomStr: array[0..5] of char;

begin
  if (CisAktIdBodu >= 0) and (CisAktIdBodu < BodColl^.Count) then
    StrPCopy(PomStr, LStr(PIdBod(BodColl^.At(CisAktIdBodu))^.Cislo))
  else
  begin
    CisAktIdBodu := -1;
    StrPCopy(PomStr, '');
    EnableWindow(GetDlgItem(HWindow, id_VypTrKl)   , false);
    EnableWindow(GetDlgItem(HWindow, id_VymazIdB)  , false);
    EnableWindow(GetDlgItem(HWindow, id_VymazVsIdB), false);
    EnableWindow(GetDlgItem(HWindow, id_VypniIdB)  , false);
    EnableWindow(GetDlgItem(HWindow, id_ZapniIdB)  , false);
    EnableWindow(GetDlgItem(HWindow, id_EditujIdB) , false);
    EnableWindow(GetDlgItem(HWindow, id_OpravIdB)  , false);
    EnableWindow(GetDlgItem(HWindow, id_IdB)       , false);
    EnableWindow(GetDlgItem(HWindow, id_PopisCIdB) , false);
    EnableWindow(GetDlgItem(HWindow, id_Nahoru)    , false);
    EnableWindow(GetDlgItem(HWindow, id_Dolu)      , false);
  end;
  SetDlgItemText(HWindow, id_IdB, PomStr);
end;


procedure TTrTab.WMDalsiIdB;
begin
  EndDlg(id_DalsiIdB);
end;

procedure TTrTab.WMVymazIdB;
var
  DC: HDC;

begin
  if (CisAktIdBodu >= 0) and (CisAktIdBodu < BodColl^.Count) then
  begin
    DC := GetDC(RBOwDr^.HWindow);
    KresliRamecekAktIdBodu(DC);
    BodColl^.AtDelete(CisAktIdBodu);
    if CisAktIdBodu > 0 then
      dec(CisAktIdBodu);
    NastavCisIdB;
    if Vyska < BodColl^.Count then
      ScBV^.SetRange(0, BodColl^.Count-Vyska)
    else
      ScBV^.SetRange(0, 0);
    ScBV^.SetPosition(0);
    Kresli(DC);
    KresliRamecekAktIdBodu(DC);
    ReleaseDC(RBOwDr^.HWindow, DC);
  end;
end;

procedure TTrTab.WMVymazVsIdB;
var
  DC: HDC;

begin
  DC := GetDC(RBOwDr^.HWindow);
  KresliRamecekAktIdBodu(DC);
  BodColl^.FreeAll;
  CisAktIdBodu := 0;
  NastavCisIdB;
  ScBV^.SetRange(0, 0);
  ScBV^.SetPosition(0);
  Kresli(DC);
  KresliRamecekAktIdBodu(DC);
  ReleaseDC(RBOwDr^.HWindow, DC);
end;

procedure TTrTab.WMClickTrTab(var Msg: TMessage);
type
  PtrRec = record
    Lo, Hi: Word
  end;

var
  x, y: integer;
  DC: HDC;

begin
  if CisAktIdBodu >= 0 then
  begin
    with Msg do
    begin
      x := PtrRec(lParam).Lo;
      y := PtrRec(lParam).Hi;
    end;

    if yPos = 0 then
    begin
      if (y > Size.Height) and (y div Size.Height <= BodColl^.Count) then
      begin
        DC := GetDC(RBOwDr^.HWindow);
        KresliRamecekAktIdBodu(DC);
        CisAktIdBodu := pred(y div Size.Height);
        KresliRamecekAktIdBodu(DC);
        ReleaseDC(RBOwDr^.HWindow, DC);
      end;
    end else
    begin
      if y div Size.Height + yPos <= BodColl^.Count then
      begin
        DC := GetDC(RBOwDr^.HWindow);
        KresliRamecekAktIdBodu(DC);
        CisAktIdBodu := pred(y div Size.Height + yPos);
        KresliRamecekAktIdBodu(DC);
        ReleaseDC(RBOwDr^.HWindow, DC);
      end;
    end;

    if ((yPos = 0) and (y > Size.Height) and (y div Size.Height <= BodColl^.Count)) or
       ((yPos > 0) and (y div Size.Height + yPos <= BodColl^.Count))then
    begin
      NastavCisIdB;
      if x <= 3*Size.Width then
        if PIdBod(BodColl^.At(CisAktIdBodu))^.TypIdBodu = Transformacni then
          VypniAktIdBod
        else
          ZapniAktIdBod;
    end;
  end;
end;

procedure TTrTab.WMDblClickTrTab(var Msg: TMessage);
type
  PtrRec = record
    Lo, Hi: Word
  end;

var
  x, y: integer;
  DC: HDC;

begin
  if CisAktIdBodu >= 0 then
  begin
    with Msg do
    begin
      x := PtrRec(lParam).Lo;
      y := PtrRec(lParam).Hi;
    end;
    if yPos = 0 then
    begin
      if (y > Size.Height) and (y div Size.Height <= BodColl^.Count) then
      begin
        DC := GetDC(RBOwDr^.HWindow);
        KresliRamecekAktIdBodu(DC);
        CisAktIdBodu := pred(y div Size.Height);
        KresliRamecekAktIdBodu(DC);
        ReleaseDC(RBOwDr^.HWindow, DC);
      end;
    end else
    begin
      if y div Size.Height + yPos <= BodColl^.Count then
      begin
        DC := GetDC(RBOwDr^.HWindow);
        KresliRamecekAktIdBodu(DC);
        CisAktIdBodu := pred(y div Size.Height + yPos);
        KresliRamecekAktIdBodu(DC);
        ReleaseDC(RBOwDr^.HWindow, DC);
      end;
    end;

    if ((yPos = 0) and (y > Size.Height) and (y div Size.Height <= BodColl^.Count)) or
       ((yPos > 0) and (y div Size.Height + yPos <= BodColl^.Count))then
    begin
      NastavCisIdB;
      EditujAktIdBod;
    end;
  end;
end;



procedure TTrTab.VypniAktIdBod;
var
  DC: HDC;
  First, Last: integer;

begin
  PIdBod(BodColl^.At(CisAktIdBodu))^.VlozTypIdBodu(kontrolni);

  First := yPos;
  Last  := First + Vyska;

  if (CisAktIdBodu >= First) and (CisAktIdBodu < Last) then
  begin
    DC := GetDC(RBOwDr^.HWindow);
    KresliZapnuti(DC, CisAktIdBodu - First + 1, kontrolni);
    ReleaseDC(RBOwDr^.HWindow, DC);
  end;
end;

procedure TTrTab.ZapniAktIdBod;
var
  DC: HDC;
  First, Last: integer;

begin
  PIdBod(BodColl^.At(CisAktIdBodu))^.VlozTypIdBodu(transformacni);
  First := yPos;
  Last  := First + Vyska;

  if (CisAktIdBodu >= First) and (CisAktIdBodu < Last) then
  begin
    DC := GetDC(RBOwDr^.HWindow);
    KresliZapnuti(DC, CisAktIdBodu - First + 1, transformacni);
    ReleaseDC(RBOwDr^.HWindow, DC);
  end;
end;


procedure TTrTab.EditujAktIdBod;
begin
  with PIdBod(BodColl^.At(CisAktIdBodu))^ do
    if Dimenze = 2 then
      Application^.ExecDialog(New(PEditIdB2D, Init(@Self, Cislo, Poznamka, Vaha, cX, cY, zX, zY)))
    else
      Application^.ExecDialog(New(PEditIdB3D, Init(@Self, Cislo, Poznamka, Vaha, cX, cY, cZ, zX, zY, zZ)));
end;

procedure TTrTab.WMVypniIdB;
begin
  VypniAktIdBod;
end;

procedure TTrTab.WMZapniIdB;
begin
  ZapniAktIdBod;
end;

procedure TTrTab.WMEditujIdB;
var
  DC: HDC;

begin
  DC := GetDC(RBOwDr^.HWindow);
  KresliRamecekAktIdBodu(DC);
  EditujAktIdBod;
  Kresli(DC);
  KresliRamecekAktIdBodu(DC);
  ReleaseDC(RBOwDr^.HWindow, DC);
end;

procedure TTrTab.WMOpravIdB;
begin
  EndDlg(id_OpravIdB);
end;

procedure TTrTab.WMNovyIdB(var Msg: TMessage);
var
  DC: HDC;

begin
  if Msg.wParam < pred(BodColl^.Count) then
  begin
    DC := GetDC(RBOwDr^.HWindow);
    KresliRamecekAktIdBodu(DC);
    CisAktIdBodu := Msg.wParam;
    KresliRamecekAktIdBodu(DC);
    ReleaseDC(RBOwDr^.HWindow, DC);
  end;
end;


procedure TTrTab.WMNahoru;
var
  DC: HDC;

begin
  if CisAktIdBodu < pred(BodColl^.Count) then
  begin
    DC := GetDC(RBOwDr^.HWindow);
    KresliRamecekAktIdBodu(DC);
    inc(CisAktIdBodu);
    NastavCisIdB;
    KresliRamecekAktIdBodu(DC);
    ReleaseDC(RBOwDr^.HWindow, DC);
  end;
end;

procedure TTrTab.WMDolu;
var
  DC: HDC;

begin
  if CisAktIdBodu > 0 then
  begin
    DC := GetDC(RBOwDr^.HWindow);
    KresliRamecekAktIdBodu(DC);
    dec(CisAktIdBodu);
    NastavCisIdB;
    KresliRamecekAktIdBodu(DC);
    ReleaseDC(RBOwDr^.HWindow, DC);
  end;
end;

procedure TTrTab.WMVypoctiTrKlic;
var
  DC: HDC;

begin
  CBTypTr^.GetSelString(NazevTransformace^, 20);
  DC := GetDC(RBOwDr^.HWindow);
  KresliRamecekAktIdBodu(DC);
  VypoctiTrKlic;
  Kresli(DC);
  KresliRamecekAktIdBodu(DC);
  ReleaseDC(RBOwDr^.HWindow, DC);
end;


procedure TTrTab.VyplneniOdchylek;
var
  i: longInt;

begin
  for i := 0 to pred(BodColl^.Count) do
    with PIdBod(BodColl^.At(i))^ do
    begin
      OdchX := 0; OdchY := 0;  OdchZ := 0;
    end;
  mX := 0; mY := 0;  mZ := 0; mP := 0;
end;

procedure TTrTab.VypocetOdchylek;
var
  i, N: longInt;
  ZBod, CBod: Bod;
  Suma1, Suma2, Suma3: extended;

begin
  if pointer(Transformace^) <> nil then
  begin
    Suma1 := 0;
    Suma2 := 0;
    Suma3 := 0;
    for i := 0 to pred(BodColl^.Count) do
      with PIdBod(BodColl^.At(i))^ do
      begin
        ZBod.X := zY; ZBod.Y := zX; ZBod.Z := zZ;
        TransformaceTransformuj(pointer(Transformace^), ZBod, CBod);
        OdchY := cY - CBod.X;
        OdchX := cX - CBod.Y;
        if Dimenze = 3 then
          OdchZ := cZ - CBod.Z;
        if TypIdBodu = Transformacni then
        begin
          inc(N);
          Suma1 := Suma1 + sqr(OdchY);
          Suma2 := Suma2 + sqr(OdchX);
          if Dimenze = 3 then
            Suma3 := Suma3 + sqr(OdchZ);
        end;
      end;
    dec(N);
    if N > 0 then
    begin
      mY := sqrt(Suma1/N);
      mX := sqrt(Suma2/N);
      if Dimenze = 3 then
        mZ := sqrt(Suma3/N);
      if Dimenze = 3 then
        mP := sqrt(sqr(mY) +sqr(mX) + sqr(mZ))
      else
        mP := sqrt(sqr(mY) +sqr(mX));
    end else
    begin
      mY := 0;
      mX := 0;
      mZ := 0;
      mP := 0;
    end;
  end
  else
    VyplneniOdchylek;
end;


procedure TTrTab.VypoctiTrKlic;
var
  PPtr: PExtVector;
  PocetTrIdBodu: longInt;
  PomKurzor: HCursor;

begin
  PomKurzor := SetCursor(LoadCursor(0, idc_Wait));
  if pointer(Transformace^) <> nil then
  begin
    TransformaceDone(pointer(Transformace^));
    pointer(Transformace^) := nil;
  end;

  if StrIComp(NazevTransformace^, CPodobn_2D) = 0 then
  begin
    Dimenze := 2;
    DejBufferAPocet(BodColl, PPtr, PocetTrIdBodu);
    pointer(Transformace^) := TransformaceInit(PPtr, PocetTrIdBodu, 0);
    DisposeBuffer(PPtr, PocetTrIdBodu);
  end
  else if StrIComp(NazevTransformace^, CAfinn__2D) = 0 then
  begin
    Dimenze := 2;
    DejBufferAPocet(BodColl, PPtr, PocetTrIdBodu);
    pointer(Transformace^) := TransformaceInit(PPtr, PocetTrIdBodu, 1);
    DisposeBuffer(PPtr, PocetTrIdBodu);
  end
  else if StrIComp(NazevTransformace^, CKolin__2D) = 0 then
  begin
    Dimenze := 2;
    DejBufferAPocet(BodColl, PPtr, PocetTrIdBodu);
    pointer(Transformace^) := TransformaceInit(PPtr, PocetTrIdBodu, 2);
    DisposeBuffer(PPtr, PocetTrIdBodu);
  end
  else if StrIComp(NazevTransformace^, CPodobn_3D) = 0 then
  begin
    Dimenze := 3;
    DejBufferAPocet(BodColl, PPtr, PocetTrIdBodu);
    pointer(Transformace^) := TransformaceInit(PPtr, PocetTrIdBodu, 3);
    DisposeBuffer(PPtr, PocetTrIdBodu);
  end
  else if StrIComp(NazevTransformace^, CAfinn__3D) = 0 then
  begin
    Dimenze := 3;
    DejBufferAPocet(BodColl, PPtr, PocetTrIdBodu);
    pointer(Transformace^) := TransformaceInit(PPtr, PocetTrIdBodu, 4);
    DisposeBuffer(PPtr, PocetTrIdBodu);
  end
  else if StrIComp(NazevTransformace^, CKolin__3D) = 0 then
  begin
    Dimenze := 3;
    DejBufferAPocet(BodColl, PPtr, PocetTrIdBodu);
    pointer(Transformace^) := TransformaceInit(PPtr, PocetTrIdBodu, 5);
    DisposeBuffer(PPtr, PocetTrIdBodu);
  end
  else if StrIComp(NazevTransformace^, C2_St_Pol_) = 0 then
  begin
    Dimenze := 2;
    DejBufferAPocet(BodColl, PPtr, PocetTrIdBodu);
    pointer(Transformace^) := TransformaceInit(PPtr, PocetTrIdBodu, 6);
    DisposeBuffer(PPtr, PocetTrIdBodu);
  end
  else if StrIComp(NazevTransformace^, C3_St_Pol_) = 0 then
  begin
    Dimenze := 2;
    DejBufferAPocet(BodColl, PPtr, PocetTrIdBodu);
    pointer(Transformace^) := TransformaceInit(PPtr, PocetTrIdBodu, 7);
    DisposeBuffer(PPtr, PocetTrIdBodu);
  end;

  if pointer(Transformace^) <> nil then
  begin
    if (TransformaceVratCisloChyby(pointer(Transformace^)) <> 0) or
        not TransformaceKlicVypocten(pointer(Transformace^)) then
    begin
      SetCursor(PomKurzor);
      Hlaska1(HWindow, TransformaceVratPopisChyby(pointer(Transformace^)));
      VyplneniOdchylek;
      TransformaceDone(pointer(Transformace^));
      pointer(Transformace^) := nil;
    end else
    begin
      VypocetOdchylek;
      SetCursor(PomKurzor);
    end;
  end;
end;

procedure TTrTab.ZapisDoSouboru;
var
  F: text;
  i: longInt;

begin
  assign(F, JmenoTrTab^);
{$I-}
  rewrite(F);
{$I+}
  if IOResult <> 0 then exit;

{$I-}
  writeln(F, StrPas(NazevTransformace^));
{$I+}
  if IOResult <> 0 then exit;

  for i := 0 to pred(BodColl^.Count) do
    with PIdBod(BodColl^.At(i))^ do
    begin
      if Dimenze = 2 then
      begin
{$I-}
         write(F, Cislo:6, ' ',    zY:14:4, ' ',    zX:14:4, ' > ',
                                   cY:13:4, ' ',    cX:13:4, ' ',
                                OdchY:10:4, ' ', OdchX:10:4);
{$I+}
         if IOResult <> 0 then exit;
      end else
      begin
{$I-}
         write(F, Cislo:6, ' ',    zY:14:4, ' ',    zX:14:4, ' ',    zZ:14:4, ' > ',
                                   cY:13:4, ' ',    cX:13:4, ' ',    cZ:13:4, ' ',
                                OdchY:10:4, ' ', OdchX:10:4, ' ', OdchZ:10:4);
{$I+}
         if IOResult <> 0 then exit;
      end;
{$I-}
      case TypIdBodu of
        Transformacni: write(F, '  T');
        Kontrolni:     write(F, '  K');
        Pasivni:       write(F, '  P')
      end;
{$I+}
      if IOResult <> 0 then exit;
{$I-}
      write(F, '  ', '"', StrPas(Poznamka), '"');
{$I+}
      if IOResult <> 0 then exit;
{$I-}
      writeLn(F, '  ', Vaha:6:4);
    end;
  close(F)
end;


function TransformacniTabulka(
                                  aRastr: boolean;
                              var aBodColl: PIdBodCollection;
                              var aTransformace: pointer;
                              var aNazevTransformace: TNazevTran;
                              var aJmenoTrTab, aOldName: TPathStr): integer;

begin
  TransformacniTabulka := Application^.ExecDialog(New(PTrTab, Init(aRastr, aBodColl,
                                                                   aTransformace,
                                                                   aNazevTransformace,
                                                                   aJmenoTrTab,
                                                                   aOldName)));
end;



procedure DejBufferAPocet(
                              BodColl      : PIdBodCollection;
                          var PPtr         : PExtVector;
                          var PocetTrIdBodu: longInt);
var
  VelikostPrenosu, VelikostBuffru, i, j: longInt;

begin
  PPtr := nil;
  PocetTrIdBodu := 0;

  if BodColl^.Count <> 0 then
  begin
    for i := 0 to pred(BodColl^.Count) do
      if PIdBod(BodColl^.At(i))^.TypIdBodu = Transformacni then
        inc(PocetTrIdBodu);

    VelikostPrenosu := 5 * SizeOf(extended);
    VelikostBuffru  := PocetTrIdBodu * VelikostPrenosu;

    getMem(PPtr, VelikostBuffru);

    if PPtr <> nil then
    begin
      j := 0;
{$R-}
      for i := 0 to pred(BodColl^.Count) do
        with PIdBod(BodColl^.At(i))^ do
          if TypIdBodu = Transformacni then
          begin
            inc(j);
            PPtr^[j] := Vaha;
            inc(j);
            PPtr^[j] := zY;
            inc(j);
            PPtr^[j] := zX;
            inc(j);
            PPtr^[j] := cY;
            inc(j);
            PPtr^[j] := cX;
          end;
{$R+}
    end;
  end;
end;

procedure DisposeBuffer(
                        var PPtr         : PExtVector;
                            PocetTrIdBodu: longInt);
var
  VelikostPrenosu, VelikostBuffru: longInt;

begin
  VelikostPrenosu := 5 * SizeOf(extended);
  VelikostBuffru  := PocetTrIdBodu * VelikostPrenosu;

  if PPtr <> nil then
     freeMem(PPtr, VelikostBuffru);
  PPtr:= nil
end;


function PrectiTransfTabulku(
                             var   BodColl             : PIdBodCollection;
                             const JmTrTab             : TPathStr;
                             var   NazevTransformaceIdB: TNazevTran): boolean;

var
  Bod: PIdBod;
  F: text;
  Radek: string;
  TypTr, ZnakDimense: char;
  OKej: boolean;
  RadekObj: TCtiRadek;
  MeziApostrofy: boolean;
  IniPoznamka: string[12];
  Retezec1: array[0..50] of char;
  aP, aA, aK, a2, a3: char;
  i: integer;

  procedure NactiRadekTrTabulky(
                                    Radek: string;
                                var OKej: boolean);
  var
    TypRadku: char;

  begin
    OKej:= false;
    RadekObj.Init(Radek);

    with RadekObj, Bod^ do
    begin
      Cislo := DejInteger;

      if ZnakDimense = '2' then
      begin
        zY := DejReal;
        zX := DejReal;
        zZ := 0;
      end else
      begin
        zY := DejReal;
        zX := DejReal;
        zZ := DejReal;
      end;

      if ZnakDimense = '2' then
      begin
        cY := DejReal;
        cX := DejReal;
        cZ := 0;
      end else
      begin
        cY := DejReal;
        cX := DejReal;
        cZ := DejReal;
      end;

      repeat
        TypRadku:= upCase(DejChar)
      until (TypRadku in ['T', 'K', 'P']) or DosloKChybe;

      if not DosloKChybe then
      begin
        if TypRadku in ['T', 'K', 'P'] then
        begin
          case TypRadku of
            'T': TypIdBodu := Transformacni;
            'K': TypIdBodu := Kontrolni;
            'P': TypIdBodu := Pasivni;
          end;
          OKej:= true
        end;

        IniPoznamka := '';
        while (Obsah[Ukazovatko] <> '"') and (Ukazovatko <= length (Obsah)) do
          inc(Ukazovatko);
        if Ukazovatko <= length (Obsah) then
        begin
          inc(Ukazovatko);
          while (Ukazovatko <= length (Obsah)) and not (Obsah[Ukazovatko] = '"') do
          begin
            IniPoznamka := IniPoznamka + Obsah[Ukazovatko];
            inc (Ukazovatko);
          end;
        end;

        StrPCopy(Poznamka, IniPoznamka);

        if Ukazovatko < length (Obsah) then
          Vaha := DejReal
        else
          Vaha := 1;
      end else
      begin
        TypIdBodu := Transformacni;
        StrPCopy(Poznamka, '');
        Vaha := 1;
      end;
    end;

    RadekObj.Done
  end;


begin
  LoadString(HInstance, 621, Retezec1, 20); {Podobnost}
  aP := Retezec1[0];
  LoadString(HInstance, 622, Retezec1, 20); {Afinita}
  aA := Retezec1[0];
  LoadString(HInstance, 623, Retezec1, 20); {Kolineace}
  aK := Retezec1[0];
  LoadString(HInstance, 627, Retezec1, 20); {2.st.Pol.}
  a2 := Retezec1[0];
  LoadString(HInstance, 628, Retezec1, 20); {3.st.Pol.}
  a3 := Retezec1[0];

  BodColl := New(PIdBodCollection, Init(1, 1));

  OKej:= false;
  assign(F, JmTrTab);
{$I-}
  fileMode := moOpenRONN;
  reset(F);
  fileMode := moStandard;
{$I+}
  if IOResult = 0 then
  begin
    readLn(F, Radek);
    RadekObj.Init(Radek);

    with RadekObj do
    begin
      repeat
        TypTr:= upCase(DejChar)
      until TypTr in [aP, aA, aK, a2, a3];

      if not (TypTr in ['2','3']) then
        repeat
          ZnakDimense:= DejChar
        until ZnakDimense in ['2','3']
      else
        ZnakDimense:= '2'
    end;

    if not RadekObj.DosloKChybe then
    begin
      Dimenze := ord(ZnakDimense) - 48;

      if TypTr = aP then
      begin
        if ZnakDimense = '2' then
          LoadString(HInstance, 621, NazevTransformaceIdB, 20)
        else
          LoadString(HInstance, 621, NazevTransformaceIdB, 20);
      end
      else
        if TypTr = aA then
        begin
          if ZnakDimense = '2' then
            LoadString(HInstance, 622, NazevTransformaceIdB, 20)
          else
            LoadString(HInstance, 622, NazevTransformaceIdB, 20);
        end
        else
          if TypTr = aK then
          begin
            if ZnakDimense = '2' then
              LoadString(HInstance, 623, NazevTransformaceIdB, 20)
            else
              LoadString(HInstance, 623, NazevTransformaceIdB, 20);
          end
          else
            if TypTr = a2 then
              LoadString(HInstance, 627, NazevTransformaceIdB, 20)
            else
              LoadString(HInstance, 628, NazevTransformaceIdB, 20);
    end else
    begin
      LoadString(HInstance, 193, Retezec1, 256);
      {'Spatna transformacni tabulka!'}
      Hlaska(StrPas(Retezec1));
    end;

    RadekObj.Done;

    i := 1;

    if not eof(F) then
    begin
      readln(F, Radek);

      Bod := New(PIdBod, Init(i, true));
      NactiRadekTrTabulky(Radek,  OKej);
      BodColl^.Insert(Bod);

      while not eof(F) do
      begin
        inc(i);
        readln(F, Radek);
        Bod := New(PIdBod, Init(i, true));
        NactiRadekTrTabulky(Radek, OKej);
        BodColl^.Insert(Bod);
      end;
    end;
    close(F);
    PrectiTransfTabulku := true;
  end else
  begin
    BodColl          := nil;
    PrectiTransfTabulku := false;
    LoadString(HInstance, 192, Retezec1, 50);
    {'Transformacni tabulka neexistuje!'}
    Hlaska(StrPas(Retezec1));
  end;
end;


function NactiRohy(
                   const JmenoSouboruROH          : TPathStr;
                   var   MinSRadkuN, MinSSloupcuN,
                         MaxSRadkuN, MaxSSloupcuN,
                         CRadkuN, CSloupcuN       : extended;
                   var   RadkuN, SloupcuN         : word): boolean;
var
  fRoh: text;
  Retezec1: array[0..100] of char;

begin
  NactiRohy := false;
  assign(fRoh, JmenoSouboruROH);
{$I-}
  reset(fRoh);
  if IOResult <> 0 then
  begin
    LoadString(HInstance, 35, Retezec1, sizeof(Retezec1));
    Hlaska(JmenoSouboruNa30(JmenoSouboruROH) + StrPas(Retezec1));
    exit;
  end;
  readLn(fRoh, RadkuN, SloupcuN);
  if IOResult <> 0 then
  begin
    LoadString(HInstance, 35, Retezec1, sizeof(Retezec1));
    Hlaska(JmenoSouboruNa30(JmenoSouboruROH) + StrPas(Retezec1));
    exit;
  end;

  readLn(fRoh, MinSRadkuN, MinSSloupcuN, MaxSRadkuN, MaxSSloupcuN);
  if IOResult <> 0 then
  begin
    LoadString(HInstance, 35, Retezec1, sizeof(Retezec1));
    Hlaska(JmenoSouboruNa30(JmenoSouboruROH) + StrPas(Retezec1));
    exit;
  end;

  readLn(fRoh, CRadkuN, CSloupcuN);
  if IOResult <> 0 then
  begin
    LoadString(HInstance, 35, Retezec1, sizeof(Retezec1));
    Hlaska(JmenoSouboruNa30(JmenoSouboruROH) + StrPas(Retezec1));
    exit;
  end;
  {$I+}
  close(fRoh);
  NactiRohy := true;
end;


end.
