{$N+,E+,R-,Q-}
unit PTranPoV;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} interface {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}

uses TranType, PakTrans;

{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}



type

  PPodobnostni2D = ^TPodobnostni2D;
  TPodobnostni2D = object(TTransformace2D)

    constructor Init(
                     var PoleIdBodu       : PExtVector;
                         PocetDvojicIdBodu: integer);

    procedure   Transformuj(
                            const ZdrojBod: Bod;
                            var   CilBod  : Bod); virtual;

    procedure   InvTransformuj(
                               const ZdrojBod: Bod;
                               var   CilBod  : Bod); virtual;

  end;


  PAfinni2D = ^TAfinni2D;
  TAfinni2D = object(TTransformace2D)

    constructor Init(
                     var PoleIdBodu       : PExtVector;
                         PocetDvojicIdBodu: integer);

    procedure   Transformuj(
                            const ZdrojBod: Bod;
                            var   CilBod  : Bod); virtual;

    procedure   InvTransformuj(
                               const ZdrojBod: Bod;
                               var   CilBod  : Bod); virtual;

  end;


  PKolinearni2D = ^TKolinearni2D;
  TKolinearni2D = object(TTransformace2D)

    constructor Init(
                    var PoleIdBodu       : PExtVector;
                        PocetDvojicIdBodu: integer);

    procedure   Transformuj(
                            const ZdrojBod: Bod;
                            var   CilBod  : Bod); virtual;

    procedure   InvTransformuj(
                               const ZdrojBod: Bod;
                               var   CilBod  : Bod); virtual;

  end;


  PPodobnostni3D = ^TPodobnostni3D;
  TPodobnostni3D = object(TTransformace3D)

    constructor Init(
                     var PoleIdBodu       : PExtVector;
                         PocetDvojicIdBodu: integer);

    procedure   Transformuj(
                            const ZdrojBod: Bod;
                            var   CilBod  : Bod); virtual;

  end;


  PAfinni3D = ^TAfinni3D;
  TAfinni3D  = object(TTransformace3D)

    constructor Init(
                     var PoleIdBodu       : PExtVector;
                         PocetDvojicIdBodu: integer);
    procedure   Transformuj(
                            const ZdrojBod: Bod;
                            var   CilBod  : Bod); virtual;

  end;

  PKolinearni3D = ^TKolinearni3D;
  TKolinearni3D = object(TTransformace3D)

    constructor Init(
                     var PoleIdBodu       : PExtVector;
                         PocetDvojicIdBodu: integer);

    procedure   Transformuj(
                            const ZdrojBod: Bod;
                            var   CilBod  : Bod); virtual;

  end;

(*
  podobnostniF3DPtr=^podobnostniF3D;
  podobnostniF3D=object(Transformace3D)
    constructor Init(var PoleIdBodu: Matice;PocetDvojicIdBodu:integer);
    procedure Transformuj(ZdrojBod:Bod;var CilBod:Bod);virtual;
  end;
*)


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&} implementation {&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}


{&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&}


procedure TPodobnostni2D.Transformuj(
                                     const ZdrojBod: Bod;
                                     var   CilBod  : Bod);
var
  H: Bod;

begin
  H.X      := ZdrojBod.X - ZdrojStred.X;
  H.Y      := ZdrojBod.Y - ZdrojStred.Y;
  CilBod.X := H.X *Klic[1] - H.Y * Klic[2] + CilStred.X;
  CilBod.Y := H.X *Klic[2] + H.Y * Klic[1] + CilStred.Y;
end;



procedure TAfinni2D.Transformuj(
                                const ZdrojBod: Bod;
                                var   CilBod  : Bod);
var
  H: Bod;

begin
  H.X      := ZdrojBod.X - ZdrojStred.X;
  H.Y      := ZdrojBod.Y - ZdrojStred.Y;
  CilBod.X := H.X * Klic[1] + H.Y * Klic[2] + Klic[3] + CilStred.X;
  CilBod.Y := H.X * Klic[4] + H.Y * Klic[5] + Klic[6] + CilStred.Y;
end;



procedure TKolinearni2D.Transformuj(
                                    const ZdrojBod: Bod;
                                    var   CilBod  : Bod);
var
  H: Bod;
  hh: extended;

begin
  H.X      := ZdrojBod.X - ZdrojStred.X;
  H.Y      := ZdrojBod.Y - ZdrojStred.Y;
  hh       := H.X * Klic[7] + H.Y * Klic[8] + 1;
  CilBod.X := CilStred.X + (H.X * Klic[1] + H.Y * Klic[2] + Klic[3]) / hh;
  CilBod.Y := CilStred.Y + (H.X * Klic[4] + H.Y * Klic[5] + Klic[6]) / hh;
end;

procedure TPodobnostni2D.InvTransformuj(
                                        const ZdrojBod: Bod;
                                        var   CilBod  : Bod);
var
  H: Bod;

begin
  H.X      := ZdrojBod.X - CilStred.X;
  H.Y      := ZdrojBod.Y - CilStred.Y;
  CilBod.X := H.X * InvKlic[1] - H.Y * InvKlic[2] + ZdrojStred.X;
  CilBod.Y := H.X * InvKlic[2] + H.Y * InvKlic[1] + ZdrojStred.Y;
end;



procedure TAfinni2D.InvTransformuj(
                                   const ZdrojBod: Bod;
                                   var   CilBod  : Bod);
var
  H: Bod;

begin
  H.X      := ZdrojBod.X - CilStred.X;
  H.Y      := ZdrojBod.Y - CilStred.Y;
  CilBod.X := H.X * InvKlic[1] + H.Y * InvKlic[2] + InvKlic[3] + ZdrojStred.X;
  CilBod.Y := H.X * InvKlic[4] + H.Y * InvKlic[5] + InvKlic[6] + ZdrojStred.Y;
end;



procedure TKolinearni2D.InvTransformuj(
                                       const ZdrojBod: Bod;
                                       var   CilBod  : Bod);
var
  H: Bod;
  hh: extended;

begin
  H.X      := ZdrojBod.X - CilStred.X;
  H.Y      := ZdrojBod.Y - CilStred.Y;
  hh       := H.X * InvKlic[7] + H.Y * InvKlic[8] + 1;
  CilBod.X := ZdrojStred.X + (H.X * InvKlic[1] + H.Y * InvKlic[2] + InvKlic[3]) / hh;
  CilBod.Y := ZdrojStred.Y + (H.X * InvKlic[4] + H.Y * InvKlic[5] + InvKlic[6]) / hh;
end;



procedure TPodobnostni3D.Transformuj(
                                     const ZdrojBod: Bod;
                                     var   CilBod  : Bod);
var
  H: Bod;

begin
  H.X      := ZdrojBod.X - ZdrojStred.X;
  H.Y      := ZdrojBod.Y - ZdrojStred.Y;
  H.Z      := ZdrojBod.Z - ZdrojStred.Z;
  CilBod.X := CilStred.X + H.X * Klic[1] + H.Y * Klic[2] + H.Z * Klic[3];
  CilBod.Y := CilStred.Y + H.X * Klic[4] + H.Y * Klic[5] + H.Z * Klic[6];
  CilBod.Z := CilStred.Z + H.X * Klic[7] + H.Y * Klic[8] + H.Z * Klic[9];
end;


procedure TAfinni3D.Transformuj(
                                const ZdrojBod: Bod;
                                var   CilBod  : Bod);
var
  H: Bod;

begin
  H.X      := ZdrojBod.X - ZdrojStred.X;
  H.Y      := ZdrojBod.Y - ZdrojStred.Y;
  H.Z      := ZdrojBod.Z - ZdrojStred.Z;
  CilBod.X := CilStred.X + H.X * Klic[1] + H.Y * Klic[ 2] + H.Z * Klic[ 3] + Klic[ 4];
  CilBod.Y := CilStred.Y + H.X * Klic[5] + H.Y * Klic[ 6] + H.Z * Klic[ 7] + Klic[ 8];
  CilBod.Z := CilStred.Z + H.X * Klic[9] + H.Y * Klic[10] + H.Z * Klic[11] + Klic[12];
end;



procedure TKolinearni3D.Transformuj(
                                    const ZdrojBod: Bod;
                                    var   CilBod  : Bod);
var
  H: Bod;
  hh: extended;

begin
  H.X      := ZdrojBod.X - ZdrojStred.X;
  H.Y      := ZdrojBod.Y - ZdrojStred.Y;
  H.Z      := ZdrojBod.Z - ZdrojStred.Z;
  hh       := H.X * Klic[13] + H.Y * Klic[14] + H.Z * Klic[15] + 1;
  CilBod.X := CilStred.X +(H.X * Klic[1] + H.Y * Klic[ 2] + H.Z * Klic[ 3] + Klic[ 4]) / hh;
  CilBod.Y := CilStred.Y +(H.X * Klic[5] + H.Y * Klic[ 6] + H.Z * Klic[ 7] + Klic[ 8]) / hh;
  CilBod.Z := CilStred.Z +(H.X * Klic[9] + H.Y * Klic[10] + H.Z * Klic[11] + Klic[12]) / hh;
end;


constructor TPodobnostni2D.Init(
                                var PoleIdBodu       : PExtVector;
                                    PocetDvojicIdBodu: integer);
const
  PocetParametru = 2;

var
  V: PExtVector;
  PM: PExtVector;
  VPS: PExtVector;
  Delta: TKlic;
  Ukoncit: boolean;
  i, j, PocetRovnic: integer;
  eps: extended;

begin
  DostatecnyPocetDvojic := 2;
  if PocetDvojicIdBodu < DostatecnyPocetDvojic then
  begin
    NelzeVypocistKlic := true;
    CisloChyby        := 3;
  end else
  begin
    inherited Init(PoleIdBodu, PocetDvojicIdBodu);

    i       := 1;
    Klic[i] := 0.5;

    i       := 2;
    Klic[i] := 0.5;

    i          := 1;
    InvKlic[i] := 0.5;

    i          := 2;
    InvKlic[i] := 0.5;

    GetMem(V, SizeOf(extended) * PocetDvojicIdBodu);
    GetMem(PM, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu * PocetParametru);
    GetMem(VPS, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);


    j := 0;
    for i := 1 to PocetDvojicIdBodu do
    begin
      V^[i]  :=  Vaha[i];

      inc(j);
      PM^[j] :=  Sta[i].X;
      inc(j);
      PM^[j] := -Sta[i].Y;
      inc(j);
      PM^[j] :=  Sta[i].Y;
      inc(j);
      PM^[j] :=  Sta[i].X;
    end;

    repeat
      Ukoncit := true;

      j := 0;
      for i := 1 to PocetDvojicIdBodu do
      begin
        inc(j);
        VPS^[j] := Nov[i].X - Klic[1] * Sta[i].X + Klic[2] * Sta[i].Y;
        inc(j);
        VPS^[j] := Nov[i].Y - Klic[1] * Sta[i].Y - Klic[2] * Sta[i].X;
      end;

      PocetRovnic := DimenseTransformace * PocetDvojicIdBodu;

      if not ResSoustRovnic(V, PM, VPS, Delta, PocetRovnic, PocetParametru, DimenseTransformace) then
      begin
        NelzeVypocistKlic := true;
        CisloChyby        := 2;
      end else
      begin
        eps := 1e-15 * (abs(Klic[1]) + abs(Klic[2]));

        for i := 1 to 2 do
        begin
          Klic[i] := Klic[i] + Delta[i];

          if abs(Delta[i]) > eps then
            Ukoncit:=false;
        end;
      end;
    until (Ukoncit) or (NelzeVypocistKlic);

    if Ukoncit then
    begin
      j := 0;

      for i := 1 to PocetDvojicIdBodu do
      begin
        inc(j);
        PM^[j] :=  Nov[i].X;
        inc(j);
        PM^[j] := -Nov[i].Y;
        inc(j);
        PM^[j] :=  Nov[i].Y;
        inc(j);
        PM^[j] :=  Nov[i].X;
      end;

      repeat
        Ukoncit := true;

        j := 0;

        for i := 1 to PocetDvojicIdBodu do
        begin
          inc(j);
          VPS^[j] := Sta[i].X - InvKlic[1] * Nov[i].X + InvKlic[2] * Nov[i].Y;
          inc(j);
          VPS^[j] := Sta[i].Y - InvKlic[1] * Nov[i].Y - InvKlic[2] * Nov[i].X;
        end;

        PocetRovnic := DimenseTransformace * PocetDvojicIdBodu;

        if not ResSoustRovnic(V, PM, VPS, Delta, PocetRovnic, PocetParametru, DimenseTransformace) then
        begin
          NelzeVypocistKlic := true;
          CisloChyby        := 2;
        end else
        begin
          eps := 1e-15 * (abs(InvKlic[1]) + abs(InvKlic[2]));

          for i :=1 to 2 do
          begin
            InvKlic[i] := InvKlic[i] + Delta[i];
            if abs(delta[i]) > eps then
              Ukoncit:=false;
          end;
        end;
      until (Ukoncit) or (NelzeVypocistKlic);
    end;
    FreeMem(V, SizeOf(extended) * PocetDvojicIdBodu);
    FreeMem(PM, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu * PocetParametru);
    FreeMem(VPS, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);
  end;
end;



constructor TAfinni2D.Init(
                           var PoleIdBodu       : PExtVector;
                               PocetDvojicIdBodu: integer);
const
  PocetParametru = 6;

var
  V: PExtVector;
  PM: PExtVector;
  VPS: PExtVector;
  i, j, k, PocetRovnic: integer;

begin
  DostatecnyPocetDvojic := 3;

  if PocetDvojicIdBodu < DostatecnyPocetDvojic then
  begin
    NelzeVypocistKlic := true;
    CisloChyby        := 3;
  end else
  begin
    inherited Init(PoleIdBodu, PocetDvojicIdBodu);
    GetMem(V, SizeOf(extended) * PocetDvojicIdBodu);
    GetMem(PM, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu * PocetParametru);
    GetMem(VPS, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);

    j := 0;
    k := 0;

    for i := 1 to PocetDvojicIdBodu do
    begin
      V^[i]     := Vaha[i];

      inc(j);
      PM^[j]    := Sta[i].X;
      inc(j);
      PM^[j]    := Sta[i].Y;
      inc(j);
      PM^[j]    := 1;
      inc(j);
      PM^[j]    := 0;
      inc(j);
      PM^[j]    := 0;
      inc(j);
      PM^[j]    := 0;

      inc(k);
      VPS^[k]   := Nov[i].X;

      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].Y;
      inc(j);
      PM^[j] := 1;

      inc(k);
      VPS^[k]   := Nov[i].Y;
    end;

    PocetRovnic := DimenseTransformace * PocetDvojicIdBodu;

    if not ResSoustRovnic(V, PM, VPS, Klic, PocetRovnic, PocetParametru, DimenseTransformace) then
    begin
      NelzeVypocistKlic := true;
      CisloChyby        := 2;
    end;

    if not NelzeVypocistKlic then
    begin
      j := 0;
      k := 0;

      for i := 1 to PocetDvojicIdBodu do
      begin
        inc(j);
        PM^[j] := Nov[i].X;
        inc(j);
        PM^[j] := Nov[i].Y;
        inc(j);
        PM^[j] := 1;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;

        inc(k);
        VPS^[k]   := Sta[i].X;

        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := Nov[i].X;
        inc(j);
        PM^[j] := Nov[i].Y;
        inc(j);
        PM^[j] := 1;

        inc(k);
        VPS^[k]   := Sta[i].Y;
      end;

      PocetRovnic := DimenseTransformace * PocetDvojicIdBodu;

      if not ResSoustRovnic(V, PM, VPS, InvKlic, PocetRovnic, PocetParametru, DimenseTransformace) then
      begin
        NelzeVypocistKlic := true;
        CisloChyby        := 2;
      end;
    end;
    FreeMem(V, SizeOf(extended) * PocetDvojicIdBodu);
    FreeMem(PM, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu * PocetParametru);
    FreeMem(VPS, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);
  end;
end;



constructor TKolinearni2D.Init(
                               var PoleIdBodu       : PExtVector;
                                   PocetDvojicIdBodu: integer);
const
  PocetParametru=8;

var
  V: PExtVector;
  PM: PExtVector;
  VPS: PExtVector;
  i, j, k, PocetRovnic:integer;

begin
  DostatecnyPocetDvojic := 4;

  if PocetDvojicIdBodu < DostatecnyPocetDvojic then
  begin
    NelzeVypocistKlic := true;
    CisloChyby        := 3;
  end else
  begin
    inherited Init(PoleIdBodu, PocetDvojicIdBodu);
    GetMem(V, SizeOf(extended) * PocetDvojicIdBodu);
    GetMem(PM, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu * PocetParametru);
    GetMem(VPS, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);

    j := 0;
    K := 0;

    for i := 1 to PocetDvojicIdBodu do
    begin
      V^[i]  := Vaha[i];

      inc(j);
      PM^[j] := Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].Y;
      inc(j);
      PM^[j] := 1;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := -Sta[i].X*Nov[i].X;
      inc(j);
      PM^[j] := -Sta[i].Y*Nov[i].X;

      inc(k);
      VPS^[k]   := Nov[i].X;

      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].Y;
      inc(j);
      PM^[j] := 1;
      inc(j);
      PM^[j] := -Sta[i].X*Nov[i].Y;
      inc(j);
      PM^[j] := -Sta[i].Y*Nov[i].Y;

      inc(k);
      VPS^[k]   := Nov[i].Y
    end;

    PocetRovnic := DimenseTransformace * PocetDvojicIdBodu;

    if not ResSoustRovnic(V, PM, VPS, Klic, PocetRovnic, PocetParametru, DimenseTransformace) then
    begin
      NelzeVypocistKlic := true;
      CisloChyby        := 2;
    end;

    if not NelzeVypocistKlic then
    begin
      j := 0;
      k := 0;

      for i := 1 to PocetDvojicIdBodu do
      begin
        inc(j);
        PM^[j] := Nov[i].X;
        inc(j);
        PM^[j] := Nov[i].Y;
        inc(j);
        PM^[j] := 1;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := -Nov[i].X*Sta[i].X;
        inc(j);
        PM^[j] := -Nov[i].Y*Sta[i].X;

        inc(k);
        VPS^[k]   := Sta[i].X;

        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := 0;
        inc(j);
        PM^[j] := Nov[i].X;
        inc(j);
        PM^[j] := Nov[i].Y;
        inc(j);
        PM^[j] := 1;
        inc(j);
        PM^[j] := -Nov[i].X*Sta[i].Y;
        inc(j);
        PM^[j] := -Nov[i].Y*Sta[i].Y;

        inc(k);
        VPS^[k]   := Sta[i].Y
      end;

      PocetRovnic := DimenseTransformace * PocetDvojicIdBodu;

      if not ResSoustRovnic(V, PM, VPS, InvKlic, PocetRovnic, PocetParametru, DimenseTransformace) then
      begin
        NelzeVypocistKlic := true;
        CisloChyby        := 2;
      end;
    end;
    FreeMem(V, SizeOf(extended) * PocetDvojicIdBodu);
    FreeMem(PM, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu * PocetParametru);
    FreeMem(VPS, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);
  end;
end;




constructor TPodobnostni3D.Init(
                               var PoleIdBodu       : PExtVector;
                                   PocetDvojicIdBodu: integer);
const
  PocetParametru = 1;
  DelkaKlice     = 9;
  Prevod         = 63.66197724;

var
  PM, VPS: PExtVector;
  CilMer, ZdrojMer, SumaKa, SumaX, SumaY, SumaFi, SumaOm: extended;
  a, b, c, d, e, f: extended;
  om, fi, ka, ep, eps: extended;
  DeltaKa, DeltaFi, DeltaOm, DX, DY, DZ: extended;
  Ukoncit: boolean;
  i, ir, iq, ip, PocetRovnic, PocetIteraci: integer;


procedure VypoctiKlice;

begin
  a := cos(om);
  b := sin(om);
  c := cos(fi);
  d := sin(fi);
  e := cos(ka);
  f := sin(ka);

  Klic[1] :=  c * e;
  Klic[2] := -c * f;
  Klic[3] := -d;

  Klic[4] :=  a * f - b * d * e;
  Klic[5] :=  a * e + b * d * f;
  Klic[6] := -b * c;

  Klic[7] :=  b * f + a * d * e;
  Klic[8] :=  b * e - a * d * f;
  Klic[9] :=  a * c;
end;


begin
  DostatecnyPocetDvojic := 3;

  if PocetDvojicIdBodu < DostatecnyPocetDvojic then
    NelzeVypocistKlic := true
  else
  begin
    inherited Init(PoleIdBodu, PocetDvojicIdBodu);
    GetMem(PM, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);
    GetMem(VPS, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);
    PocetRovnic := DimenseTransformace * PocetDvojicIdBodu;

    CilMer   := 0;
    ZdrojMer := 0;

    for i := 1 to PocetDvojicIdBodu do
    begin
      CilMer   := CilMer + sqrt(Nov[i].X * Nov[i].X + Nov[i].Y * Nov[i].Y + Nov[i].Z * Nov[i].Z);
      ZdrojMer := ZdrojMer + sqrt(Sta[i].X * Sta[i].X + Sta[i].Y * Sta[i].Y + Sta[i].Z * Sta[i].Z);
    end;

    if (ZdrojMer=0) or (CilMer=0) then
      NelzeVypocistKlic := true
    else
    begin
      { vypocet parametru expanse a posuvu }

      ep:=CilMer/ZdrojMer;

      { vypocet pocatecnich uhlu prostorove rotace }

      om      := 0.00000157079;
      fi      := 0.00000157079;
      ka      := 0.00000157079;
      DeltaKa := 1;
      DeltaFi := 1;
      DeltaOm := 1;
      eps     := 0.00000157079;

      { odhad uhlu rotace pomoci iterace }


      PocetIteraci := 0;

      repeat
        inc(PocetIteraci);
        Ukoncit := true;

        VypoctiKlice;

        {---------------- rotace kapa ----------------}

        SumaX := 0;
        SumaY := 0;

        for i := 1 to PocetDvojicIdBodu do
        begin
          iq       :=  2 * i;
          ip       := iq - 1;

          PM^[ip]  := Klic[2] * Sta[i].X - Klic[1] * Sta[i].Y;
          PM^[iq]  := Klic[5] * Sta[i].X - Klic[4] * Sta[i].Y;

          VPS^[ip] := (Nov[i].X) / ep - (Klic[1] * Sta[i].X + Klic[2] * Sta[i].Y + Klic[3] * Sta[i].Z);
          VPS^[iq] := (Nov[i].Y) / ep - (Klic[4] * Sta[i].X + Klic[5] * Sta[i].Y + Klic[6] * Sta[i].Z);

          SumaX    := SumaX + VPS^[ip] / PM^[ip];
          SumaY    := SumaY + VPS^[iq] / PM^[iq];
        end;

        DeltaKa := (SumaX + SumaY) / (PocetDvojicIdBodu * 2);
        Ka      := Ka + DeltaKa;

        VypoctiKlice;

        {---------------- rotace fi -------------------}

        SumaFi:=0;

        for i := 1 to PocetDvojicIdBodu do
        begin
          ir       := i * 3;

          PM^[ir]  := -a * (c* (-e * Sta[i].X + f * Sta[i].Y) + d * Sta[i].Z);
          VPS^[ir] := Nov[i].Z / ep - (Klic[7] * Sta[i].X + Klic[8] * Sta[i].Y + Klic[9] * Sta[i].Z);
          SumaFi   := SumaFi + VPS^[ir] / PM^[ir];
        end;

        DeltaFI := SumaFi / PocetDvojicIdBodu;
        Fi      := Fi + DeltaFi;

        VypoctiKlice;

        {---------------- rotace omega ----------------}

        SumaOm := 0;

        for i := 1 to PocetDvojicIdBodu do
        begin
          ir:=i*3;

          PM^[ir]  := Klic[4] * Sta[i].X + Klic[5] * Sta[i].Y + Klic[6] * Sta[i].Z;
          VPS^[ir] := Nov[i].Z / ep - (Klic[7] * Sta[i].X + Klic[8] * Sta[i].Y + Klic[9] * Sta[i].Z);
          SumaOm   := SumaOm+VPS^[ir]/PM^[ir];

        end;

        DeltaOm := SumaOm / PocetDvojicIdBodu;
        Om      := Om + DeltaOm;

        if ((DeltaKa > eps) or (DeltaFI > eps) or (DeltaOm > eps)) then
          Ukoncit := false;

        if PocetIteraci > 40  then
        begin
          NelzeVypocistKlic:=true;
        end;
      until ((Ukoncit) or (NelzeVypocistKlic));
    end;
    FreeMem(PM, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);
    FreeMem(VPS, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);
  end;
end;



constructor TAfinni3D.Init(
                           var PoleIdBodu       : PExtVector;
                               PocetDvojicIdBodu: integer);
const
  PocetParametru=12;

var
  V: PExtVector;
  PM: PExtVector;
  VPS: PExtVector;
  i, j, k, PocetRovnic: integer;

begin
  DostatecnyPocetDvojic := 4;

  if PocetDvojicIdBodu < DostatecnyPocetDvojic then
  begin
    NelzeVypocistKlic := true;
    CisloChyby        := 3;
  end else
  begin
    inherited Init(PoleIdBodu, PocetDvojicIdBodu);
    GetMem(V, SizeOf(extended) * PocetDvojicIdBodu);
    GetMem(PM, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu * PocetParametru);
    GetMem(VPS, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);

    j := 0;
    k := 0;

    for i := 1 to PocetDvojicIdBodu do
    begin
      V^[i]  := Vaha[i];

      inc(j);
      PM^[j] := Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].Z;
      inc(j);
      PM^[j] := 1;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;

      inc(k);
      VPS^[k]    := Nov[i].X;

      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].Z;
      inc(j);
      PM^[j] := 1;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;

      inc(k);
      VPS^[k]    := Nov[i].Y;

      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].Z;
      inc(j);
      PM^[j] := 1;

      inc(k);
      VPS^[k]    := Nov[i].Z;
    end;

    PocetRovnic := DimenseTransformace * PocetDvojicIdBodu;

    if not ResSoustRovnic(V, PM, VPS, Klic, PocetRovnic, PocetParametru, DimenseTransformace) then
    begin
      NelzeVypocistKlic := true;
      CisloChyby        := 2;
    end;
    FreeMem(V, SizeOf(extended) * PocetDvojicIdBodu);
    FreeMem(PM, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu * PocetParametru);
    FreeMem(VPS, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);
  end;
end;



constructor TKolinearni3D.Init(
                               var PoleIdBodu       : PExtVector;
                                   PocetDvojicIdBodu: integer);
const
  PocetParametru = 15;
var
  V: PExtVector;
  PM: PExtVector;
  VPS: PExtVector;
  i, j, k, PocetRovnic: integer;

begin
  DostatecnyPocetDvojic := 5;

  if PocetDvojicIdBodu < DostatecnyPocetDvojic then
  begin
    NelzeVypocistKlic := true;
    CisloChyby        := 3;
  end else
  begin
    inherited Init(PoleIdBodu, PocetDvojicIdBodu);
    GetMem(V, SizeOf(extended) * PocetDvojicIdBodu);
    GetMem(PM, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu * PocetParametru);
    GetMem(VPS, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);

    j := 0;
    k := 0;

    for i := 1 to PocetDvojicIdBodu do
    begin
      V^[i]  := Vaha[i];

      inc(j);
      PM^[j] := Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].Z;
      inc(j);
      PM^[j] := 1;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := -Sta[i].X * Nov[i].X;
      inc(j);
      PM^[j] := -Sta[i].Y * Nov[i].X;
      inc(j);
      PM^[j] := -Sta[i].Z * Nov[i].X;

      inc(k);
      VPS^[k]    := Nov[i].X;

      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].Z;
      inc(j);
      PM^[j] := 1;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := -Sta[i].X * Nov[i].Y;
      inc(j);
      PM^[j] := -Sta[i].Y * Nov[i].Y;
      inc(j);
      PM^[j] := -Sta[i].Z * Nov[i].Y;

      inc(k);
      VPS^[k]    := Nov[i].Y;

      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := 0;
      inc(j);
      PM^[j] := Sta[i].X;
      inc(j);
      PM^[j] := Sta[i].Y;
      inc(j);
      PM^[j] := Sta[i].Z;
      inc(j);
      PM^[j] := 1;
      inc(j);
      PM^[j] := -Sta[i].X * Nov[i].Z;
      inc(j);
      PM^[j] := -Sta[i].Y * Nov[i].Z;
      inc(j);
      PM^[j] := -Sta[i].Z * Nov[i].Z;

      inc(k);
      VPS^[k]    := Nov[i].Z;
    end;

    PocetRovnic := DimenseTransformace * PocetDvojicIdBodu;

    if not ResSoustRovnic(V, PM, VPS, Klic, PocetRovnic, PocetParametru, DimenseTransformace) then
    begin
      NelzeVypocistKlic := true;
      CisloChyby        := 2;
    end;
    FreeMem(V, SizeOf(extended) * PocetDvojicIdBodu);
    FreeMem(PM, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu * PocetParametru);
    FreeMem(VPS, DimenseTransformace * SizeOf(extended) * PocetDvojicIdBodu);
  end;
end;



(*





procedure podobnostniF3D.Transformuj(ZdrojBod:Bod;var CilBod:Bod);


var

  H:Bod;

begin
  H.X:=ZdrojBod.X-ZdrojStred.X;
  H.Y:=ZdrojBod.Y-ZdrojStred.Y;
  H.Z:=ZdrojBod.Z-ZdrojStred.Z;
  CilBod.X:=CilStred.X+H.X*Klic[1]+H.Y*Klic[2]+H.Z*Klic[3];
  CilBod.Y:=CilStred.Y+H.X*Klic[4]+H.Y*Klic[5]+H.Z*Klic[6];
  CilBod.Z:=CilStred.Z+H.X*Klic[7]+H.Y*Klic[8]+H.Z*Klic[9];
end;




constructor podobnostniF3D.Init(var PoleIdBodu: Matice; PocetDvojicIdBodu:integer);

{ Varianta programu pro reseni absolutni orientace s vyuzitim klasickych
  vypoctu prvku vnejsi orientace.
  Transformace je pouze na 4 identicke body a je nutne dodrzovat jejich
  poradi.

        .1   .2


        .3   .4
 }

const

   PocetParametru=1;
   DelkaKlice=9;
   Prevod=63.66197724;

type

  PMpole=array[1..150] of extended;
  VPSpole=array[1..150] of extended;

var

  PM:^PMpole;
  VPS:^VPSpole;
  CilMer,ZdrojMer,DYN14,DXN14,DYN23,DXN23,DYS14,DXS14,DYS23,DXS23:extended;
  a,b,c,d,e,f,S13,S24,S12,S34,DZ1,DZ2,DZ3,DZ4,Delta14,Delta23:extended;
  om,fi,ka,ep,eps:extended;
  DeltaKa,DeltaFi,DeltaOm:extended;
  DX1,DX2,DX3,DX4,DY1,DY2,DY3,DY4,DX,DY,DZ:extended;
  Ukoncit:boolean;
  i,PocetRovnic,PocetIteraci:integer;

procedure VypoctiKlice;

begin
  a:=cos(om);
  b:=sin(om);
  c:=cos(fi);
  d:=sin(fi);
  e:=cos(ka);
  f:=sin(ka);


  Klic[1]:=c*e;
  Klic[2]:=-c*f;
  Klic[3]:=-d;

  Klic[4]:=a*f-b*d*e;
  Klic[5]:=a*e+b*d*f;
  Klic[6]:=-b*c;

  Klic[7]:=b*f+a*d*e;
  Klic[8]:=b*e-a*d*f;
  Klic[9]:=a*c;
end;




 function  Acos(x:real):real;

 begin
   if x=1 then begin
     acos:=0;
   end else if x=-1 then begin
     acos:=Pi;
   end else begin
     acos:=Pi/2-arctan(x/sqrt(1-sqr(x)));
   end;
 end;



 function ATAN2(DY,DX:REAL):REAL;

 { ARCUS TANGENS DVOU ARGUMENTU
   VSTUP:DY,DX; VYSTUP:ATAN2...UHEL V ROZMEZI 0 AZ 2*PI}

 var

   A:real;

 begin
   ATAN2:=3333;   { ZUSTALO BY POUZE PRO DY AND DX =0 }
   if not ((DY=0) and (DX=0)) then begin;
     if (DY=0) and (DX>0) then begin
       ATAN2:=0;
     end else if (DY=0) and (DX<0) then begin
       ATAN2:=PI;
     end else if (DX=0) and (DY>0) then begin
       ATAN2:=0.5*PI;
     end else if (DX=0) and (DY<0) then begin
       ATAN2:=1.5*PI;
     end else begin
       A:=ARCTAN(DY/DX);
       ATAN2:=A;
       if (DY>0) and (DX<0) then begin
         ATAN2:=A+(PI);
       end;
       if (DY<0) and (DX<0) then begin
         ATAN2:=A+PI;
       end;
       if (DY<0) and (DX>0) then begin
         ATAN2:=A+2*PI;
       end;
     end;
   end;
 end;


begin
  DostatecnyPocetDvojic:=3;
  if PocetDvojicIdBodu<DostatecnyPocetDvojic then begin
    NelzeVypocistKlic:=true;
  end
  else
  begin
    Transformace3D.Init(PoleIdBodu, PocetDvojicIdBodu);
    if MaxAvail>SizeOf(PMpole) then begin
      GetMem(PM,SizeOf(PMpole));
      if Maxavail>SizeOf(VPSpole) then begin
        GetMem(VPS,SizeOf(VPSpole));

        PocetRovnic:=dimense*PocetDvojicIdBodu;




        CilMer:=0;
        ZdrojMer:=0;
        for i:=1 to PocetDvojicIdBodu do begin
          CilMer:=CilMer+sqrt(Nov[i].X*Nov[i].X+Nov[i].Y*Nov[i].Y
             +Nov[i].Z*Nov[i].Z);
          ZdrojMer:=ZdrojMer+sqrt(Sta[i].X*Sta[i].X+Sta[i].Y*Sta[i].Y
             +Sta[i].Z*Sta[i].Z);
        end;

        if (ZdrojMer=0) or (CilMer=0) then begin
          NelzeVypocistKlic:=true;
        end else begin

          { vypocet parametru expanse a posuvu }

          ep:=CilMer/ZdrojMer;

          { vypocet pocatecnich uhlu prostorove rotace }

          om:=0.00000157079;
          fi:=0.00000157079;
          ka:=0.00000157079;
          DeltaKa:=1;
          DeltaFi:=1;
          DeltaOm:=1;
          eps:=0.000157079;

          { odhad uhlu rotace pomoci iterace }


          PocetIteraci:=0;

          repeat
            inc(PocetIteraci);
            Ukoncit:=true;

            VypoctiKlice;


          {--------  rotace kapa ----------}

             DYN14:=Nov[4].Y-Nov[1].Y;
             DXN14:=Nov[4].X-Nov[1].X;
             DYN23:=Nov[3].Y-Nov[2].Y;
             DXN23:=Nov[3].X-Nov[2].X;
             DYS14:=ep*((klic[4]*sta[4].X+klic[5]*Sta[4].Y+Klic[6]*Sta[4].Z)
                       -(klic[4]*sta[1].X+klic[5]*Sta[1].Y+Klic[6]*Sta[1].Z));
             DXS14:=ep*((klic[1]*sta[4].X+klic[2]*Sta[4].Y+Klic[3]*Sta[4].Z)
                       -(klic[1]*sta[1].X+klic[2]*Sta[1].Y+Klic[3]*Sta[1].Z));
             DYS23:=ep*((klic[4]*sta[3].X+klic[5]*Sta[3].Y+Klic[6]*Sta[3].Z)
                       -(klic[4]*sta[2].X+klic[5]*Sta[2].Y+Klic[6]*Sta[2].Z));
             DXS23:=ep*((klic[1]*sta[3].X+klic[2]*Sta[3].Y+Klic[3]*Sta[3].Z)
                       -(klic[1]*sta[2].X+klic[2]*Sta[2].Y+Klic[3]*Sta[2].Z));
             Delta14:=(ATAN2(DYN14,DXN14)-ATAN2(DYS14,DXS14))*Prevod;
             Delta23:=(ATAN2(DYN23,DXN23)-ATAN2(DYS23,DXS23))*Prevod;
             DeltaKa:=((ATAN2(DYN14,DXN14)-ATAN2(DYS14,DXS14))
                      +(ATAN2(DYN23,DXN23)-ATAN2(DYS23,DXS23)))/2;

            Ka:=Ka+DeltaKa;

              VypoctiKlice;


          {----------   rotace fi  ----------}

             DZ1:=(Nov[1].Z)/ep-(klic[7]*sta[1].X+klic[8]*Sta[1].Y
                         +Klic[9]*Sta[1].Z);
             DZ2:=(Nov[2].Z)/ep-(klic[7]*sta[2].X+klic[8]*Sta[2].Y
                         +Klic[9]*Sta[2].Z);
             DZ3:=(Nov[3].Z)/ep-(klic[7]*sta[3].X+klic[8]*Sta[3].Y
                         +Klic[9]*Sta[3].Z);
             DZ4:=(Nov[4].Z)/ep-(klic[7]*sta[4].X+klic[8]*Sta[4].Y
                         +Klic[9]*Sta[4].Z);

                S13:=sqrt((Nov[3].Y-Nov[1].Y)*(Nov[3].Y-Nov[1].Y) + (Nov[3].X-Nov[1].X)*(Nov[3].X-Nov[1].X));
                S24:=sqrt((Nov[4].Y-Nov[2].Y)*(Nov[4].Y-Nov[2].Y) + (Nov[4].X-Nov[2].X)*(Nov[4].X-Nov[2].X));
                DeltaFI:=((DZ3-DZ1)/S13 + (DZ4-DZ2)/S24)/2;

             Fi:=Fi+DeltaFi;

                VypoctiKlice;


           {------------  rotace omega ---------- }

             DZ1:=(Nov[1].Z)/ep-(klic[7]*sta[1].X+klic[8]*Sta[1].Y
                         +Klic[9]*Sta[1].Z);
             DZ2:=(Nov[2].Z)/ep-(klic[7]*sta[2].X+klic[8]*Sta[2].Y
                         +Klic[9]*Sta[2].Z);
             DZ3:=(Nov[3].Z)/ep-(klic[7]*sta[3].X+klic[8]*Sta[3].Y
                         +Klic[9]*Sta[3].Z);
             DZ4:=(Nov[4].Z)/ep-(klic[7]*sta[4].X+klic[8]*Sta[4].Y
                         +Klic[9]*Sta[4].Z);

                S12:=sqrt((Nov[2].Y-Nov[1].Y)*(Nov[2].Y-Nov[1].Y) + (Nov[2].X-Nov[1].X)*(Nov[2].X-Nov[1].X));
                S34:=sqrt((Nov[4].Y-Nov[3].Y)*(Nov[4].Y-Nov[3].Y) + (Nov[4].X-Nov[3].X)*(Nov[4].X-Nov[3].X));
                DeltaOm:=((DZ1-DZ2)/S12 + (DZ3-DZ4)/S34)/2;

             Om:=Om+DeltaOm;


            if ((DeltaKa>eps) or (DeltaFI>eps) or (DeltaOm>eps)) then begin
               ukoncit:=false;
            end;


              if PocetIteraci>40  then begin
                NelzeVypocistKlic:=true;
             end;


          until ((Ukoncit) or (NelzeVypocistKlic));

             for i:=1 to 9 do begin
               Klic[i]:=Klic[i]*ep;
             end;

        end;
        FreeMem(VPS,SizeOf(VPSpole));
      end else begin
        NelzeVypocistKlic:=true;
      end;
      FreeMem(PM,SizeOf(PMpole));
    end else begin
      NelzeVypocistKlic:=true;
    end;
  end;
end;
*)

end.
